<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Backup
  {

   function __construct() {}

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_RESTORE_DATABASE:
        {
         return 'Not implemented jet';//wm3Backup::xxx($w3);//TODO
         break;
        }
       case WM3_cACTION_DELETE_DATABASE:
        {
         return wm3Backup::deleteDatabase($w3);
		}
       case WM3_cACTION_SAVE_BACKUP_DATABASE:
        {
		 return wm3Backup::backupDatabase($w3,true);
		}
       default:
        {
         return wm3Backup::backupDatabase($w3);
        }
      }     
    }

   public static function deleteDatabase($w3)
    {
	 // Initialize form
	 $_FIELD = webmatic3::getPostValueArray(array('confirm'));
     $action = WM3_cACTION_DELETE_DATABASE;
     require(WM3_cPATH_INCLUDE.'admin_database_delete_form.inc');
     $form->setSubmitLabel($w3->getWord(1778));
     $form->setTitle($w3->getWord(1778));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['confirm']->setValue(WM3_cDISABLED);
      }
     else
      {
       if($form->validate())
        {
         wm3Setup::deleteDatabase();
         header("Location: ".WM3_cCONFIG_HOME_FILE); die; // Redirect to home page
		}
      }
     return $form->render();
    }

   public static function backupDatabase($w3,$save = false)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(array('target'));
	 $action = WM3_cACTION_SAVE_BACKUP_DATABASE;
	 require(WM3_cPATH_INCLUDE.'admin_database_backup_form.inc');
     $form->setSubmitLabel($w3->getWord(1762));
     $form->setTitle($w3->getWord(1761));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
      }
     else
      {
       if($form->validate())
        {
         if($save) // Save database backup
          {
           $ts = time(); $date = date("m-d-Y",$ts); $time = date("(H.i.s)",$ts);
           $backup_header = "-- Database: ".WM3_cCONFIG_DB_NAME."\n".
                            "-- Backup date: $date $time\n\n";
           $backup = wm3Util::quoteHTML(wm3Backup::backupDB($w3));
           if($_FIELD['target'] == WM3_cDATABASE_TARGET_FILE)
            {
             $filename  = WM3_cCONFIG_DB_NAME."_".$date.$time.".sql";
             $mime_type = "text/plain";
             header("Content-type: $mime_type"); 
             header("Content-Disposition: attachment; filename=$filename");
             echo $backup_header.$backup;
             die;         
    		}
           if($_FIELD['target'] == WM3_cDATABASE_TARGET_VIDEO)
            {
             // Create list items
             $f1 = new wm3GUITextArea('backup',$backup_header.$backup,'',22,125);
             $b1 = new wm3GUIButton('select_all',$w3->getWord(1308));
              $b1->setJavascript("onClick=\"wm3_selectAll('backup');\"");
             $_DATA = array();
             $_DATA[0]->content = $f1->render();
             $_DATA[0]->button  = $b1->render();

             // Render List
             $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1761));
             $list->setRenderCaption(false);
             $list->setWidths(array(20,80));
             $list->setRenderPagesNavigator(false);
             return $list->render();
    		}
	      }
		}
      }
     return $form->render();
    }

   private function backupDB($w3)
    {
	 // Create a database backup in Sql format
     $str         = '';
     $table_rs    = $w3->getDBObj()->listTables();
     $table_total = $w3->getDBObj()->totalRows($table_rs);
     for($j = 0; $j < $table_total; $j++)
      {
       $table_name = $w3->getDBObj()->tableName($table_rs,$j);
       //TODO Parse only table that name start with WM3_cCONFIG_DB_PREFIX ???
       //if($table_name == WM3_cCONFIG_DB_PREFIX)//TODO
       {
		// Create database table structure
        $field_rs    = $w3->getDBObj()->listFields($table_name);
        $field_total = $w3->getDBObj()->totalFields($field_rs);
        $str .= "CREATE TABLE $table_name\n (";
        for($i = 0; $i < $field_total; $i++)
         {
          $field_name  = $w3->getDBObj()->fieldName  ($field_rs,$i);
          $field_type  = $w3->getDBObj()->fieldType  ($field_rs,$i);
          $field_len   = $w3->getDBObj()->fieldLenght($field_rs,$i);
          $field_flags = $w3->getDBObj()->fieldFlags ($field_rs,$i);

          // Keep only unsigned, primary key and auto_increment flags //(TODO ne mancano altri???)
          $flags = '';
          if(stristr($field_flags, "unsigned"      ) != '') $flags .= " unsigned";
          if(stristr($field_flags, "primary_key"   ) != '') $flags .= " primary key";
          if(stristr($field_flags, "auto_increment") != '') $flags .= " auto_increment";

          if($field_type == "string") $field_type = "char";
          if($field_type == "date" || $field_type =="time") $str .= "\n  $field_name $field_type$flags";
          else                                              $str .= "\n  $field_name $field_type($field_len)$flags";
          if($i != $field_total - 1) $str .= ",";        
         }
        $str .= "\n );";

        // Create database table content
        $rs = $w3->getDBObj()->query("SELECT * FROM ".$table_name);
        while($row = $w3->getDBObj()->fetch($rs,false))
         {
          $str .= "\nINSERT INTO $table_name VALUES (";
          for($i = 0; $i < $field_total; $i++)
           {
            $str .= "  ".$w3->getDBObj()->fieldName($field_rs,$i)."='$row[$i]'";
            if($field_total > 1 && $i == $field_total - 1) $str .= "\n"; else $str .= ", ";
           }
          $str .= ");\n";
         }
        if($j != $table_total - 1) $str .= "\n\n";
       }
     }
    return $str;
   }

  }

?>
