<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Download extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for download section
     return array(
                  'section'                       => WM3_cSECTION_DOWNLOADS,
                  'allowed_section'               => WM3_cSECTION_DOWNLOADS,
                  'allow_category_description'    => true,
                  'allow_subcategory_description' => true,
                  'category_form'                 => 'admin_download_category_form.inc',
                  'search_form'                   => 'admin_download_search_form.inc',
                  'subcategory_form'              => 'admin_download_subcategory_form.inc',
                  'table_categories'              => '_downloads_categories',
                  'table_subcategories'           => '_downloads_subcategories',
                  'table_subcategories_count'     => '_downloads_subcategories',
                  'table_items_count'             => '_downloads',
                  'action_add_category'           => WM3_cACTION_ADD_DOWNLOAD_CATEGORY,
                  'action_show_subcategory'       => WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY,
                  'action_add_subcategory'        => WM3_cACTION_ADD_DOWNLOAD_SUBCATEGORY,
                  'action_disable_category'       => WM3_cACTION_DISABLE_DOWNLOAD_CATEGORY,
                  'action_enable_category'        => WM3_cACTION_ENABLE_DOWNLOAD_CATEGORY,
                  'action_edit_category'          => WM3_cACTION_EDIT_DOWNLOAD_CATEGORY,
                  'action_delete_category'        => WM3_cACTION_DELETE_DOWNLOAD_CATEGORY,
                  'action_show_items'             => WM3_cACTION_SHOW_DOWNLOAD,
                  'action_add_item'               => WM3_cACTION_ADD_DOWNLOAD,
                  'action_disable_subcategory'    => WM3_cACTION_DISABLE_DOWNLOAD_SUBCATEGORY,
                  'action_enable_subcategory'     => WM3_cACTION_ENABLE_DOWNLOAD_SUBCATEGORY,
                  'action_edit_subcategory'       => WM3_cACTION_EDIT_DOWNLOAD_SUBCATEGORY,
                  'action_delete_subcategory'     => WM3_cACTION_DELETE_DOWNLOAD_SUBCATEGORY,
                  'action_search'                 => WM3_cACTION_SHOW_DOWNLOAD,
                  'label_category_list_title'     => 1678,
                  'label_subcategory_add'         => 1663,
                  'label_subcategories_count'     => 1051,
                  'label_items_count'             => 1108,
                  'label_item_add'                => 661,				  
                  'extra_button_action'           => WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,
				  'extra_button_icon'             => 'action_up.png',
				  'extra_button_label'            => 1216);
    }

   public static function getDownloadFieldsArray()
    { // TODO update_ts ???
     return array('downloadID','subcategoryID','name','source','download_from_local','download','download_from_remote','hits','download_from_external','render_mode','description',
                  'enabled','languageID','ts',
                  'votes_counts','votes_sum','votes_average');
    }

   public static function getDownloadPictureFieldsArray()
    { // TODO update_ts ???
     //return array('pictureID','downloadID','picture','thumbnail','description','enabled','languageID','ts','categoryID','subcategoryID');
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Download page content
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_DOWNLOAD:
        {
         return wm3Download::getDownloadList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_DOWNLOAD:
        {
         return wm3Download::renderDownload($w3);
         break;
        }
       case WM3_cACTION_GET_FILE_DOWNLOAD:
        {
		 wm3Download::hitDownload($w3);
         return wm3Download::getDownloadFile($w3);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::getDownloadSubcategoryList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING:
        {
         /*return wm3Download::renderDownloadTopRating($w3,"ORDER BY votes_average DESC",1219,true, false,false)."<br><br>".
		        wm3Download::renderDownloadTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true, false)."<br><br>".
				wm3Download::renderDownloadTopRating($w3,"ORDER BY votes_counts DESC" ,1221,false,false,true);*/
		 return wm3Download::renderDownloadTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true, false);
         break;
        }
       default:
        {
         return wm3Download::getDownloadCategoryList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_DOWNLOAD_CATEGORY:
        {
         return wm3Download::addDownloadCategory($w3);
         break;
        }
       case WM3_cACTION_EDIT_DOWNLOAD_CATEGORY:
        {
         return wm3Download::editDownloadCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_DOWNLOAD_CATEGORY:
        {
         wm3Download::disableDownloadCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Download::getDownloadCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DOWNLOAD_CATEGORY:
        {
         wm3Download::enableDownloadCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Download::getDownloadCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DOWNLOAD_CATEGORY:
        {
         wm3Download::deleteDownloadCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Download::getDownloadCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::addDownloadSubcategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_DOWNLOAD_SUBCATEGORY:
        {
         wm3Download::disableDownloadSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Download::getDownloadSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DOWNLOAD_SUBCATEGORY:
        {
         wm3Download::enableDownloadSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Download::getDownloadSubcategoryList($w3,$w3->getVariable('subcategoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DOWNLOAD_SUBCATEGORY:
        {
         wm3Download::deleteDownloadSubcategory($w3,$w3->getVariable('subcategoryID','get'));
         return wm3Download::getDownloadSubcategoryList($w3);
         break;
        }
       case WM3_cACTION_EDIT_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::editDownloadSubcategory($w3);
         break;
        }
       case WM3_cACTION_ADD_DOWNLOAD:
        {
         return wm3Download::addDownload($w3);
         break;
        }
       case WM3_cACTION_SAVE_DOWNLOAD:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads               WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
         $error = wm3Download::checkDownloadError($w3);
         if(!$error) {
                      $lastID = wm3Download::saveDownload($w3);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Download::getDownloadList($w3,$lastID);
                     }
         else        {
			          $w3->getDBObj()->query("UNLOCK TABLES");
			          return wm3Download::addDownload($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_EDIT_DOWNLOAD:
        {
         return wm3Download::editDownload($w3);
         break;
        }
       case WM3_cACTION_UPDATE_DOWNLOAD:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads               WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
									   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
         $error = wm3Download::checkDownloadError($w3);
         if(!$error) {
                      $lastID = wm3Download::updateDownload($w3);
           			  $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3Download::getDownloadList($w3,$lastID);
                     }
         else        {
			          $w3->getDBObj()->query("UNLOCK TABLES");
			          return wm3Download::editDownload($w3,$error);
				     }
         break;
        }
       case WM3_cACTION_DISABLE_DOWNLOAD:
        {
         wm3Download::disableDownload($w3,$w3->getVariable('downloadID','get'));
         return wm3Download::getDownloadList($w3,$w3->getVariable('downloadID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_DOWNLOAD:
        {
         wm3Download::enableDownload($w3,$w3->getVariable('downloadID','get'));
         return wm3Download::getDownloadList($w3,$w3->getVariable('downloadID','get'));
         break;
        }
       case WM3_cACTION_DELETE_DOWNLOAD:
        {
         wm3Download::deleteDownload($w3,$w3->getVariable('downloadID','get'));
         return wm3Download::getDownloadList($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_DOWNLOAD:
        {
         $lastID = wm3Download::duplicateDownload($w3);
         return wm3Download::getDownloadList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD:
        {
         return wm3Download::getDownloadList($w3);
         break;
        }
       case WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY:
        {
         return wm3Download::getDownloadSubcategoryList($w3);
         break;
        }
       default:
        {
         return wm3Download::getDownloadCategoryList($w3);
        }
      }     
    }

   public static function getDownloadCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin,false,false,'',false,false,false,false,false,'',true);
    }

   public static function addDownloadCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editDownloadCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function disableDownloadCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableDownloadCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteDownloadCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($w3,$categoryID);
    }

   public static function selectDownloadCategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$all,$admin);
    }

   public static function getDownloadCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($w3,$categoryID);
    }

   public static function getDownloadSubcategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getSubcategoryList($w3,$currentID,$admin,false,false,'',false,false,false,false,true);
    }

   public static function addDownloadSubcategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addSubcategory($w3,$error);
    }

   public static function editDownloadSubcategory($w3,$error = 0) 
    {
     return $w3->getSectionObj()->editSubcategory($w3,$error);
    }

   public static function disableDownloadSubcategory($w3,$subcategoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories SET enabled = '".WM3_cDISABLED."' WHERE subcategoryID = '$subcategoryID'");
    }

   public static function enableDownloadSubcategory($w3,$subcategoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories SET enabled = '".WM3_cENABLED."' WHERE subcategoryID = '$subcategoryID'");
    }
   
   public static function deleteDownloadSubcategory($w3,$subcategoryID)
    {
     $w3->getSectionObj()->deleteSubcategory($w3,$subcategoryID);
    }

   public static function getDownloadSubcategoryName($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getSubcategoryName($w3,$subcategoryID);
    }

   public static function selectDownloadSubcategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$all,$admin);
   	}

   public static function getDownloadCategoryID($w3,$subcategoryID)
    {
     return $w3->getSectionObj()->getCategoryID($w3,$subcategoryID);
    }

   public static function getDownloadList($w3,$currentID = 0,$admin = true)
    {
     // Get downloads list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
     $subcategoryID = $w3->getVariable('subcategoryID');
     if($subcategoryID && !$categoryID) // When make a search take only subcategoryID (but need also categoryID)
      $categoryID = wm3Download::getDownloadCategoryID($w3,$subcategoryID);
     if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.description LIKE '%$filter%'";
     	         }
     else        { if(!$subcategoryID) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
     $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_downloads.description DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'downloadID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&downloadID=$row->downloadID";
	   $description = wm3Util::renderContent($w3,$row->description,$row->render_mode);
       if($allowed) $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
       if($subcategoryID) {
                           if($admin) $_DATA[$p]->title = "<a href=\"".wm3Download::makeDownloadDirectLink($w3,$row)."\">$row->name</a><br><br><i>$description</i>";
				           else       $_DATA[$p]->title = "<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD.">$row->name</a> ($row->hits downloads)<br><br><i>$description</i><div align=\"right\">".wm3Util::actionButton("$link$page_link&action=".WM3_cACTION_GET_FILE_DOWNLOAD,"action_down.png","","",$w3->getWord(1087),0,16,16)." </div>";
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           $_DATA[$p]->title = "<a href=\"".wm3Download::makeDownloadDirectLink($w3,$row)."\">$row->name</a><br><i>$description</i><br>(".$w3->getWord(659)."
                           	                               <a href=\"".$base_link."&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID))."</a>
                           	                               $_PSEP <a href=\"".$base_link.$search_link."&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$row->subcategoryID)."</a>)";
									  }
                           else       {
							           $_DATA[$p]->title = "<a href=$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&subcategoryID=$row->subcategoryID&downloadID=$row->downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD.">$row->name</a><br>(".$w3->getWord(659)."
                           	                               <a href=\"$base_link$page_link&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID)."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->subcategoryID))."</a>
                           	                               $_PSEP <a href=\"$base_link$search_link$page_link&subcategoryID=$row->subcategoryID&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$row->subcategoryID)."</a>)";
									  }
                          }
       if($admin)
        {
		 $file_size = wm3Folder::renderFileSize($w3,@filesize(wm3Download::makeDownloadDirectLink($w3,$row)),$w3->getWord(1075));
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag."<br><a href=\"".wm3Download::makeDownloadDirectLink($w3,$row)."\">$row->download</a> ($row->hits downloads)<br>$file_size";
         $_DATA[$p]->info = $info;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_DOWNLOAD,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_DOWNLOAD,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_DOWNLOAD,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_DOWNLOAD,"action_delete.png",$w3->getWord(179),$w3->getWord(772));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
        }
       if($row->downloadID == $currentID && !$found) {  $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE.'admin_download_search_form.inc');
     $list->setTotalItems($total_items);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1678)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");
     if($subcategoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$page_link."&categoryID=$categoryID&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)." ($total_items)</a>");
       if($admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_DOWNLOAD,"action_add.png","","",$w3->getWord(661),0,16,16));
      }
	 if(!$admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $list->setSearchForm($search_form);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) {
		         if($found) $list->setCurrentID($currentID);
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_DOWNLOAD.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(50,50));
                 $list->setCaptionColspan(array(1,1,4));
                 $list->setWidths(array(50,50));
			    }
     else       {
		         $list->setRenderCaption(false);
		         $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD.$id_link.$search_link);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function checkDownloadError($w3)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray());

     if($_FIELD['name']=='') return 7;
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       $aux = time()."_".rand(1,99999); // Avoid overwritting the files
       // Upload the file and give the name to the files
       if($_FILES['download_from_local']['name']) $download_name = $aux.".".wm3Util::cutExtension($_FILES['download_from_local']['name']);
       else                                       $download_name = "";
       $error = wm3Folder::uploadFile("download_from_local",WM3_cPATH_DOWNLOADS,$download_name,true,wm3Folder::mimeTypeApplicationDocument(),0);
       if($error) return $error;
      }
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL) if(!wm3Util::isUrl($_FIELD['download_from_external']) && !wm3Util::isUrlRelative($_FIELD['download_from_external'])) return 8; // External link
	 if(!$w3->getSectionObj()->existsSubcategory($w3,$_FIELD['subcategoryID'])) return 9;
     return 0; // Take file from remote folder (or no errors)
    }

   public static function addDownload($w3,$error = 0)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray());
	 $action = WM3_cACTION_SAVE_DOWNLOAD;
     require(WM3_cPATH_INCLUDE.'admin_download_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1063));
     $form->setFieldsValues($_FIELD);

     if($error) $form->setError(true);
     switch($error)
      {
       // File upload error
       case 1: // Upload error
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 2: // File not allowed
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 3: // File already exist error
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("File already exists (check overwrite box) $error");
         break;
        }
       case 5: // File too big
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Too big $error");
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }
       // Other errors
       case 7: // Empty name
        {
         $_F['name']->setError(true);
         $form->setTitle($w3->getWord(4));
         break;
        }
       case 8: // Invalid external link
        {
         $_F['download_from_external']->setError(true);
         $form->setTitle("Error invalid url $error");
         break;
        }
       case 9: // Subcategory do not exists
        {
         $_F['subcategoryID']->setError(true);
         $form->setTitle("Invalid subcategory");
         break;
        }
       default:
        {
         // Default values for the form
         $_F['subcategoryID']->setValue($w3->getVariable('subcategoryID','get')); // Take subcategoryID from get
         $_F['enabled']->setValue(WM3_cENABLED);
       	}
      }

     // Operation to do before render the form
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['download_from_local']->setVisible(true);
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_F['download_from_remote']->setVisible(true);
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_F['download_from_external']->setVisible(true);

     return $form->render();
    }

   public static function editDownload($w3,$error = 0)
    {
	 // Initialize form
	 $action = WM3_cACTION_UPDATE_DOWNLOAD;
     require(WM3_cPATH_INCLUDE.'admin_download_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(1077));

     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_downloads
                               WHERE downloadID = '".$w3->getVariable('downloadID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Download::getDownloadFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray());
       $form->setError(true);
      }
     $form->setFieldsValues($_FIELD);

     switch($error)
      {
       // File upload error
       case 1: // Upload error
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 2: // File not allowed
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 3: // File already exist error
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("File already exists (check overwrite box) $error");
         break;
        }
       case 5: // File too big
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Too big $error");
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_F['download_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }
       // Other errors
       case 7: // Empty name
        {
         $_F['name']->setError(true);
         $form->setTitle($w3->getWord(4));
         break;
        }
       case 8: // Invalid external link
        {
         $_F['download_from_external']->setError(true);
         $form->setTitle("Error invalid url $error");
         break;
        }
       case 9: // Subcategory do not exists
        {
         $_F['subcategoryID']->setError(true);
         $form->setTitle("Invalid subcategory");
         break;
        }
       default:
        {
         $_FIELD['download_from_local'] = $_FIELD['download_from_remote'] = $_FIELD['download_from_external'] = '';
         if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_F['download_from_remote']->setValue($_FIELD['download']);
	     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_F['download_from_external']->setValue($_FIELD['download']);
       	}
      }

     // Operation to do before render the form
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['download_from_local']->setVisible(true);
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_F['download_from_remote']->setVisible(true);
	 if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_F['download_from_external']->setVisible(true);

     return $form->render();
    }

   public static function saveDownload($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['download'] = $_FILES['download_from_local']['name'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['download'] = $_FIELD['download_from_remote'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['download'] = $_FIELD['download_from_external'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     $_FIELD['ts'] = time();
     $_FIELD['hits']          = 0;
     $_FIELD['votes_counts']  = 0;
     $_FIELD['votes_sum']     = 0;
     $_FIELD['votes_average'] = 0;
     $w3->getDBObj()->saveAllTableFields('_downloads',$_FIELD,array('download_from_local','download_from_remote','download_from_external'));
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateDownload($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Download::getDownloadFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['download'] = $_FILES['download_from_local']['name'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['download'] = $_FIELD['download_from_remote'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['download'] = $_FIELD['download_from_external'];
     if($_FIELD['source'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // TODO Attenzionare campo categoryID (da togliere ???)
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                             SET   subcategoryID = '".$_FIELD['subcategoryID']."',
                                   name          = '".$_FIELD['name']."',
                                   description   = '".$_FIELD['description']."',
                                   render_mode   = '".$_FIELD['render_mode']."',
                                   download      = '".$_FIELD['download']."',
                                   source        = '".$_FIELD['source']."',
                                   enabled       = '".$_FIELD['enabled']."',
                                   languageID    = '".$_FIELD['languageID']."'
                             WHERE downloadID    = '".$_FIELD['downloadID']."'");
     return $_FIELD['downloadID'];
    }

   public static function duplicateDownload($w3)
    {
     // Take fields from database and duplicate data creating a new row	 
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_downloads               WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories    WRITE");
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_downloads
                                   WHERE downloadID = '".$w3->getVariable('downloadID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Download::getDownloadFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['name']    = $w3->getWord(1417).$_FIELD['name'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts']      = time();
       $_FIELD['hits']          = 0;
       $_FIELD['votes_counts']  = 0;
       $_FIELD['votes_sum']     = 0;
       $_FIELD['votes_average'] = 0;
       $w3->getDBObj()->saveAllTableFields('_downloads',$_FIELD);
	   $w3->getDBObj()->query("UNLOCK TABLES");
       return $w3->getDBObj()->getLastInsertID();
      }
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function disableDownload($w3,$downloadID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads SET enabled = '".WM3_cDISABLED."' WHERE downloadID = '$downloadID'");
    }

   public static function enableDownload($w3,$downloadID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads SET enabled = '".WM3_cENABLED."' WHERE downloadID = '$downloadID'");
    }
   
   public static function deleteDownload($w3,$downloadID)
    {
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_downloads WHERE downloadID = '$downloadID'");
    }

   public static function getDownloadName($w3,$downloadID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_downloads
                             WHERE downloadID = '$downloadID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function selectDownloadSource($w3)
    {
     // Return an array of wm3GUIOption objects for download source select
     return wm3Util::selectArray(array($w3->getWord(1061)."from local drive","from remote folder",$w3->getWord(1062)),
                                 array(WM3_cUPLOAD_FROM_LOCAL,WM3_cUPLOAD_FROM_REMOTE,WM3_cUPLOAD_FROM_URL));
    }

   public static function renderDownload($w3,$admin = false)
    {
     // Show a download item (home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
	 $subcategoryID = $w3->getVariable('subcategoryID');
     $downloadID    = $w3->getVariable('downloadID');
	 if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) $search_link = "&filter=$filter"; else $search_link = '';
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     $pageID = $w3->getVariable('pageID');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
	 $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
			   WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter";
     $rs = $rs_aux = $w3->getDBObj()->query($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_downloads.description DESC"); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." AND ".WM3_cCONFIG_DB_PREFIX."_downloads.downloadID = '$downloadID'");

     // Create item
     $_DATA = $_COLSPAN = $_COLORS = array();
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
       $link = $base_link.$id_link.$search_link.$extra_link;
       if($allowed)
	    {
	     $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
	     $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
        }
       else $button = '';
       $name        = "$button<b>$row->name</b> ($row->hits download from ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage()).")<br><br>";
	   $description = "<i>".wm3Util::renderContent($w3,$row->description,$row->render_mode)."</i>";
	   $byte        = @filesize(wm3Download::makeDownloadDirectLink($w3,$row));
	   $info        = wm3Download::makeDownloadInfo($w3,$byte);
	   $button      = "<div align=\"right\">".wm3Util::actionButton("$link$page_link&downloadID=$row->downloadID&action=".WM3_cACTION_GET_FILE_DOWNLOAD,"action_down.png","","",$w3->getWord(1087),0,16,16)." </div>";
       $_DATA[0]->name        = $name;        $_COLSPAN[0] = array(2);
       $_DATA[1]->description = $description; $_COLSPAN[1] = array(2); $_COLORS[1] = 0;
       $_DATA[2]->info        = $info;        $_COLSPAN[2] = array(2);
       if($byte !== false)
	    {
	     $_56k  = wm3Download::makeDownloadTime($w3,$byte,7000);
	     $_64k  = wm3Download::makeDownloadTime($w3,$byte,8000);
	     $_640k = wm3Download::makeDownloadTime($w3,$byte,80000);
	     $_7m   = wm3Download::makeDownloadTime($w3,$byte,875000);
	     $_20m  = wm3Download::makeDownloadTime($w3,$byte,2500000);	
         $_DATA[3]->label = "Modem 56K"; $_DATA[3]->value = $_56k;
         $_DATA[4]->label = "ISDN 64K";  $_DATA[4]->value = $_64k;
         $_DATA[5]->label = "ADSL 640K"; $_DATA[5]->value = $_640k;
         $_DATA[6]->label = "ADSL 7M";   $_DATA[6]->value = $_7m;
         $_DATA[7]->label = "ADSL 20M";  $_DATA[7]->value = $_20m;
        }
       $c = count($_DATA);
	   $_DATA[$c]->info = $button; $_COLSPAN[$c] = array(2);
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN,$_COLORS);
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     $list->setColumns(2); // Force header to span 2 columns
     require(WM3_cPATH_INCLUDE.'admin_download_search_form.inc');
     $list->setSearchForm($search_form);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1678)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");
     if($categoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)."</a>");
	   if($row) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&downloadID=$downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD."\">".wm3Download::getDownloadName($w3,$downloadID)."</a>");
	   $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     $list->setRenderCaption(false);
     $list->setWidths(array(10,90));
     if($row) {
               $list->setPageNavigatorRS($rs_aux);
               $list->setPageNavigatorField('downloadID');
               $list->setPageNavigatorID($row->downloadID);
               $list->setPagesNavigatorLink($base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD);
		      }
     return $list->render();
    }

   public static function getDownloadFile($w3,$admin = false)
    {
     // Download file (home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
	 $subcategoryID = $w3->getVariable('subcategoryID');
     $downloadID    = $w3->getVariable('downloadID');
	 if($subcategoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID = '$subcategoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) $search_link = "&filter=$filter"; else $search_link = "";
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $pageID = $w3->getVariable('pageID');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FAQ."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
	 $id_link = "&categoryID=$categoryID&subcategoryID=$subcategoryID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
			   WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter";
     $rs = $rs_aux = $w3->getDBObj()->query($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_downloads.description DESC"); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." AND ".WM3_cCONFIG_DB_PREFIX."_downloads.downloadID = '$downloadID'");

     // Create item
     $_DATA = array();
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
       $link = $base_link.$id_link.$search_link.$extra_link;
       if($allowed)
	    {
	     $allowed_link = $base_allowed_link."&downloadID=$row->downloadID";
	     $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
        }
       else $button = '';
       $name    = "$button<b>$row->name</b> ($row->hits download from ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage()).")";
	   $message = $w3->getWord(1102);
	   $button  = $w3->getWord(1103)." ".wm3Util::actionButton(wm3Download::makeDownloadDirectLink($w3,$row),"action_down.png","","",$w3->getWord(1104),0,16,16).wm3Util::metaRefresh(5,wm3Download::makeDownloadDirectLink($w3,$row));
       $_DATA[0]->name    = $name;
	   $_DATA[1]->message = $message;
	   $_DATA[2]->button  = $button;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     require(WM3_cPATH_INCLUDE.'admin_download_search_form.inc');
     $list->setSearchForm($search_form);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1678)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");
     if($categoryID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_SUBCATEGORY."\">".wm3Download::getDownloadCategoryName($w3,$categoryID)."</a>");
       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD."\">".wm3Download::getDownloadSubcategoryName($w3,$subcategoryID)."</a>");
	   if($row) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&downloadID=$downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD."\">".wm3Download::getDownloadName($w3,$downloadID)."</a>");
	   $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_DOWNLOAD_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setWidths(array(100));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function makeDownloadDirectLink($w3,$row)
    {
     // Return direct download link from $row (admin and home side)
     if($row->source == WM3_cUPLOAD_FROM_URL) return $row->download;
	 else                                     return WM3_cPATH_DOWNLOADS."$row->download";
    }

   public static function makeDownloadTime($w3,$byte,$speed)
    {
	 // Make download time informations (admin and home side)
	 $ss = floor($byte/$speed);
	 if($ss <= 300)               $pic = wm3Util::renderImg("misc_timer_fast.png");
	 if($ss > 300 && $ss <= 1200) $pic = wm3Util::renderImg("misc_timer_medium.png");
	 if($ss > 1200)               $pic = wm3Util::renderImg("misc_timer_slow.png");
	 $dd = floor($ss/86400); $ss = $ss - $dd * 86400;
	 $hh = floor($ss/3600);  $ss = $ss - $hh * 3600;
	 $mm = floor($ss/60);    $ss = $ss - $mm * 60;
	 if($ss < 10) $ss = "0".$ss;
	 if($mm < 10) $mm = "0".$mm;
	 if($hh < 10) $hh = "0".$hh;
	 $download_time = "($dd:$hh:$mm:$ss)";
	 return $pic." ".$download_time;
    }

   public static function makeDownloadInfo($w3,$byte)
    {
	 // Make download informations (admin and home side)
	 if($byte !== false)
	  {
	   $size = wm3Folder::renderFileSize($w3,$byte,$w3->getWord(1075));
	   $str = "<br><b>$size</b><br><br>".wm3Util::renderImg("misc_time.png")." ".$w3->getWord(1089)."<br><br>";
	  }
	 else
	  {
	   $str = "<br><b>".$w3->getWord(1075)." unknown</b>"; // Unknown size
	  }
	 return $str;
    }

   public static function renderDownloadTopRating($w3,$order_by,$label,$by_rate,$by_hits,$by_votes,$max_items=15,$admin=false)
    {
     // Get download top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_DOWNLOADS); // Used to enable admin buttons in home stage
     $filter = ''; $categoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_DOWNLOAD."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_DOWNLOADS;
     $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_downloads.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_downloads.languageID='".WM3_cLANGUAGE_ALL."') ";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories,
                      ".WM3_cCONFIG_DB_PREFIX."_downloads
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories.subcategoryID=".WM3_cCONFIG_DB_PREFIX."_downloads.subcategoryID
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $id_link = "&categoryID=".wm3Download::getDownloadCategoryID($w3,$row->subcategoryID)."&subcategoryID=$row->subcategoryID";
       $link  = $base_link.$page_link.$id_link."&downloadID=$row->downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD;
       $n     = ($p+1).".";   
       $title = "<a href=\"$link\">$row->name</a><br><i>".$row->description."</i>";
       if($by_rate)
	    {
	     $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)."</nobr>";
         $value  = "<nobr>($row->votes_average)</nobr>";
	    }
	   else
	    {
         if($by_hits)  $value = "<nobr>$row->hits hits</nobr>";
		 if($by_votes) $value = "<nobr>$row->votes_counts votes</nobr>";
		}
       if($by_rate) {
		             $_DATA[$p]->n      = $n;
		             $_DATA[$p]->title  = $title;
		             $_DATA[$p]->rating = $rating;
		             $_DATA[$p]->value  = $value;
		            }
	   else         {
		             $_DATA[$p]->n     = $n;
		             $_DATA[$p]->title = $title;
		             $_DATA[$p]->value = $value;
	                }
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&downloadID=$row->downloadID&action=".WM3_cACTION_SHOW_SINGLE_DOWNLOAD;
         $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_DOWNLOAD,"action_edit.png",$w3->getWord(178));
        }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
	 $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false); 
     if($by_hits)
	  {
	   require(WM3_cPATH_INCLUDE.'admin_download_search_form.inc');
       $list->setSearchForm($search_form);
       $_SEP = $w3->getSkinObj()->getSeparator();
       $list->setTitle($w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(1678)."</a>");
       $list->setWidths(array(0,85,10,5));
      }
	 else
	  {
	   $list->setTitle($w3->getWord($label));
	   $list->setWidths(array(0,90,10));
	  }
     return $list->render();
    }

   public static function hitDownload($w3)
    {
     $downloadID = $w3->getVariable('downloadID','get');
	 if(!wm3Session::downloadAllowed($w3,$downloadID,WM3_cSESSION_HIT)) return;
	 else wm3Session::downloadProtect($w3,$downloadID,WM3_cSESSION_HIT);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                       SET    hits = hits + 1
                       WHERE  downloadID = '$downloadID'");
    }

   public static function isUsedDownloadFile($w3,$file)
    {
	 // Return true if a picture its used in a row
	 $rs = $w3->getDBObj()->query("SELECT downloadID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_downloads
							 WHERE  download = '$file'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
	 else                                     return true;
    }

  }

?>
