<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Forum extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for forum section
     return array(
                  'section'                    => WM3_cSECTION_FORUMS,
                  'allowed_section'            => WM3_cSECTION_FORUMS,
                  'allow_category_description' => true,
                  'category_form'              => 'admin_forum_category_form.inc',
                  'search_form'                => 'admin_forum_search_form.inc',
                  'table_categories'           => '_forums_categories',
                  'table_subcategories'        => '_forums',
                  'table_subcategories_count'  => '_forums',
                  'action_add_category'        => WM3_cACTION_ADD_FORUM_CATEGORY,
                  'action_show_subcategory'    => WM3_cACTION_SHOW_FORUM,
                  'action_add_subcategory'     => WM3_cACTION_ADD_FORUM,
                  'action_disable_category'    => WM3_cACTION_DISABLE_FORUM_CATEGORY,
                  'action_enable_category'     => WM3_cACTION_ENABLE_FORUM_CATEGORY,
                  'action_edit_category'       => WM3_cACTION_EDIT_FORUM_CATEGORY,
                  'action_delete_category'     => WM3_cACTION_DELETE_FORUM_CATEGORY,
                  'action_search'              => WM3_cACTION_SHOW_FORUM,
                  'label_category_list_title'  => 974,
                  'label_subcategory_add'      => 356,
                  'label_subcategories_count'  => 1757);
    }

   public static function getForumFieldsArray()
    {
     return array('forumID','title','categoryID','topic','userID','expire_days','enabled','languageID',
                  'users_read','visitors_read','users_write','visitors_write','group_open','users_open','visitors_open',
                  'denied_words','ts');
    }

   public static function getForumPostFieldsArray()
    {
     return array('postID','title','render_mode','post',
                  'discussionID','quoteID','locked','forumID','userID','replyID','unlink_quote','enabled','languageID','hits','ts');
    }

   public static function getForumPostReadFieldsArray()
    {
     return array('readID','userID','postID','read_ts');
    }

   public static function getForumPermissionsArray($w3,$forumID = 0)
    {
     // Return forum permissions array
     $_PERMISSIONS = array(
                           'forum_read'              => false,
                           'forum_write_reply'       => false,
                           'forum_open_discussion'   => false,
						   'forum_edit_discussion'   => false,
						   'forum_lock_discussion'   => false,
                           'forum_delete_discussion' => false,
						   'forum_edit_reply'        => false,
						   'forum_delete_reply'      => false						   
                          );
     if($forumID == 0) $forumID = $w3->getVariable('forumID');
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled,
	                                ".WM3_cCONFIG_DB_PREFIX."_forums.*
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_forums,
							        ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_forums.categoryID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums.enabled*".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled='".WM3_cENABLED."'
							   AND  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = '$forumID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return $_PERMISSIONS;
     $row = $w3->getDBObj()->fetch($rs); 

	 // Set visitors permissions (no user logged)
     $_PERMISSIONS['forum_read']              = $row->visitors_read;
     $_PERMISSIONS['forum_write_reply']       = $row->visitors_write;
     $_PERMISSIONS['forum_open_discussion']   = $row->visitors_open;
	 $_PERMISSIONS['forum_edit_discussion']   = false;
	 $_PERMISSIONS['forum_lock_discussion']   = false;
     $_PERMISSIONS['forum_delete_discussion'] = false;
	 $_PERMISSIONS['forum_edit_reply']        = false;
	 $_PERMISSIONS['forum_delete_reply']      = false;

     // Set user or administrator permissions (user or administrator logged)
     if($w3->getAuthenticateAdminUserID())
      {
       $_PERMISSIONS['forum_read']              = $row->users_read;
       $_PERMISSIONS['forum_write_reply']       = $row->users_write;
       $_PERMISSIONS['forum_open_discussion']   = $row->users_open;

	   // If logged user/administrator group its the same of moderator group
       if(wm3User::getGroupID($w3,$w3->getAuthenticateAdminUserID()) == wm3User::getGroupID($w3,$row->userID))
	    {
         $_PERMISSIONS['forum_read']              = true;
         $_PERMISSIONS['forum_write_reply']       = true;
         $_PERMISSIONS['forum_open_discussion']   = $row->group_open;
	    }
	   // If logged user/administrator its moderator
       if($w3->getAuthenticateAdminUserID() == $row->userID)
	    {
         $_PERMISSIONS['forum_read']              = true;
         $_PERMISSIONS['forum_write_reply']       = true;
         $_PERMISSIONS['forum_open_discussion']   = true;
	     $_PERMISSIONS['forum_edit_discussion']   = true;
		 $_PERMISSIONS['forum_lock_discussion']   = true;
         $_PERMISSIONS['forum_delete_discussion'] = true;
    	 $_PERMISSIONS['forum_edit_reply']        = true;
	     $_PERMISSIONS['forum_delete_reply']      = true;
	    }
	   // If administrator can manage forums (and manage users ??? TODO poichè se gestisce gli utenti puo' mettersi il permesso di gestire il forum)
       if(wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS))
	    {
         $_PERMISSIONS['forum_read']              = true;
         $_PERMISSIONS['forum_write_reply']       = true;
         $_PERMISSIONS['forum_open_discussion']   = true;
         $_PERMISSIONS['forum_edit_discussion']   = true;		 		 
		 $_PERMISSIONS['forum_lock_discussion']   = true;
         $_PERMISSIONS['forum_delete_discussion'] = true;
    	 $_PERMISSIONS['forum_edit_reply']        = true;
	     $_PERMISSIONS['forum_delete_reply']      = true;
		}
      }
     return $_PERMISSIONS;
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // Forum page content
     $_PERMISSIONS = wm3Forum::getForumPermissionsArray($w3); // Get forum permissions
	 wm3Forum::expireForumDiscussions($w3); // Expire old discussions
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FORUM_QUOTE:
        {
		 // Check if an user try to quote in an invalid forumID/postID
	     if($w3->getVariable('postID') == $w3->getVariable('quoteID')) $postID = 0; // Try to quote a discussion
	     else  $postID = $w3->getVariable('postID');
	     $check = wm3Forum::existsForumReply($w3,$w3->getVariable('forumID'),$postID,$w3->getVariable('quoteID'));

         if($_PERMISSIONS['forum_write_reply'] && $check && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID'))) return wm3Forum::addForumQuote($w3,$_PERMISSIONS);
         else                                                                                                                   return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_ADD_FORUM_REPLY:
        {
         if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID'))) return wm3Forum::addForumReply($w3,$_PERMISSIONS);
         else                                                                                                         return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_EDIT_FORUM_REPLY:
        {
         if($_PERMISSIONS['forum_write_reply'] && $_PERMISSIONS['forum_edit_reply']) return wm3Forum::editForumReply($w3,$_PERMISSIONS);
         else                                                                        return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_DELETE_FORUM_REPLY:
	    {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_delete_reply'])
		  {
           wm3Forum::deleteForumReply($w3,$w3->getVariable('replyID'));
           return wm3Forum::renderForumReplies($w3,0,$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
		}
       case WM3_cACTION_ADD_FORUM_DISCUSSION:
        {
         if($_PERMISSIONS['forum_open_discussion']) return wm3Forum::addForumDiscussion($w3,$_PERMISSIONS);
         else                                       return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_EDIT_FORUM_DISCUSSION:
        {
         if($_PERMISSIONS['forum_open_discussion'] && $_PERMISSIONS['forum_edit_discussion']) return wm3Forum::editForumDiscussion($w3,$_PERMISSIONS);
         else                                                                                 return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_LOCK_FORUM_DISCUSSION:
        {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_lock_discussion'])
		  {
           wm3Forum::lockForumDiscussion($w3,$w3->getVariable('postID'));
           return wm3Forum::renderForumDiscussions($w3,$w3->getVariable('postID'),$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_UNLOCK_FORUM_DISCUSSION:
	    {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_lock_discussion'])
		  {
           wm3Forum::unlockForumDiscussion($w3,$w3->getVariable('postID'));
           return wm3Forum::renderForumDiscussions($w3,$w3->getVariable('postID'),$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
		}
       case WM3_cACTION_DELETE_FORUM_DISCUSSION:
	    {
		 if($_PERMISSIONS['forum_read'] && $_PERMISSIONS['forum_delete_discussion'])
		  {
           wm3Forum::deleteForumDiscussion($w3,$w3->getVariable('postID'));
           return wm3Forum::renderForumDiscussions($w3,0,$_PERMISSIONS);
	      }
		 else return wm3Forum::renderForumDenied($w3);
         break;
		}
       case WM3_cACTION_SHOW_FORUM_REPLIES:
        {
         if($_PERMISSIONS['forum_read']) return wm3Forum::renderForumReplies($w3,$w3->getVariable('replyID'),$_PERMISSIONS);
         else                            return wm3Forum::renderForumDenied($w3);
         break;
        }
       case WM3_cACTION_SHOW_FORUM_DISCUSSIONS:
        {
         if($_PERMISSIONS['forum_read']) return wm3Forum::renderForumDiscussions($w3,0,$_PERMISSIONS);
         else                            return wm3Forum::renderForumDenied($w3);
         break;
        }
	   case WM3_cACTION_SEARCH_FORUM:
        {
         return wm3Forum::renderForumSearch($w3,0,$_PERMISSIONS);
         break;
        }	
       default:
        {
         return wm3Forum::renderForumCompleteList($w3);
        }
      }
    }

   public static function executeUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FORUM:
        {
         return wm3Forum::addForum($w3,true);
         break;
        }
       case WM3_cACTION_EDIT_FORUM:
        {
         return wm3Forum::editForum($w3,true);
         break;
        }
       case WM3_cACTION_DISABLE_FORUM:
        {
         wm3Forum::disableForum($w3,$w3->getVariable('forumID','get'),true);
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'),true,true);
         break;
        }
       case WM3_cACTION_ENABLE_FORUM:
        {
         wm3Forum::enableForum($w3,$w3->getVariable('forumID','get'),true);
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'),true,true);
         break;
        }
       case WM3_cACTION_DELETE_FORUM:
        {
         wm3Forum::deleteForum($w3,$w3->getVariable('forumID','get'),true);
         return wm3Forum::getForumList($w3,0,true,true);
         break;
        }
       default:
        {
         return wm3Forum::getForumList($w3,0,true,true);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_FORUM_CATEGORY:
        {
         return wm3Forum::addForumCategory($w3);
         break;
        }
       case WM3_cACTION_EDIT_FORUM_CATEGORY:
        {
         return wm3Forum::editForumCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_FORUM_CATEGORY:
        {
         wm3Forum::disableForumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Forum::getForumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_FORUM_CATEGORY:
        {
         wm3Forum::enableForumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Forum::getForumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_FORUM_CATEGORY:
        {
         wm3Forum::deleteForumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3Forum::getForumCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_FORUM:
        {
         return wm3Forum::addForum($w3);
         break;
        }
       case WM3_cACTION_EDIT_FORUM:
        {
         return wm3Forum::editForum($w3);
         break;
        }
       case WM3_cACTION_DISABLE_FORUM:
        {
         wm3Forum::disableForum($w3,$w3->getVariable('forumID','get'));
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_FORUM:
        {
         wm3Forum::enableForum($w3,$w3->getVariable('forumID','get'));
         return wm3Forum::getForumList($w3,$w3->getVariable('forumID','get'));
         break;
        }
       case WM3_cACTION_DELETE_FORUM:
        {
         wm3Forum::deleteForum($w3,$w3->getVariable('forumID','get'));
         return wm3Forum::getForumList($w3);
         break;
        }
       case WM3_cACTION_ADD_CHATROOM:
        {
         return wm3Chatroom::addChatroom($w3);
         break;
        }
       case WM3_cACTION_EDIT_CHATROOM:
        {
         return wm3Chatroom::editChatroom($w3);
         break;
        }
       case WM3_cACTION_DISABLE_CHATROOM:
        {
         wm3Chatroom::disableChatroom($w3,$w3->getVariable('chatroomID','get'));
         return wm3Chatroom::getChatroomList($w3,$w3->getVariable('chatroomID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_CHATROOM:
        {
         wm3Chatroom::enableChatroom($w3,$w3->getVariable('chatroomID','get'));
         return wm3Chatroom::getChatroomList($w3,$w3->getVariable('chatroomID','get'));
         break;
        }
       case WM3_cACTION_DELETE_CHATROOM:
        {
         wm3Chatroom::deleteChatroom($w3,$w3->getVariable('chatroomID','get'));
         return wm3Chatroom::getChatroomList($w3);
         break;
        }
	   case WM3_cACTION_SHOW_CHATROOM:
	    {
		 return wm3Chatroom::getChatroomList($w3);
		 break;
		}
       case WM3_cACTION_SHOW_FORUM:
        {
         return wm3Forum::getForumList($w3);
         break;
        }
       default:
        {
         return wm3Forum::getForumCategoryList($w3);
        }
      }     
    }

   public static function renderForumDenied($w3)
    {
     // Give a denied access message (home side)

     // Prepare variables to create the content
     $forumID = $w3->getVariable('forumID');
     $postID  = $w3->getVariable('postID');
     $pg = $w3->getVariable('pg');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND forumID = '$forumID' AND discussionID = '$postID' OR postID = '$postID'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID');
     $id_link   = "&forumID=$forumID";

     // Create list content
     $_DATA = array();
     $link = $base_link.$id_link.$page_link.$search_link.$extra_link;//."&postID=$row->postID";
     $_DATA[0]->message = "<div align=\"center\"><br><img src=\"".WM3_cPATH_DATA."misc_stop.png\" border=\"0\" width=\"40\" height=\"37\"><br><br><b>Access denied!</b><br><br>You can not perform this action for this forum.</div><br>";

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setRenderPagesNavigator(false);
     $list->setRenderCaption(false);
     $list->setWidths(array(100));
     return wm3Forum::renderForumHeader($w3,$forumID,1,false,'','',true,true).$list->renderBody().$list->renderBottom();
    }

   public static function renderForumCompleteList($w3)
    {
     // Render complete category forum and forum list (for forum page content) 

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $filter       = $w3->getVariable('filter'); // Search field
	 $filter_check = $w3->getVariable('filter_check');
	 $forumID = 0; // Used in search form
     $query_filter = "WHERE enabled='".WM3_cENABLED."' AND (languageID='".$w3->getHomeLanguage()."' OR languageID='".WM3_cLANGUAGE_ALL."')";
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FORUMS;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
	 $page_link = "&pageID=".$w3->getVariable('pageID');
	 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SEARCH_FORUM.$page_link;
     $id_link = '';

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_categories $query_filter";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&categoryID=$row->categoryID";
       if($allowed) $allowed_link = $base_allowed_link."&categoryID=$row->categoryID";
       $icon = "<img src=\"".WM3_cPATH_ICONS."$row->icon\" width=\"36\" height=\"36\" border=\"0\">";
       $name = "$row->name<br>$row->description";
       if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FORUM_CATEGORY,"action_edit.png",$w3->getWord(178)); else $button = '';
       $title = $icon."<br>".$name;
       $_DATA[$p]->content = wm3Forum::renderForumList($w3,$row->categoryID,$title,$button);
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(992));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'home_forum_search_form.inc');
     $list->setSearchForm($search_form);
     $list->setWidths(array(100));
     $list->setUseColors(false);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function renderForumList($w3,$categoryID,$title,$button)
    {
     // Render forums list for a category (for forum page content) 

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $query_filter = "WHERE enabled='".WM3_cENABLED."' AND categoryID='$categoryID' AND (languageID='".$w3->getHomeLanguage()."' OR languageID='".WM3_cLANGUAGE_ALL."')";
     if($allowed) { $columns = 7; $buttons = 1; } else { $columns = 6; $buttons = 0; }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FORUMS;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID','get');
     $id_link = '';

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums $query_filter";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$page_link."&forumID=$row->forumID";
       if($allowed) $allowed_link = $base_allowed_link."&forumID=$row->forumID";
       $icon  = "";//<img src=\"".WM3_cPATH_ICONS."$row->icon\" width=\"36\" height=\"36\" border=\"0\">";
       $forum = "<a href=\"$link&action=".WM3_cACTION_SHOW_FORUM_DISCUSSIONS."\">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a><br>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>Created ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       $discussions = wm3Forum::countForumDiscussions($w3,$row->forumID);
       $replies     = wm3Forum::countForumReplies($w3,$row->forumID);
       $last_discussionID       = wm3Forum::getLastDiscussionID($w3,$row->forumID);
	   $last_replyID            = wm3Forum::getLastForumReplyID($w3,$row->forumID);
	   $last_reply_discussionID = wm3Forum::getLastReplyDiscussionID($w3,$last_replyID);
       $last_discussion = wm3Forum::renderForumPostDate($w3,$last_discussionID);
       $last_reply      = wm3Forum::renderForumPostDate($w3,$last_replyID);
	   if($last_discussion != "-") $last_discussion .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_discussionID)." ".wm3Util::actionButton("$link&postID=$last_discussionID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
       if($last_reply != "-")      $last_reply      .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_replyID)." ".wm3Util::actionButton("$link&postID=$last_reply_discussionID&replyID=$last_replyID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
	   $_DATA[$p]->icon = $icon;
	   $_DATA[$p]->forum = $forum;
	   $_DATA[$p]->discussion = $discussions;
	   $_DATA[$p]->replies = $replies;
	   $_DATA[$p]->last_discussion = $last_discussion;
	   $_DATA[$p]->last_reply = $last_reply;
       if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FORUM,"action_edit.png",$w3->getWord(178));
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$title);
     $list->setSearchForm($button);
     $list->setTotalItems($total_items);
     $list->setCaptionLabels(array($w3->getWord(1261),$w3->getWord(984),$w3->getWord(1329),$w3->getWord(1398),$w3->getWord(1399)));
     $list->setCaptionWidths(array(54,5,5,18,18));
     $list->setCaptionColspan(array(2,1,1,1,1));
     $list->setWidths(array(0,54,5,5,18,18));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function renderForumDiscussions($w3,$currentID,$_PERMISSIONS)
    {
     // Get discussion for a forum (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $buttons = $_PERMISSIONS['forum_edit_discussion'] + $_PERMISSIONS['forum_lock_discussion'] + $_PERMISSIONS['forum_delete_discussion'];
	 $columns = 6 + $buttons;
     $forumID = $w3->getVariable('forumID');
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND forumID='$forumID' AND discussionID = '0'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID');
     $id_link   = "&forumID=$forumID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'postID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $link = $base_link.$page_link.$id_link.$search_link."&postID=$row->postID";
       $replies = wm3Forum::countForumDiscussionReplies($w3,$row->forumID,$row->postID);
	   if($replies >= 25)                                    $hot  = true;  else $hot  = false;
       if($row->locked)                                      $lock = true;  else $lock = false;
	   if(wm3Forum::isForumDiscussionRead($w3,$row->postID)) $new  = false; else $new  = true;
	   $icon       = $w3->getSkinObj()->getForumIcon($hot,$lock,$new);
       $title      = "<a href=\"$link&action=".WM3_cACTION_SHOW_FORUM_REPLIES."\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       $author     = wm3User::getUserLogin($w3,$row->userID); if(!$author) $author = $w3->getWord(988);
       $hits       = $row->hits;
	   $last_replyID = wm3Forum::getLastDiscussionReplyID($w3,$row->postID);
       $last_reply   = wm3Forum::renderForumPostDate($w3,$last_replyID);
       if($last_reply != "-") $last_reply .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_replyID)." ".wm3Util::actionButton("$link&replyID=$last_replyID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
       $_DATA[$p]->icon       = $icon;
       $_DATA[$p]->title      = $title;
       $_DATA[$p]->author     = $author;
       $_DATA[$p]->replies    = $replies;
       $_DATA[$p]->hits       = $hits;
       $_DATA[$p]->last_reply = $last_reply;
       // Buttons
       if($_PERMISSIONS['forum_edit_discussion']) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_DISCUSSION,"action_edit.png",$w3->getWord(178));
       if($_PERMISSIONS['forum_lock_discussion'])
		{
         if($row->locked) $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_UNLOCK_FORUM_DISCUSSION,"action_unlock.png",$w3->getWord(1624));
         else             $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_LOCK_FORUM_DISCUSSION,"action_lock.png",$w3->getWord(1623));
	    }
       if($_PERMISSIONS['forum_delete_discussion']) $_DATA[$p]->b3 = wm3Util::actionButton("$link$extra_link&action=".WM3_cACTION_DELETE_FORUM_DISCUSSION,"action_delete.png",$w3->getWord(179),$w3->getWord(1016));
       if($row->postID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_FORUM_DISCUSSIONS.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(984),$w3->getWord(1328),$w3->getWord(1329),$w3->getWord(1619),$w3->getWord(1399)));
     $list->setCaptionWidths(array(56,15,2,2,25));
     $list->setCaptionColspan(array(2,1,1,1,1,3));
     $list->setWidths(array(0,56,15,2,2,25));
     if($_PERMISSIONS['forum_open_discussion']) $button_discussion = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link."&action=".WM3_cACTION_ADD_FORUM_DISCUSSION,"action_add.png","","",$w3->getWord(1024),0,16,16);
     else                                       $button_discussion = '';
     return wm3Forum::renderForumHeader($w3,$forumID,$columns,false,$button_discussion).$list->renderBody().$list->renderBottom();
    }

   public static function lockForumDiscussion($w3,$postID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET locked = '".WM3_cENABLED."' WHERE postID = '$postID' AND discussionID='0'");
	}

   public static function unlockForumDiscussion($w3,$postID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET locked = '".WM3_cDISABLED."' WHERE postID = '$postID' AND discussionID='0'");
	}

   public static function deleteForumDiscussion($w3,$postID)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
  	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WHERE postID = '$postID'");
 	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE discussionID = '$postID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE postID = '$postID' AND discussionID = '0'");
     $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function renderForumReplies($w3,$currentID,$_PERMISSIONS)
    {
     // Get replies for a discussion in a forum (home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $buttons = $_PERMISSIONS['forum_edit_reply'] + $_PERMISSIONS['forum_delete_reply'];
	 $columns = 6 + $buttons;
     $forumID = $w3->getVariable('forumID');
     $postID  = $w3->getVariable('postID'); if(!$postID) $postID = 0;
     $pg = $w3->getVariable('pg');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)//TODO la ricerca (ed i filtri) qui servono??? si usano???
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND ((forumID = '$forumID' AND discussionID = '$postID') OR (forumID='$forumID' AND postID = '$postID')) AND 0 = (SELECT discussionID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE postID='$postID' AND discussionID = '0') AND $postID > 0";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID');
     $id_link   = "&forumID=$forumID&postID=$postID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'postID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     wm3Forum::setForumDiscussionRead($w3,$postID);
	 wm3Forum::hitForumDiscussion($w3);
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$page_link.$search_link.$extra_link."&replyID=$row->postID";
       if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$postID)) $quote_button = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link.$extra_link."&quoteID=$row->postID&action=".WM3_cACTION_ADD_FORUM_QUOTE,"action_add.png","","",$w3->getWord(1578),0,16,16);
       else                                                                                      $quote_button = '';
       $user_rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
                                    WHERE userID = '$row->userID'");
       if($w3->getDBObj()->totalRows($user_rs) == 1)
        {
         $user_row = $w3->getDBObj()->fetch($user_rs);
         $user_info = wm3Util::renderImg($user_row->avatar,'',36,36,WM3_cPATH_AVATARS,1)."<br>".wm3Util::makeLink(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_USER_INFORMATIONS."&userID=$user_row->userID",$user_row->login);
        }
       else $user_info = wm3Util::renderImg('misc_anonymous.png','',36,36,WM3_cPATH_DATA,1)."<br>".$w3->getWord(988);
       $post_date = wm3Forum::renderForumPostDate($w3,$row->postID);
       if($row->quoteID) $quote_text = wm3Forum::renderForumQuoteText($w3,$row->quoteID);
       else              $quote_text = '';
	   $post = wm3Util::renderContent($w3,$row->post,$row->render_mode);
       if($p == 0) $reply = "<i>$post_date</i> $quote_button<br><br><b>".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</b><br><br>".$quote_text.$post; // Discussion
       else        $reply = "<i>$post_date</i> $quote_button<br><br>".$quote_text.$post;                                                                             // Replies
       $_DATA[$p]->user  = $user_info;
       $_DATA[$p]->reply = $reply;
       // Buttons
       if($row->discussionID != 0) // Normal reply
	    {
         if($_PERMISSIONS['forum_edit_reply'])   $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_REPLY,"action_edit.png",$w3->getWord(178));
         if($_PERMISSIONS['forum_delete_reply']) $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FORUM_REPLY,"action_delete.png",$w3->getWord(179),$w3->getWord(1017));
	    }
	   else // Discussion
	    {
		 if($buttons > 0)
		  {
		   if($_PERMISSIONS['forum_edit_discussion']) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_DISCUSSION,"action_edit.png",$w3->getWord(178));
		   else                                       $_DATA[$p]->b1 = wm3Util::renderImg("action_edit_inactive.png",'',24,24,WM3_cPATH_DATA);
		   if($_PERMISSIONS['forum_delete_discussion']) $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FORUM_DISCUSSION,"action_delete.png",$w3->getWord(179),$w3->getWord(1016));
		   else                                         $_DATA[$p]->b2 = wm3Util::renderImg("action_delete_inactive.png",'',24,24,WM3_cPATH_DATA);
	      }
		}
       if($row->postID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$page_link.$id_link."&action=".WM3_cACTION_SHOW_FORUM_REPLIES.$search_link);
     $list->setCaptionLabels(array($w3->getWord(1328),$w3->getWord(1618)));
     $list->setCaptionWidths(array(0,100));
     $list->setCaptionColspan(array(1,1,2));
     $list->setWidths(array(0,100));
     if($_PERMISSIONS['forum_open_discussion']) $button_discussion = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link.$extra_link."&action=".WM3_cACTION_ADD_FORUM_DISCUSSION,"action_add.png","","",$w3->getWord(1024),0,16,16);
     else                                       $button_discussion = '';
     if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$postID)) $button_reply = wm3Util::actionButton($base_link.$id_link.$page_link.$search_link.$extra_link."&action=".WM3_cACTION_ADD_FORUM_REPLY,"action_add.png","","",$w3->getWord(1025),0,16,16);
     else                                                                                      $button_reply = '';
     return wm3Forum::renderForumHeader($w3,$forumID,$columns,false,$button_discussion,$button_reply).$list->renderBody().$list->renderBottom();
    }

   public static function renderForumSearch($w3,$currentID,$_PERMISSIONS)
    {
     // Render a forum search (home side)

     // Prepare variables to create the list
     $max_page_items = 12; $columns = 9;
     $forumID = $w3->getVariable('forumID');
     $pg = $w3->getVariable('pg');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     $filter       = $w3->getVariable('filter'); // Search field
	 $filter_check = $w3->getVariable('filter_check');
     if($filter)
      {
       $search_link = "&filter=$filter";   
       $query_filter = " AND (".WM3_cCONFIG_DB_PREFIX."_forums_posts.title LIKE '%$filter%' OR post LIKE '%$filter%')";
	   if($filter_check)
	    {
		 $search_link  .= "&filter_check=$filter_check";
		 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '0' ";
		}
      }
     else { $search_link = ''; $query_filter = " AND 1 = 0 "; }
	 if($forumID) $query_filter .= "AND ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = '$forumID'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID');
     $id_link   = "&forumID=$forumID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts DESC";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled,
	                  ".WM3_cCONFIG_DB_PREFIX."_forums.enabled,
	                  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.*
	           FROM   ".WM3_cCONFIG_DB_PREFIX."_forums_categories,
			          ".WM3_cCONFIG_DB_PREFIX."_forums,
					  ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	           WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_forums.categoryID
			     AND  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID
				 AND  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled*".WM3_cCONFIG_DB_PREFIX."_forums.enabled*".WM3_cCONFIG_DB_PREFIX."_forums_posts.enabled='".WM3_cENABLED."'
				 AND  (".WM3_cCONFIG_DB_PREFIX."_forums.languageID = '".WM3_cLANGUAGE_ALL."'
				  OR   ".WM3_cCONFIG_DB_PREFIX."_forums.languageID = '".$w3->getHomeLanguage()."')
				 AND  (".WM3_cCONFIG_DB_PREFIX."_forums_categories.languageID = '".WM3_cLANGUAGE_ALL."'
				  OR   ".WM3_cCONFIG_DB_PREFIX."_forums_categories.languageID = '".$w3->getHomeLanguage()."')
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'postID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $link = $base_link.$page_link.$id_link."&forumID=$row->forumID"."&postID=$row->postID";
       if(!$forumID) $_PERMISSIONS = wm3Forum::getForumPermissionsArray($w3,$row->forumID);
       if($_PERMISSIONS['forum_read'])
	    {
         if($row->discussionID == 0) // Show a discussion
	      {
           $replies = wm3Forum::countForumDiscussionReplies($w3,$row->forumID,$row->postID);
	       if($replies >= 25)                                    $hot  = true;  else $hot  = false;
           if($row->locked)                                      $lock = true;  else $lock = false;
	       if(wm3Forum::isForumDiscussionRead($w3,$row->postID)) $new  = false; else $new  = true;
	       $icon       = $w3->getSkinObj()->getForumIcon($hot,$lock,$new);
           $post       = "<a href=\"$link&action=".WM3_cACTION_SHOW_FORUM_REPLIES."\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a><br>".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
           $hits       = $row->hits;
	       $last_replyID = wm3Forum::getLastDiscussionReplyID($w3,$row->postID);
           $last_reply   = wm3Forum::renderForumPostDate($w3,$last_replyID);
           if($last_reply != "-") $last_reply .= "<br><nobr>[".wm3Forum::renderUserPostID($w3,$last_replyID)." ".wm3Util::actionButton("$link&replyID=$last_replyID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]</nobr>";
	      }
	     else // Show a normal post
	      {
		   $icon = '';
		   $replies = $title = $hits = $last_reply = "-";
		   $post = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage())."[".wm3Util::actionButton("$link&postID=$row->discussionID&replyID=$row->postID&action=".WM3_cACTION_SHOW_FORUM_REPLIES,"misc_go.png",$w3->getWord(366),'','',0,14,14)."]<br><br>".wm3Util::renderContent($w3,$row->post,$row->render_mode);
          }
		 $author = wm3User::getUserLogin($w3,$row->userID); if(!$author) $author = $w3->getWord(988);
	    }
	   else
	    {
		 $icon = '';
		 $author = $replies = $hits = $last_reply = "-";
		 $post = wm3Util::renderImg("misc_error_mini.png")." You can not read this post<br><br>";
		}
       $_DATA[$p]->icon       = $icon;
       $_DATA[$p]->post       = $post;
       $_DATA[$p]->author     = $author;
       $_DATA[$p]->replies    = $replies;
       $_DATA[$p]->hits       = $hits;
       $_DATA[$p]->last_reply = $last_reply;
       // Buttons
       if($row->discussionID == 0)
	    {
         if($_PERMISSIONS['forum_lock_discussion'])
	      {
           if($row->locked) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_UNLOCK_FORUM_DISCUSSION,"action_unlock.png",$w3->getWord(1624));
           else             $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_LOCK_FORUM_DISCUSSION,"action_lock.png",$w3->getWord(1623));
	      }
		 else $_DATA[$p]->b1 = '';
         if($_PERMISSIONS['forum_edit_discussion'])   $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM_DISCUSSION,"action_edit.png",$w3->getWord(178));                        else $_DATA[$p]->b2 = '';
         if($_PERMISSIONS['forum_delete_discussion']) $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_FORUM_DISCUSSION,"action_delete.png",$w3->getWord(179),$w3->getWord(1016)); else $_DATA[$p]->b3 = '';
	    }
       else
	    {
		 $_DATA[$p]->b1 = '';
	     if($_PERMISSIONS['forum_edit_reply'])   $_DATA[$p]->b2 = wm3Util::actionButton("$link&postID=$row->discussionID&replyID=$row->postID&action=".WM3_cACTION_EDIT_FORUM_REPLY,"action_edit.png",$w3->getWord(178));                        else $_DATA[$p]->b1 = '';
	     if($_PERMISSIONS['forum_delete_reply']) $_DATA[$p]->b3 = wm3Util::actionButton("$link&postID=$row->discussionID&replyID=$row->postID&action=".WM3_cACTION_DELETE_FORUM_REPLY,"action_delete.png",$w3->getWord(179),$w3->getWord(1017)); else $_DATA[$p]->b2 = '';
	    }
       if($row->postID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SEARCH_FORUM.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(984),$w3->getWord(1328),$w3->getWord(1329),$w3->getWord(1619),$w3->getWord(1399)));
     $list->setCaptionWidths(array(56,15,2,2,25));
     $list->setCaptionColspan(array(2,1,1,1,1,3));
     $list->setWidths(array(0,56,15,2,2,25));
     return wm3Forum::renderForumHeader($w3,$forumID,$columns,false,'','',false,true,true,$total_items).$list->renderBody().$list->renderBottom();
    }

   public static function deleteForumReply($w3,$postID)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE postID = '$postID' AND discussionID != '0'");
     $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function addForumQuote($w3,$_PERMISSIONS)
    {
     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID'),1,true);

	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     $_FIELD['pageID']  = $w3->getVariable('pageID');
     $_FIELD['forumID'] = $w3->getVariable('forumID');
     $_FIELD['postID']  = $w3->getVariable('postID');
     $_FIELD['quoteID'] = $w3->getVariable('quoteID');
	 $action = WM3_cACTION_ADD_FORUM_QUOTE;
     require(WM3_cPATH_INCLUDE.'home_forum_quote_form.inc');
     $_F['quote']->setValue(wm3Forum::renderForumQuoteText($w3,$_FIELD['quoteID']));
     $_F['quote']->setEnabled(true);
     $_F['postID']->addValidation(WM3_cVALIDATE_EXISTS_FORUM_DISCUSSION_OR_REPLY,"Invalid discussion or reply",array($_FIELD['forumID'],$_FIELD['quoteID'],$w3));
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1578));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['render_mode']->setValue(WM3_cRENDER_MODE_BB_CODE);
      }
     else
      {
       if($form->validate())
        {
         if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID')))
          {
           $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_users             WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $lastID = wm3Forum::saveForumQuote($w3);
           $w3->getDBObj()->query("UNLOCK TABLES");
           return wm3Forum::renderForumReplies($w3,$lastID,$_PERMISSIONS);
		  }
         else return wm3Forum::renderForumDenied($w3);
	    }
      }
     return $str.$form->render();
    }

   public static function saveForumQuote($w3)
    {
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['ts'] = time();
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
       $_FIELD['userID']       = $w3->getAuthenticateAdminUserID();
       $_FIELD['discussionID'] = $_FIELD['postID'];
       $_FIELD['quoteID']      = $_FIELD['quoteID'];
       $_FIELD['enabled']      = WM3_cENABLED;
       $w3->getDBObj()->saveAllTableFields('_forums_posts',$_FIELD,array('replyID','unlink_quote'));
       
       // Send notice mail to all discussion users
       wm3Forum::sendEmailForumReply($w3,$w3->getVariable('postID','post'));
      }
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function addForumReply($w3,$_PERMISSIONS)
    {
     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID'),1,true);

	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     $_FIELD['pageID']  = $w3->getVariable('pageID');
     $_FIELD['forumID'] = $w3->getVariable('forumID');
     $_FIELD['postID']  = $w3->getVariable('postID');
	 $action = WM3_cACTION_ADD_FORUM_REPLY;
     require(WM3_cPATH_INCLUDE.'home_forum_reply_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1025));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['render_mode']->setValue(WM3_cRENDER_MODE_BB_CODE);
      }
     else
      {
       if($form->validate())
        {
         if($_PERMISSIONS['forum_write_reply'] && !wm3Forum::isForumDiscussionLocked($w3,$w3->getVariable('postID')))
          {
           $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_users             WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $lastID = wm3Forum::saveForumReply($w3);
           $w3->getDBObj()->query("UNLOCK TABLES");
           return wm3Forum::renderForumReplies($w3,$lastID,$_PERMISSIONS);
		  }
         else return wm3Forum::renderForumDenied($w3);
	    }
      }
     return $str.$form->render();
    }

   public static function saveForumReply($w3)
    {
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['ts'] = time();
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
       $_FIELD['userID']       = $w3->getAuthenticateAdminUserID();
       $_FIELD['discussionID'] = $_FIELD['postID'];
       $_FIELD['quoteID']      = 0;
       $_FIELD['enabled']      = WM3_cENABLED;
       $w3->getDBObj()->saveAllTableFields('_forums_posts',$_FIELD,array('replyID','unlink_quote'));
       
       // Send notice mail to all discussion users
       wm3Forum::sendEmailForumReply($w3,$w3->getVariable('postID','post'));
      }
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function editForumReply($w3,$_PERMISSIONS)
    {
     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID'),1,true);

	 // Initialize form
	 $action = WM3_cACTION_EDIT_FORUM_REPLY;
	 require(WM3_cPATH_INCLUDE.'home_forum_quote_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit reply");
     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                               WHERE postID = '".$w3->getVariable('replyID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumPostFieldsArray(),$row);

       // Default value for fields not in $row object
	   $_F['unlink_quote']->setValue(WM3_cDISABLED);
       $_F['postID']->addValidation(WM3_cVALIDATE_EXISTS_FORUM_DISCUSSION,"Invalid discussion",array($_FIELD['forumID'],$w3));
       $_FIELD['postID']  = $w3->getVariable('postID');
       $_FIELD['replyID'] = $w3->getVariable('replyID');
	   $_FIELD['quoteID'] = $row->quoteID;
       $_FIELD['pageID']  = $w3->getVariable('pageID');
       if($_FIELD['quoteID'])
        {
         $_F['quote']->setValue(wm3Forum::renderForumQuoteText($w3,$_FIELD['quoteID']));
         $_F['quote']->setEnabled(true);
         $_F['unlink_quote']->setEnabled(true);
        }
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
       $_FIELD['pageID'] = $w3->getVariable('pageID');
       if($_FIELD['quoteID'])
        {
         $_F['quote']->setValue(wm3Forum::renderForumQuoteText($w3,$_FIELD['quoteID']));
         $_F['quote']->setEnabled(true);
         $_F['unlink_quote']->setEnabled(true);
        }
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         if($_PERMISSIONS['forum_write_reply'] && $_PERMISSIONS['forum_edit_reply'])
          {
           $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $lastID = wm3Forum::updateForumReply($w3);
           $w3->getDBObj()->query("UNLOCK TABLES");
           return wm3Forum::renderForumReplies($w3,$lastID,$_PERMISSIONS);
          }
         else return wm3Forum::renderForumDenied($w3);
        }
      }
     return $str.$form->render();
    }

   public static function updateForumReply($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
	 if($_FIELD['unlink_quote']) $quoteID = 0; else $quoteID = $_FIELD['quoteID'];
     if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	    $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	  $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                       SET   post         =  '".$_FIELD['post']."',
                             render_mode  =  '".$_FIELD['render_mode']."',
                             quoteID      =  '$quoteID'
                       WHERE postID       =  '".$_FIELD['replyID']."'
					     AND discussionID != '0'");
     return $_FIELD['replyID'];
    }

   public static function addForumDiscussion($w3,$_PERMISSIONS)
    {
     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID'),1,true);

	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
     $_FIELD['pageID'] = $w3->getVariable('pageID');
     $_FIELD['forumID'] = $w3->getVariable('forumID');
	 $action = WM3_cACTION_ADD_FORUM_DISCUSSION;
     require(WM3_cPATH_INCLUDE.'home_forum_discussion_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1024));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['render_mode']->setValue(WM3_cRENDER_MODE_BB_CODE);
      }
     else
      {
       if($form->validate())
        {
         if($_PERMISSIONS['forum_open_discussion'])
          {
           $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_users             WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
                                           ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $lastID = wm3Forum::saveForumDiscussion($w3);
           $w3->getDBObj()->query("UNLOCK TABLES");
           return wm3Forum::renderForumDiscussions($w3,$lastID,$_PERMISSIONS);
		  }
         else return wm3Forum::renderForumDenied($w3);
	    }
      }
     return $str.$form->render();
    }

   public static function saveForumDiscussion($w3)
    {
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
       $_FIELD['ts'] = time();
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
       $_FIELD['userID']       = $w3->getAuthenticateAdminUserID();
       $_FIELD['discussionID'] = 0;
       $_FIELD['quoteID']      = 0;       
       $_FIELD['enabled']      = WM3_cENABLED;
       $w3->getDBObj()->saveAllTableFields('_forums_posts',$_FIELD,array('replyID','unlink_quote'));

       // Send notice mail to all discussion users
       wm3Forum::sendEmailForumDiscussion($w3,$w3->getVariable('forumID','post'));
      }
     $lastID = $w3->getDBObj()->getLastInsertID();
	 wm3Forum::setForumDiscussionRead($w3,$lastID);
	 return $lastID;
    }

   public static function editForumDiscussion($w3,$_PERMISSIONS)
    {
     // Create forum header
     $str = wm3Forum::renderForumHeader($w3,$w3->getVariable('forumID'),1,true);

	 // Initialize form
	 $action = WM3_cACTION_EDIT_FORUM_DISCUSSION;
	 require(WM3_cPATH_INCLUDE.'home_forum_discussion_form.inc');
	 $_F['postID']->addValidation(WM3_cVALIDATE_IS_FORUM_DISCUSSION,"Invalid discussion",$w3);
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle("Edit forum discussion");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                               WHERE postID = '".$w3->getVariable('postID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumPostFieldsArray(),$row);

       // Default value for fields not in $row object
       $_FIELD['pageID']  = $w3->getVariable('pageID');

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray());
       $_FIELD['pageID'] = $w3->getVariable('pageID');
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         if($_PERMISSIONS['forum_open_discussion'] && $_PERMISSIONS['forum_edit_discussion'])
          {
           $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
		                                 ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions          WRITE,
										 ".WM3_cCONFIG_DB_PREFIX."_sessions_actions  WRITE");
           $lastID = wm3Forum::updateForumDiscussion($w3);
           $w3->getDBObj()->query("UNLOCK TABLES");
           return wm3Forum::renderForumDiscussions($w3,$lastID,$_PERMISSIONS);
          }
         else return wm3Forum::renderForumDenied($w3);
        }
      }
     return $str.$form->render();
    }

   public static function updateForumDiscussion($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	    $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	  $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                   SET   title        = '".$_FIELD['title']."',
                             post         = '".$_FIELD['post']."',
                             render_mode  = '".$_FIELD['render_mode']."'
                       WHERE postID       = '".$_FIELD['postID']."'
					     AND discussionID = '0'");
     return $_FIELD['postID'];
    }

   public static function getForumCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function addForumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editForumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function disableForumCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableForumCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteForumCategory($w3,$categoryID)
    { 
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE categoryID = '$categoryID'");
     while($row = $w3->getDBObj()->fetch($rs))
	  {
	   wm3Forum::deleteForum($w3,$row->forumID);
	  }
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_categories WHERE categoryID = '$categoryID'");
     $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function selectForumCategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$all,$admin);
    }

   public static function getForumCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($w3,$categoryID);
    }

   public static function getForumModerator($w3,$forumID)
    {
     // Get moderetor for $forumID
     $rs = $w3->getDBObj()->query("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE forumID = '$forumID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->userID;
    }

   public static function existsForumReply($w3,$forumID,$discussionID,$replyID)
    {
     // Return true if discussion with postID exists and its a discussion of forumID else return false 
     $rs = $w3->getDBObj()->query("SELECT postID
	                         FROM  ".WM3_cCONFIG_DB_PREFIX."_forums_posts,
							       ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = '$forumID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '$discussionID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID = '$replyID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums.forumID");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                         return false;
    }

   public static function existsForumDiscussion($w3,$forumID,$discussionID)
    {
     // Return true if discussion with postID exists and its a discussion of forumID else return false 
     $rs = $w3->getDBObj()->query("SELECT postID
	                         FROM  ".WM3_cCONFIG_DB_PREFIX."_forums_posts,
							       ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = '$forumID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '0'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID = '$discussionID'
							   AND ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums.forumID");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                         return false;
    }

   public static function existsForum($w3,$forumID)
    {
     // Return true if the forum with forumID exists else return false
     $rs = $w3->getDBObj()->query("SELECT forumID FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE  forumID = '$forumID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                         return false;
    }

   public static function getForumList($w3,$currentID = 0,$admin = true,$user = false)
    {
     // Get forum list (admin,user and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FORUMS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_forums.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_forums.title LIKE '%$filter%'";
     	         }
     else        { if(!$categoryID) if(!$user) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
	             if(!$user) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_FORUM;
	             else       $search_form_link = WM3_cCONFIG_USER_FILE;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_FORUM."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_forums.enabled*".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled='".WM3_cENABLED."' AND (".WM3_cCONFIG_DB_PREFIX."_forums.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."_forums.languageID='".WM3_cLANGUAGE_ALL."')";
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_FORUMS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_forums.title";
	 if(!$user)
	  {
       $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_forums_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_forums.*
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_forums_categories,".WM3_cCONFIG_DB_PREFIX."_forums
                 WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_forums.categoryID
                 $query_filter";
	  }
	 else
	  {
       $query = "SELECT *
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_forums
                 WHERE  userID = '".$w3->getAuthenticateUserID()."'
                 $query_filter";
	  }
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'forumID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&forumID=$row->forumID";
       if($allowed) $allowed_link = $base_allowed_link."&forumID=$row->forumID";
       $moderator   = wm3User::getUserLogin($w3,$row->userID);
       $group       = wm3User::getGroupName($w3,wm3User::getGroupID($w3,$row->userID));
       $permissions = wm3Forum::getForumPermissionsLegend($row);
       if($categoryID) {
                        if($admin) $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>(0 discussions, 0 replies)<p><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i></p>";
                        else       $_DATA[$p]->title = "<a href=$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_FORUM.">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a>(0 discussions, 0 replies)<p><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i></p>";
                       }
       else            {
       	                // For the search in all categories (TODO for the forums)
                        if($admin) 
                         {
						  if(!$user) $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>(".$w3->getWord(659)." <a href=\"".$base_link.$search_link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$row->categoryID)."</a>)";
                          else       $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."<br>(0 discussions, 0 replies)<p><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i></p>";
                         }
                        else $_DATA[$p]->title = "<a href=$link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_SINGLE_FORUM.">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a><br>(".$w3->getWord(659)." <a href=\"".$link.$page_link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$row->categoryID)."</a>)";
                       }
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->permissions = $permissions;
         $_DATA[$p]->info = "$lang_flag (".$w3->getWord(999)." $moderator, group $group)";
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_FORUM,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_FORUM,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_FORUM,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_FORUM,"action_delete.png",$w3->getWord(179),$w3->getWord(997));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_FORUM,"action_edit.png",$w3->getWord(178));
        }
       if($row->forumID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     $list->setTotalItems($total_items);
	 $_SEP  = $w3->getSkinObj()->getSeparator();
     $_PSEP = $w3->getSkinObj()->getPathSeparator();
     require(WM3_cPATH_INCLUDE.'admin_forum_search_form.inc');
     $list->setSearchForm($search_form);
     if($admin)
	  {
	   if(!$user) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(974)."</a>");
	   else       $list->setTitle($w3->getWord(1545));
      }
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(974)."</a>");
     if($categoryID && !$user)
      {
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_FORUM."\">".wm3Forum::getForumCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_FORUM,"action_add.png","","",$w3->getWord(356),0,16,16));
       //else      $list->setTitle($list->getTitle()." $_SEP Make a question TODO".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_ADD_FORUM,"action_down.png","","",$w3->getWord(356),0,16,16));
      }
	 if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) {
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_FORUM.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(2,1,3));
                 $list->setWidths(array(40,30,30));
			    }
     else       {
                 $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_FORUM.$id_link.$search_link);
		         $list->setRenderCaption(false);
                 $list->setWidths(array(50,50));
                }
     return $list->render();
    }

   public static function addForum($w3,$user = false)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray());
	 $action = WM3_cACTION_ADD_FORUM;
     if($user) require(WM3_cPATH_INCLUDE.'user_forum_form.inc');
	 else      require(WM3_cPATH_INCLUDE.'admin_forum_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1453));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['categoryID']->setValue($w3->getVariable('categoryID','get')); // Take categoryID from get
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE");
       if($form->validate())
        {
         if($user) $lastID = wm3Forum::saveForum($w3,true);
         else      $lastID = wm3Forum::saveForum($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         if($user) return wm3Forum::getForumList($w3,$lastID,true,true);
         else      return wm3Forum::getForumList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editForum($w3,$user = false)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_FORUM;
     if($user) require(WM3_cPATH_INCLUDE.'user_forum_form.inc');
	 else      require(WM3_cPATH_INCLUDE.'admin_forum_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(1028));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                               WHERE forumID = '".$w3->getVariable('forumID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_forums_categories WRITE");
       if($form->validate())
        {
         if($user) $lastID = wm3Forum::updateForum($w3,true);
         else      $lastID = wm3Forum::updateForum($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         if($user) return wm3Forum::getForumList($w3,$lastID,true,true);
         else      return wm3Forum::getForumList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function saveForum($w3,$user = false)
    {//TODO controllare dipendenze per i campi group_open, users_read, users_write, users_open, visitors_read, visitors_write, visitors_open (esempio se posso scrivere posso anche leggere)
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
	 if($user) $_FIELD['userID'] = $w3->getAuthenticateUserID();
     $w3->getDBObj()->saveAllTableFields('_forums',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateForum($w3,$user = false)
    {//TODO controllare dipendenze per i campi group_open, users_read, users_write, users_open, visitors_read, visitors_write, visitors_open (esempio se posso scrivere posso anche leggere)
     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumFieldsArray(),WM3_cQUOTE_DB);
	 if($user) $_FIELD['userID'] = $w3->getAuthenticateUserID();
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                       SET   title          = '".$_FIELD['title']."',
                             categoryID     = '".$_FIELD['categoryID']."',
                             topic          = '".$_FIELD['topic']."',
                             userID         = '".$_FIELD['userID']."',
                             expire_days    = '".$_FIELD['expire_days']."',
                             denied_words   = '".$_FIELD['denied_words']."',
                             users_read     = '".$_FIELD['users_read']."',
                             visitors_read  = '".$_FIELD['visitors_read']."',
                             users_write    = '".$_FIELD['users_write']."',
                             visitors_write = '".$_FIELD['visitors_write']."',                             
                             group_open     = '".$_FIELD['group_open']."',
                             users_open     = '".$_FIELD['users_open']."',
                             visitors_open  = '".$_FIELD['visitors_open']."',
                             enabled        = '".$_FIELD['enabled']."',
                             languageID     = '".$_FIELD['languageID']."'
                       WHERE forumID        = '".$_FIELD['forumID']."'");
     return $_FIELD['forumID'];
    }

   public static function selectForum($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$all,$admin,"title","forumID");
    }

   public static function duplicateForum($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums
                             WHERE forumID = '".$w3->getVariable('forumID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Forum::getForumFieldsArray(),$row);
       $_FIELD['title'] = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_forums',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disableForum($w3,$forumID,$user = false)
    {
	 if($user) $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cDISABLED."' WHERE forumID = '$forumID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cDISABLED."' WHERE forumID = '$forumID'");
	}

   public static function enableForum($w3,$forumID,$user = false)
    {
	 if($user) $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cENABLED."' WHERE forumID = '$forumID' AND userID='".$w3->getAuthenticateUserID()."'");
	 else      $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums SET enabled = '".WM3_cENABLED."' WHERE forumID = '$forumID'");
	}
   
   public static function deleteForum($w3,$forumID,$user = false)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts      WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
	 if($user) {
		        $userID = $w3->getAuthenticateUserID();
		        if(wm3Forum::getForumModerator($w3,$forumID) == $userID)
				 {
		          $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
				  while($row = $w3->getDBObj()->fetch($rs))
				   {
				    $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WHERE postID = '$row->postID'");
			       }
		          $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
		          $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE forumID = '$forumID' AND userID='$userID'");
			     }
			   }
	 else      {
		        $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
				while($row = $w3->getDBObj()->fetch($rs))
				 {
				  $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WHERE postID = '$row->postID'");
			     }
		        $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE forumID = '$forumID'");
		        $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE forumID = '$forumID'");
			   }
     $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function selectForumExpireDays($w3)
    {
     // Return an array of wm3GUIOption objects for forum expire days select
     $array = array();
     for($i = 0; $i <= 15; $i++)
      {
       if($i <= 10) $v = $i;
       if($i == 11) $v = 15;
       if($i == 12) $v = 20;
       if($i == 13) $v = 30;
       if($i == 14) $v = 60;
       if($i == 15) $v = 90;
       if($i == 0) $l = $w3->getWord(1003);
       else        if($i == 1) $l = $v." ".$w3->getWord(1005);
                   else        $l = $v." ".$w3->getWord(1006);
       array_push($array,new wm3GUIOption($l,$v));
      }
     return $array;
    }

   public static function getForumPermissionsLegend($row)
    {
     $visitors_permissions = "";
     if($row->visitors_read)  $visitors_permissions .= "read, ";
     if($row->visitors_write) $visitors_permissions .= "write, ";
     if($row->visitors_open)  $visitors_permissions .= "open discussion";
     if($visitors_permissions == "") $visitors_permissions .= "no access";

     $users_permissions = "";
     if($row->users_read)  $users_permissions .= "read, ";
     if($row->users_write) $users_permissions .= "write, ";
     if($row->users_open)  $users_permissions .= "open discussion";
     if($users_permissions == "") $users_permissions .= "no access";

     $group_permissions = "read, write";
     if($row->users_open)  $group_permissions .= ", open discussion";

     $str = "Visitors: $visitors_permissions<br>
             Users: $users_permissions<br>
             Group: $group_permissions";
     return $str;
    }

   public static function renderForumHeader($w3,$forumID,$columns,$bottom = false,$button_discussion = "",$button_reply = "",$no_search_form = false,$no_info = false,$search = false,$total_search_items = 0)
    {
	 $filter = $w3->getVariable('filter'); // Search field
	 $filter_check = $w3->getVariable('filter_check');
     $pageID = $w3->getVariable('pageID');
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=$pageID";
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums WHERE forumID = '$forumID'");
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items == 1) $row = $w3->getDBObj()->fetch($rs);
     $_DATA = $_COLSPAN = array(); $p = 0;
     if(!$no_search_form)
      {
       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SEARCH_FORUM.$page_link;
       require(WM3_cPATH_INCLUDE.'home_forum_search_form.inc');
      }
     $link = $base_link.$page_link;
	 $all_forum = "<a href=\"$link\">".$w3->getWord(992)."</a>";
	 if($total_items == 1)
	  {
       $_PSEP = $w3->getSkinObj()->getPathSeparator();
	   $category_name = " ".$_PSEP." ".wm3Forum::getForumCategoryName($w3,$row->categoryID);
	   $forum_title   = " ".$_PSEP." <a href=\"$link&forumID=$forumID&action=".WM3_cACTION_SHOW_FORUM_DISCUSSIONS."\">".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</a>";
      }
	 else $category_name = $forum_title = '';
     $button = $button_discussion." ".$button_reply;
     if(!$no_info)
	  {
	   $_PERMISSIONS = wm3Forum::getForumPermissionsArray($w3,$forumID);
	   $permissions = ''; $i = 0;
	   foreach($_PERMISSIONS as $key => $value)
	    {
         if($_PERMISSIONS[$key]) $permissions .= " ".$w3->getWord(1694+$i).",";
		 $i++;
        }
	   if(!$permissions) $permissions = $w3->getWord(1010);
	   $you_can = "You can:".rtrim($permissions,',').".";
	   $_DATA[$p]->content = "<b>".wm3Util::renderContent($w3,$row->title,WM3_cRENDER_MODE_PLAIN_TEXT)."</b><br><i>".wm3Util::renderContent($w3,$row->topic,WM3_cRENDER_MODE_PLAIN_TEXT)."</i><br>Creato il ".wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage()).", moderator: <b>".wm3User::getUserLogin($w3,$row->userID)."</b> (group: ".wm3User::getGroupName($w3,wm3User::getGroupID($w3,$row->userID)).")<br>$you_can<br><br>$button";
	   $_COLSPAN[$p] = array($columns); $p++;
      }
	 if($search)
	  {
       $_DATA[$p]->content = "<b>$total_search_items matches for \"".wm3Util::renderContent($w3,$filter,WM3_cRENDER_MODE_PLAIN_TEXT)."\"";
       $_COLSPAN[$p] = array($columns);
      }

     // Render List (header, bottom and an item when needed)
     $list = new wm3GUIList($w3,$_DATA,$all_forum.$category_name.$forum_title,$_COLSPAN);
     if(!$no_search_form) $list->setSearchForm($search_form);
     $list->setWidths(array(100));
     $list->setColumns($columns);
     $str = $list->renderHeader();
     if(!$no_info) $str .= $list->makeItem($_DATA[0],1,false,$_COLSPAN[0]);
     if($bottom)   $str .= $list->renderBottom();
     return $str;
    }

   private static function countForumDiscussions($w3,$forumID)
    {
     // Get the number of discussions for a forum
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_forums_posts","WHERE forumID = '$forumID' AND discussionID = '0'");
     return $total;
    }

   private static function countForumReplies($w3,$forumID)
    {
     // Get the number of replies for a forum
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_forums_posts","WHERE forumID = '$forumID' AND discussionID <> '0'");
     return $total;
    }

   private static function countForumDiscussionReplies($w3,$forumID,$discussionID)
    {
     // Get the number of replies for a single discussion in a forum
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_forums_posts","WHERE forumID = '$forumID' AND discussionID = '$discussionID'");
     return $total;
    }

   private static function renderForumPostDate($w3,$postID)
    {
     // Render the date for a discussion/reply

     $rs = $w3->getDBObj()->query("SELECT ts FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE postID = '$postID'");
     if($w3->getDBObj()->totalRows($rs) == 0) return "-";
     $row = $w3->getDBObj()->fetch($rs);
     return wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
    }

   private static function renderUserPostID($w3,$postID,$link = true)
    {
     // Render user login for a postID
     $rs = $w3->getDBObj()->query("SELECT userID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  postID = '$postID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);
	 $login = wm3User::getUserLogin($w3,$row->userID);
	 if($link && $login) $login = wm3Util::makeLink(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&action=".WM3_cACTION_SHOW_USER_INFORMATIONS."&userID=$row->userID",$login);
	 if(!$login) $login = $w3->getWord(988);
	 return $login;
    }

   private static function getLastReplyDiscussionID($w3,$postID)
    {
     // Get discussionID of a postID
     $rs = $w3->getDBObj()->query("SELECT discussionID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  postID = '$postID' AND discussionID != '0'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->discussionID;
    }

   private static function getLastDiscussionReplyID($w3,$discussionID)
    {
     // Get the last reply postID of discussionID
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  discussionID = '$discussionID'
                             ORDER BY ts DESC LIMIT 0,1");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->postID;
    }

   private static function getLastDiscussionID($w3,$forumID)
    {
     // Get the last discussion postID of forumID
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  forumID = '$forumID' AND discussionID = '0'
                             ORDER BY ts DESC LIMIT 0,1");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->postID;
    }

   private static function getLastForumReplyID($w3,$forumID)
    {
     // Get the last reply postID of forumID
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  forumID = '$forumID' AND discussionID <> '0'
                             ORDER BY ts DESC LIMIT 0,1");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->postID;
    }

   private static function renderForumQuoteText($w3,$postID)
    {
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE postID = '$postID'");
     if($w3->getDBObj()->totalRows($rs) != 1)
      {
       $post   = "???"; // TODO post deleted by moderator or ...???
       $author = "";
      }
     else
      {
       $row = $w3->getDBObj()->fetch($rs);
       $author = wm3User::getUserLogin($w3,$row->userID)." ".$w3->getWord(1588)."<br>";
       if(!$author) $author = $w3->getWord(988);
	   $post = wm3Util::renderContent($w3,$row->post,$row->render_mode);
      }
     $str = $author;

	 ob_start();
	 $quote_open  = $w3->getSkinObj()->getQuoteOpen();
	 $content     = $post;
	 $quote_close = $w3->getSkinObj()->getQuoteClose();
     require($w3->getSkinObj()->getForumQuote());
     $str .= ob_get_contents();
	 ob_end_clean();

     return $str;
    }

   private static function isForumDiscussionRead($w3,$postID)
    {
	 if(!$w3->getAuthenticateAdminUserID()) return true; // No user logged

     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                             WHERE  postID = '$postID' AND userID = '".$w3->getAuthenticateAdminUserID()."'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false; // Not jet readed

     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                             WHERE  postID = '$postID'
							   AND  userID = '".$w3->getAuthenticateAdminUserID()."'
							   AND  read_ts < (SELECT MAX(ts) AS max
							                   FROM   ".WM3_cCONFIG_DB_PREFIX."_forums_posts
											   WHERE  discussionID = '$postID'
											      OR (discussionID = '0' AND postID = '$postID')
											  )");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     else                         return false;
	}

   private static function isForumDiscussionLocked($w3,$postID)
    {
     $rs = $w3->getDBObj()->query("SELECT locked FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  discussionID = '0' AND postID = '$postID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return true;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->locked;
	}

   public static function isForumDiscussion($w3,$postID)
    {
     $rs = $w3->getDBObj()->query("SELECT discussionID FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  discussionID = '0' AND postID = '$postID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
     else                         return false;
	}

   public static function hitForumDiscussion($w3)
    {
     $discussionID = $w3->getVariable('postID');
	 if(!wm3Session::forumPostAllowed($w3,$discussionID,WM3_cSESSION_HIT)) return;
	 else wm3Session::forumPostProtect($w3,$discussionID,WM3_cSESSION_HIT);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                       SET    hits         = hits + 1
                       WHERE  postID       = '$discussionID'
					     AND  discussionID = '0'");
    }

   private static function setForumDiscussionRead($w3,$postID)
    {
	 $userID = $w3->getAuthenticateAdminUserID();
	 if($userID && $postID != 0)
	  {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read WRITE");
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                               WHERE  postID = '$postID' AND userID = '$userID'");
       if($w3->getDBObj()->totalRows($rs) != 1) // Readed for first time
        {
	     $_FIELD = webmatic3::getPostValueArray(wm3Forum::getForumPostReadFieldsArray(),WM3_cQUOTE_DB);
	     $_FIELD['userID']  = $userID;
	     $_FIELD['postID']  = $postID;
         $_FIELD['read_ts'] = time();
         $w3->getDBObj()->saveAllTableFields('_forums_posts_read',$_FIELD);
	    }
	   else // Post already readed in the past ("read_ts" need to update)
	    {
		 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                           SET    read_ts = '".time()."'
			 		       WHERE  postID  = '$postID' AND userID = '$userID'");
        }
	   $w3->getDBObj()->query("UNLOCK TABLES");
	  }
	}

   public static function expireForumDiscussions($w3)
    {
	 // Remove all the discussions with more then "expire_days" days of inactivity
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_forums       WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_forums_posts WRITE");
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_forums.expire_days * 86400 AS expire_days,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts.ts
				             FROM   ".WM3_cCONFIG_DB_PREFIX."_forums,
				                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '0'
			   		           AND  ".WM3_cCONFIG_DB_PREFIX."_forums.expire_days != '0'");
      $ts = time();
      while($row = $w3->getDBObj()->fetch($rs))
       {
		// Get last reply ts
        $rs_last = $w3->getDBObj()->query("SELECT ts FROM ".WM3_cCONFIG_DB_PREFIX."_forums_posts WHERE discussionID = '$row->postID' ORDER BY ts DESC LIMIT 0,1");
		if($w3->getDBObj()->totalRows($rs_last) != 1) $last_ts = $row->ts;
		else
		 {
		  $row_last = $w3->getDBObj()->fetch($rs_last);
          $last_ts = $row_last->ts;
	     }
		$end_ts = $last_ts+$row->expire_days;
		// Delete discussion if last discussion post was written $row->expire_days ago
		if($end_ts <= $ts) wm3Forum::deleteForumDiscussion($w3,$row->postID);
       }
     $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function sendEmailForumDiscussion($w3,$forumID)
    {
	 // Send notice email to forum moderator (except if is the moderator that write the discussion)
	 // TODO controllare bene che funzioni e che la traduzione nelle varie lingue sia ok!
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_forums.title,
	                                ".WM3_cCONFIG_DB_PREFIX."_users.email,
	                                ".WM3_cCONFIG_DB_PREFIX."_users.userID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_forums,
							        ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums.userID = ".WM3_cCONFIG_DB_PREFIX."_users.userID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = '$forumID'");
      $row = $w3->getDBObj()->fetch($rs);
      if($row->userID != $w3->getAuthenticateAdminUserID())
       {
        $discussion_url = "http://".$w3->getPreferences('site_address')."/".WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_PAGES."&pageID=".$w3->getVariable('pageID','post')."&forumID=$forumID&action=".WM3_cACTION_SHOW_FORUM_DISCUSSIONS;
        $sender     = $w3->getPreferences('service_email');
        $subject    = "New discussion for the forum: $row->title (".$w3->getPreferences('site_address').")";
        $email_body = "An user open a new discussion for the forum: $row->title,\nyou can see the new discussion here:\n\n$discussion_url\n";
        @mail($row->email,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
	   }
	}

   public static function sendEmailForumReply($w3,$postID)
    {
	 // Send notice email to all current discussion users (except the logged user)
	 // TODO controllare bene che funzioni e che la traduzione nelle varie lingue sia ok!
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_forums.title AS forum_title,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums.forumID,
                                    ".WM3_cCONFIG_DB_PREFIX."_forums_posts.*,
	                                ".WM3_cCONFIG_DB_PREFIX."_users.email
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_forums,
	                                ".WM3_cCONFIG_DB_PREFIX."_forums_posts,
							        ".WM3_cCONFIG_DB_PREFIX."_users
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.userID = ".WM3_cCONFIG_DB_PREFIX."_users.userID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums.forumID = ".WM3_cCONFIG_DB_PREFIX."_forums_posts.forumID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_forums_posts.userID != '".$w3->getAuthenticateAdminUserID()."'
                               AND  (".WM3_cCONFIG_DB_PREFIX."_forums_posts.discussionID = '$postID' OR ".WM3_cCONFIG_DB_PREFIX."_forums_posts.postID = '$postID')
                             GROUP BY userID");
      while($row = $w3->getDBObj()->fetch($rs))
       {
		$discussion_url = "http://".$w3->getPreferences('site_address')."/".WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_PAGES."&pageID=".$w3->getVariable('pageID','post')."&forumID=$row->forumID&postID=$postID&action=".WM3_cACTION_SHOW_FORUM_REPLIES;
		$sender     = $w3->getPreferences('service_email');
		$subject    = "You received a response from the forum: $row->forum_title (".$w3->getPreferences('site_address').")";
		$email_body = "Someone has replied to your message,\nyou can see your answer here:\n\n$discussion_url\n";
        @mail($row->email,$subject,$email_body,"From: $sender\nX-Mailer: PHP/".phpversion());
       }
	}

  }

?>
