<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Horoscope
  {

   function __construct() { }

   public static function getHoroscopeFieldsArray()
    {
     return array('horoscopeID','render_mode','message','languageID','enabled','p1','p2','p3','p4','p5','p6','p7','p8','ts');
    }

   public static function getQuoteFieldsArray()
    {
     return array('quoteID','languageID','render_mode','quote','author','year','occupation','author_url','enabled','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_QUOTE:
        {
         wm3Horoscope::disableQuote($w3,$w3->getVariable('quoteID','get'));
         return wm3Horoscope::getQuoteList($w3,$w3->getVariable('quoteID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_QUOTE:
        {
         wm3Horoscope::enableQuote($w3,$w3->getVariable('quoteID','get'));
         return wm3Horoscope::getQuoteList($w3,$w3->getVariable('quoteID','get'));
         break;
        }
       case WM3_cACTION_DELETE_QUOTE:
        {
         wm3Horoscope::deleteQuote($w3,$w3->getVariable('quoteID','get'));
         return wm3Horoscope::getQuoteList($w3);
         break;
        }
       case WM3_cACTION_ADD_QUOTE:
        {
         return wm3Horoscope::addQuote($w3);
         break;
        }
       case WM3_cACTION_EDIT_QUOTE:
        {
         return wm3Horoscope::editQuote($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_QUOTE:
        {
         $lastID = wm3Horoscope::duplicateQuote($w3);
         // $msg= quote duplicated... //TODO
         return wm3Horoscope::getQuoteList($w3,$lastID);
         break;
        }
       case WM3_cACTION_DISABLE_HOROSCOPE:
        {
         wm3Horoscope::disableHoroscope($w3,$w3->getVariable('horoscopeID','get'));
         return wm3Horoscope::getHoroscopeList($w3,$w3->getVariable('horoscopeID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_HOROSCOPE:
        {
         wm3Horoscope::enableHoroscope($w3,$w3->getVariable('horoscopeID','get'));
         return wm3Horoscope::getHoroscopeList($w3,$w3->getVariable('horoscopeID','get'));
         break;
        }
       case WM3_cACTION_DELETE_HOROSCOPE:
        {
         wm3Horoscope::deleteHoroscope($w3,$w3->getVariable('horoscopeID','get'));
         return wm3Horoscope::getHoroscopeList($w3);
         break;
        }
       case WM3_cACTION_ADD_HOROSCOPE:
        {
         return wm3Horoscope::addHoroscope($w3);
         break;
        }
       case WM3_cACTION_EDIT_HOROSCOPE:
        {
         return wm3Horoscope::editHoroscope($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_HOROSCOPE:
        {
         $lastID = wm3Horoscope::duplicateHoroscope($w3);
         // $msg= horoscope duplicated... //TODO
         return wm3Horoscope::getHoroscopeList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_QUOTE:
        {
         return wm3Horoscope::getQuoteList($w3);
         break;
        }
       default:
        {
         return wm3Horoscope::getHoroscopeList($w3);
        }
      }     
    }

   public static function getHoroscopeList($w3,$currentID = 0,$admin = true)
    {
     // Get horoscopes list
	 
     // Prepare variables to create the list	 
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter) { $search_link = "&filter=$filter";
     	           $query_filter = "WHERE message LIKE '%$filter%'"; }
     else        { $search_link = $query_filter = ''; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_horoscopes.message";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'horoscopeID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&horoscopeID=$row->horoscopeID";	
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
	   $info = $lang_flag;
	   $info .= "<br> ".wm3Util::makeStars($w3,$row->p1)."(".$w3->getWord(237).")";
	   $info .= "<br> ".wm3Util::makeStars($w3,$row->p2)."(".$w3->getWord(238).")";
	   $info .= "<br> ".wm3Util::makeStars($w3,$row->p3)."(".$w3->getWord(239).")";
	   $info .= "<br> ".wm3Util::makeStars($w3,$row->p4)."(".$w3->getWord(240).")";
	   $info .= "<br> ".wm3Util::makeStars($w3,$row->p5)."(".$w3->getWord(241).")";
       $_DATA[$p]->message = $row->message;
       $_DATA[$p]->info    = $info;
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_HOROSCOPE,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_HOROSCOPE,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_HOROSCOPE,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_HOROSCOPE,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
       $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_HOROSCOPE,"action_delete.png",$w3->getWord(179),$w3->getWord(705));
       if($row->horoscopeID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;       
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(388));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_horoscope_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(228),$w3->getWord(1407)));
     $list->setCaptionWidths(array(60,40));
     $list->setCaptionColspan(array(1,1,4));
     $list->setWidths(array(60,40));
     return $list->render();
    }

   public static function addHoroscope($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getHoroscopeFieldsArray());
	 $action = WM3_cACTION_ADD_HOROSCOPE;
	 require(WM3_cPATH_INCLUDE.'admin_horoscope_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(350));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Horoscope::saveHoroscope($w3);
         return wm3Horoscope::getHoroscopeList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editHoroscope($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_HOROSCOPE;
	 require(WM3_cPATH_INCLUDE.'admin_horoscope_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit horoscope");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes
                               WHERE horoscopeID = '".$w3->getVariable('horoscopeID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Horoscope::getHoroscopeFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getHoroscopeFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Horoscope::updateHoroscope($w3);
         return wm3Horoscope::getHoroscopeList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveHoroscope($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getHoroscopeFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['ts'] = time();
	 $_FIELD['p6'] = $_FIELD['p7'] = $_FIELD['p8'] = '1';
     $w3->getDBObj()->saveAllTableFields('_horoscopes',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateHoroscope($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getHoroscopeFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_horoscopes
                       SET   message     = '".$_FIELD['message']."',
					         render_mode = '".$_FIELD['render_mode']."',
                             enabled     = '".$_FIELD['enabled']."',
							 p1          = '".$_FIELD['p1']."',
							 p2          = '".$_FIELD['p2']."',
							 p3          = '".$_FIELD['p3']."',
							 p4          = '".$_FIELD['p4']."',
							 p5          = '".$_FIELD['p5']."',
							 languageID  = '".$_FIELD['languageID']."'
                       WHERE horoscopeID = '".$_FIELD['horoscopeID']."'");
     return $_FIELD['horoscopeID'];
    }

   public static function duplicateHoroscope($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes
                             WHERE horoscopeID = '".$w3->getVariable('horoscopeID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Horoscope::getHoroscopeFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts']      = time();
       $w3->getDBObj()->saveAllTableFields('_horoscopes',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disableHoroscope($w3,$horoscopeID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_horoscopes SET enabled = '".WM3_cDISABLED."' WHERE horoscopeID = '$horoscopeID'");
    }

   public static function enableHoroscope($w3,$horoscopeID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_horoscopes SET enabled = '".WM3_cENABLED."' WHERE horoscopeID = '$horoscopeID'");
   	}
   
   public static function deleteHoroscope($w3,$horoscopeID)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_horoscopes         WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies WRITE");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies WHERE horoscopeID = '$horoscopeID'");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes WHERE horoscopeID = '$horoscopeID'");
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function getQuoteList($w3,$currentID = 0,$admin = true)
    {
     // Get quotes list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter) { $search_link = "&filter=$filter";
     	           $query_filter = "WHERE quote LIKE '%$filter%'"; }
     else        { $search_link = $query_filter = ''; }
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_QUOTE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ts";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_quotes $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'quoteID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&quoteID=$row->quoteID";	
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
       $info = $lang_flag;
       if($row->author)
        {
         $info .= "<br>";
         if($row->author_url) $info .= "<a href=\"$row->author_url\" target=\"_blank\">".$row->author."</a>";
         else                 $info .= $row->author;
         if($row->year) $info .= " ($row->year)";
         if($row->occupation) $info .= ", ".$row->occupation;
        }
       $_DATA[$p]->quote = wm3Util::renderContent($w3,$row->quote,$row->render_mode);
       $_DATA[$p]->info  = $info;
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_QUOTE,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_QUOTE,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_QUOTE,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_QUOTE,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
       $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_QUOTE,"action_delete.png",$w3->getWord(179),$w3->getWord(1611));
       if($row->quoteID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;       
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1602));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_horoscope_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_QUOTE.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(228),$w3->getWord(1407)));
     $list->setCaptionWidths(array(60,40));
     $list->setCaptionColspan(array(1,1,4));
     $list->setWidths(array(60,40));
     return $list->render();
    }

   public static function addQuote($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getQuoteFieldsArray());
	 $action = WM3_cACTION_ADD_QUOTE;
	 require(WM3_cPATH_INCLUDE.'admin_quote_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1603));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Horoscope::saveQuote($w3);
         return wm3Horoscope::getQuoteList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editQuote($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_QUOTE;
	 require(WM3_cPATH_INCLUDE.'admin_quote_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit quote");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_quotes
                               WHERE quoteID = '".$w3->getVariable('quoteID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Horoscope::getQuoteFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getQuoteFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Horoscope::updateQuote($w3);
         return wm3Horoscope::getQuoteList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveQuote($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getQuoteFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_quotes',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateQuote($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Horoscope::getQuoteFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_quotes
                       SET quote       = '".$_FIELD['quote']."',
				           render_mode = '".$_FIELD['render_mode']."',
                           author      = '".$_FIELD['author']."',
                           year        = '".$_FIELD['year']."',
                           occupation  = '".$_FIELD['occupation']."',
                           author_url  = '".$_FIELD['author_url']."',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE quoteID   = '".$_FIELD['quoteID']."'");
     return $_FIELD['quoteID'];
    }

   public static function duplicateQuote($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_quotes
                             WHERE quoteID = '".$w3->getVariable('quoteID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3Horoscope::getQuoteFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['quote']   = $w3->getWord(1417).$_FIELD['quote'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['ts']      = time();
       $w3->getDBObj()->saveAllTableFields('_quotes',$_FIELD);
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function disableQuote($w3,$quoteID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_quotes SET enabled = '".WM3_cDISABLED."' WHERE quoteID = '$quoteID'");
    }

   public static function enableQuote($w3,$quoteID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_quotes SET enabled = '".WM3_cENABLED."' WHERE quoteID = '$quoteID'");
   	}
   
   public static function deleteQuote($w3,$quoteID)
    {
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_quotes WHERE quoteID = '$quoteID'");
    }

   public static function selectZodiacSign($w3)
    {
     // Return an array of wm3GUIOption objects for horoscope signs select
     $_LABELS = $w3->getLanguageObj()->getArrayZodiacSign(true);
     $_VALUES = array(1,2,3,4,5,6,7,8,9,10,11,12);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function renderHoroscope($w3)
    {
     // Render horoscope panel in home page
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

     // Create horoscope panel form
     $link = $base_link;
     $select = new wm3GUISelect('sign','',$w3->getWord(297),wm3Horoscope::selectZodiacSign($w3));

     $form = new wm3GUIForm($w3,$link.'&section='.WM3_cSECTION_HOME.'&action='.WM3_cACTION_CONSULT_HOROSCOPE,'','wm3_form',array($select));
     $form->setRenderResetButton(false);
     $form->setUseWasSubmit(false);
     $form->setSubmitLabel($w3->getWord(296));
     return $form->render();
    }

   public function existHoroscopeDaily($w3,$sign,$languageID)
    {
	 // Delete expired daily horoscopes
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies WHERE expire_ts <= '".time()."'");

	 // Check if daily horoscope already exists
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies WHERE sign = '$sign' AND languageID = '$languageID' ORDER BY ts LIMIT 1");
     if($w3->getDBObj()->totalRows($rs) == 1) { $row = $w3->getDBObj()->fetch($rs); return $row->horoscopeID; }

     // If daily horoscope not exists then create a new one
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes WHERE languageID = '$languageID' AND enabled = '".WM3_cENABLED."' ORDER BY RAND() LIMIT 1");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
	 $row = $w3->getDBObj()->fetch($rs); 
	 $ts = time();
	 $ts_next_day = mktime(0,0,0,date("n",$ts+86400),date("j",$ts+86400),date("Y",$ts+86400));
	 $_FIELD['horoscope_dailyID'] = '';
	 $_FIELD['horoscopeID']       = $row->horoscopeID;
	 $_FIELD['sign']              = $sign;
	 $_FIELD['expire_ts']         = $ts_next_day;
	 $_FIELD['enabled']           = WM3_cENABLED;
	 $_FIELD['languageID']        = $languageID;
	 $_FIELD['ts']                = $ts;
	 $w3->getDBObj()->saveAllTableFields('_horoscopes_dailies',$_FIELD);
     return $row->horoscopeID;
	}

   public function renderHoroscopeConsult($w3)
    {
     // Render horoscope consult in home page
	 $sign = intval($w3->getVariable('sign','post'));
	 if($sign < 1 || $sign > 12) $sign = 1;

     // Get daily horoscope if already exists or create a new one
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_horoscopes         WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies WRITE");
	 $daily_horoscopeID = wm3Horoscope::existHoroscopeDaily($w3,$sign,$w3->getHomeLanguage());

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_horoscopes WHERE horoscopeID = '$daily_horoscopeID'";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $w3->getDBObj()->query("UNLOCK TABLES");

     // Create horoscope consult
     $_DATA = array(); $_COLSPAN = array();
     if($total_items == 1)
      {
       $row = $w3->getDBObj()->fetch($rs);	 
	   $sign_name  = $w3->getWordZodiacSign($sign);
	   $sign_image = wm3Util::renderImg("zodiac_sign_$sign.png",$sign_name,64,64,WM3_cPATH_DATA)."</a>";
	   $sign_info  = $w3->getWordZodiacSign($sign,true);
       $horoscope  = "<br>".wm3Util::renderContent($w3,$row->message,$row->render_mode);

  	   $_DATA[0]->image = $sign_image;
	   $_DATA[0]->name  = "<b>$sign_name</b><br><i>($sign_info)</i>";
       for($i=1;$i<=5;$i++)
        { 
	     $field = 'p'.$i;
	     $_DATA[$i]->label = $w3->getWord(236+$i);
	     $_DATA[$i]->stars = wm3Util::makeStars($w3,$row->$field);
        }
	   $_DATA[6]->horoscope = $horoscope;
	   $_COLSPAN[6]= array(2);
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
     $list->setRenderCaption(false);
     $list->setEmptyLabel($w3->getWord(1753));
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

   public static function renderFortune($w3)
    {
     // Render fortune panel with a random quote (for home page)

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_quotes
                        WHERE enabled = '".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'
                        ORDER BY RAND() LIMIT 1";
     $rs = $w3->getDBObj()->query($query);
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create survey question and answers
     $_DATA = array();
     if($total_items == 1)
      {
       $row = $w3->getDBObj()->fetch($rs);
       $quote = wm3Util::renderContent($w3,$row->quote,$row->render_mode);
       $info = "<div align=\"right\"><i>";
       if($row->author)
        {
         if($row->author_url) $info .= "<a href=\"$row->author_url\" target=\"_blank\">".$row->author."</a>";
         else                 $info .= $row->author;
         if($row->year) $info .= " ($row->year)";
         if($row->occupation) $info .= ", ".$row->occupation;
        }
       $info .= "</i></div>";
       $_DATA[0]->text = $quote;
       $_DATA[1]->text = $info;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setEmptyLabel($w3->getWord(1612));
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(100));
     return $list->render();
    }

  }

?>
