<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Language
  {
   private $_WORD,$_WORD_CATEGORY,$_WORD_EXPANSION,$_HELP;
   private $_MONTH,$_DAY_OF_THE_WEEK,$_ZODIAC_SIGN;
   private $_LANGUAGES;

   function __construct($w3,$languageID = 0,$setup = false)
    {
     if($setup) $this->getSetupLanguageFile($languageID);
     else       $this->_LANGUAGES = wm3Language::getLanguagesDataArray($w3);
    }

   public static function getLanguageFieldsArray()
    {
     return array('languageID','','ts');//TODO
    }

   public static function getLanguagesDataArray($w3)
    {
	 // Get languages data from database and put the result in an array of objects
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages ORDER BY languageID");
     return $w3->getDBObj()->resultToArray($rs);
	}

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_LANGUAGE:
        {
         wm3Language::disableLanguage($w3,$w3->getVariable('languageID','get'));
         return wm3Language::getLanguageList($w3,$w3->getVariable('languageID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_LANGUAGE:
        {
         wm3Language::enableLanguage($w3,$w3->getVariable('languageID','get'));
         return wm3Language::getLanguageList($w3,$w3->getVariable('languageID','get'));
         break;
        }
       default:
        {
         return wm3Language::getLanguageList($w3);
        }
      }
    }

   public static function getLanguageList($w3,$currentID = 0,$admin = true)
    {
     // Get languages list (admin side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_FAQ); // Used to enable admin buttons in home stage
     $pg = $w3->getVariable('pg');
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MESSAGES;
     $search_link = '';
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_languages.languageID";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'languageID',$rs);     
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&languageID=$row->languageID";
       if($allowed) $allowed_link = $base_allowed_link."&languageID=$row->languageID";
       $_DATA[$p]->name = $row->name;
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 $info = $lang_flag."<br>Language file: ".WM3_cPATH_LANGUAGES.$row->file." (".wm3Folder::renderFileSize($w3,@filesize(WM3_cPATH_LANGUAGES.$row->file)).")";
         $_DATA[$p]->info = $info;
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_LANGUAGE,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_LANGUAGE,"action_enable.png",$w3->getWord(181));
         //$_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MESSAGE,"action_edit.png",$w3->getWord(178));
        }
       if($row->languageID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1297));
     $list->setTotalItems($total_items);
     if($admin) {
		         if($found) $list->setCurrentID($currentID);
		         $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(907),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(30,70));
                 $list->setCaptionColspan(array(1,1,1));
                 $list->setWidths(array(30,70));
			    }
     else       {
		         $list->setRenderCaption(false);
		         $list->setRenderPagesNavigator(false);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function disableLanguage($w3,$languageID)
    {
	 // Disable a language only if at least one language still enabled
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_languages WRITE");

	 if($w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_languages","WHERE enabled='".WM3_cENABLED."'") > 1)
	  $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET enabled = '".WM3_cDISABLED."' WHERE languageID = '$languageID'");

	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function enableLanguage($w3,$languageID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET enabled = '".WM3_cENABLED."' WHERE languageID = '$languageID'");
	}

   public static function getFirstLanguageEnabled($w3)
    {
	 $rs = $w3->getDBObj()->query("SELECT languageID FROM ".WM3_cCONFIG_DB_PREFIX."_languages WHERE enabled='".WM3_cENABLED."' LIMIT 1");
	 $row = $w3->getDBObj()->fetch($rs);
	 return $row->languageID;
	}

   public static function isLanguageEnabled($w3,$languageID)
    {
     if($languageID == 0) return false;
	 $_ARRAY = $w3->getLanguageObj()->getLanguagesArray();
	 if($_ARRAY[$languageID - 1]->enabled) return true;
	 else                                  return false;
	}

   public static function writeCookieHomeLanguageID($w3,$languageID = 0)
    {
     if(!isset($_COOKIE['home_languageID']))
      {
	   if(wm3Language::isLanguageEnabled($w3,WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	   else                                                                  $languageID = wm3Language::getFirstLanguageEnabled($w3);
       setcookie("home_languageID",$languageID,time()+3600*24*365); // Set default home language if enabled, else get the first enabled language
       return $languageID;
      }
     else 
      {
	   if(!wm3Language::isLanguageEnabled($w3,$_COOKIE['home_languageID']))
	    {
		 // Rewrite bad cookies
	     if(wm3Language::isLanguageEnabled($w3,WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	     else                                                                  $languageID = wm3Language::getFirstLanguageEnabled($w3);
		 setcookie("home_languageID",$languageID,time()+3600*24*365);
		 return $languageID;
		}
	   if(wm3Language::isLanguageEnabled($w3,$languageID))
        {
         setcookie("home_languageID",$languageID,time()+3600*24*365); // New selected language
         return $languageID;
        }
      }
     return $_COOKIE['home_languageID'];
    }

   public static function writeCookieAdminLanguageID($w3,$languageID = 0,$setup = false)
    {
	 if($setup) // Do not check for enabled language in database when setup is running
	  {
       if(!isset($_COOKIE['admin_languageID']))
        {
         setcookie("admin_languageID",WM3_cCONFIG_STARTING_LANGUAGE,time()+3600*24*365); // Default admin language
         return WM3_cCONFIG_STARTING_LANGUAGE;
        }
       else 
        {
	     if($_COOKIE['admin_languageID'] < WM3_cLANGUAGE_EN || $_COOKIE['admin_languageID'] > WM3_cLANGUAGE_EL)
	      {
		   // Rewrite bad cookies
		   setcookie("admin_languageID",WM3_cCONFIG_STARTING_LANGUAGE,time()+3600*24*365);
		   return WM3_cCONFIG_STARTING_LANGUAGE;
	  	  }
         if($languageID != 0)
          {
           setcookie("admin_languageID",$languageID,time()+3600*24*365); // New selected language
           return $languageID;
          }
        }
       return $_COOKIE['admin_languageID'];
	  }
	 else
	  {
       if(!isset($_COOKIE['admin_languageID']))
        {
	     if(wm3Language::isLanguageEnabled($w3,WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	     else                                                                  $languageID = wm3Language::getFirstLanguageEnabled($w3);
         setcookie("admin_languageID",$languageID,time()+3600*24*365); // Set default admin language if enabled, else get the first enabled language
         return $languageID;
        }
       else 
        {
	     if(!wm3Language::isLanguageEnabled($w3,$_COOKIE['admin_languageID']))
	      {
  		   // Rewrite bad cookies
	       if(wm3Language::isLanguageEnabled($w3,WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	       else                                                                  $languageID = wm3Language::getFirstLanguageEnabled($w3);
		   setcookie("admin_languageID",$languageID,time()+3600*24*365);
		   return $languageID;
		  }
         if(wm3Language::isLanguageEnabled($w3,$languageID))
          {
           setcookie("admin_languageID",$languageID,time()+3600*24*365); // New selected language
           return $languageID;
          }
        }
       return $_COOKIE['admin_languageID'];
      }
    }

   public static function writeCookiePreferencesLanguageID($w3,$languageID = 0)
    {
     if(!isset($_COOKIE['preferences_languageID']))
      {
	   if(wm3Language::isLanguageEnabled($w3,WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	   else                                                                  $languageID = wm3Language::getFirstLanguageEnabled($w3);
       setcookie("preferences_languageID",$languageID,time()+3600*24*365); // Set default preferences language (admin side) if enabled, else get the first enabled language
       return $languageID;
      }
     else 
      {
	   if(!wm3Language::isLanguageEnabled($w3,$_COOKIE['preferences_languageID']))
	    {
		 // Rewrite bad cookies
	     if(wm3Language::isLanguageEnabled($w3,WM3_cCONFIG_STARTING_LANGUAGE)) $languageID = WM3_cCONFIG_STARTING_LANGUAGE;
	     else                                                                  $languageID = wm3Language::getFirstLanguageEnabled($w3);
		 setcookie("preferences_languageID",$languageID,time()+3600*24*365);
		 return $languageID;
		}
       if(wm3Language::isLanguageEnabled($w3,$languageID))
        {
         setcookie("preferences_languageID",$languageID,time()+3600*24*365); // New selected language
         return $languageID;
        }
      }
     return $_COOKIE['preferences_languageID'];
    }

   public static function getFormPanel($w3,$languageID,$n)
    {
     // Return an array of wm3GUIRadio objects for language selection panel
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                             WHERE enabled='".WM3_cENABLED."'");
     $array = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $label   = "<img src=\"".WM3_cPATH_DATA.$row->flag."\" width=\"19\" height=\"13\" border=\"1\">";
       $country = $row->name;
       if($row->languageID == $languageID) $array[$p] = new wm3GUIRadio($n,$row->languageID,$label,true);
       else                                $array[$p] = new wm3GUIRadio($n,$row->languageID,$label);
       $array[$p]->setSpan(2);
       $array[$p]->setLabelWidth(0);
       $array[$p]->setWidths(array(0,100));
       $array['l'.$p] = new wm3GUILabel($n,$country);
       $p++;
      }
     return $array;
    }

   public static function selectLanguage($w3,$all = false)
    {
     // Return an array of wm3GUIOption objects for language select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                                   WHERE enabled = '".WM3_cENABLED."'");
     if($w3->getDBObj()->totalRows($rs) == 0) return $array;
	 if($all)
	  array_push($array,new wm3GUIOption($w3->getWord(1574),WM3_cLANGUAGE_ALL));
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption(html_entity_decode($row->name),$row->languageID));
     return $array;
    }

   public static function selectSetupLanguage($w3)
    {
     // Return an array of wm3GUIOption objects for setup language select
     $array = array();
     $_DATA = array('English','Italiano','Français','Deutsch','Español','Nederlands','Ελληνικά');
     for($i = 0; $i < count($_DATA); $i++)
      array_push($array,new wm3GUIOption($_DATA[$i],$i+1));
     return $array;
    }

   public static function getFlag($w3,$languageID)
    {
	 if($languageID == WM3_cLANGUAGE_ALL) return "flag_all.png";
     $rs = $w3->getDBObj()->query("SELECT flag FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                                   WHERE languageID= '$languageID'");
     $row = $w3->getDBObj()->fetch($rs);
     return  $row->flag;
    }

   public static function getCountryCode($w3,$languageID)
    {
	 if($languageID == WM3_cLANGUAGE_ALL) return '';
     $rs = $w3->getDBObj()->query("SELECT flag FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                                   WHERE languageID= '$languageID'");
     $row = $w3->getDBObj()->fetch($rs);
     return substr($row->flag,5,2);
    }

   public static function getName($w3,$languageID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                                   WHERE languageID='$languageID'");
     $row = $w3->getDBObj()->fetch($rs);
     return  $row->name;
    }

   public static function getFile($w3,$languageID)
    {
     $rs = $w3->getDBObj()->query("SELECT file FROM ".WM3_cCONFIG_DB_PREFIX."_languages
                                   WHERE languageID='$languageID'");
	 if($w3->getDBObj()->totalRows($rs) != 1) return "language_en.php";
     $row = $w3->getDBObj()->fetch($rs);
     return  $row->file;
    }

   public function getLanguageFile($w3,$languageID,$path = WM3_cPATH_LANGUAGES)
    {
	 // Default language if other language do not exists
	 $language_file = $path."language_en.php";
     if(file_exists($language_file)) require($language_file);

     // Load current language
	 if($languageID != WM3_cLANGUAGE_EN)
	  {
	   $language_file = $path.wm3Language::getFile($w3,$languageID);
	   if(file_exists($language_file)) require($language_file);
      }

     // Override the original language (if override file exists)
     $override_file = $path."override_".substr($language_file,-6,6);
     if(file_exists($override_file)) require($override_file);
    }

   public function getSetupLanguageFile($languageID)
    {
     require(WM3_cPATH_LANGUAGES."language_en.php"); // Default language if other language do not exists
	 if($languageID == WM3_cLANGUAGE_IT) if(file_exists(WM3_cPATH_LANGUAGES."language_it.php")) require(WM3_cPATH_LANGUAGES."language_it.php");
	 if($languageID == WM3_cLANGUAGE_FR) if(file_exists(WM3_cPATH_LANGUAGES."language_fr.php")) require(WM3_cPATH_LANGUAGES."language_fr.php");
	 if($languageID == WM3_cLANGUAGE_DE) if(file_exists(WM3_cPATH_LANGUAGES."language_de.php")) require(WM3_cPATH_LANGUAGES."language_de.php");
	 if($languageID == WM3_cLANGUAGE_ES) if(file_exists(WM3_cPATH_LANGUAGES."language_es.php")) require(WM3_cPATH_LANGUAGES."language_es.php");
	 if($languageID == WM3_cLANGUAGE_NL) if(file_exists(WM3_cPATH_LANGUAGES."language_nl.php")) require(WM3_cPATH_LANGUAGES."language_nl.php");
	 if($languageID == WM3_cLANGUAGE_EL) if(file_exists(WM3_cPATH_LANGUAGES."language_el.php")) require(WM3_cPATH_LANGUAGES."language_el.php");
    }

   public function translate($s)
    {
     // Translate some words from category panels and pages
     if($s == "PANEL_MESSAGES") 	  return $this->_WORD_CATEGORY[0];
     if($s == "PANEL_LOGIN") 		  return $this->_WORD_CATEGORY[1];
     if($s == "PANEL_CHANNELS") 	  return $this->_WORD_CATEGORY[2];
     if($s == "PANEL_SEARCH") 		  return $this->_WORD_CATEGORY[3];
     if($s == "PANEL_HOROSCOPE") 	  return $this->_WORD_CATEGORY[4];
     if($s == "PANEL_NEWSLETTER") 	  return $this->_WORD_CATEGORY[5];
     if($s == "PANEL_SEND_TO_FRIEND") return $this->_WORD_CATEGORY[6];
     if($s == "PANEL_LANGUAGES") 	  return $this->_WORD_CATEGORY[7];
     if($s == "PANEL_ECOMMERCE") 	  return $this->_WORD_CATEGORY[16];
     if($s == "PANEL_SURVEY") 	 	  return $this->_WORD_CATEGORY[18];
     if($s == "PANEL_FORTUNE")		  return $this->_WORD_CATEGORY[30];
     if($s == "PANEL_RSS_FEEDS")	  return $this->_WORD_CATEGORY[31];
     if($s == "PANEL_BIRTHDAY")  	  return $this->_WORD_CATEGORY[32];
     if($s == "PANEL_SPECIAL_OFFER")  return $this->_WORD_CATEGORY[33];
     if($s == "PANEL_CUSTOM")  		  return $this->_WORD_CATEGORY[35];
	 if($s == "PANEL_EXPANSION")	  return $this->_WORD_CATEGORY[36];
	 if($s == "PANEL_MENU")	          return $this->_WORD_CATEGORY[37];
	 if($s == "PANEL_TAGS")           return $this->_WORD_CATEGORY[39];

     if($s == "PAGE_MARKET") 	    	return $this->_WORD_CATEGORY[11];
     if($s == "PAGE_FAQ") 			    return $this->_WORD_CATEGORY[12];
     if($s == "PAGE_SEARCH_ENGINE") 	return $this->_WORD_CATEGORY[13];
     if($s == "PAGE_USER_REGISTRATION") return $this->_WORD_CATEGORY[14];
     if($s == "PAGE_LINKS") 			return $this->_WORD_CATEGORY[15];
     if($s == "PAGE_STATISTICS") 	    return $this->_WORD_CATEGORY[17];
     if($s == "PAGE_USER_INFORMATIONS") return $this->_WORD_CATEGORY[19];
     if($s == "PAGE_FORUMS")			return $this->_WORD_CATEGORY[21];
     if($s == "PAGE_DOWNLOADS")		    return $this->_WORD_CATEGORY[22];
     if($s == "PAGE_GUESTBOOKS")        return $this->_WORD_CATEGORY[23];
     if($s == "PAGE_DIRECTORIES")       return $this->_WORD_CATEGORY[24];
     if($s == "PAGE_MEDIA_ALBUMS")		return $this->_WORD_CATEGORY[25];
     if($s == "PAGE_CONTACT")		    return $this->_WORD_CATEGORY[26];
     if($s == "PAGE_CHAT")			    return $this->_WORD_CATEGORY[28];
     if($s == "PAGE_WEBMAIL")		    return $this->_WORD_CATEGORY[29];
     if($s == "PAGE_CUSTOM")            return $this->_WORD_CATEGORY[34];
     if($s == "PAGE_EXPANSION")         return $this->_WORD_CATEGORY[36];

     if($s == "MENU_ITEM_CHANNEL")  return $this->_WORD_CATEGORY[8];
     if($s == "MENU_ITEM_HOME")     return $this->_WORD_CATEGORY[9];
     if($s == "MENU_ITEM_ADMIN")    return $this->_WORD_CATEGORY[10];
     if($s == "MENU_ITEM_USER")     return $this->_WORD_CATEGORY[20];
     if($s == "MENU_ITEM_EXTERNAL") return $this->_WORD_CATEGORY[27];
	 if($s == "MENU_ITEM_CUSTOM")   return $this->_WORD_CATEGORY[34];
	 if($s == "MENU_ITEM_VOID")     return $this->_WORD_CATEGORY[38];

     return $s;
    }

   public function setWordEpansionArray($array) { $this->_WORD_EXPANSION = $array; }

   public function getLanguagesArray() { return $this->_LANGUAGES; }

   public function getWord($i) { if($i >= 0) return $this->_WORD[$i]; else return; }
   
   public function getWordHelp($i) { if($i >= 0) return $this->_HELP[$i]; else return; }
   
   public function getWordCategory($i) { return $this->_WORD_CATEGORY[$i]; }

   public function getWordExpansion($i) { if($i >= 0) return $this->_WORD_EXPANSION[$i]; else return; }

   public function getArrayMonth() { return $this->_MONTH; }

   public function getArrayDayOfTheWeek() { return $this->_DAY_OF_THE_WEEK; }

   public function getArrayZodiacSign($name_only = false)
    {
	 if($name_only)
	  {
	   $array = array();
	   for($i = 0; $i < 12; $i++) array_push($array,$this->_ZODIAC_SIGN[$i][0]);
	   return $array;
      }
	 else return $this->_ZODIAC_SIGN;
	}

  }

?>
