<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3MediaAlbum extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for media album section
     return array(
                  'section'                    => WM3_cSECTION_MEDIA_ALBUMS,
                  'allowed_section'            => WM3_cSECTION_MEDIA_ALBUMS,
                  'allow_category_description' => true,
                  'category_form'              => 'admin_media_album_category_form.inc',
                  'search_form'                => 'admin_media_album_search_form.inc',
                  'table_categories'           => '_media_albums_categories',
                  'table_subcategories'        => '_media_albums',
                  'table_subcategories_count'  => '_media_albums',
                  'table_items_count'          => '_media_albums_items',
                  'field_items_count'          => 'media_albumID',
                  'action_add_category'        => WM3_cACTION_ADD_MEDIA_ALBUM_CATEGORY,
                  'action_show_subcategory'    => WM3_cACTION_SHOW_MEDIA_ALBUM,
                  'action_add_subcategory'     => WM3_cACTION_ADD_MEDIA_ALBUM,
                  'action_disable_category'    => WM3_cACTION_DISABLE_MEDIA_ALBUM_CATEGORY,
                  'action_enable_category'     => WM3_cACTION_ENABLE_MEDIA_ALBUM_CATEGORY,
                  'action_edit_category'       => WM3_cACTION_EDIT_MEDIA_ALBUM_CATEGORY,
                  'action_delete_category'     => WM3_cACTION_DELETE_MEDIA_ALBUM_CATEGORY,
                  'action_search'              => WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM,
                  'label_category_list_title'  => 364,
                  'label_subcategory_add'      => 1337,
                  'label_subcategories_count'  => 1348,
                  'label_items_count'          => 1683,
				  'extra_button_action'        => WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,
				  'extra_button_icon'          => 'action_up.png',
				  'extra_button_label'         => 1216);
    }

   public static function getMediaAlbumFieldsArray()
    {
     return array('media_albumID','title','categoryID','description','media_album_type','userID','enabled','languageID',
                  'group_read','users_read','visitors_read',
				  'ts','icon');
    }

   public static function getMediaAlbumItemFieldsArray()
    {
     return array('media_album_itemID','media_albumID','title','alt',
                  'source_media','media_from_local','media','media_from_remote','hits','media_from_external',
                  'source_thumbnail','thumbnail_from_local','thumbnail','thumbnail_from_remote','ts','thumbnail_from_external',
                  'enabled','languageID',
                  'votes_counts','votes_sum','votes_average');
    }

   public static function getMediaAlbumPermissionsArray($w3,$media_albumID = 0)
    {
     // Return media album permissions array
     $_PERMISSIONS = array(
                           'media_read' => false
                          );
     if($media_albumID == 0) $media_albumID = $w3->getVariable('media_albumID');
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
	                                ".WM3_cCONFIG_DB_PREFIX."_media_albums.*
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums,
							        ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                             WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID = ".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID
                               AND  ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."'
							   AND  ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID = '$media_albumID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return $_PERMISSIONS;
     $row = $w3->getDBObj()->fetch($rs); 

	 // Set visitors permissions (no user logged)
     $_PERMISSIONS['media_read'] = $row->visitors_read;

     // Set user or administrator permissions (user or administrator logged)
     if($w3->getAuthenticateAdminUserID())
      {
       $_PERMISSIONS['media_read'] = $row->users_read;

	   // If logged user/administrator group its the same of the owner group
       if(wm3User::getGroupID($w3,$w3->getAuthenticateAdminUserID()) == wm3User::getGroupID($w3,$row->userID))
	    {
         $_PERMISSIONS['media_read'] = $row->group_read;
	    }
	   // If logged user/administrator its owner
       if($w3->getAuthenticateAdminUserID() == $row->userID)
	    {
         $_PERMISSIONS['media_read'] = true;
	    }
	   // If administrator can manage media albums (and manage users ??? TODO poichè se gestisce gli utenti puo' mettersi il permesso di gestire il media album)
       if(wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS))
	    {
         $_PERMISSIONS['media_read'] = true;
		}
      }
     return $_PERMISSIONS;
    }

   public static function executeHomeAction($w3,$pageID)
    {
     // MediaAlbum page content
     $_PERMISSIONS = wm3MediaAlbum::getMediaAlbumPermissionsArray($w3); // Get forum permissions
     switch($w3->getAction())
      {
       case WM3_cACTION_SHOW_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::getMediaAlbumList($w3,0,false);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM:
        {
         if(!$w3->getVariable('media_albumID') || ($w3->getVariable('media_albumID') && $_PERMISSIONS['media_read']) )
		  return wm3MediaAlbum::getMediaAlbumItemList($w3,0,false,true);
		 else
		  return wm3MediaAlbum::renderMediaAlbumDenied($w3);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_MEDIA:
        {
		 if($_PERMISSIONS['media_read'])
		  {
		   wm3MediaAlbum::hitMediaAlbumItem($w3);
           return wm3MediaAlbum::renderSingleMediaAlbumItem($w3);
		  }
         else return wm3MediaAlbum::renderMediaAlbumDenied($w3);
         break;
        }
       case WM3_cACTION_RATE_MEDIA_ALBUM_ITEM:
        {
         if($_PERMISSIONS['media_read'])
          {
           wm3MediaAlbum::rateMediaAlbumItem($w3);
           return wm3MediaAlbum::renderSingleMediaAlbumItem($w3);
		  }
		 else return wm3MediaAlbum::renderMediaAlbumDenied($w3);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING:
        {
         return wm3MediaAlbum::renderMediaAlbumItemTopRating($w3,"ORDER BY votes_average DESC",1219,true, false,false)."<br><br>".
		        wm3MediaAlbum::renderMediaAlbumItemTopRating($w3,"ORDER BY hits DESC"         ,1220,false,true, false)."<br><br>".
				wm3MediaAlbum::renderMediaAlbumItemTopRating($w3,"ORDER BY votes_counts DESC" ,1221,false,false,true);
         break;
        }
       default:
        {
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_MEDIA_ALBUM_CATEGORY:
        {
         return wm3MediaAlbum::addMediaAlbumCategory($w3);
         break;
        }
       case WM3_cACTION_EDIT_MEDIA_ALBUM_CATEGORY:
        {
         return wm3MediaAlbum::editMediaAlbumCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_MEDIA_ALBUM_CATEGORY:
        {
         wm3MediaAlbum::disableMediaAlbumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MEDIA_ALBUM_CATEGORY:
        {
         wm3MediaAlbum::enableMediaAlbumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MEDIA_ALBUM_CATEGORY:
        {
         wm3MediaAlbum::deleteMediaAlbumCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::addMediaAlbum($w3);
         break;
        }
       case WM3_cACTION_EDIT_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::editMediaAlbum($w3);
         break;
        }
       case WM3_cACTION_DISABLE_MEDIA_ALBUM:
        {
         wm3MediaAlbum::disableMediaAlbum($w3,$w3->getVariable('media_albumID','get'));
         return wm3MediaAlbum::getMediaAlbumList($w3,$w3->getVariable('media_albumID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MEDIA_ALBUM:
        {
         wm3MediaAlbum::enableMediaAlbum($w3,$w3->getVariable('media_albumID','get'));
         return wm3MediaAlbum::getMediaAlbumList($w3,$w3->getVariable('media_albumID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MEDIA_ALBUM:
        {
         wm3MediaAlbum::deleteMediaAlbum($w3,$w3->getVariable('media_albumID','get'));
         return wm3MediaAlbum::getMediaAlbumList($w3);
         break;
        }       
       case WM3_cACTION_ADD_MEDIA_ALBUM_ITEM:
        {
         return wm3MediaAlbum::addMediaAlbumItem($w3);
         break;
        }
       case WM3_cACTION_SAVE_MEDIA_ALBUM_ITEM:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items      WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
         $media_album_type = wm3MediaAlbum::getMediaAlbumType($w3,$w3->getVariable('media_albumID','post'));
         $error = wm3MediaAlbum::checkMediaAlbumItemError($w3,$media_album_type);
         if(!$error) {
                      $lastID = wm3MediaAlbum::saveMediaAlbumItem($w3);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3MediaAlbum::getMediaAlbumItemList($w3,$lastID);
                     }
         else       {
			         $w3->getDBObj()->query("UNLOCK TABLES");
			         return wm3MediaAlbum::addMediaAlbumItem($w3,$error);
				    }
         break;
        }
       case WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM:
        {
         return wm3MediaAlbum::editMediaAlbumItem($w3);
         break;
        }
       case WM3_cACTION_UPDATE_MEDIA_ALBUM_ITEM:
        {
		 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items      WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
		                               ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
         $media_album_type = wm3MediaAlbum::getMediaAlbumType($w3,$w3->getVariable('media_albumID','post'));
         $error = wm3MediaAlbum::checkMediaAlbumItemError($w3,$media_album_type);
         if(!$error) {
                      $lastID = wm3MediaAlbum::updateMediaAlbumItem($w3);
                      $w3->getDBObj()->query("UNLOCK TABLES");
                      return wm3MediaAlbum::getMediaAlbumItemList($w3,$lastID);
                     }
         else        {
			          $w3->getDBObj()->query("UNLOCK TABLES");
			          return wm3MediaAlbum::editMediaAlbumItem($w3,$error);
		             }
         break;
        }
       case WM3_cACTION_DISABLE_MEDIA_ALBUM_ITEM:
        {
         wm3MediaAlbum::disableMediaAlbumItem($w3,$w3->getVariable('media_album_itemID','get'));
         return wm3MediaAlbum::getMediaAlbumItemList($w3,$w3->getVariable('media_album_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MEDIA_ALBUM_ITEM:
        {
         wm3MediaAlbum::enableMediaAlbumItem($w3,$w3->getVariable('media_album_itemID','get'));
         return wm3MediaAlbum::getMediaAlbumItemList($w3,$w3->getVariable('media_album_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MEDIA_ALBUM_ITEM:
        {
         wm3MediaAlbum::deleteMediaAlbumItem($w3,$w3->getVariable('media_album_itemID','get'));
         return wm3MediaAlbum::getMediaAlbumItemList($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_MEDIA_ALBUM_ITEM:
        {
         $lastID = wm3MediaAlbum::duplicateMediaAlbumItem($w3);
         return wm3MediaAlbum::getMediaAlbumItemList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM:
        {
         return wm3MediaAlbum::getMediaAlbumItemList($w3);
         break;
        }
       case WM3_cACTION_SHOW_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::getMediaAlbumList($w3);
         break;
        }
       case WM3_cACTION_MOVE_MEDIA_ALBUM:
        {
         return wm3MediaAlbum::getMediaAlbumItemList($w3,0,true,false,true);
         break;
        }
       case WM3_cACTION_MOVE_MEDIA_ALBUM_ITEM:
        {
		 wm3MediaAlbum::moveMediaAlbumItem($w3);
         return wm3MediaAlbum::getMediaAlbumItemList($w3,0,true,false,true);
         break;
        }
       default:
        {
         return wm3MediaAlbum::getMediaAlbumCategoryList($w3);
        }
      }     
    }

   public static function renderMediaAlbumDenied($w3)
    {
     // Give a denied access message (home side)

     // Prepare variables to create the content
     $media_albumID = $w3->getVariable('media_albumID');
	 $categoryID = $w3->getVariable('categoryID');
     $pg = $w3->getVariable('pg');
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     $filter = $w3->getVariable('filter'); // Search field
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     else { $search_link = $query_filter = ''; }
     if($query_filter) $query_filter .= " AND "; else $query_filter .= " WHERE ";
     $query_filter .= "enabled='".WM3_cENABLED."' AND media_albumID = '$media_albumID'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $page_link = "&pageID=".$w3->getVariable('pageID');
     $id_link   = "&media_albumID=$media_albumID";

     // List items
     $_DATA = array();
     $link = $base_link.$id_link.$page_link.$search_link.$extra_link;//."&postID=$row->postID";
     $message = "<div align=\"center\"><br><img src=\"".WM3_cPATH_DATA."misc_stop.png\" border=\"0\" width=\"40\" height=\"37\"><br><br><b>Access denied!</b><br><br>You can not see media in this media album.</div><br>";
     $_DATA[0]->message = $message;

     // Render List
     $list = new wm3GUIList($w3,$_DATA,"<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     $_SEP = $w3->getSkinObj()->getSeparator();
     if($media_albumID && $categoryID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                                        ." $_PSEP ".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID));
      }
     $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setWidths(array(100));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function getMediaAlbumCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function addMediaAlbumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editMediaAlbumCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function disableMediaAlbumCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableMediaAlbumCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteMediaAlbumCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($w3,$categoryID,'media_albumID');
    }

   public static function selectMediaAlbumCategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$all,$admin);
    }

   public static function getMediaAlbumCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($w3,$categoryID);
    }

   public static function selectMediaAlbum($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectSubcategory($w3,$all,$admin,'title','media_albumID');
    }

   public static function getMediaAlbumList($w3,$currentID = 0,$admin = true)
    {
     // Get media album list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) $search_link = "&filter=$filter"; else $search_link = '';
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums.languageID='".$w3->getHomeLanguage()."'";
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
     $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_media_albums.title";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_media_albums.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,".WM3_cCONFIG_DB_PREFIX."_media_albums
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'media_albumID',$rs);
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$search_link.$extra_link."&media_albumID=$row->media_albumID";
       if($allowed) $allowed_link = $base_allowed_link."&media_albumID=$row->media_albumID";
       $moderator   = wm3User::getUserLogin($w3,$row->userID);
       $group       = wm3User::getGroupName($w3,wm3User::getGroupID($w3,$row->userID));
       $icon        = wm3MediaAlbum::getMediaAlbumMimeIcons($row->media_album_type);
       $permissions = wm3MediaAlbum::getMediaAlbumPermissionsLegend($row);
       if($categoryID) {
                        if($admin) $_DATA[$p]->title = "<a href=\"$link&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a><br>".wm3MediaAlbum::makeCounterMediaAlbumItems($w3,$row->media_albumID)."<p><i>$row->description</i></p>";
                        else       $_DATA[$p]->title = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a> ".wm3MediaAlbum::makeCounterMediaAlbumItems($w3,$row->media_albumID,"AND enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'")."<p><i>$row->description</i></p>";
                       }
       else            {
       	                // For the search in all categories (TODO for the forums)
                        if($admin) $_DATA[$p]->title = "<a href=\"$link&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a><br>(".$w3->getWord(659)." <a href=\"".$link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$row->categoryID)."</a>)";
                        else       $_DATA[$p]->title = "<a href=\"$link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">$row->title</a><br>(".$w3->getWord(659)." <a href=\"".$link.$page_link."&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$row->categoryID)."</a>)";
                       }
       $_DATA[$p]->permissions = $icon."<br>".$permissions;
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = "$lang_flag (".$w3->getWord(999)." $moderator, group $group)";
         // Buttons
         $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_MEDIA_ALBUM_ITEM,"action_add_from.png",$w3->getWord(1342));
         if($row->enabled) $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_MEDIA_ALBUM,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_MEDIA_ALBUM,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_MEDIA_ALBUM,"action_delete.png",$w3->getWord(179),$w3->getWord(699));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM,"action_edit.png",$w3->getWord(178));
        }
       if($row->media_albumID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_media_album_search_form.inc');
     $list->setSearchForm($search_form);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(364)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     if($categoryID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_MEDIA_ALBUM,"action_add.png","","",$w3->getWord(365),0,16,16));
       else       $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) {
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(40,30,30));
                 $list->setCaptionColspan(array(2,1,4));
                 $list->setWidths(array(40,30,30));
			    }
     else       {
		         $list->setRenderCaption(false);
                 $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM.$id_link.$search_link);
                 $list->setWidths(array(50,50));
                }
     return $list->render();
    }

   public static function addMediaAlbum($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray());
	 $action = WM3_cACTION_ADD_MEDIA_ALBUM;
	 require(WM3_cPATH_INCLUDE.'admin_media_album_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1337));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['categoryID']->setValue($w3->getVariable('categoryID','get')); // Take categoryID from get
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
       if($form->validate())
        {
         $lastID = wm3MediaAlbum::saveMediaAlbum($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3MediaAlbum::getMediaAlbumList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editMediaAlbum($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_MEDIA_ALBUM;
	 require(WM3_cPATH_INCLUDE.'admin_media_album_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit media album");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums
                               WHERE media_albumID = '".$w3->getVariable('media_albumID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
       if($form->validate())
        {
         $lastID = wm3MediaAlbum::updateMediaAlbum($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3MediaAlbum::getMediaAlbumList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function saveMediaAlbum($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_media_albums',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateMediaAlbum($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                       SET   title            = '".$_FIELD['title']."',
                             categoryID       = '".$_FIELD['categoryID']."',
                             description      = '".$_FIELD['description']."',
                             media_album_type = '".$_FIELD['media_album_type']."',
                             userID           = '".$_FIELD['userID']."',
                             users_read       = '".$_FIELD['users_read']."',
                             visitors_read    = '".$_FIELD['visitors_read']."',
                             group_read       = '".$_FIELD['group_read']."',
                             enabled          = '".$_FIELD['enabled']."',
                             languageID       = '".$_FIELD['languageID']."'
                       WHERE media_albumID    = '".$_FIELD['media_albumID']."'");
     return $_FIELD['media_albumID'];
    }

   public static function duplicateMediaAlbumItem($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items      WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_media_albums            WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories WRITE");
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                             WHERE media_album_itemID = '".$w3->getVariable('media_album_itemID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),$row,WM3_cQUOTE_DB);
       $_FIELD['title']   = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
	   $_FIELD['hits']    = $_FIELD['votes_counts'] = $_FIELD['votes_sum'] = $_FIELD['votes_average'] = 0;
       $_FIELD['ts']      = time();
       $w3->getDBObj()->saveAllTableFields('_media_albums_items',$_FIELD);
       $w3->getDBObj()->query("UNLOCK TABLES");
       return $w3->getDBObj()->getLastInsertID();
      }
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function disableMediaAlbum($w3,$media_albumID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums SET enabled = '".WM3_cDISABLED."' WHERE media_albumID = '$media_albumID'"); }

   public static function enableMediaAlbum($w3,$media_albumID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums SET enabled = '".WM3_cENABLED."' WHERE media_albumID = '$media_albumID'"); }
   
   public static function deleteMediaAlbum($w3,$media_albumID) 
    {
	 $w3->getSectionObj()->deleteSubcategory($w3,$media_albumID,'media_albumID');
	 //$w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums WHERE media_albumID = '$media_albumID'");
	}

   public static function getMediaAlbumItemName($w3,$media_album_itemID)
    {
     // Get media album item name
     $rs = $w3->getDBObj()->query("SELECT title FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                             WHERE media_album_itemID = '$media_album_itemID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";                             
     $row = $w3->getDBObj()->fetch($rs);
     return $row->title;
    }

   public static function getMediaAlbumType($w3,$media_albumID)
    {
     // Get media album type
     $rs = $w3->getDBObj()->query("SELECT media_album_type FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums
                             WHERE media_albumID = '$media_albumID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;                             
     $row = $w3->getDBObj()->fetch($rs);
     return $row->media_album_type;
    }

   public static function getMediaAlbumName($w3,$media_albumID)
    {
     return $w3->getSectionObj()->getSubcategoryName($w3,$media_albumID,"title","media_albumID");
    }

   public static function getMediaAlbumCategoryID($w3,$media_albumID)
    {
     return $w3->getSectionObj()->getCategoryID($w3,$media_albumID,"media_albumID");
    }

   public static function getMediaAlbumItemList($w3,$currentID = 0,$admin = true,$media_search = false,$move = false)
    {
     // Get media album item list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
     $media_albumID = $w3->getVariable('media_albumID');
     if($media_albumID && !$categoryID) // When make a search take only media_albumID (but need also categoryID)
      $categoryID = wm3MediaAlbum::getMediaAlbumCategoryID($w3,$media_albumID);
     if($media_albumID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID = '$media_albumID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND (".WM3_cCONFIG_DB_PREFIX."_media_albums_items.title LIKE '%$filter%'".
				                   " OR ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.alt LIKE '%$filter%')";
     	         }
     else        { if(!$media_albumID) $query_filter =" AND 1=0"; $search_link = ''; }
     if($admin) {
                 $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.languageID='".$w3->getHomeLanguage()."'";
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $id_link = "&categoryID=$categoryID&media_albumID=$media_albumID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.title";
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID=".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID
               $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'media_album_itemID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;     
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&media_album_itemID=$row->media_album_itemID";
       if($allowed) $allowed_link = $base_allowed_link."&media_album_itemID=$row->media_album_itemID";
	   $_MIME_INFO = wm3Folder::getMimeInfoArray($w3,$row->media);
       $mime_icon = $_MIME_INFO['mime_icon'];
       if($media_albumID) {
                           if($admin) {
							           if($move)
							            {
										 $chk_item = new wm3GUICheckBox('chk_item'.($p+1),$row->media_album_itemID);
										 $chk_item->setIsBoolean(false);
							             $_DATA[$p]->check_box = $chk_item->render();
									    }
							           $_DATA[$p]->media = "<a href=\"".WM3_cPATH_MEDIA_ALBUM."$row->media\" target=\"_blank\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>";
                        	           $_DATA[$p]->title = $mime_icon." ".$row->title."<br><i>".$row->alt."</i>";
									  }
                           else       {
							           if($filter)
									    {
							             $picture = "<a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\"></a>";
									     $_DATA[$p]->media = $picture;
							             $_DATA[$p]->title = "$mime_icon <a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->title</a><br><i>".$row->alt."</i>";
									    }
									   else
									    {
							             if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178)); else $button = '';
                           	             $picture_content = "<a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"120\" height=\"90\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\"></a>";
                                         $title_content   = "$mime_icon <a href=\"$link$page_link&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->title</a> $button";
                                         ob_start();
                                         require($w3->getSkinObj()->getFramePicture());
                                         $item_content = ob_get_contents();
                                         ob_end_clean();
                           	             $_DATA[$p]->media = $item_content;
									    }
                           	          }
                          }
       else               {
       	                   // For the search in all categories -> subcategories
						   $_PSEP = $w3->getSkinObj()->getPathSeparator();
                           if($admin) {
							           $_DATA[$p]->media = "<a href=\"".WM3_cPATH_MEDIA_ALBUM."$row->media\" target=\"_blank\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>";
							           $_DATA[$p]->title = "$mime_icon $row->title<br><i>".$row->alt."</i><br>(".$w3->getWord(659)."
                           	                      <a href=\"$base_link&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->media_albumID,'media_albumID')."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->media_albumID,'media_albumID'))."</a>
                           	                      $_PSEP <a href=\"$base_link$search_link&media_albumID=$row->media_albumID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">".wm3MediaAlbum::getMediaAlbumName($w3,$row->media_albumID)."</a>)";
									  }
                           else       {
							           if($media_search) $_PERMISSIONS = wm3MediaAlbum::getMediaAlbumPermissionsArray($w3,$row->media_albumID);
							           if($_PERMISSIONS['media_read'])
									    {
									     $picture = "<a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\"></a>";
										 $content = "$mime_icon <a href=\"$base_link$page_link&categoryID=$categoryID&media_albumID=$row->media_albumID&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA."\">$row->title</a><br><i>".$row->alt."</i><br>(".$w3->getWord(659)."
                           	                         <a href=\"".$base_link.$page_link."&categoryID=".$w3->getSectionObj()->getCategoryID($w3,$row->media_albumID,'media_albumID')."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$w3->getSectionObj()->getCategoryID($w3,$row->media_albumID,'media_albumID'))."</a>
                           	                         $_PSEP <a href=\"".$base_link.$search_link.$page_link."&media_albumID=$row->media_albumID&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">".wm3MediaAlbum::getMediaAlbumName($w3,$row->media_albumID)."</a>)";
										}
									   else
									    {
										 $picture = wm3Util::renderImg("misc_error_mini.png");
										 $content = "You can not see this media";
									    }
									   $_DATA[$p]->media = $picture;
							           $_DATA[$p]->title = $content;
									  }
                          }
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag." $row->hits hits<br>".wm3Util::makeStars($w3,$row->votes_average)." $row->votes_average ($row->votes_counts voti)";
         // Buttons
         if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_MEDIA_ALBUM_ITEM,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_MEDIA_ALBUM_ITEM,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DUPLICATE_MEDIA_ALBUM_ITEM,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1416));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_MEDIA_ALBUM_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(772));
        }
       else
        {
         if($filter) if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178));
        }
       if($admin) if($row->media_album_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     $list->setTotalItems($total_items);
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE.'admin_media_album_search_form.inc');
	 $list->setSearchForm($search_form);
     if($admin) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(364)."</a>");
     else       $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     if($media_albumID)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                                                   ." $_PSEP ".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID)." ($total_items)");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                                                   ." $_PSEP ".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID)." ($total_items)");
       if($admin) {
		           $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_MEDIA_ALBUM_ITEM,"action_add.png","","",$w3->getWord(1342),0,16,16));
	               if($move) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM,"action_show.png","","",$w3->getWord(366),0,16,16));
				   else      $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_MOVE_MEDIA_ALBUM,"action_move.png","","",$w3->getWord(1421),0,16,16));
				  }
      }
     if(!$admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
	 if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     if($admin) {
                 if($move) {
                            $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_MOVE_MEDIA_ALBUM.$id_link.$search_link);
                            $list->setCaptionLabels(array($w3->getWord(-1),$w3->getWord(194),$w3->getWord(1671),$w3->getWord(1407)));
                            $list->setCaptionWidths(array(0,0,60,40));
                            $list->setCaptionColspan(array(1,1,1,1,4));
                            $list->setWidths(array(0,0,60,40));
                            $list->setBottomContent($form->renderClose()); // Close move form
                            require(WM3_cPATH_INCLUDE.'admin_media_album_move_form.inc');
                            $list->setExtraHeader($move_form);
					       }
                 else      {
                            $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM.$id_link.$search_link);
                            $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671),$w3->getWord(1407)));
                            $list->setCaptionWidths(array(0,60,40));
                            $list->setCaptionColspan(array(1,1,1,4));
                            $list->setWidths(array(0,60,40));
						   }
			    }
     else       {
		         $list->setRenderCaption(false);
                 $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM.$id_link.$search_link);
                 if($filter) {
                              $list->setWidths(array(0,100));
                             }
                 else        {
                              $list->setWidths(array(25,25,25,25));
                              $list->setObjectsPerRow(4);
                              $list->setUseColors(false);
			                 }
                }
     return $list->render();
    }

   public static function checkMediaAlbumItemError($w3,$media_album_type)
    {
     // Check form invalid inputs and upload error
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());

     $aux = time()."_".rand(1,99999); // Avoid overwritting the files
     if($_FIELD['title']=='') return 13;
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['media_from_local']['name']) $media_name = $aux.".".wm3Util::cutExtension($_FILES['media_from_local']['name']);
       else                                    $media_name = "";
       $error = wm3Folder::uploadFile("media_from_local",WM3_cPATH_MEDIA_ALBUM,$media_name,true,wm3MediaAlbum::getMimeTypeArray($media_album_type),0);//TODO prendere mimeType array corretto (in base a media_album_type)
       if($error) return $error;
      }
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL) if(!$_FIELD['media_from_external']) return 14; // External link

     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL) // Take file from local hard drive
      {
       // Upload the file and give the name to the files
       if($_FILES['thumbnail_from_local']['name']) $thumbnail_name = $aux."_t.".wm3Util::cutExtension($_FILES['thumbnail_from_local']['name']);
       else                                        $thumbnail_name = "";
       $error = wm3Folder::uploadFile("thumbnail_from_local",WM3_cPATH_MEDIA_ALBUM,$thumbnail_name,true,wm3Folder::mimeTypeImage(),0);
       if($error) return $error + 6;
      }
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL) if(!$_FIELD['thumbnail_from_external']) return 15; // External link
	 if(!$w3->getSectionObj()->existsSubcategory($w3,$_FIELD['media_albumID'],'media_albumID')) return 16;
     return 0; // Take file from remote folder (or no errors)
    }

   public static function addMediaAlbumItem($w3,$error = 0)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());
	 $action = WM3_cACTION_SAVE_MEDIA_ALBUM_ITEM;
     require(WM3_cPATH_INCLUDE.'admin_media_album_item_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1342));
     $form->setFieldsValues($_FIELD);

     if($error)
      {
       // Delete bad uploaded files (if exists)
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']))     @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']);
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name'])) @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name']);
       $form->setError(true);
      }
     switch($error)
      {
       // Media error
       case 1: // Upload error
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 2: // File not allowed
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 3: // File already exist error
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("File already exist (check overwrite box) $error");
         break;
        }
       case 5: // File too big
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("File too big $error");
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }
       // Thumbnail error
       case 7: // Upload error
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 8: // File not allowed
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 9: // File already exist error
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("File already exist (check overwrite box) $error");
         break;
        }
       case 11: // File too big
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("File too big $error");
         break;
        }
       case 12: // Empty file given (no upload performed)
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }
       // Other errors
       case 13: // Empty title
        {
         $_F['title']->setError(true);
         $form->setTitle($w3->getWord(166));
         break;
        }
       case 14: // Empty external link (media)
        {
         $_F['media_from_external']->setError(true);
         $form->setTitle("Error empty url $error");
         break;
        }
       case 15: // Empty external link (thumbnail)
        {
         $_F['thumbnail_from_external']->setError(true);
         $form->setTitle("Error empty url $error");
         break;
        }
       default:
        {
         // Default values for the form
         $_F['media_albumID']->setValue($w3->getVariable('media_albumID','get')); // Take media_albumID from get
         $_F['enabled']->setValue(WM3_cENABLED);
       	}
      }

     // Operation to do before render the form
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['media_from_local']->setVisible(true);
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_F['media_from_remote']->setVisible(true);
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_F['media_from_external']->setVisible(true);
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['thumbnail_from_local']->setVisible(true);
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_F['thumbnail_from_remote']->setVisible(true);
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_F['thumbnail_from_external']->setVisible(true);

     return $form->render();
    }

   public static function editMediaAlbumItem($w3,$error = 0)
    {
	 // Initialize form
	 $action = WM3_cACTION_UPDATE_MEDIA_ALBUM_ITEM;
     require(WM3_cPATH_INCLUDE.'admin_media_album_item_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit media");

     // Take variables value from db and set correct form style
     if(!$error)
      {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                               WHERE media_album_itemID = '".$w3->getVariable('media_album_itemID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),$row);
       // Default value for fields not in $row object
      }
     else $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray());

     if($error)
      {
       // Delete bad uploaded files (if exists)
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']))     @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['media_from_local']['name']);
       if(file_exists(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name'])) @unlink(WM3_cPATH_MEDIA_ALBUM.$_FILES['thumbnail_from_local']['name']);
       $form->setError(true);
      }
     $form->setFieldsValues($_FIELD);

     switch($error)
      {
       // Media error
       case 1: // Upload error
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 2: // File not allowed
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 3: // File already exist error
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("File already exist (check overwrite box) $error");
         break;
        }
       case 5: // File too big
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("File too big $error");
         break;
        }
       case 6: // Empty file given (no upload performed)
        {
         $_F['media_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }
       // Thumbnail error
       case 7: // Upload error
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Upload error $error");
         break;
        }
       case 8: // File not allowed
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Not allowed $error");
         break;
        }
       case 9: // File already exist error
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("File already exist (check overwrite box) $error");
         break;
        }
       case 11: // File too big
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("File too big $error");
         break;
        }
       case 12: // Empty file given (no upload performed)
        {
         $_F['thumbnail_from_local']->setError(true);
         $form->setTitle("Empty file name $error");
         break;
        }
       // Other errors
       case 13: // Empty title
        {
         $_F['title']->setError(true);
         $form->setTitle($w3->getWord(166));
         break;
        }
       case 14: // Empty external link (media)
        {
         $_F['media_from_external']->setError(true);
         $form->setTitle("Error empty url $error");
         break;
        }
       case 15: // Empty external link (thumbnail)
        {
         $_F['thumbnail_from_external']->setError(true);
         $form->setTitle("Error empty url $error");
         break;
        }
       default:
        {
         $_FIELD['media_from_local'] = $_FIELD['media_from_remote'] = $_FIELD['media_from_external'] = "";
         if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_F['media_from_remote']->setValue($_FIELD['media']);
	     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_F['media_from_external']->setValue($_FIELD['media']);
         $_FIELD['thumbnail_from_local'] = $_FIELD['thumbnail_from_remote'] = $_FIELD['thumbnail_from_external'] = "";
         if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_F['thumbnail_from_remote']->setValue($_FIELD['thumbnail']);
	     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_F['thumbnail_from_external']->setValue($_FIELD['thumbnail']);
       	}
      }

     // Operation to do before render the form
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['media_from_local']->setVisible(true);
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_F['media_from_remote']->setVisible(true);
	 if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_F['media_from_external']->setVisible(true);
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_F['thumbnail_from_local']->setVisible(true);
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_F['thumbnail_from_remote']->setVisible(true);
	 if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_F['thumbnail_from_external']->setVisible(true);

     return $form->render();
    }

   public static function saveMediaAlbumItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),WM3_cQUOTE_DB);

     // Media
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['media'] = $_FILES['media_from_local']['name'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['media'] = $_FIELD['media_from_remote'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['media'] = $_FIELD['media_from_external'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_media'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_media" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // Thumbnail
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['thumbnail'] = $_FILES['thumbnail_from_local']['name'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_remote'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_external'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_thumbnail'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_thumbnail" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_media_albums_items',$_FIELD,array('media_from_local','media_from_remote','media_from_external','thumbnail_from_local','thumbnail_from_remote','thumbnail_from_external'));
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateMediaAlbumItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3MediaAlbum::getMediaAlbumItemFieldsArray(),WM3_cQUOTE_DB);

     // Media
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['media'] = $_FILES['media_from_local']['name'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['media'] = $_FIELD['media_from_remote'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['media'] = $_FIELD['media_from_external'];
     if($_FIELD['source_media'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_media'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_media" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // Thumbnail
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['thumbnail'] = $_FILES['thumbnail_from_local']['name'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_REMOTE) $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_remote'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_URL)    $_FIELD['thumbnail'] = $_FIELD['thumbnail_from_external'];
     if($_FIELD['source_thumbnail'] == WM3_cUPLOAD_FROM_LOCAL)  $_FIELD['source_thumbnail'] = WM3_cUPLOAD_FROM_REMOTE; // All file uploaded from local hard drive will be stored in remote folder that the "source_thumbnail" can be only WM3_cUPLOAD_FROM_REMOTE or WM3_cUPLOAD_FROM_URL
     // TODO Attenzionare campo categoryID
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                       SET   media_albumID      = '".$_FIELD['media_albumID']."',
                             title              = '".$_FIELD['title']."',
                             alt                = '".$_FIELD['alt']."',
                             media              = '".$_FIELD['media']."',
                             thumbnail          = '".$_FIELD['thumbnail']."',
                             source_media       = '".$_FIELD['source_media']."',
                             source_thumbnail   = '".$_FIELD['source_thumbnail']."',
                             enabled            = '".$_FIELD['enabled']."',
                             languageID         = '".$_FIELD['languageID']."'
                       WHERE media_album_itemID = '".$_FIELD['media_album_itemID']."'");
     return $_FIELD['media_album_itemID'];
    }

   public static function disableMediaAlbumItem($w3,$media_album_itemID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items SET enabled = '".WM3_cDISABLED."' WHERE media_album_itemID = '$media_album_itemID'");
    }

   public static function enableMediaAlbumItem($w3,$media_album_itemID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items SET enabled = '".WM3_cENABLED."' WHERE media_album_itemID = '$media_album_itemID'");
    }

   public static function deleteMediaAlbumItem($w3,$media_album_itemID)
    {
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_media_albums_items WHERE media_album_itemID = '$media_album_itemID'");
    }

   public static function moveMediaAlbumItem($w3)
    {
	 // Move all selected media from a media album to another
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_media_albums_items WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_media_albums       WRITE");
     $to_media_albumID = $w3->getVariable('to_media_albumID','post');
	 $total_items      = intval($w3->getVariable('total_items','post'));
	 if($w3->getSectionObj()->existsSubcategory($w3,$to_media_albumID,'media_albumID'))
	  {
	   for($i = 1; $i <= $total_items; $i++)
	    {
         $media_album_itemID = $w3->getVariable('chk_item'.$i,'post');
		 if($media_album_itemID)
		  {
           $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                             SET    media_albumID      = '$to_media_albumID'
                             WHERE  media_album_itemID = '$media_album_itemID'");
          }
        }
	  }
     $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function renderSingleMediaAlbumItem($w3,$admin = false)
    {
     // Get single media (home side)

     // Prepare variables
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $categoryID    = $w3->getVariable('categoryID');
     $media_albumID = $w3->getVariable('media_albumID');
     $media_album_itemID = $w3->getVariable('media_album_itemID');
     if($media_albumID && !$categoryID) // When make a search take only media_albumID (but need also categoryID)
      $categoryID = wm3MediaAlbum::getMediaAlbumCategoryID($w3,$media_albumID);
     if($media_albumID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID = '$media_albumID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) $search_link   = "&filter=$filter"; else $search_link = '';
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';

     $pageID = $w3->getVariable('pageID');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.languageID='".$w3->getHomeLanguage()."'";

     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $id_link = "&categoryID=$categoryID&media_albumID=$media_albumID";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID=".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID
               $query_filter";
     $rs = $rs_aux = $w3->getDBObj()->query($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.title"); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_album_itemID = '$media_album_itemID'");

     // Create item
     $_DATA = array();
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
       $link = $base_link.$id_link.$search_link.$extra_link;
       if($allowed) $allowed_link = $base_allowed_link."&media_album_itemID=$row->media_album_itemID";
       require(WM3_cPATH_INCLUDE.'home_media_album_item_rate_form.inc');
       $rating = $row->votes_average;
       $info = "<nobr>(Rating $rating ".wm3Util::makeStars($w3,$rating).") $row->votes_counts votes ($row->hits hits)</nobr>";
       $embed = false;
	   $_MIME_INFO = wm3Folder::getMimeInfoArray($w3,$row->media);
       $mime_icon = $_MIME_INFO['mime_icon'];
	   if($_MIME_INFO['mime_type'] == 'audio') { $embed = true; $width = $height = 0; }
	   if($_MIME_INFO['mime_type'] == 'video') { $embed = true; $width = 400; $height = 300; }
       if($embed)
	    $picture_content = "<object id       = \"mediaPlayer\"
	                                width    = \"$width\"
			  					    height   = \"$height\"
	                                classid  = \"CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95\"
								    codebase = \"http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701\"
								    standby  = \"Loading Media Player components...\"
								    type     = \"application/x-oleobject\">
                             <param name = \"fileName\"           value = \"".WM3_cPATH_MEDIA_ALBUM."$row->media\">
                             <param name = \"animationatStart\"   value = \"true\">
                             <param name = \"transparentatStart\" value = \"true\">
                             <param name = \"autoStart\"          value = \"true\">
                             <param name = \"showControls\"       value = \"true\">
                             <param name = \"loop\"               value = \"false\">
                             <embed type          = \"application/x-mplayer2\"
                                    pluginspage   = \"http://microsoft.com/windows/mediaplayer/en/download/\"
                                    id            = \"mediaPlayer\"
							        name          = \"mediaPlayer\"
								    displaysize   = \"4\"
								    autosize      = \"-1\" 
                                    bgcolor       = \"darkblue\"
								    showcontrols  = \"true\"
								    showtracker   = \"-1\" 
                                    showdisplay   = \"0\"
								    showstatusbar = \"-1\"
								    videoborder3d = \"-1\"
								    width         = \"$width\"
								    height        = \"$height\"
                                    src           = \"".WM3_cPATH_MEDIA_ALBUM."$row->media\"
								    autostart     = \"true\"
								    designtimesp  = \"5311\"
								    loop          = \"false\">
                                  </embed>
                                 </object>";
	   else
	    $picture_content = "<img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->media\" border=\"0\" alt=\"$row->alt\" title=\"$row->alt\">";
       if($allowed) $button = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178)); else $button = "";
       $title_content = "$mime_icon $row->title $button<br><br>$info<br><br>$home_content<br>";
       ob_start();
       require($w3->getSkinObj()->getFramePicture());
       $item_content = ob_get_contents();
       ob_end_clean();
       $_DATA[0]->content = $item_content;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,"<a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     require(WM3_cPATH_INCLUDE.'admin_media_album_search_form.inc');
     $list->setSearchForm($search_form);
     if($media_albumID)
      {
	   $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM."\">".wm3MediaAlbum::getMediaAlbumCategoryName($w3,$categoryID)."</a>"
                                        ." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."\">".wm3MediaAlbum::getMediaAlbumName($w3,$media_albumID)."</a>"
                                        ." $_PSEP ".wm3MediaAlbum::getMediaAlbumItemName($w3,$media_album_itemID));
       $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$page_link."&action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM_TOP_RATING,"action_up.png","","",$w3->getWord(1216),0,16,16));
      }
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setWidths(array(100));
     if($row) {
               $list->setPageNavigatorRS($rs_aux);
               $list->setPageNavigatorField('media_album_itemID');
               $list->setPageNavigatorID($row->media_album_itemID);
               $list->setPagesNavigatorLink($base_link.$id_link.$search_link.$extra_link.$page_link."&action=".WM3_cACTION_SHOW_SINGLE_MEDIA);
		      }
     return $list->render();
    }

   public static function selectMediaAlbumType($w3)
    {
     // Return an array of wm3GUIOption objects for media album file type to upload
     return wm3Util::selectArray(array($w3->getWord(1364),$w3->getWord(1358),$w3->getWord(1359),$w3->getWord(1360),$w3->getWord(1361),$w3->getWord(1362),$w3->getWord(1363)),
                                 array(WM3_cMEDIA_ALBUM_TYPE_ALL,WM3_cMEDIA_ALBUM_TYPE_PICTURES,WM3_cMEDIA_ALBUM_TYPE_VIDEO,WM3_cMEDIA_ALBUM_TYPE_AUDIO,WM3_cMEDIA_ALBUM_TYPE_PICTURES_VIDEO,WM3_cMEDIA_ALBUM_TYPE_PICTURES_AUDIO,WM3_cMEDIA_ALBUM_TYPE_AUDIO_VIDEO));
    }

   public static function getMediaAlbumPermissionsLegend($row)
    {
     if($row->visitors_read) $visitors_permissions = "read medias";
     else                    $visitors_permissions = "no access";
     if($row->users_read)    $users_permissions    = "read medias";
     else                    $users_permissions    = "no access";
     if($row->group_read)    $group_permissions    = "read medias";
     else                    $group_permissions    = "no access";
     $str = "Visitors: $visitors_permissions<br>
             Users: $users_permissions<br>
             Group: $group_permissions";
     return $str;
    }

   public static function rateMediaAlbumItem($w3)
    {
	 if(!$w3->getPreferences('anonymous_vote_media_albums') &&
	    !$w3->getAuthenticateAdminUserID()) return;
     $media_album_itemID = $w3->getVariable('media_album_itemID','post');
	 if(!wm3Session::mediaAlbumItemAllowed($w3,$media_album_itemID,WM3_cSESSION_RATE)) return;
	 else wm3Session::mediaAlbumItemProtect($w3,$media_album_itemID,WM3_cSESSION_RATE);
     $vote = $w3->getVariable('vote','post');
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                       SET    votes_counts = votes_counts + 1,
                              votes_sum = votes_sum + $vote,
							  votes_average = votes_sum/votes_counts
                       WHERE  media_album_itemID = '$media_album_itemID'");
    }

   public static function hitMediaAlbumItem($w3)
    {
     $media_album_itemID = $w3->getVariable('media_album_itemID','get');
	 if(!wm3Session::mediaAlbumItemAllowed($w3,$media_album_itemID,WM3_cSESSION_HIT)) return;
	 else wm3Session::mediaAlbumItemProtect($w3,$media_album_itemID,WM3_cSESSION_HIT);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                       SET    hits = hits + 1
                       WHERE  media_album_itemID = '$media_album_itemID'");
    }

   public static function renderMediaAlbumItemTopRating($w3,$order_by,$label,$by_rate,$by_hits,$by_votes,$max_items=15,$admin=false)
    {
     // Get media album top rating items list (for home side)

     // Prepare variables to create the list
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_MEDIA_ALBUMS); // Used to enable admin buttons in home stage
     $filter = ''; $categoryID = 0;
     $pageID = $w3->getVariable('pageID','get');
     $page_link        = "&pageID=$pageID";
     $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_MEDIA_ALBUM_ITEM."$page_link";
     $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_MEDIA_ALBUMS;
     $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled*".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.languageID='".$w3->getHomeLanguage()."'";

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.enabled,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items.*
               FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums,
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
               WHERE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_media_albums.categoryID AND
                      ".WM3_cCONFIG_DB_PREFIX."_media_albums.media_albumID=".WM3_cCONFIG_DB_PREFIX."_media_albums_items.media_albumID
               $query_filter
			   $order_by
			   LIMIT 0,$max_items";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       //$id_link = "&categoryID=$row->categoryID&media_albumID=$row->media_albumID";
	   $id_link = "&media_albumID=$row->media_albumID";
       $link = $base_link.$page_link.$id_link."&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA;
       $n    = ($p+1).".";   
       $_PERMISSIONS = wm3MediaAlbum::getMediaAlbumPermissionsArray($w3,$row->media_albumID);
       if($_PERMISSIONS['media_read'])
	    {
         $image = "<a href=\"$link\"><img src=\"".WM3_cPATH_MEDIA_ALBUM."$row->thumbnail\" width=\"60\" height=\"45\" border=\"0\"></a>";
         $title = "<a href=\"$link\">$row->title</a><br><i>".$row->alt."</i>";
		}
	   else
        {
		 $image = wm3Util::renderImg("misc_error_mini.png");
		 $title = "You can not see this media";
	    }	
       if($by_rate)
	    {
	     $rating = "<nobr>".wm3Util::makeStars($w3,$row->votes_average)."</nobr>";
         $value  = "<nobr>($row->votes_average)</nobr>";
	    }
	   else
	    {
         if($by_hits)  $value = "<nobr>$row->hits hits</nobr>";
		 if($by_votes) $value = "<nobr>$row->votes_counts votes</nobr>";
		}
       if($by_rate) {
		             $_DATA[$p]->n      = $n;
		             $_DATA[$p]->image  = $image;
		             $_DATA[$p]->title  = $title;
		             $_DATA[$p]->rating = $rating;
		             $_DATA[$p]->value  = $value;
		            }
	   else         {
		             $_DATA[$p]->n     = $n;
		             $_DATA[$p]->image = $image;
		             $_DATA[$p]->title = $title;
		             $_DATA[$p]->value = $value;
	                }
       if($allowed)
        {
         $allowed_link = $base_allowed_link."&media_album_itemID=$row->media_album_itemID&action=".WM3_cACTION_SHOW_SINGLE_MEDIA;
         $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_MEDIA_ALBUM_ITEM,"action_edit.png",$w3->getWord(178));
        }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
	 $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     if($by_rate)
	  {
	   require(WM3_cPATH_INCLUDE.'admin_media_album_search_form.inc');
       $list->setSearchForm($search_form);
	   $_SEP = $w3->getSkinObj()->getSeparator();
       $list->setTitle($w3->getWord($label)." $_SEP <a href=\"$base_link$page_link\">".$w3->getWord(364)."</a>");
       $list->setWidths(array(0,0,85,10,5));
      }
	 else
	  {
	   $list->setTitle($w3->getWord($label));
	   $list->setWidths(array(0,0,90,10));
	  }
     return $list->render();
    }

   public static function makeCounterMediaAlbumItems($w3,$media_albumID,$filter="")
    {
     // Get the number of items in a media album
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_media_albums_items","WHERE media_albumID = '$media_albumID' $filter");
     if($total == 1) $label = $w3->getWord(1684); else $label = $w3->getWord(1683);
     return " ($total $label)";
    }

   public static function getMimeTypeArray($media_album_type)
    {
     // Get the right mime type array
	 switch($media_album_type)
      {
       case WM3_cMEDIA_ALBUM_TYPE_ALL:            { return wm3Folder::mimeTypeImageAudioVideo(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES:       { return wm3Folder::mimeTypeImage(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_VIDEO:          { return wm3Folder::mimeTypeVideo(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO:          { return wm3Folder::mimeTypeAudio(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_VIDEO: { return wm3Folder::mimeTypeImageVideo(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_AUDIO: { return wm3Folder::mimeTypeImageAudio(); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO_VIDEO:    { return wm3Folder::mimeTypeAudioVideo(); break; }
       default:                                   { return array(); }
	  }
    }

   public static function getMediaAlbumMimeIcons($media_album_type)
    {
     // Get media album mime icons
	 switch($media_album_type)
      {
 	   case WM3_cMEDIA_ALBUM_TYPE_ALL:           { $icon = wm3Util::renderImg("mime_image.png",'',24,24).wm3Util::renderImg("mime_audio.png",'',24,24).wm3Util::renderImg("mime_video.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES:      { $icon = wm3Util::renderImg("mime_image.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_VIDEO:         { $icon = wm3Util::renderImg("mime_video.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO:         { $icon = wm3Util::renderImg("mime_audio.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_VIDEO:{ $icon = wm3Util::renderImg("mime_image.png",'',24,24).wm3Util::renderImg("mime_video.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_PICTURES_AUDIO:{ $icon = wm3Util::renderImg("mime_image.png",'',24,24).wm3Util::renderImg("mime_audio.png",'',24,24); break; }
	   case WM3_cMEDIA_ALBUM_TYPE_AUDIO_VIDEO:   { $icon = wm3Util::renderImg("mime_audio.png",'',24,24).wm3Util::renderImg("mime_video.png",'',24,24);	break; }
	   default:                                  { $icon = ""; }
      }
	 return $icon;
    }

   public static function isUsedMediaAlbumItemPicture($w3,$file)
    {
	 // Return true if a picture its used in a row
	 $rs = $w3->getDBObj()->query("SELECT media_albumID
	                         FROM   ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
							 WHERE  media = '$file' OR  thumbnail = '$file'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
	 else                         return true;
    }

  }

?>
