<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Menu
  {

   function __construct() { }

   public static function getMenuFieldsArray()
    {
     return array('menuID','name','description','icon','enabled','languageID','ts');
    }

   public static function getMenuItemFieldsArray()
    {
     return array('menu_itemID','title','position','is_separator',
	              'menuID','menudropdownID','categoryID','pageID','url','subchannelID','target','link_external_url','link_external_target','linkID',
				  'enabled','languageID','ts');
    }

   public static function getMenusDataArray($w3)
    {
	 // Get active menu from database and put the result in an array of objects
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items
                                   WHERE enabled = '".WM3_cENABLED."' AND languageID = '".$w3->getHomeLanguage()."'
                                   ORDER BY position");
     return $w3->getDBObj()->resultToArray($rs);
	}

   public static function makeMenuItemLink($row,$icon = '')
    {
     // Make a menu item link from a "_menus_items" row's (passing a row perform a minor number of queries)
     $str = '';
     $title = $row->title.$icon;
     switch($row->categoryID)
      {
       case WM3_cMENU_ITEM_CATEGORY_CUSTOM:
        {
         $str .= wm3Page::makePageLink($row->linkID,$title);
         break;
        }
       case WM3_cMENU_ITEM_CATEGORY_CHANNEL:
        {
         // TODO
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$row->linkID\">$title</a>";
         break;
        }
       case WM3_cMENU_ITEM_CATEGORY_HOME:
        {
         $str .= "<a href=\"".WM3_cCONFIG_HOME_FILE."\">$title</a>";
         break;
        }
       case WM3_cMENU_ITEM_CATEGORY_ADMIN:
        {
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."\">$title</a>";
         break;
        }
       case WM3_cMENU_ITEM_CATEGORY_USER:
        {
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."\">$title</a>";
         break;
        }
       case WM3_cMENU_ITEM_CATEGORY_EXTERNAL:
        {
         $str .= "<a href=\"$row->url\" target=\"$row->target\">$title</a>";
         break;
        }
       case WM3_cMENU_ITEM_CATEGORY_VOID:
        {
         $str .= "<a href=\"javascript:void(0);\">$title</a>";
         break;
        }
      }
     return $str;
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_MENU_ITEM:
        {
         wm3Menu::disableMenuItem($w3,$w3->getVariable('menu_itemID','get'));
         return wm3Menu::getMenuItemList($w3,$w3->getVariable('menu_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MENU_ITEM:
        {
         wm3Menu::enableMenuItem($w3,$w3->getVariable('menu_itemID','get'));
         return wm3Menu::getMenuItemList($w3,$w3->getVariable('menu_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MENU_ITEM:
        {
         wm3Menu::deleteMenuItem($w3,$w3->getVariable('menu_itemID','get'));
         return wm3Menu::getMenuItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_MENU_ITEM:
        {
         return wm3Menu::addMenuItem($w3);
         break;
        }
       case WM3_cACTION_EDIT_MENU_ITEM:
        {
         return wm3Menu::editMenuItem($w3);
         break;
        }
       case WM3_cACTION_SWAP_MENU_ITEM:
        {
         wm3Menu::swapMenuItem($w3);
         return wm3Menu::getMenuItemList($w3,$w3->getVariable('menu_itemID','get'));
         break;
        }
       case WM3_cACTION_UNLINK_MENU_ITEM:
        {
         wm3Menu::unlinkMenuItem($w3,$w3->getVariable('menu_itemID','get'));
         return wm3Menu::getMenuItemList($w3,$w3->getVariable('menu_itemID','get'));
         break;
        }
       case WM3_cACTION_ADD_MENU:
        {
         return wm3Menu::addMenu($w3);
         break;
        }
       case WM3_cACTION_EDIT_MENU:
        {
         return wm3Menu::editMenu($w3);
         break;
        }
       case WM3_cACTION_DISABLE_MENU:
        {
         wm3Menu::disableMenu($w3,$w3->getVariable('menuID','get'));
         return wm3Menu::getMenuList($w3,$w3->getVariable('menuID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MENU:
        {
         wm3Menu::enableMenu($w3,$w3->getVariable('menuID','get'));
         return wm3Menu::getMenuList($w3,$w3->getVariable('menuID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MENU:
        {
         wm3Menu::deleteMenu($w3,$w3->getVariable('menuID','get'));
         return wm3Menu::getMenuList($w3);
         break;
        }
       case WM3_cACTION_SHOW_MENU:
        {
         return wm3Menu::getMenuItemList($w3);
         break;
        }
       default:
        {
         return wm3Menu::getMenuList($w3);
        }
      }
    }

   public static function getMenuList($w3,$currentID = 0)
    {
     // Get menus list

     // Prepare variables to create the list
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus ORDER BY menuID";
     $rs = $w3->getDBObj()->query($query);
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false; $i = 1;
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $total = wm3Menu::countMenuItems($w3,$row->menuID);
       if($total == 1) $tlabel = $w3->getWord(1351);
       else            $tlabel = $w3->getWord(1350);
       $link = $base_link.$id_link."&menuID=$row->menuID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\"> ";
       if($row->menuID == WM3_cMAIN_MENU) $_DATA[$p]->main = wm3Util::renderImg('misc_star.png',         $w3->getWord(1783),24,24);
       else                               $_DATA[$p]->main = wm3Util::renderImg('misc_star_inactive.png','Normal menu',24,24);
       $row_menu_item = wm3Menu::getMenuItemDropdownLink($w3,$row->menuID);
       if($row_menu_item)
        {
		 $label = $w3->getWord(-1)."Linked as dropdown menu from '".wm3Menu::getMenuName($w3,$row_menu_item->menuID)."->"."$row_menu_item->title' (Click to edit)";
         $_DATA[$p]->link = wm3Util::actionButton("$link&menu_itemID=$row_menu_item->menu_itemID&action=".WM3_cACTION_EDIT_MENU_ITEM,"misc_link.png",$label);
	    }
       else $_DATA[$p]->link = wm3Util::renderImg('misc_link_broken.png','Not linked as dropdown menu',24,24);
       if($row->menuID == WM3_cMAIN_MENU)
        {
         $_DATA[$p]->name = "<a href=\"$link&action=".WM3_cACTION_SHOW_MENU."\">".$w3->getWord(1782)."</a><br>($total $tlabel)";
         $_DATA[$p]->info = $lang_flag.$w3->getWord(1783);
		}
	   else
	    {
         $_DATA[$p]->name = "<a href=\"$link&action=".WM3_cACTION_SHOW_MENU."\">$row->name</a><br>($total $tlabel)";
         $_DATA[$p]->info = $lang_flag.$row->description;
	    }
       $i++;

       // Buttons
       $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_MENU_ITEM,"action_add_from.png",$w3->getWord(1767));
       if($row->menuID == WM3_cMAIN_MENU)
        {
         if($row->enabled) $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_MENU,"action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_MENU,"action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b3 = wm3Util::renderImg('action_edit_inactive.png','',24,24);
         $_DATA[$p]->b4 = wm3Util::renderImg('action_delete_inactive.png','',24,24);
	    }
	   else
	    {
		 $_DATA[$p]->b2 = wm3Util::renderImg('action_disable_inactive.png','',24,24);
		 $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MENU,"action_edit.png",$w3->getWord(178));
		 $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_MENU,"action_delete.png",$w3->getWord(179),$w3->getWord(1785));
		}
       if($row->menuID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;       
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(1766));
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setCaptionLabels(array('',$w3->getWord(189),$w3->getWord(1407)));
     $list->setCaptionWidths(array(0,40,60));
     $list->setCaptionColspan(array(2,1,1,4));
     $list->setWidths(array(0,0,40,60));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function addMenu($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuFieldsArray());
	 $action = WM3_cACTION_ADD_MENU;
	 require(WM3_cPATH_INCLUDE.'admin_menu_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(5));
     $form->setFieldsValues($_FIELD);

     // Render form
     if($form->wasSubmit())
      {
       if($form->validate())
        {
         $lastID = wm3Menu::saveMenu($w3);
         return wm3Menu::getMenuList($w3,$lastID);
		}
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['icon']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ICONS); // Set due preview image
     $_F['icon']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_ICONS,1,'top','preview_image'));

     return $form->render();
    }

   public static function editMenu($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_MENU;
	 require(WM3_cPATH_INCLUDE.'admin_menu_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(171));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus
                                     WHERE menuID = '".$w3->getVariable('menuID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Menu::getMenuFieldsArray(),$row);

       // Default value for fields not in $row object

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Menu::updateMenu($w3);
         return wm3Menu::getMenuList($w3,$lastID);
		}
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['icon']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ICONS); // Set due preview image
     $_F['icon']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_ICONS,1,'top','preview_image'));

     return $form->render();
    }


   public static function saveMenu($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $_FIELD['enabled'] = WM3_cENABLED;
     $_FIELD['languageID'] = WM3_cLANGUAGE_ALL;
     
     $w3->getDBObj()->saveAllTableFields('_menus',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateMenu($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuFieldsArray(),WM3_cQUOTE_DB);
     
     if($_FIELD['menuID'] == WM3_cMAIN_MENU) return; // Can not edit main menu

     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus
                             SET name        = '".$_FIELD['name']."',
                                 description = '".$_FIELD['description']."',
                                 icon        = '".$_FIELD['icon']."'
                             WHERE menuID = '".$_FIELD['menuID']."'");
     return $_FIELD['menuID'];
    }

   public static function disableMenu($w3,$menuID)
    {
	 if($menuID == WM3_cMAIN_MENU)
	  $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus SET enabled = '".WM3_cDISABLED."' WHERE menuID = '$menuID'");
	}

   public static function enableMenu($w3,$menuID)
    {
	 if($menuID == WM3_cMAIN_MENU)
	  $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus SET enabled = '".WM3_cENABLED."'  WHERE menuID = '$menuID'");
	}

   public static function deleteMenu($w3,$menuID)
    {
	 if($menuID == WM3_cMAIN_MENU) return; // Can not delete main menu

     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menus_items WRITE, ".WM3_cCONFIG_DB_PREFIX."_menus WRITE");

     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items WHERE menuID='$menuID'");
     while($row = $w3->getDBObj()->fetch($rs))
      wm3Menu::deleteMenuItem($w3,$row->menu_itemID,false); // Delete items for the menu
   	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_menus WHERE menuID = '$menuID'");

   	 $w3->getDBObj()->query("UNLOCK TABLES");
   	}

   public static function getPositions($w3,$menuID)
    {
     // Create an array with menu item position
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items WHERE menuID='$menuID' ORDER BY position");
     $i = 1; $_MPOS['up'][0] = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $_MPOS['up'][$i] = $_MPOS['down'][$i] = $row->menu_itemID;
       $i++;
      }
     $m = $i-1; $_MPOS['down'][$i] = 0;
     for($i = $m;$i >= 1; $i--) $_MPOS['up'][$i]   = $_MPOS['up'][$i-1];
     for($i = 1;$i <= $m; $i++) $_MPOS['down'][$i] = $_MPOS['down'][$i+1];
     return $_MPOS;
    }

   public static function getPosition($w3,$menu_itemID)
    {
     // Get the position of a menu item
     $rs = $w3->getDBObj()->query("SELECT position FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items
                                   WHERE menu_itemID = '$menu_itemID'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) return $row->position;
    }

   public static function getMenuItemList($w3,$currentID = 0)
    {
     // Get items list for a menu

     // Prepare variables to create the list
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $menuID    = $w3->getVariable('menuID');
     $id_link   = "&menuID=$menuID";

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items WHERE menuID='$menuID' ORDER BY position";
     $rs = $w3->getDBObj()->query($query);
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false; $i = 1;
     $_MPOS = wm3Menu::getPositions($w3,$menuID);
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&menu_itemID=$row->menu_itemID";

       // Move panels up and down buttons and panel info
       $_DATA[$p]->position = $row->position;
       if($_MPOS['up'][$i]   == 0) $_DATA[$p]->b1 = wm3Util::renderImg('action_equal.png','',24,24);
       else                        $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_MENU_ITEM."&swapID=".$_MPOS['up'][$i],"action_up.png",$w3->getWord(1279));
       if($_MPOS['down'][$i] == 0) $_DATA[$p]->b2 = wm3Util::renderImg('action_equal.png','',24,24);
       else                        $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_MENU_ITEM."&swapID=".$_MPOS['down'][$i],"action_down.png",$w3->getWord(1280));
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
       $lang_flag .= " (".wm3Menu::getMenuItemCategoryName($w3,$row->categoryID).") ";
       if($row->menudropdownID != 0) $lang_flag .= wm3Util::actionButton("$link&menuID=".$row->menudropdownID."&action=".WM3_cACTION_SHOW_MENU,"misc_link_mini.png",'','',$w3->getWord(1770),0,16,16);
       $_DATA[$p]->title = wm3Menu::makeMenuItemLink($row);
       $_DATA[$p]->info  = $lang_flag;
       $i++;

       // Buttons
       if($row->menudropdownID == 0) $_DATA[$p]->b3 = '';
       else                          $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_UNLINK_MENU_ITEM,"misc_link_broken.png",$w3->getWord(180)."Linked to menu: '".wm3Menu::getMenuName($w3,$row->menudropdownID)."' (click to unlink) TODO",$w3->getWord(1786));
       if($row->enabled)             $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_MENU_ITEM,"action_disable.png",$w3->getWord(180));
       else                          $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_MENU_ITEM,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b5 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MENU_ITEM,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b6 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_MENU_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(713));
       if($row->menu_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;       
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(174));
     $list->setTotalItems($total_items);
     $list->setTitle("<a href=\"$base_link\">".$w3->getWord(1766)."</a>");
     if($menuID)
      {
       $_SEP  = $w3->getSkinObj()->getSeparator();
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
	   if($menuID == WM3_cMAIN_MENU) $menu_name = $w3->getWord(1782);
	   else                          $menu_name = wm3Menu::getMenuName($w3,$menuID);
       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_MENU."\">$menu_name ($total_items)</a>");
       $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_MENU_ITEM,"action_add.png","","",$w3->getWord(1767),0,16,16));
      }
     if($found) $list->setCurrentID($currentID);
     $list->setCaptionLabels(array($w3->getWord(543),$w3->getWord(194),$w3->getWord(1407)));
     $list->setCaptionWidths(array(0,40,60));
     $list->setCaptionColspan(array(3,1,1,4));
     $list->setWidths(array(0,0,0,40,60));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function addMenuItem($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuItemFieldsArray());
	 $action = WM3_cACTION_ADD_MENU_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_menu_item_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(5));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['menuID']->setValue($w3->getVariable('menuID','get')); // Take menuID from get
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Menu::saveMenuItem($w3);
         return wm3Menu::getMenuItemList($w3,$lastID);
		}
      }

     // Operation to do before render the form
	 if($_FIELD['categoryID'] == WM3_cMENU_ITEM_CATEGORY_CUSTOM || !$_FIELD['categoryID']) $_F['pageID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_ITEM_CATEGORY_CHANNEL)                          $_F['subchannelID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_ITEM_CATEGORY_EXTERNAL)                         { $_F['link_external_url']->setVisible(true); $_F['link_external_target']->setVisible(true); }

     return $form->render();
    }

   public static function editMenuItem($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_MENU_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_menu_item_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(171));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items
                                     WHERE menu_itemID = '".$w3->getVariable('menu_itemID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Menu::getMenuItemFieldsArray(),$row);

       // Default value for fields not in $row object
       switch($_FIELD['categoryID'])
        {
         case WM3_cMENU_ITEM_CATEGORY_CUSTOM:   { $_FIELD['pageID']       = $_FIELD['linkID']; $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; break; }
         case WM3_cMENU_ITEM_CATEGORY_CHANNEL:  { $_FIELD['subchannelID'] = $_FIELD['linkID']; $_FIELD['pageID']       = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; break; }
	     case WM3_cMENU_ITEM_CATEGORY_EXTERNAL: { $_FIELD['pageID'] = $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['url']; $_FIELD['link_external_target'] = $_FIELD['target']; break; }
         default: { $_FIELD['pageID'] = $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; }
        }

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuItemFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Menu::updateMenuItem($w3);
         return wm3Menu::getMenuItemList($w3,$lastID);
		}
      }

     // Operation to do before render the form
	 if($_FIELD['categoryID'] == WM3_cMENU_ITEM_CATEGORY_CUSTOM || !$_FIELD['categoryID']) $_F['pageID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_ITEM_CATEGORY_CHANNEL)                          $_F['subchannelID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_ITEM_CATEGORY_EXTERNAL)                         { $_F['link_external_url']->setVisible(true); $_F['link_external_target']->setVisible(true); }

     return $form->render();
    }

   public static function saveMenuItem($w3)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menus_items WRITE");

     $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $_FIELD['is_separator'] = WM3_cDISABLED; //TODO...
     switch($_FIELD['categoryID'])
      {
       case WM3_cMENU_ITEM_CATEGORY_CUSTOM:   { $_FIELD['linkID'] = $_FIELD['pageID'];  $_FIELD['url'] = $_FIELD['target'] = ''; break; }
       case WM3_cMENU_ITEM_CATEGORY_CHANNEL:  { $_FIELD['linkID'] = $_FIELD['subchannelID']; $_FIELD['url'] = $_FIELD['target'] = ''; break; }
	   case WM3_cMENU_ITEM_CATEGORY_EXTERNAL: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['link_external_url']; $_FIELD['target'] = $_FIELD['link_external_target']; break; }
       default: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['target'] = ''; }
      }
     if($_FIELD['position'] <= 0) $_FIELD['position'] = 1; // If position its <= 0 (invalid position) the position will be 1
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                             SET position = position + 1
                             WHERE position >= '".$_FIELD['position']."'");
     // The last array passed, will remove variables that are not used in the db table
     $w3->getDBObj()->saveAllTableFields('_menus_items',$_FIELD,array('pageID','subchannelID','link_external_url','link_external_target'));

     $w3->getDBObj()->query("UNLOCK TABLES");
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateMenuItem($w3)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menus_items WRITE");
     
     $_FIELD = webmatic3::getPostValueArray(wm3Menu::getMenuItemFieldsArray(),WM3_cQUOTE_DB);
     
     wm3Menu::updateMenuItemPositions($w3,$_FIELD['menu_itemID'],$_FIELD['position']);

     switch($_FIELD['categoryID'])
      {
       case WM3_cMENU_ITEM_CATEGORY_CUSTOM:   { $_FIELD['linkID'] = $_FIELD['pageID'];  $_FIELD['url'] = $_FIELD['target'] = ''; break; }
       case WM3_cMENU_ITEM_CATEGORY_CHANNEL:  { $_FIELD['linkID'] = $_FIELD['subchannelID']; $_FIELD['url'] = $_FIELD['target'] = ''; break; }
	   case WM3_cMENU_ITEM_CATEGORY_EXTERNAL: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['link_external_url']; $_FIELD['target'] = $_FIELD['link_external_target']; break; }
       default: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['target'] = ''; }
      }

     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                       SET title          = '".$_FIELD['title']."',
                           menuID         = '".$_FIELD['menuID']."',
                           menudropdownID = '".$_FIELD['menudropdownID']."',
                           linkID         = '".$_FIELD['linkID']."',
                           categoryID     = '".$_FIELD['categoryID']."',
                           url            = '".$_FIELD['url']."',
                           target         = '".$_FIELD['target']."',
                           position       = '".$_FIELD['position']."',
                           enabled        = '".$_FIELD['enabled']."',
                           languageID     = '".$_FIELD['languageID']."'
                       WHERE menu_itemID = '".$_FIELD['menu_itemID']."'");
                       
     $w3->getDBObj()->query("UNLOCK TABLES");
     return $_FIELD['menu_itemID'];
    }

   public static function swapMenuItem($w3)
    {
     // Swap two item position (move up or down items)
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menus_items WRITE");
     
     $menu_itemID   = $w3->getVariable('menu_itemID','get');
     $swapID        = $w3->getVariable('swapID','get');     
     $swap_position = wm3Menu::getPosition($w3,$swapID);
     $position      = wm3Menu::getPosition($w3,$menu_itemID);

     if($position && $swap_position) // Swap effected only if the item exists (by checking the position)
      {
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                         SET position      = '$swap_position'
                         WHERE menu_itemID = '$menu_itemID'");
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                         SET position      = '$position'
                         WHERE menu_itemID = '$swapID'");
      }

     $w3->getDBObj()->query("UNLOCK TABLES");
     return $menu_itemID;
    }

   public static function updateMenuItemPositions($w3,$menu_itemID,$new_position)
    {
     // Update the right item position when an item position changed
     $position = wm3Menu::getPosition($w3,$menu_itemID);

     if($position) // Update effected only if the item exists (by checking the position)
      {
       if($new_position > $position)
        {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                           SET position = position - 1
                           WHERE position > '$position' AND position <= '$new_position'");

         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                           SET position      = '$new_position'
                           WHERE menu_itemID = '$menu_itemID'");
        }
       else
        {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                           SET position = position + 1
                           WHERE position >= '$new_position' AND position < '$position'");

         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                           SET position      = '$new_position'
                           WHERE menu_itemID = '$menu_itemID'");
        }
      }
    }

   public static function disableMenuItem($w3,$menu_itemID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items SET enabled = '".WM3_cDISABLED."' WHERE menu_itemID = '$menu_itemID'"); }

   public static function enableMenuItem($w3,$menu_itemID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items SET enabled = '".WM3_cENABLED."'  WHERE menu_itemID = '$menu_itemID'"); }
   
   public static function unlinkMenuItem($w3,$menu_itemID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items SET menudropdownID = '0'  WHERE menu_itemID = '$menu_itemID'"); }
   
   public static function deleteMenuItem($w3,$menu_itemID,$lock = true)
    {
     if($lock) $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menus_items WRITE");

     $position = wm3Menu::getPosition($w3,$menu_itemID);
     if($position) // Update positions only if the deleted item exists (by checking the position)
      {
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
                         SET position = position - 1
                         WHERE position > '$position'");
      }
   	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items WHERE menu_itemID = '$menu_itemID'");

   	 if($lock) $w3->getDBObj()->query("UNLOCK TABLES");
   	}

   public static function selectMenuItemCategory($w3)
    {
     // Return an array of wm3GUIOption objects for menu item categories select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories
                                   ORDER BY position DESC");
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($w3->getLanguageObj()->translate($row->name),$row->categoryID));
     return $array;
    }

   public static function selectMenu($w3,$dropdown = false)
    {
     // Return an array of wm3GUIOption objects for menu select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus ORDER BY menuID,name DESC");
     if($dropdown) array_push($array,new wm3GUIOption($w3->getWord(1784),0));
     while($row = $w3->getDBObj()->fetch($rs))
      {
       if($row->menuID == WM3_cMAIN_MENU) array_push($array,new wm3GUIOption($w3->getWord(1782),$row->menuID));
       else                               array_push($array,new wm3GUIOption($row->name,$row->menuID));
      }
     return $array;
    }

   public static function getMenuItemDropdownLink($w3,$menuID)
    {
     // Return true if the menu is linked as dropdown menu by a menu item else return false
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items WHERE menudropdownID = '$menuID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row;
	}

   public static function getMenuName($w3,$menuID)
    {
     // Get menu name from menuID
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_menus WHERE menuID = '$menuID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function getMenuItemCategoryName($w3,$categoryID)
    {
     // Get menu item category name
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories WHERE categoryID = '$categoryID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $w3->getLanguageObj()->translate($row->name);
    }

   public static function existsMenu($w3,$menuID)
    {
     // Return true if the menu with menuID exists else return false
     $rs = $w3->getDBObj()->query("SELECT menuID FROM ".WM3_cCONFIG_DB_PREFIX."_menus
                                   WHERE  menuID = '$menuID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                                     return false;
	}

   private static function countMenuItems($w3,$menuID,$filter = '')
    {
     // Get the number of menu items for a menu
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_menus_items","WHERE menuID = '$menuID'$filter");
     return $total;
    }

   public static function selectMenuItemPosition($w3)
    {
     // Return an array of wm3GUIOption objects for menu item position select
     $array = array(); $i = 1;
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menus_items");
     while($row = $w3->getDBObj()->fetch($rs))
      {
       array_push($array,new wm3GUIOption($i,$i));
       $i++;
      }
     if($w3->getAction() == WM3_cACTION_ADD_MENU_ITEM) array_push($array,new wm3GUIOption($i,$i));
     return $array;
    }

  }

?>
