<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3News extends wm3Section
  {

   function __construct() { }

   public static function getSectionParameters()
    {
     // Set the right parameters for news section
     return array(
                  'section'                   => WM3_cSECTION_NEWS,
                  'allowed_section'           => WM3_cSECTION_LINKS,
                  'category_form'             => 'admin_news_category_form.inc',
                  'search_form'               => 'admin_news_search_form.inc',
                  'table_categories'          => '_news_categories',
                  'table_subcategories'       => '_news',
                  'table_subcategories_count' => '_news',
                  'action_add_category'       => WM3_cACTION_ADD_NEWS_CATEGORY,
                  'action_edit_category'      => WM3_cACTION_EDIT_NEWS_CATEGORY,
                  'action_show_subcategory'   => WM3_cACTION_SHOW_NEWS,
                  'action_add_subcategory'    => WM3_cACTION_ADD_NEWS,
                  'action_disable_category'   => WM3_cACTION_DISABLE_NEWS_CATEGORY,
                  'action_enable_category'    => WM3_cACTION_ENABLE_NEWS_CATEGORY,
                  'action_delete_category'    => WM3_cACTION_DELETE_NEWS_CATEGORY,
                  'action_search'             => WM3_cACTION_SHOW_NEWS,
                  'label_category_list_title' => 833,
                  'label_subcategory_add'     => 1654,
                  'label_subcategories_count' => 1679);
    }

   public static function getNewsFieldsArray()
    {
     return array('newsID','title','categoryID','userID','render_mode','news','enabled','languageID','update_ts','hits','news_ts','ts','votes_counts','votes_sum','votes_average');
    }

   public static function getNewsCommentFieldsArray()
    {
     return array('commentID','render_mode','comment','newsID','userID','enabled','languageID','ts');
    }

   public static function executeHomeAction($w3)
    {
     // News page content
     switch($w3->getAction())
      {
       case WM3_cACTION_DELETE_NEWS_COMMENT:
        {
		 if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS)) wm3News::deleteNewsComment($w3,$w3->getVariable('newsID','get'),$w3->getVariable('commentID','get'));
         return wm3News::renderSingleNews($w3);
         break;
        }
       case WM3_cACTION_DELETE_ALL_NEWS_COMMENT:
        {
         if(wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS)) wm3News::deleteNewsComment($w3,$w3->getVariable('newsID','get'),0,true);
         return wm3News::renderSingleNews($w3);
         break;
        }
       case WM3_cACTION_SHOW_SINGLE_NEWS:
        {
         wm3News::hitNews($w3);			
         return wm3News::renderSingleNews($w3);
         break;
        }
       case WM3_cACTION_PRINTABLE_SINGLE_NEWS:
        {
         wm3News::renderSingleNewsPrintable($w3);
         break;
        }
       default:
        {
         return wm3News::renderAllNews($w3);
        }
      }     
    }

   public static function executeUserAction($w3,$full)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_NEWS:
        {
         return wm3News::addNews($w3,true,$full);
         break;
        }
       case WM3_cACTION_EDIT_NEWS:
        {
         return wm3News::editNews($w3,0,true,$full);
         break;
        }
       case WM3_cACTION_DISABLE_NEWS:
        {
         wm3News::disableNews($w3,$w3->getVariable('newsID','get'),true,$full);
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'),true,true,$full);
         break;
        }
       case WM3_cACTION_ENABLE_NEWS:
        {
         wm3News::enableNews($w3,$w3->getVariable('newsID','get'),true,$full);
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'),true,true,$full);
         break;
        }
       case WM3_cACTION_DELETE_NEWS:
        {
         wm3News::deleteNews($w3,$w3->getVariable('newsID','get'),true,$full);
         return wm3News::getNewsList($w3,0,true,true,$full);
         break;
        }
       case WM3_cACTION_DUPLICATE_NEWS:
        {
         $lastID = wm3News::duplicateNews($w3);
         // $msg= news duplicated...//TODO
         return wm3News::getNewsList($w3,$lastID,true,true,$full);
         break;
        }
       default:
        {
         return wm3News::getNewsList($w3,0,true,true,$full);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_NEWS_CATEGORY:
        {
         return wm3News::addNewsCategory($w3);
         break;
        }
       case WM3_cACTION_EDIT_NEWS_CATEGORY:
        {
         return wm3News::editNewsCategory($w3);
         break;
        }
       case WM3_cACTION_DISABLE_NEWS_CATEGORY:
        {
         wm3News::disableNewsCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3News::getNewsCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_NEWS_CATEGORY:
        {
         wm3News::enableNewsCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3News::getNewsCategoryList($w3,$w3->getVariable('categoryID','get'));
         break;
        }
       case WM3_cACTION_DELETE_NEWS_CATEGORY:
        {
         wm3News::deleteNewsCategory($w3,$w3->getVariable('categoryID','get'));
         return wm3News::getNewsCategoryList($w3);
         break;
        }
       case WM3_cACTION_ADD_NEWS:
        {
         return wm3News::addNews($w3);
         break;
        }
       case WM3_cACTION_EDIT_NEWS:
        {
         return wm3News::editNews($w3);
         break;
        }
       case WM3_cACTION_DISABLE_NEWS:
        {
         wm3News::disableNews($w3,$w3->getVariable('newsID','get'));
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_NEWS:
        {
         wm3News::enableNews($w3,$w3->getVariable('newsID','get'));
         return wm3News::getNewsList($w3,$w3->getVariable('newsID','get'));
         break;
        }
       case WM3_cACTION_DELETE_NEWS:
        {
         wm3News::deleteNews($w3,$w3->getVariable('newsID','get'));
         return wm3News::getNewsList($w3);
         break;
        }
       case WM3_cACTION_DUPLICATE_NEWS:
        {
         $lastID = wm3News::duplicateNews($w3);
         // $msg= news duplicated...//TODO
         return wm3News::getNewsList($w3,$lastID);
         break;
        }
       case WM3_cACTION_SHOW_NEWS:
        {
         return wm3News::getNewsList($w3);
         break;
        }
       default:
        {
         return wm3News::getNewsCategoryList($w3);
        }
      }
    }

   public static function renderCommentNews($w3,$currentID = 0)
    {
     // Render comments list for a single news in home page

     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
     $newsID     = $w3->getVariable('newsID');
     $pg         = '';// $w3->getVariable('pg'); //TODO Visualizzare tutti i commenti su unica pagina oppure su piu' pagine? (in tal caso non confondere $pg delle notizie con il $pg (che va quindi rinominato) dei commenti)
     $query_filter = " WHERE newsID='$newsID' AND enabled='".WM3_cENABLED."'";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $order_by = "ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news_comments.ts DESC";
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news_comments
               $query_filter"; //TODO Join per categorie disabled
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     //if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");//TODO decommentare questa riga se si vogliono visualizzare i commenti su piu' pagine
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by);//TODO togliere questa riga se si vogliono visualizzare i commenti su piu' pagine

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       $pic  = wm3User::getAvatar($w3,$row->userID);
       $date = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
       $_DATA[$p]->icon = "<div align=\"center\"><img src=\"$pic\" border=\"\" width=\"36\" height=\"36\"><br>".wm3User::getUserLogin($w3,$row->userID)."</div></td>";
       $_DATA[$p]->text = "<i>$date</i><br>".wm3Util::renderContent($w3,$row->comment,$row->render_mode)."</td>";
       // Buttons
       if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$base_link&newsID=$newsID&commentID=$row->commentID&action=".WM3_cACTION_DELETE_NEWS_COMMENT,"action_delete.png",$w3->getWord(179),$w3->getWord(1247));
       if($row->commentID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(559));
     $list->setTotalItems($total_items);
     if($allowed && $total_items > 0)
      {
	   $_SEP = $w3->getSkinObj()->getSeparator();
       $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton("$base_link&newsID=$newsID&action=".WM3_cACTION_DELETE_ALL_NEWS_COMMENT,"action_delete_mini.png","",$w3->getWord(1551),$w3->getWord(-1)."Delete all comments",0,16,16));
	  }
     //TODO decommentare se si vogliono visualizzare i commenti su piu' pagine
     //$list->setMaxPageItems($max_page_items);
     //$list->setPage($pg);
     //$list->setPagesNavigatorLink($base_link);
     if($found) $list->setCurrentID($currentID);
     $list->setRenderPagesNavigator(false);
     $list->setRenderCaption(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

   public static function deleteNewsComment($w3,$newsID,$commentID,$all = false)
    {
	 if($all) $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_news_comments WHERE newsID = '$newsID'");
	 else     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_news_comments WHERE commentID = '$commentID' AND newsID = '$newsID'");
    }

   public static function renderSingleNewsPrintable($w3)
    {
     // Render a single printable news

     // Prepare variables to create the list
     $categoryID = $w3->getVariable('categoryID');
     $newsID     = $w3->getVariable('newsID');
     $query_filter = " WHERE enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'";
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.newsID = '$newsID'";

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news
               $query_filter";// TODO Join per categorie disabled

     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Render News
     $row = $w3->getDBObj()->fetch($rs);
	 if(!$row)
	  {
	   // TODO fare meglio
	   $title = $subtitle = "&nbsp;";
	   $content = wm3GUIList::makeNotFoundItem($w3);
      }
	 else
	  {
       $title    = wm3Util::renderContent($w3,$row->title,$row->render_mode);
       $content  = wm3Util::renderContent($w3,$row->news,$row->render_mode,true);
	   $subtitle = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage(),true,'',false)." (newsID #".$row->newsID.")";;
      }
	 require($w3->getSkinObj()->getPage($w3));
    }

   public static function renderSingleNews($w3)
    {
     // Render a single news with comments in home page

     // Prepare variables to create the list
     $max_page_items = 3;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
     $newsID     = $w3->getVariable('newsID');
     $pg         = $w3->getVariable('pg');
     $lastID     = 0;
     $query_filter = " WHERE enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'";
     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.newsID = '$newsID'";
     if($pg) $extra_link  = "&pg=$pg"; else $extra_link = "";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news
               $query_filter";// TODO Join per categorie disabled

     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     //if($total_items != 0) $rs = $w3->getDBObj()->query($query."ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Render News
     $row = $w3->getDBObj()->fetch($rs);
	 if(!$row)
	  {
	   // TODO fare meglio
	   $title = $info = $icon = $hits = $comments = $comments_form = "&nbsp;";
	   $social_facebook = $social_gplusone = $social_twitter = "";
	   $content = wm3GUIList::makeNotFoundItem($w3);
      }
	 else
	  {
       $link = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
       if($allowed) $allowed_button = " ".wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178)); else $allowed_button = "";
       $icon_file = $w3->getSectionObj()->getCategoryIcon($w3,$row->categoryID);
	   $author = " ".$w3->getWord(232)." <a href=\"$base_link&userID=$row->userID\">".wm3User::getUserLogin($w3,$row->userID)."</a>";
       $comments = wm3News::makeCounterCommentNews($w3,$row->newsID);
       $date = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage());

       $printable_button = wm3Util::actionButton($base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_PRINTABLE_SINGLE_NEWS,"action_print.png",$w3->getWord(1400),"","",0,24,24,"absmiddle","_blank");
       $title = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a>".$allowed_button;
       $info = $date.$author.$comments;
       $icon = "<a href=\"$base_link&categoryID=$row->categoryID\"><img src=\"".WM3_cPATH_ICONS."$icon_file\" width=\"36\" height=\"36\" border=\"0\"></a>";      
       $content = wm3Util::renderContent($w3,$row->news,$row->render_mode,true);
       $social_facebook = wm3Social::renderFacebook($w3,$link);
       $social_gplusone = wm3Social::renderGPlusone($w3,$link);
       $social_twitter  = wm3Social::renderTwitter($w3,$link,$row->title);
       $hits = "$printable_button <b>".$w3->getWord(1298);
       if($row->hits == 1) $hits .= " $row->hits ".$w3->getWord(1299)."</b>";
       else                $hits .= " $row->hits ".$w3->getWord(1300)."</b>";

       // Comments
	   if($w3->getPreferences('enable_news_comments'))
	    {
		 if($w3->getPreferences('anonymous_news_comments') || $w3->getAuthenticateAdminUserID() != WM3_cUSER_ANONYMOUS)
		  {
           $array = wm3News::addNewsComment($w3); // Add comment form
           $comments_form = $array[0];
           $lastID = $array[1];
	      }
		 else $comments_form = "&nbsp;";
         $comments = wm3News::renderCommentNews($w3,$lastID); // Comments list
	    }
	   else $comments = $comments_form = "&nbsp;";
      }
     require($w3->getSkinObj()->getNews($w3->getPreferences('enable_news_comments'))); 
    }

   public static function renderAllNews($w3)
    {
     // Render news list in home page

     // Prepare variables to create the list
     $max_page_items = $w3->getPreferences('home_news_max');
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
	 $userID     = $w3->getVariable('userID');
     $pg         = $w3->getVariable('pg');
     $query_filter = " WHERE ".WM3_cCONFIG_DB_PREFIX."_news.enabled='".WM3_cENABLED."'
                         AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'
                         AND ".WM3_cCONFIG_DB_PREFIX."_news.categoryID=".WM3_cCONFIG_DB_PREFIX."_news_categories.categoryID
                         AND ".WM3_cCONFIG_DB_PREFIX."_news.userID=".WM3_cCONFIG_DB_PREFIX."_users.userID";
     if($categoryID) $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.categoryID = '$categoryID'";
	 if($userID)     $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.userID = '$userID'";
     if($pg) $extra_link  = "&pg=$pg"; else $extra_link = "";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_NEWS;
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_news.*, ".WM3_cCONFIG_DB_PREFIX."_news_categories.icon, ".WM3_cCONFIG_DB_PREFIX."_users.login
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news, ".WM3_cCONFIG_DB_PREFIX."_news_categories, ".WM3_cCONFIG_DB_PREFIX."_users
               $query_filter";// TODO Join per categorie disabled
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC LIMIT ".($pg*$max_page_items).",$max_page_items");

     // News list
	 if($total_items != 0)
	  {
	   $all_rss = wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS."&languageID=".$w3->getHomeLanguage(),"misc_rss_big.png",'','',$w3->getWord(-1)."RSS Feed",0,16,16);
	   $title   = $w3->getSkinObj()->getLeftPageTitle().$w3->getWord(567).$w3->getSkinObj()->getRightPageTitle();
	   $content = $all_rss;
	   require($w3->getSkinObj()->getNewsHead());
      }
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";       

       // Render news
       if($allowed) $allowed_button = " ".wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178)); else $allowed_button = "";
       $author = " ".$w3->getWord(232)." <a href=\"$base_link&userID=$row->userID\">$row->login</a>";
       $comments = wm3News::makeCounterCommentNews($w3,$row->newsID);
       $date = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage());
       $title = "<a href=\"$link\">".wm3Util::renderContent($w3,$row->title,$row->render_mode)."</a>".$allowed_button;
       $info  = $date.$author.$comments;
       $icon  = "<a href=\"$base_link&categoryID=$row->categoryID\">".wm3Util::renderImg($row->icon,'',36,36,WM3_cPATH_ICONS)."</a>";
       $content = wm3Util::renderContent($w3,$row->news,$row->render_mode,true,$link);
       $social_facebook = wm3Social::renderFacebook($w3,$link);
       $social_gplusone = wm3Social::renderGPlusone($w3,$link);
       $social_twitter  = wm3Social::renderTwitter($w3,$link,$row->title);
       $hits = $w3->getWord(1298);
       if($row->hits == 1) $hits .= " $row->hits ".$w3->getWord(1299);
       else                $hits .= " $row->hits ".$w3->getWord(1300);
       $comments = $comments_form = "";
       require($w3->getSkinObj()->getNews());
      }

     // Create page navigator
     if($total_items > $max_page_items)
      {
       $bottom = wm3GUIList::makePagesNavigator($w3,$total_items,$max_page_items,$pg,$base_link."&userID=$userID&categoryID=$categoryID");
       require($w3->getSkinObj()->getNewsBottom());
      }
    }

   public static function getNewsCategoryList($w3,$currentID = 0,$admin = true)
    {
     return $w3->getSectionObj()->getCategoryList($w3,$currentID,$admin);
    }

   public static function addNewsCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->addCategory($w3,$error);
    }

   public static function editNewsCategory($w3,$error = 0)
    {
     return $w3->getSectionObj()->editCategory($w3,$error);
    }

   public static function disableNewsCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_categories SET enabled = '".WM3_cDISABLED."' WHERE categoryID = '$categoryID'");
    }

   public static function enableNewsCategory($w3,$categoryID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_categories SET enabled = '".WM3_cENABLED."' WHERE categoryID = '$categoryID'");
    }
   
   public static function deleteNewsCategory($w3,$categoryID)
    {
     $w3->getSectionObj()->deleteCategory($w3,$categoryID);
    }

   public static function selectNewsCategory($w3,$all = false,$admin = true)
    {
     return $w3->getSectionObj()->selectCategory($w3,$all,$admin);
    }

   public static function getNewsCategoryName($w3,$categoryID)
    {
     return $w3->getSectionObj()->getCategoryName($w3,$categoryID);
    }

   public static function getNewsList($w3,$currentID = 0,$admin = true,$user = false,$full = false)
    {
     // Get news list (admin and user side)

     // $full its true when an user can have full control for own news
     // Prepare variables to create the list
     $max_page_items = 12;
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_NEWS); // Used to enable admin buttons in home stage
     $categoryID = $w3->getVariable('categoryID');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."_news.categoryID = '$categoryID'"; else $query_filter = "";
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) {
     	          $search_link   = "&filter=$filter";
     	          $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.news LIKE '%$filter%'";
     	         }
     else        { if(!$categoryID) if(!$user) $query_filter =" AND 1=0"; $search_link = ""; }
     if($admin) {
                 $width_title = 70;
	             if(!$user) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=".WM3_cACTION_SHOW_NEWS;
	             else       $search_form_link = WM3_cCONFIG_USER_FILE;
                 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $columns = 6; $buttons = 4;
     	        }
     else       {
                 $pageID = $w3->getVariable('pageID','get');
                 $page_link        = "&pageID=$pageID";
                 $search_form_link = WM3_cCONFIG_HOME_FILE."?action=".WM3_cACTION_SHOW_NEWS."$page_link";
                 $base_link        = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
                 $width_title = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.enabled*".WM3_cCONFIG_DB_PREFIX."_news_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='".$w3->getHomeLanguage()."'";
     	         if($allowed) { $columns = 2; $buttons = 1; } else { $columns = 1; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_NEWS;
     $id_link = "&categoryID=$categoryID";

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC";
     if(!$user)
	  {	 
       $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_news_categories.enabled,".WM3_cCONFIG_DB_PREFIX."_news.*
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_news_categories,".WM3_cCONFIG_DB_PREFIX."_news
                 WHERE  ".WM3_cCONFIG_DB_PREFIX."_news_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."_news.categoryID
                 $query_filter";
      }
	 else
	  {
       $query = "SELECT *
                 FROM   ".WM3_cCONFIG_DB_PREFIX."_news
                 WHERE  userID = '".$w3->getAuthenticateUserID()."'
                 $query_filter";
	  }
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'newsID',$rs);
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&newsID=$row->newsID";
       if($allowed) $allowed_link = $base_allowed_link."&newsID=$row->newsID";
	   $date = wm3Util::renderDate($w3,$row->news_ts,$w3->getHomeLanguage());
       if($categoryID) {                       
                        if($admin) $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,$row->render_mode)."<br>$date";
                        else       $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,$row->render_mode)." ($row->hits hits)<br>$row->news";
                       }
       else            {
		                // For the search in all categories
                        if($admin)
						 {
						  if(!$user) $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,$row->render_mode)."<br>$date<br>(".$w3->getWord(659)." <a href=\"$base_link$search_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$row->categoryID)."</a>)";
						  else       $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,$row->render_mode)."<br>(".$w3->getWord(659)." ".wm3News::getNewsCategoryName($w3,$row->categoryID).")";
					     }
                        else $_DATA[$p]->title = wm3Util::renderContent($w3,$row->title,$row->render_mode)." ($row->hits hits) (".$w3->getWord(659)." <a href=\"$base_link$search_link$page_link&categoryID=$row->categoryID&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$row->categoryID)."</a>)<br>$row->news";
                       }
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
		 if(wm3User::checkAdminPermission($w3,WM3_cSECTION_USERS)) $author = " ".$w3->getWord(232)." <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_USERS."&userID=$row->userID&action=".WM3_cACTION_EDIT_USER."\">".wm3User::getUserLogin($w3,$row->userID)."</a>";
		 else                                                      $author = " ".$w3->getWord(232)." ".wm3User::getUserLogin($w3,$row->userID);
		 $hits      = "<br>($row->hits hits)";
		 $info = $lang_flag.$author.$hits;
         $_DATA[$p]->info = $info;
         // Buttons
         if($row->enabled)
		  {
		   if($user && !$full) $_DATA[$p]->b1 = "<img src=\"".WM3_cPATH_DATA."action_disable_inactive.png\"";
		   else                $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_NEWS,"action_disable.png",$w3->getWord(180));
		  }
         else
		  {
		   if($user && !$full) $_DATA[$p]->b1 = "<img src=\"".WM3_cPATH_DATA."action_enable_inactive.png\"";
		   else                $_DATA[$p]->b1 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_NEWS,"action_enable.png",$w3->getWord(181));
	      }
         $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DUPLICATE_NEWS,"action_duplicate.png",$w3->getWord(1415),$w3->getWord(1419));
         if($user && !$full) $_DATA[$p]->b4 = "<img src=\"".WM3_cPATH_DATA."action_delete_inactive.png\"";
		 else                $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_NEWS,"action_delete.png",$w3->getWord(179),$w3->getWord(772));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=".WM3_cACTION_EDIT_NEWS,"action_edit.png",$w3->getWord(178));
        }
       if($row->newsID == $currentID && !$found) {  $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
	 $_SEP = $w3->getSkinObj()->getSeparator();
     require(WM3_cPATH_INCLUDE."admin_news_search_form.inc");
     $list->setTotalItems($total_items);
     if($admin)
	  {
	   if(!$user) $list->setTitle("<a href=\"$base_link\">".$w3->getWord(833)."</a>");
	   else       $list->setTitle($w3->getWord(833));
      }
     else $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord(833)."</a>");
     if($categoryID && !$user)
      {
	   $_PSEP = $w3->getSkinObj()->getPathSeparator();
       if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$categoryID)." ($total_items)</a>");
       else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".WM3_cACTION_SHOW_NEWS."\">".wm3News::getNewsCategoryName($w3,$categoryID)." ($total_items)</a>");
       if($admin) $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_NEWS,"action_add.png","","",$w3->getWord(1654),0,16,16));
      }
     if($admin) {
		         $list->setSearchForm($search_form);
		         if($found) $list->setCurrentID($currentID);
		         $list->setMaxPageItems($max_page_items);
                 $list->setPage($pg);
                 $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_NEWS.$id_link.$search_link);
                 $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1671)));
                 $list->setCaptionWidths(array(70,30));
                 $list->setCaptionColspan(array(1,1,4));
                 $list->setWidths(array(70,30));
			    }
     else       {
		         $list->setRenderCaption(false);
                 $list->setPagesNavigatorLink($base_link.$page_link."&action=".WM3_cACTION_SHOW_NEWS.$id_link.$search_link);
                 $list->setWidths(array(100));
                }
     return $list->render();
    }

   public static function addNews($w3,$user = false, $full = false)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray());
     $action = WM3_cACTION_ADD_NEWS;
     if($user) if($full) require(WM3_cPATH_INCLUDE.'user_news_full_form.inc');
	           else      require(WM3_cPATH_INCLUDE.'user_news_form.inc');
	 else      require(WM3_cPATH_INCLUDE.'admin_news_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(347));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['categoryID']->setValue($w3->getVariable('categoryID','get')); // Take categoryID from get
       if($user && $full || !$user) $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
       if($form->validate())
        {
         if($user) $lastID = wm3News::saveNews($w3,true,$full);
         else      $lastID = wm3News::saveNews($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         if($user) return wm3News::getNewsList($w3,$lastID,true,true,$full);
         else      return wm3News::getNewsList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editNews($w3,$error = 0,$user = false,$full = false)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_NEWS;
     if($user) if($full) require(WM3_cPATH_INCLUDE.'user_news_full_form.inc');
	           else      require(WM3_cPATH_INCLUDE.'user_news_form.inc');
	 else      require(WM3_cPATH_INCLUDE.'admin_news_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit news");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                               WHERE newsID = '".$w3->getVariable('newsID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3News::getNewsFieldsArray(),$row);

       // Default value for fields not in $row object
       $_FIELD['update_ts'] = '';

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
       if($form->validate())
        {
         if($user) $lastID = wm3News::updateNews($w3,true,$full);
         else      $lastID = wm3News::updateNews($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         if($user) return wm3News::getNewsList($w3,$lastID,true,true,$full);
         else      return wm3News::getNewsList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     $_F['update_ts']->setEnabled(true);

     return $form->render();
    }

   public static function saveNews($w3,$user = false,$full = false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['news_ts'] = $_FIELD['ts'] = time();
     $_FIELD['hits']          = 0;
     $_FIELD['votes_counts']  = 0;
     $_FIELD['votes_sum']     = 0;
     $_FIELD['votes_average'] = 0;
	 if($user) {
		        $_FIELD['userID'] = $w3->getAuthenticateUserID();
				if($_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML ||
				   $_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML_BB_CODE)
				$_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;				 
	            if(!$full) $_FIELD['enabled'] = WM3_cDISABLED;
			   }
     $w3->getDBObj()->saveAllTableFields('_news',$_FIELD,array('update_ts'));
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateNews($w3,$user = false,$full = false)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['update_ts']) $news_ts = time(); else $news_ts = wm3News::getNewsTS($w3,$_FIELD['newsID']);     
	 if($user) {
		        $userID = $w3->getAuthenticateUserID();
				if($_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML ||
				   $_FIELD['render_mode'] == WM3_cRENDER_MODE_HTML_BB_CODE)
				 $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
				if(!$full) $_FIELD['enabled'] = WM3_cDISABLED;
		       }
	 else      $userID = $_FIELD['userID'];
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                       SET title       = '".$_FIELD['title']."',
                           categoryID  = '".$_FIELD['categoryID']."',
                           userID      = '$userID',
						   render_mode = '".$_FIELD['render_mode']."',
                           news        = '".$_FIELD['news']."',
                           news_ts     = '$news_ts',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE newsID    = '".$_FIELD['newsID']."'");
     return $_FIELD['newsID'];
    }

   public static function duplicateNews($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_news            WRITE,
                                         ".WM3_cCONFIG_DB_PREFIX."_news_categories WRITE");
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news
                                   WHERE newsID = '".$w3->getVariable('newsID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3News::getNewsFieldsArray(),$row);
       $_FIELD['title']   = $w3->getWord(1417).$_FIELD['title'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['hits']          = 0;
       $_FIELD['votes_counts']  = 0;
       $_FIELD['votes_sum']     = 0;
       $_FIELD['votes_average'] = 0;
       $_FIELD['news_ts'] = $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_news',$_FIELD,array('update_ts'));
	   $w3->getDBObj()->query("UNLOCK TABLES");
       return $w3->getDBObj()->getLastInsertID();
      }
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   public static function disableNews($w3,$newsID,$user = false,$full = false)
    {
	 if($user) { if($full) $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cDISABLED."' WHERE newsID = '$newsID' AND userID='".$w3->getAuthenticateUserID()."'"); }
	 else      { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cDISABLED."' WHERE newsID = '$newsID'"); }
	}

   public static function enableNews($w3,$newsID,$user = false,$full = false)
    {
	 if($user) { if($full) $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cENABLED."' WHERE newsID = '$newsID' AND userID='".$w3->getAuthenticateUserID()."'"); }
	 else      { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news SET enabled = '".WM3_cENABLED."' WHERE newsID = '$newsID'"); }
	}

   public static function deleteNews($w3,$newsID,$user = false,$full = false)
    {
     if($user) { if($full) $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_news WHERE newsID = '$newsID' AND userID='".$w3->getAuthenticateUserID()."'"); }
	 else      { $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_news WHERE newsID = '$newsID'"); }
	}

   public static function checkNewsCommentError($w3)
    {
     // Check form invalid inputs
     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsCommentFieldsArray());
     if($_FIELD['comment']=='') return 1;
	 if(wm3Captcha::canUseCaptcha())
	  if(!wm3Captcha::testPassedCaptcha($w3)) return 2;
     return 0;
    }

   public static function addNewsComment($w3)
    {
	 // Initialize form

     // Fields for paging default value
     $pg = $filter = '';

     $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsCommentFieldsArray());
	 $action = WM3_cACTION_SHOW_SINGLE_NEWS;
	 require(WM3_cPATH_INCLUDE.'home_news_comment_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1119));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['newsID']->setValue($w3->getVariable('newsID')); // Take newsID from both
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3News::saveNewsComment($w3);
         $_F['render_mode']->setValue(WM3_cRENDER_MODE_PLAIN_TEXT);
         $_F['comment']->setValue('');
		}
	   else $form->setTitle("<a name=\"comments\"></a>".$form->getTitle());
      }
     if(!isset($lastID)) $lastID = 0;
     return array($form->render(),$lastID);
    }

   public static function saveNewsComment($w3)
    {
	 if(!$w3->getPreferences('enable_news_comments')) return 0;
     if(wm3Session::actionAllowed($w3,$w3->getVariable('_ID','post')))
      {
       wm3Session::protectAction($w3,$w3->getVariable('_ID','post'));
       $_FIELD = webmatic3::getPostValueArray(wm3News::getNewsCommentFieldsArray(),WM3_cQUOTE_DB);
	   $userID = $w3->getAuthenticateAdminUserID();
       $_FIELD['ts']      = time();
       $_FIELD['userID']  = $userID;
       $_FIELD['enabled'] = WM3_cENABLED;
       if($_FIELD['render_mode'] != WM3_cRENDER_MODE_PLAIN_TEXT &&
	      $_FIELD['render_mode'] != WM3_cRENDER_MODE_BB_CODE)
	    $_FIELD['render_mode'] = WM3_cRENDER_MODE_PLAIN_TEXT;
	   //$_FIELD['languageID'] = ???;
	   if($userID == WM3_cUSER_ANONYMOUS && !$w3->getPreferences('anonymous_news_comments')) return 0;
	   else $w3->getDBObj()->saveAllTableFields('_news_comments',$_FIELD);
	   return $w3->getDBObj()->getLastInsertID();
      } 
     return 0;
    }

   public static function makeCounterCommentNews($w3,$newsID)
    {
     // Get the number of comments for a news
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_news_comments","WHERE newsID = '$newsID' AND enabled='".WM3_cENABLED."'");
     if($total == 1) $label = $w3->getWord(1116); else $label = $w3->getWord(1115);
     return " ($total $label)";
    }

   public function renderRssNews($w3)
    {
     // Render rss for all news (home side)

     // Prepare variables to create the list
     $max_page_items = $w3->getPreferences('home_news_max');
	 $languageID = $w3->getVariable('languageID');
	 $query_filter = " WHERE enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_news.languageID='$languageID'";
	 if($w3->getAction() == WM3_cACTION_SHOW_RSS_CATEGORY)
	  {
       $categoryID = $w3->getVariable('categoryID');
       $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.categoryID = '$categoryID'";
      }
	 if($w3->getAction() == WM3_cACTION_SHOW_RSS_AUTHOR)
      {
       $userID = $w3->getVariable('userID');
	   $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_news.userID = '$userID'";
      }
	 $extra_link = "";
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_NEWS;

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_news
               $query_filter";// TODO Join per categorie disabled
     $rs = $w3->getDBObj()->query($query." ORDER BY ".WM3_cCONFIG_DB_PREFIX."_news.news_ts DESC LIMIT 0, $max_page_items");

     // Rss header
     $str = wm3Rss::renderHeadRss($w3,$languageID);

     // News rss items
     while($row = $w3->getDBObj()->fetch($rs))
      {
       // Render news rss item
	   $title    = $row->title;
	   $link     = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
	   $news     = wm3Util::renderContent($w3,str_replace('[more]','',$row->news),$row->render_mode,true,$link);
	   $ts       = $row->news_ts;
       $author   = wm3User::getUserLogin($w3,$row->userID);
       $comments = $base_link.$extra_link."&newsID=$row->newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS;
	   $category = wm3News::getNewsCategoryName($w3,$row->categoryID);

	   $str .= wm3Rss::renderItemRss($w3,$title,$link,$news,$ts,$author,$comments,$category);
      }

	 // Rss foot
	 $str .= wm3Rss::renderFootRss($w3);

	 return $str;
	}

   public function renderRssPanelNews($w3)
    {
     // Render RSS feed panel in home page
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS;
     $languageID = $w3->getHomeLanguage();
     $_DATA = array();

     // All RSS feed
     $link = $base_link;
     $_DATA[0]->content = "<a href=\"$link&languageID=$languageID\">".wm3Util::renderImg('misc_rss_big.png')." ".$w3->getWord(1642)."</a>";

     // RSS feed by news category
     $_DATA[1]->content = "<br>".$w3->getWord(1613);
     $_DATA[2]->content = wm3News::renderRssCategoryListNews($w3,$languageID);

     // RSS feed by author
     $_DATA[3]->content = "<br>".$w3->getWord(1614);
     $_DATA[4]->content = wm3News::renderRssAuthorListNews($w3,$languageID);

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setUseColors(false);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(100));
     return $list->render();
    }

   public function renderRssCategoryListNews($w3,$languageID)
    {
     // Render RSS feed category list for home page panel
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS;

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_news_categories
                        WHERE enabled = '".WM3_cENABLED."' AND languageID = '$languageID'
                        ORDER BY name";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $link = $base_link."&categoryID=$row->categoryID&languageID=$languageID&action=".WM3_cACTION_SHOW_RSS_CATEGORY;
       $_DATA[$p]->icon = "<a href=\"$link\">".wm3Util::renderImg('misc_rss.png','',12,12)."</a>";
       $_DATA[$p]->name = "<a href=\"$link\">$row->name</a>";
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setInvertColors(true);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

   public function renderRssAuthorListNews($w3,$languageID)
    {
     // Render RSS feed author list for home page panel
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_RSS;

     // Do the query and take the total items number
     $query = "SELECT ".WM3_cCONFIG_DB_PREFIX."_users.userID, ".WM3_cCONFIG_DB_PREFIX."_users.login
	             FROM ".WM3_cCONFIG_DB_PREFIX."_users,
	                  ".WM3_cCONFIG_DB_PREFIX."_news
                WHERE ".WM3_cCONFIG_DB_PREFIX."_users.enabled = '".WM3_cENABLED."'
				  AND ".WM3_cCONFIG_DB_PREFIX."_users.deleted = '".WM3_cDISABLED."'
				  AND ".WM3_cCONFIG_DB_PREFIX."_news.userID = ".WM3_cCONFIG_DB_PREFIX."_users.userID
				  AND ".WM3_cCONFIG_DB_PREFIX."_news.enabled = '".WM3_cENABLED."'
			    GROUP BY login
                ORDER BY login";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link."&userID=$row->userID&languageID=$languageID&action=".WM3_cACTION_SHOW_RSS_AUTHOR;
       $_DATA[$p]->icon  = "<a href=\"$link\">".wm3Util::renderImg('misc_rss.png','',12,12)."</a>";
       $_DATA[$p]->login = "<a href=\"$link\">$row->login</a>";
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setInvertColors(true);
     $list->setRenderCaption(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(0,100));
     return $list->render();
    }

   public static function getNewsData($w3,$newsID)
    {
	 // Used in class wm3Social to retrive data for facebook og
     $rs = $w3->getDBObj()->query("SELECT ".WM3_cCONFIG_DB_PREFIX."_news.*, ".WM3_cCONFIG_DB_PREFIX."_news_categories.icon
                                   FROM ".WM3_cCONFIG_DB_PREFIX."_news, ".WM3_cCONFIG_DB_PREFIX."_news_categories
                                   WHERE newsID='$newsID' && ".WM3_cCONFIG_DB_PREFIX."_news.categoryID = ".WM3_cCONFIG_DB_PREFIX."_news_categories.categoryID");
     $row = $w3->getDBObj()->fetch($rs);
     return $row;
    }

   public static function getNewsTS($w3,$newsID)
    {
	 // Return news_ts for newsID
     $rs = $w3->getDBObj()->query("SELECT news_ts FROM ".WM3_cCONFIG_DB_PREFIX."_news
                             WHERE newsID = '$newsID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->news_ts;
	}

   public static function hitNews($w3)
    {
     $newsID = $w3->getVariable('newsID','get');
	 if(!wm3Session::newsAllowed($w3,$newsID,WM3_cSESSION_HIT)) return;
	 else wm3Session::newsProtect($w3,$newsID,WM3_cSESSION_HIT);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                       SET    hits = hits + 1
                       WHERE  newsID = '$newsID'");
    }

  }

?>
