<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Panel
  {
   private $column_empty_left,$column_empty_right;
   private $_PANELS; // Panels data (array of objects contains all the panels data to be render)
   
   function __construct()
    {
     $this->column_empty_left = $this->column_empty_right = false;
    }

   public static function getPanelFieldsArray()
    {
     return array('panelID','title','languageID','categoryID','visibility','enabled','position','align','surveyID','menuID','render_mode','head','body','foot','expansion','expansion_index','expansion_config','extraID','ts');
    }

   public static function executeAction($w3)
    {
     $sep = "<br><br>";
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_PANEL:
        {
         wm3Panel::disablePanel($w3,$w3->getVariable('panelID','get'));
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT,  $w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT, $w3->getVariable('panelID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_PANEL:
        {
         wm3Panel::enablePanel($w3,$w3->getVariable('panelID','get'));
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT,  $w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT, $w3->getVariable('panelID','get'));
         break;
        }
       case WM3_cACTION_DELETE_PANEL:
        {
         wm3Panel::deletePanel($w3,$w3->getVariable('panelID','get'));
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT)  .$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT);
         break;
        }
       case WM3_cACTION_ADD_PANEL:
        {
         return wm3Panel::addPanel($w3,$sep);
         break;
        }
       case WM3_cACTION_EDIT_PANEL:
        {
         return wm3Panel::editPanel($w3,$sep);
         break;
        }
       case WM3_cACTION_SWAP_PANEL:
        {
         wm3Panel::swapPanel($w3);
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT  ,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$w3->getVariable('panelID','get')).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT ,$w3->getVariable('panelID','get'));
         break;
        }
       default:
        {
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT)  .$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT);
        }
      }
    }

   public function createPanels($w3)
    {
     // Get panels from db and store it in the objects array
	 if(wm3Section::isActionPrintable($w3))
	  {
	   $this->column_empty_left = $this->column_empty_right = true;
	   return;
      }
     $visibility = '';
     if(!$w3->getAuthenticateAdminUserID()) $visibility = "AND visibility = '".WM3_cVISIBILITY_ALL."'";
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                                   WHERE enabled = '".WM3_cENABLED."' $visibility AND languageID = '".$w3->getHomeLanguage()."'
                                   ORDER BY position");
     $_ROWS = $w3->getDBObj()->resultToArray($rs);
     for($j = WM3_cPANEL_LEFT; $j <= WM3_cPANEL_RIGHT; $j++)
      {
       $i = 0;
       $align = $j;
       if(!$w3->getPageObj()->isColumnEmpty($j))
        {
         for($k = 0; $k < count($_ROWS); $k++)
          {
		   if($_ROWS[$k]->align == $j)
		    {
             $this->_PANELS[$align][$i] = $_ROWS[$k];
             $i++;
		    }
          }
        }
       if($i == 0)
        {
         if($align == WM3_cPANEL_LEFT)  $this->column_empty_left  = true;
         if($align == WM3_cPANEL_RIGHT) $this->column_empty_right = true;
        }
      }
    }

   public function getPanels($w3,$categoryID,$extraID,$panelID = 0)
    {
     // Get panel content ($extraID its used for certain panel's categories)
     switch($categoryID)
      {
       case WM3_cPANEL_CATEGORY_MESSAGES:
        {
         require(WM3_cPATH_INCLUDE."panel_message.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_LOGIN:
        {
         require(WM3_cPATH_INCLUDE."panel_login.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_CHANNELS:
        {
         require(WM3_cPATH_INCLUDE."panel_channels.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_SEARCH:
        {
         require(WM3_cPATH_INCLUDE."panel_search.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_HOROSCOPE:
        {
         require(WM3_cPATH_INCLUDE."panel_horoscope.inc");
         return $content;
         break;
        }        
       case WM3_cPANEL_CATEGORY_NEWSLETTER:
        {
         require(WM3_cPATH_INCLUDE."panel_newsletter.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_SEND_TO_FRIEND:
        {
         require(WM3_cPATH_INCLUDE."panel_send_to_friend.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_LANGUAGES:
        {
         require(WM3_cPATH_INCLUDE."panel_language.inc");
         return $content;
         break;
        }
       case WM3_cPANEL_CATEGORY_ECOMMERCE:
        {
         require(WM3_cPATH_INCLUDE."panel_ecommerce.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_SURVEY:
        {
         require(WM3_cPATH_INCLUDE."panel_survey.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_FORTUNE:
        {
         require(WM3_cPATH_INCLUDE."panel_fortune.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_RSS_FEEDS:
        {
         require(WM3_cPATH_INCLUDE."panel_rss_feed.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_BIRTHDAY:
        {
         require(WM3_cPATH_INCLUDE."panel_birthday.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_SPECIAL_OFFER:
        {
         require(WM3_cPATH_INCLUDE."panel_special_offer.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_MENU:
        {
         require(WM3_cPATH_INCLUDE."panel_menu.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_TAGS:
        {
         require(WM3_cPATH_INCLUDE."panel_tags.inc");
         return $content;
         break;         
        }
       case WM3_cPANEL_CATEGORY_EXPANSION:
        {
         require(WM3_cPATH_INCLUDE."panel_expansion.inc");
         return $content;
         break;         
        }
       default: // No panel category found
        {
         return "&nbsp;";
        }
      }
    }

   public function renderPanels($w3,$align)
    {
     // Render panels with $w3->_skin
     $allowed = wm3User::checkAdminPermission($w3,WM3_cSECTION_PANELS); // Used to enable admin buttons
	 $w3->getSkinObj()->setCurrentSkinRender($align);// Set current skin render to panel render (left, center or right)
     if(isset($this->_PANELS[$align])) // If there are panels for this $align
      {
       for($i = 0; $i < sizeof($this->_PANELS[$align]); $i++)
        {
         // Enable admin button if allowed
         if($allowed) $edit_button = wm3Util::actionButton(WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PANELS."&action=".WM3_cACTION_EDIT_PANEL."&panelID=".$this->_PANELS[$align][$i]->panelID,"action_edit.png",$w3->getWord(178))." ";
         else         $edit_button = '';

         // Panel title      	
         $title = $edit_button.$this->_PANELS[$align][$i]->title;

         // Panel content
         $head = wm3Util::renderContent($w3,$this->_PANELS[$align][$i]->head,$this->_PANELS[$align][$i]->render_mode);
         $foot = wm3Util::renderContent($w3,$this->_PANELS[$align][$i]->foot,$this->_PANELS[$align][$i]->render_mode);
         if($this->_PANELS[$align][$i]->categoryID == WM3_cPANEL_CATEGORY_CUSTOM)
          $content = wm3Util::renderContent($w3,$this->_PANELS[$align][$i]->body,$this->_PANELS[$align][$i]->render_mode);
         else
          $content = wm3Panel::getPanels($w3,$this->_PANELS[$align][$i]->categoryID,$this->_PANELS[$align][$i]->extraID,$this->_PANELS[$align][$i]->panelID);
         $content = $head.$content.$foot;
         if($this->_PANELS[$align][$i]->categoryID == WM3_cPANEL_CATEGORY_MENU)
          {
		   require($w3->getSkinObj()->getPanelMenu());
		  }
         else
          {
           if($align == WM3_cPANEL_LEFT)   require($w3->getSkinObj()->getPanelLeft());
           if($align == WM3_cPANEL_CENTER) require($w3->getSkinObj()->getPanelCenter());
           if($align == WM3_cPANEL_RIGHT)  require($w3->getSkinObj()->getPanelRight());
	      }
        }
      }
    }

   public static function getPositions($w3,$align)
    {
     // Create an array with panels position
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                             WHERE align = '$align'
                             ORDER BY position");
     $i = 1; $_PPOS['up'][0] = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $_PPOS['up'][$i] = $_PPOS['down'][$i] = $row->panelID;
       $i++;
      }
     $m = $i-1; $_PPOS['down'][$i] = 0;
     for($i = $m;$i >= 1; $i--) $_PPOS['up'][$i]   = $_PPOS['up'][$i-1];
     for($i = 1;$i <= $m; $i++) $_PPOS['down'][$i] = $_PPOS['down'][$i+1];
     return $_PPOS;
    }

   public static function getPosition($w3,$panelID)
    {
     // Get the position of a panel
     $rs = $w3->getDBObj()->query("SELECT position FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                             WHERE panelID = '$panelID'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) return $row->position;
    }

   public static function getPanelList($w3,$align,$currentID = 0)
    {
     // Get panels list for $align

     // Prepare variables to create the list
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
     $query ="SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
              WHERE align = '$align'
              ORDER BY position";
     $rs = $w3->getDBObj()->query($query);
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false; $i = 1;
     $align_label = $w3->getWord(461 + $align);
     $_PPOS = wm3Panel::getPositions($w3,$align);
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&panelID=$row->panelID";
       if($row->categoryID == 0) $type_label = $w3->getWord(544); // Custom panel
       else                      $type_label = $w3->getLanguageObj()->translate(wm3Panel::getPanelCategoryName($w3,$row->categoryID));

       // Move panels up and down buttons and panel info
       $_DATA[$p]->position = $row->position;
       if($_PPOS['up'][$i]   == 0) $_DATA[$p]->b1 = "<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">";
       else                        $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_PANEL."&swapID=".$_PPOS['up'][$i],"action_up.png",$w3->getWord(1273));
       if($_PPOS['down'][$i] == 0) $_DATA[$p]->b2 = "<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">";
       else                        $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_PANEL."&swapID=".$_PPOS['down'][$i],"action_down.png",$w3->getWord(1274));
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
       $_DATA[$p]->title = $row->title;
       $_DATA[$p]->info  = "$lang_flag ($align_label, $type_label)";
       $i++;

       // Buttons
       if($row->enabled) $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_PANEL,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_PANEL,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_PANEL,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b5 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_PANEL,"action_delete.png",$w3->getWord(179),$w3->getWord(710));
       if($row->panelID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,"$align_label ".$w3->getWord(146));
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setCaptionLabels(array($w3->getWord(543),$w3->getWord(194),$w3->getWord(1407)));
     $list->setCaptionWidths(array(0,60,40));
     $list->setCaptionColspan(array(3,1,1,3));
     $list->setWidths(array(0,0,0,60,40));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function addPanel($w3,$sep)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray());
	 $action = WM3_cACTION_ADD_PANEL;
	 require(WM3_cPATH_INCLUDE.'admin_panel_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(144));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['body']->setVisible(true);
       $_F['body_editor']->setVisible(true);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Panel::savePanel($w3);
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT  ,$lastID).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$lastID).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT ,$lastID);
		}
      }

     // Operation to do before render the form
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY)    $_F['surveyID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_MENU)      $_F['menuID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_EXPANSION) { $_F['expansion']->setVisible(true); $_F['expansion_config']->setVisible(true); }
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_CUSTOM)    { $_F['body']->setVisible(true); $_F['body_editor']->setVisible(true); }

     return $form->render();    
    }

   public static function editPanel($w3,$sep)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_PANEL;
	 require(WM3_cPATH_INCLUDE.'admin_panel_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit panel");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                                     WHERE panelID = '".$w3->getVariable('panelID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Panel::getPanelFieldsArray(),$row);

       if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY) $_FIELD['surveyID'] = $_FIELD['extraID'];
       if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_MENU)   $_FIELD['menuID']   = $_FIELD['extraID'];
       $_FIELD['expansion'] = $_FIELD['expansion_index'].'_'.$_FIELD['expansion'];
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Panel::updatePanel($w3);
         return wm3Panel::getPanelList($w3,WM3_cPANEL_LEFT  ,$lastID).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_CENTER,$lastID).$sep.
                wm3Panel::getPanelList($w3,WM3_cPANEL_RIGHT ,$lastID);
		}
      }

     // Operation to do before render the form
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY)    $_F['surveyID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_MENU)      $_F['menuID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_EXPANSION) { $_F['expansion']->setVisible(true); $_F['expansion_config']->setVisible(true); }
	 if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_CUSTOM)    { $_F['body']->setVisible(true); $_F['body_editor']->setVisible(true); }

     return $form->render();
    }

   public static function savePanel($w3)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");

     $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY) $_FIELD['extraID'] = $_FIELD['surveyID'];
     if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_MENU)   $_FIELD['extraID'] = $_FIELD['menuID'];
     $_FIELD['expansion_index'] = strtok($_FIELD['expansion'],"_");
     $_FIELD['expansion']       = substr($_FIELD['expansion'],strlen($_FIELD['expansion_index']) + 1);     
     if($_FIELD['position'] <= 0) $_FIELD['position'] = 1; // If position its <= 0 (invalid position) the position will be 1
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                             SET position = position + 1
                             WHERE position >= '".$_FIELD['position']."'");
     $w3->getDBObj()->saveAllTableFields('_panels',$_FIELD,array('surveyID','menuID'));

     $w3->getDBObj()->query("UNLOCK TABLES");
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updatePanel($w3)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");

	 $_FIELD = webmatic3::getPostValueArray(wm3Panel::getPanelFieldsArray(),WM3_cQUOTE_DB);
     if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_SURVEY) $_FIELD['extraID'] = $_FIELD['surveyID'];
     if($_FIELD['categoryID'] == WM3_cPANEL_CATEGORY_MENU)   $_FIELD['extraID'] = $_FIELD['menuID'];
     $_FIELD['expansion_index'] = strtok($_FIELD['expansion'],"_");
     $_FIELD['expansion']       = substr($_FIELD['expansion'],strlen($_FIELD['expansion_index']) + 1);
     wm3Panel::updatePanelPositions($w3,$_FIELD['panelID'],$_FIELD['position']);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                       SET title            = '".$_FIELD['title']."',
					       render_mode      = '".$_FIELD['render_mode']."',
					       visibility       = '".$_FIELD['visibility']."',
                           head             = '".$_FIELD['head']."',
                           body             = '".$_FIELD['body']."',
                           foot             = '".$_FIELD['foot']."',
						   expansion        = '".$_FIELD['expansion']."',
						   expansion_index  = '".$_FIELD['expansion_index']."',
						   expansion_config = '".$_FIELD['expansion_config']."',
                           enabled          = '".$_FIELD['enabled']."',
                           position         = '".$_FIELD['position']."',
                           align            = '".$_FIELD['align']."',
                           categoryID       = '".$_FIELD['categoryID']."',
                           extraID          = '".$_FIELD['extraID']."',
                           languageID       = '".$_FIELD['languageID']."'
                       WHERE panelID        = '".$_FIELD['panelID']."'");

     $w3->getDBObj()->query("UNLOCK TABLES");
     return $_FIELD['panelID'];
    }

   public static function swapPanel($w3)
    {
     // Swap two panels position (move up or down panels)
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");
     
     $panelID       = $w3->getVariable('panelID','get');
     $swapID        = $w3->getVariable('swapID','get');     
     $swap_position = wm3Panel::getPosition($w3,$swapID);
     $position      = wm3Panel::getPosition($w3,$panelID);

     if($position && $swap_position) // Swap effected only if the item exists (by checking the position)
      {
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                         SET position          = '$swap_position'
                         WHERE panelID = '$panelID'");
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                         SET position          = '$position'
                         WHERE panelID = '$swapID'");
      }

     $w3->getDBObj()->query("UNLOCK TABLES");
     return $panelID;
    }

   public static function updatePanelPositions($w3,$panelID,$new_position)
    {
     // Update the right panel position when a panel position changed
     $position = wm3Panel::getPosition($w3,$panelID);

     if($position) // Update effected only if the item exists (by checking the position)
      {
       if($new_position > $position)
        {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position = position - 1
                           WHERE position > '$position' AND position <= '$new_position'");

         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position  = '$new_position'
                           WHERE panelID = '$panelID'");
        }
       else
        {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position = position + 1
                           WHERE position >= '$new_position' AND position < '$position'");

         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                           SET position  = '$new_position'
                           WHERE panelID = '$panelID'");
        }
      }
    }

   public static function disablePanel($w3,$panelID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels SET enabled = '".WM3_cDISABLED."' WHERE panelID = '$panelID'"); }

   public static function enablePanel($w3,$panelID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels SET enabled = '".WM3_cENABLED."'  WHERE panelID = '$panelID'"); }

   public static function deletePanel($w3,$panelID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_panels WRITE");

     $position = wm3Panel::getPosition($w3,$panelID);
     if($position) // Update positions only if the deleted item exists (by checking the position)
      {
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                         SET position = position - 1
                         WHERE position > '$position'");
      }
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_panels WHERE panelID = '$panelID'");

   	 $w3->getDBObj()->query("UNLOCK TABLES");
   	}

   public static function selectPanelCategory($w3)
    {
     // Return an array of wm3GUIOption objects for panel categories select
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                             ORDER BY position DESC, name");
     $i = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $_LABEL[$i] = $w3->getLanguageObj()->translate($row->name);
       $_VALUE[$i] = $row->categoryID;
       $i++;
      }
     return wm3Util::selectArray($_LABEL,$_VALUE);
    }

   public static function selectPanelPosition($w3)
    {
     // Return an array of wm3GUIOption objects for panel position select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels");
     $i = 1;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       array_push($array,new wm3GUIOption($i,$i));
       $i++;
      }
     if($w3->getAction() == WM3_cACTION_ADD_PANEL)
      array_push($array,new wm3GUIOption($i,$i));
     return $array;
    }

   public static function getPanelCategoryName($w3,$categoryID)
    {
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                             WHERE categoryID = '$categoryID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   public static function renderPanelExpansion($w3,$panelID)
    {
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_panels
                                   WHERE panelID = '$panelID' AND categoryID = '".WM3_cPANEL_CATEGORY_EXPANSION."'");
     if($w3->getDBObj()->totalRows($rs) != 1) return '';
     $row = $w3->getDBObj()->fetch($rs);

     $folder     = $row->expansion;
     $index      = $row->expansion_index; // Panel index
     $parameters = $row->expansion_config;
     $_expansion = new wm3Expansion($w3,$folder,$index,WM3_cEXPANSION_TYPE_PANEL,$parameters);
     return $_expansion->exec($w3);
	}

   public function setColumnEmpty($align,$v)
    {
     if($align == WM3_cPANEL_LEFT)  $this->column_empty_left  = $v;
     if($align == WM3_cPANEL_RIGHT) $this->column_empty_right = $v;
    }    

   public function isColumnEmpty($align) 
    {
     if($align == WM3_cPANEL_LEFT)  return $this->column_empty_left;
     if($align == WM3_cPANEL_RIGHT) return $this->column_empty_right;
    }

  }

?>
