<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Preferences
  {

   function __construct() { }

   public static function getGeneralPrefFieldsArray()
    {
     return array('total_visitors','total_signalations',
                  'skin','site_address','webmaster_email','service_email','logo','logo_width','logo_height','logo_printable','foot_content','registration_form_type','home_news_max',
                  'banners_enabled','logging_enabled',
                  'user_groupID','user_enabled','user_special','user_flag1','user_flag2','user_flag3','user_flag4','user_flag5','user_flag6','user_flag7','user_flag8');
    }

   public static function getAspectPrefFieldsArray()
    {
     return array('show_total_newsletter','show_total_signalations','show_total_search_engine','show_online_users_visitors','show_home_news','anonymous_vote_news','enable_news_comments','anonymous_news_comments','show_home_channels','hide_left_panels_action_home','hide_right_panels_action_home','anonymous_write_news','anonymous_enabled_news','anonymous_add_directories','anonymous_enabled_directories','anonymous_vote_directories','anonymous_vote_media_albums','anonymous_vote_downloads');
    }

   public static function getContentPrefFieldsArray()
    {//TODO
     return array('browser_bar_title','title','special_user_label','staff_name','home','foot',
                  'signalation_email_subject','signalation_email_text','user_registration_email_subject','user_registration_email_text',
                  'languageID');
    }

   public static function getEcommercePrefFieldsArray()
    {
     return array('ecommerce_type','ecommerce_credit_card_url','ecommerce_currency','ecommerce_shipping_cost','ecommerce_cart_expire','ecommerce_show_catalogue_price','ecommerce_show_extra','ecommerce_variable_price','ecommerce_variable_id');
    }

   public static function getEcommerceFieldPreferencesFieldsArray($w3)
    {
	 $_ARRAY = array('fieldID','type','size','show_in','required','enabled','label','ts');
	 $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = $w3->getDBObj()->fetch($rs)) array_push($_ARRAY,'label'.$row->languageID);
     return $_ARRAY;
    }

   public static function getEcommerceLabelPreferencesFieldsArray()
    {
     return array('labelID','fieldID','label','enabled','languageID','ts');
    }

   public static function getBannersExchangePrefFieldsArray()
    {
     return array('banners_exchange_enabled','banners_exchange_ratio','banners_exchange_extra_content','banners_exchange_auto_enabled','banners_exchange_starting_credits');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_CHANGE_LANGUAGE_CONTENT_PREFERENCES:
        {
         $languageID = wm3Language::writeCookiePreferencesLanguageID($w3,$_POST['languageID']);
         $w3->setPreferencesLanguage($languageID);
         return wm3Preferences::editContentPreferences($w3);
         break;
        }
       case WM3_cACTION_SET_TOTAL_VISITORS:
        {
         wm3Preferences::updateTotalVisitorsPreferences($w3);
         return wm3Preferences::editGeneralPreferences($w3);
         break;
        }
       case WM3_cACTION_SET_TOTAL_SIGNALATIONS:
        {
         wm3Preferences::updateTotalSignalationsPreferences($w3);
         return wm3Preferences::editGeneralPreferences($w3);
        }
       case WM3_cACTION_EDIT_ASPECT_PREFERENCES:
        {
         return wm3Preferences::editAspectPreferences($w3);
         break;
        }        
       case WM3_cACTION_EDIT_CONTENT_PREFERENCES:
        {
         return wm3Preferences::editContentPreferences($w3);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_PREFERENCES:
        {
         return wm3Preferences::editEcommercePreferences($w3);
         break;
        }
	   case WM3_cACTION_DISABLE_ECOMMERCE_FIELD_PREFERENCES:
        {
         wm3Preferences::disableEcommerceFieldPreferences($w3,$w3->getVariable('fieldID','get'));
         return wm3Preferences::getEcommerceFieldPreferencesList($w3,$w3->getVariable('fieldID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_ECOMMERCE_FIELD_PREFERENCES:
        {
         wm3Preferences::enableEcommerceFieldPreferences($w3,$w3->getVariable('fieldID','get'));
         return wm3Preferences::getEcommerceFieldPreferencesList($w3,$w3->getVariable('fieldID','get'));
         break;
        }
       case WM3_cACTION_DELETE_ECOMMERCE_FIELD_PREFERENCES:
        {
         wm3Preferences::deleteEcommerceFieldPreferences($w3,$w3->getVariable('fieldID','get'));
         return wm3Preferences::getEcommerceFieldPreferencesList($w3);
         break;
        }
       case WM3_cACTION_ADD_ECOMMERCE_FIELD_PREFERENCES:
        {
         return wm3Preferences::addEcommerceFieldPreferences($w3);
         break;
        }
       case WM3_cACTION_EDIT_ECOMMERCE_FIELD_PREFERENCES:
        {
         return wm3Preferences::editEcommerceFieldPreferences($w3);
         break;
        }
       case WM3_cACTION_SHOW_ECOMMERCE_FIELD_PREFERENCES:
        {
         return wm3Preferences::getEcommerceFieldPreferencesList($w3);
         break;
        }
       case WM3_cACTION_EDIT_BANNER_EXCHANGE_PREFERENCES:
        {
         return wm3Preferences::editBannersExchangePreferences($w3);
         break;
        }
       default:
        {
         return wm3Preferences::editGeneralPreferences($w3);
        }
      } 
    }

   public static function editGeneralPreferences($w3)
    {
	 // Initialize form
     $action = 0;
	 require(WM3_cPATH_INCLUDE.'admin_preferences_general_form.inc');

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = $w3->getDBObj()->fetch($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getGeneralPrefFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         wm3Preferences::updateGeneralPreferences($w3);
         header("Location: ".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=".WM3_cSECTION_PREFERENCES);
		}
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['skin']."/preview.png"; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_SKINS); // Set due preview image
     $_F['skin']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),240,150,WM3_cPATH_SKINS,1,'top','preview_image'));

     return $form1->render().$form2->render().$form->render();     
    }

   public static function updateGeneralPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET skin                   = '".$_FIELD['skin']."',
                           site_address           = '".$_FIELD['site_address']."',
                           webmaster_email        = '".$_FIELD['webmaster_email']."',
                           service_email          = '".$_FIELD['service_email']."',
                           logo                   = '".$_FIELD['logo']."',
                           logo_height            = '".$_FIELD['logo_height']."',
                           logo_width             = '".$_FIELD['logo_width']."',
                           logo_printable         = '".$_FIELD['logo_printable']."',
                           foot_content           = '".$_FIELD['foot_content']."',
                           registration_form_type = '".$_FIELD['registration_form_type']."',
                           home_news_max          = '".$_FIELD['home_news_max']."',
                           banners_enabled        = '".$_FIELD['banners_enabled']."',
                           logging_enabled        = '".$_FIELD['logging_enabled']."',
                           user_groupID           = '".$_FIELD['user_groupID']."',
                           user_enabled           = '".$_FIELD['user_enabled']."',
                           user_special           = '".$_FIELD['user_special']."',
                           user_flag1             = '".$_FIELD['user_flag1']."',
                           user_flag2             = '".$_FIELD['user_flag2']."',
                           user_flag3             = '".$_FIELD['user_flag3']."',
                           user_flag4             = '".$_FIELD['user_flag4']."',
                           user_flag5             = '".$_FIELD['user_flag5']."',
                           user_flag6             = '".$_FIELD['user_flag6']."',
                           user_flag7             = '".$_FIELD['user_flag7']."',
                           user_flag8             = '".$_FIELD['user_flag8']."'");
    }

   public static function editAspectPreferences($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_ASPECT_PREFERENCES;
	 require(WM3_cPATH_INCLUDE.'admin_preferences_aspect_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(722));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = $w3->getDBObj()->fetch($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getAspectPrefFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getAspectPrefFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate()) wm3Preferences::updateAspectPreferences($w3);
      }
     return $form->render();
    }

   public static function updateAspectPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getAspectPrefFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET show_total_newsletter         = '".$_FIELD['show_total_newsletter']."',
                           show_total_signalations       = '".$_FIELD['show_total_signalations']."',
                           show_total_search_engine      = '".$_FIELD['show_total_search_engine']."',
                           show_online_users_visitors    = '".$_FIELD['show_online_users_visitors']."',
                           show_home_news                = '".$_FIELD['show_home_news']."',
                           anonymous_vote_news           = '".$_FIELD['anonymous_vote_news']."',
                           enable_news_comments          = '".$_FIELD['enable_news_comments']."',
                           anonymous_news_comments       = '".$_FIELD['anonymous_news_comments']."',
                           show_home_channels            = '".$_FIELD['show_home_channels']."',
                           hide_left_panels_action_home  = '".$_FIELD['hide_left_panels_action_home']."',
						   hide_right_panels_action_home = '".$_FIELD['hide_right_panels_action_home']."',
                           anonymous_write_news          = '".$_FIELD['anonymous_write_news']."',
                           anonymous_enabled_news        = '".$_FIELD['anonymous_enabled_news']."',
                           anonymous_add_directories     = '".$_FIELD['anonymous_add_directories']."',
                           anonymous_enabled_directories = '".$_FIELD['anonymous_enabled_directories']."',
                           anonymous_vote_directories    = '".$_FIELD['anonymous_vote_directories']."',
                           anonymous_vote_media_albums   = '".$_FIELD['anonymous_vote_media_albums']."',
                           anonymous_vote_downloads      = '".$_FIELD['anonymous_vote_downloads']."'");
    }

   public static function editContentPreferences($w3)
    {
	 // Initialize form
     $action = WM3_cACTION_EDIT_CONTENT_PREFERENCES;
	 require(WM3_cPATH_INCLUDE.'admin_preferences_content_form.inc');

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                                     WHERE languageID='".$w3->getPreferencesLanguage()."'");
       $row = $w3->getDBObj()->fetch($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getContentPrefFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getContentPrefFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         wm3Preferences::updateContentPreferences($w3);
		}
      }
     return $form1->render().$form->render();
    }

   public static function updateContentPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getContentPrefFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                       SET   browser_bar_title               = '".$_FIELD['browser_bar_title']."',
                             title                           = '".$_FIELD['title']."',
                             special_user_label              = '".$_FIELD['special_user_label']."',
                             staff_name                      = '".$_FIELD['staff_name']."',
                             home                            = '".$_FIELD['home']."',
                             foot                            = '".$_FIELD['foot']."',
                             signalation_email_subject       = '".$_FIELD['signalation_email_subject']."',
                             signalation_email_text          = '".$_FIELD['signalation_email_text']."',
                             user_registration_email_subject = '".$_FIELD['user_registration_email_subject']."',
                             user_registration_email_text    = '".$_FIELD['user_registration_email_text']."'
					   WHERE languageID='".$_FIELD['languageID']."'");
    }

   public static function editEcommercePreferences($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_ECOMMERCE_PREFERENCES;
	 require(WM3_cPATH_INCLUDE.'admin_preferences_ecommerce_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(725));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = $w3->getDBObj()->fetch($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getEcommercePrefFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommercePrefFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         wm3Preferences::updateEcommercePreferences($w3);
		}
      }
     $list = new wm3GUIList($w3,array());
     return wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3).$list->renderBottom().$form->render();
    }

   public static function updateEcommercePreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommercePrefFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET ecommerce_type                 = '".$_FIELD['ecommerce_type']."',
					       ecommerce_credit_card_url      = '".$_FIELD['ecommerce_credit_card_url']."',
						   ecommerce_currency             = '".$_FIELD['ecommerce_currency']."',
					       ecommerce_shipping_cost        = '".$_FIELD['ecommerce_shipping_cost']."',
						   ecommerce_cart_expire          = '".$_FIELD['ecommerce_cart_expire']."',
					       ecommerce_show_catalogue_price = '".$_FIELD['ecommerce_show_catalogue_price']."',
                           ecommerce_show_extra           = '".$_FIELD['ecommerce_show_extra']."',
						   ecommerce_variable_price       = '".$_FIELD['ecommerce_variable_price']."',
						   ecommerce_variable_id          = '".$_FIELD['ecommerce_variable_id']."'");
	 $w3->setPreferences($w3); // Reload the preferences
    }

   public static function getEcommerceFieldPreferencesList($w3,$currentID = 0,$admin = true)
    {
     // Get ecommerce custom fields list

     // Prepare variables to create the list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'fieldID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     if($total_items != 0 && $admin) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&fieldID=$row->fieldID";
	   if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_INTEGER) $type = $w3->getWord(1475);
	   if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_DECIMAL) $type = $w3->getWord(1476);
	   if($row->type == WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_STRING)  $type = $w3->getWord(1477);
	   if($row->required) $required = $w3->getWord(1474); else $required = "";
	   $label = wm3Ecommerce::getEcommerceCustomFieldLabel($w3,$row->fieldID,$w3->getAdminLanguage());
	   $info = "$type ($row->size) $required";
	   $_DATA[$p]->label = $label;
       $_DATA[$p]->info  = $info;
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_ECOMMERCE_FIELD_PREFERENCES,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_ECOMMERCE_FIELD_PREFERENCES,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_ECOMMERCE_FIELD_PREFERENCES,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_ECOMMERCE_FIELD_PREFERENCES,"action_delete.png",$w3->getWord(179),$w3->getWord(774));
       if($row->fieldID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_FIELD_PREFERENCES);
     $list->setCaptionLabels(array($w3->getWord(1226),$w3->getWord(1671)));
     $list->setCaptionWidths(array(50,50));
     $list->setCaptionColspan(array(1,1,3));
     $list->setWidths(array(50,50));
     return wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3,$w3->getWord(1471)).$list->renderBody().$list->renderBottom();
    }

   public static function addEcommerceFieldPreferences($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray($w3));
	 $action = WM3_cACTION_ADD_ECOMMERCE_FIELD_PREFERENCES;
	 require(WM3_cPATH_INCLUDE.'admin_preferences_ecommerce_field_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(1472));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['required']->setValue(WM3_cDISABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Preferences::saveEcommerceFieldPreferences($w3);
         return wm3Preferences::getEcommerceFieldPreferencesList($w3,$lastID);
		}
      }
     $list = new wm3GUIList($w3,array());
     return wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3).$list->renderBottom().$form->render();
    }

   public static function editEcommerceFieldPreferences($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_ECOMMERCE_FIELD_PREFERENCES;
	 require(WM3_cPATH_INCLUDE.'admin_preferences_ecommerce_field_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit field");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                               WHERE fieldID = '".$w3->getVariable('fieldID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray($w3),$row);

       // Default value for fields not in $row object
	   $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
       while($row = $w3->getDBObj()->fetch($rs))
	    {
	     array_push($_FIELD,'label'.$row->languageID);
	     $_FIELD['label'.$row->languageID] = wm3Ecommerce::getEcommerceCustomFieldLabel($w3,$_FIELD['fieldID'],$row->languageID);
	    }

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray($w3));
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Preferences::updateEcommerceFieldPreferences($w3);
         return wm3Preferences::getEcommerceFieldPreferencesList($w3,$lastID);
		}
      }
     $list = new wm3GUIList($w3,array());
     return wm3Preferences::makeEcommerceFieldPreferencesSubmenu($w3).$list->renderBottom().$form->render();
    }

   public static function saveEcommerceFieldPreferences($w3)
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products      WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories    WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_languages               WRITE");
     $_ARRAY = array('label');	 
	 $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = $w3->getDBObj()->fetch($rs)) array_push($_ARRAY,'label'.$row->languageID);

     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray($w3),WM3_cQUOTE_DB);
	 $_FIELD['languageID'] = WM3_cLANGUAGE_ALL;
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_ecommerce_custom_fields',$_FIELD,$_ARRAY);
	 $fieldID = $w3->getDBObj()->getLastInsertID();

     // Save labels (one label for each language)
	 $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = $w3->getDBObj()->fetch($rs))
	  wm3Preferences::saveEcommerceLabelPreferences($w3,$_FIELD['label'.$row->languageID],$fieldID,$row->languageID,$_FIELD['ts']);

	 $w3->getDBObj()->query("UNLOCK TABLES");
     return $fieldID;
    }

   public static function saveEcommerceLabelPreferences($w3,$label,$fieldID,$languageID,$ts)
    {
	 $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceLabelPreferencesFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['fieldID']    = $fieldID;
	 $_FIELD['label']      = $label;
	 $_FIELD['enabled']    = WM3_cENABLED;
	 $_FIELD['languageID'] = $languageID;
	 $_FIELD['ts']         = $ts;
	 $w3->getDBObj()->saveAllTableFields('_ecommerce_custom_labels',$_FIELD,$languageID);
    }

   public static function updateEcommerceFieldPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getEcommerceFieldPreferencesFieldsArray($w3),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                       SET   type     = '".$_FIELD['type']."',
					         size     = '".$_FIELD['size']."',
							 show_in  = '".$_FIELD['show_in']."',
							 required = '".$_FIELD['required']."',
                             enabled  = '".$_FIELD['enabled']."'
                       WHERE fieldID  = '".$_FIELD['fieldID']."'");

     // Update labels (one label for each language)
	 $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages");
     while($row = $w3->getDBObj()->fetch($rs))
	  wm3Preferences::updateEcommerceLabelPreferences($w3,$_FIELD['label'.$row->languageID],$_FIELD['fieldID'],$row->languageID);

     return $_FIELD['fieldID'];
    }

   public static function updateEcommerceLabelPreferences($w3,$label,$fieldID,$languageID)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
                       SET   label      = '$label'
                       WHERE fieldID    = '$fieldID' AND
					         languageID = '$languageID'");
    }

   public static function disableEcommerceFieldPreferences($w3,$fieldID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields SET enabled = '".WM3_cDISABLED."' WHERE fieldID = '$fieldID'");
	}

   public static function enableEcommerceFieldPreferences($w3,$fieldID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields SET enabled = '".WM3_cENABLED."' WHERE fieldID = '$fieldID'");
	}
   
   public static function deleteEcommerceFieldPreferences($w3,$fieldID)
    {
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields WHERE fieldID = '$fieldID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels WHERE fieldID = '$fieldID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data   WHERE fieldID = '$fieldID'");
	}

   public static function editBannersExchangePreferences($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_BANNER_EXCHANGE_PREFERENCES;
	 require(WM3_cPATH_INCLUDE.'admin_preferences_banner_exchange_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(1320));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
       $row = $w3->getDBObj()->fetch($rs);
       $_FIELD = webmatic3::getRowValueArray(wm3Preferences::getBannersExchangePrefFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getBannersExchangePrefFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate()) wm3Preferences::updateBannersExchangePreferences($w3);
      }
     return $form->render();
    }

   public static function updateBannersExchangePreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getBannersExchangePrefFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                       SET banners_exchange_enabled          = '".$_FIELD['banners_exchange_enabled']."',
					       banners_exchange_ratio            = '".$_FIELD['banners_exchange_ratio']."',
					       banners_exchange_extra_content    = '".$_FIELD['banners_exchange_extra_content']."',
						   banners_exchange_auto_enabled     = '".$_FIELD['banners_exchange_auto_enabled']."',
						   banners_exchange_starting_credits = '".$_FIELD['banners_exchange_starting_credits']."'");
    }

   public static function updateTotalVisitorsPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_visitors = '".$_FIELD['total_visitors']."'");
    }

   public static function updateTotalSignalationsPreferences($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Preferences::getGeneralPrefFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_signalations = '".$_FIELD['total_signalations']."'");
    }

   public static function incrementTotalVisitorsPreferences($w3)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_visitors = total_visitors + 1");
    }

   public static function incrementTotalSignalationsPreferences($w3)
    {
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                       SET total_signalations = total_signalations + 1");
    }

   public static function updateMaxUsersVisitors($w3)
    {
	 $max_visitors = wm3Session::getOnlineVisitors($w3);
	 $max_users    = wm3Session::getOnlineUsers($w3);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                             SET   max_visitors = $max_visitors
                             WHERE max_visitors < $max_visitors");
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                             SET max_users = $max_users
                             WHERE max_users < $max_users");
	}

   public static function updateLastUserVisitor($w3)
    {
	 if(!$w3->getAuthenticateAdminID()) // Get only normal users or visitors (not administrators)
	  {
	   $ts = time();
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
                               SET last_user_ip  = '".getenv('REMOTE_ADDR')."',
                                   last_user_dns = '".gethostbyaddr(getenv('REMOTE_ADDR'))."',
							       last_userID   = '".$w3->getAuthenticateUserID()."',
							       last_user_ts  = '$ts'");
      }
	}

   public static function loadPreferences($w3)
    {
     // Load preferences from db
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_preferences");
     $row = $w3->getDBObj()->fetch($rs);
	 $_PREFERENCES['banners_enabled']                   = $row->banners_enabled;
     $_PREFERENCES['banner1ID']                         = $row->banner1ID;
     $_PREFERENCES['banner2ID']                         = $row->banner2ID;
     $_PREFERENCES['banner3ID']                         = $row->banner3ID;
     $_PREFERENCES['banner4ID']                         = $row->banner4ID;
     $_PREFERENCES['banner5ID']                         = $row->banner5ID;
     $_PREFERENCES['banner6ID']                         = $row->banner6ID;
     $_PREFERENCES['banner7ID']                         = $row->banner7ID;
     $_PREFERENCES['banner8ID']                         = $row->banner8ID;
     $_PREFERENCES['banner9ID']                         = $row->banner9ID;
	 $_PREFERENCES['banners_exchange_enabled']          = $row->banners_exchange_enabled;
	 $_PREFERENCES['banners_exchange_ratio']            = $row->banners_exchange_ratio;
	 $_PREFERENCES['banners_exchange_extra_content']    = $row->banners_exchange_extra_content;
	 $_PREFERENCES['banners_exchange_auto_enabled']     = $row->banners_exchange_auto_enabled;
	 $_PREFERENCES['banners_exchange_starting_credits'] = $row->banners_exchange_starting_credits;
     $_PREFERENCES['logo']           = $row->logo;
     $_PREFERENCES['logo_width']     = $row->logo_width;
     $_PREFERENCES['logo_height']    = $row->logo_height;
     $_PREFERENCES['logo_printable'] = $row->logo_printable;
     $_PREFERENCES['skin']         = $row->skin;
	 $_PREFERENCES['site_address'] = $row->site_address;
	 $_PREFERENCES['foot_content'] = $row->foot_content;
	 $_PREFERENCES['registration_form_type'] = $row->registration_form_type;
	 $_PREFERENCES['webmaster_email'] = $row->webmaster_email;
	 $_PREFERENCES['service_email']   = $row->service_email;
	 $_PREFERENCES['home_news_max']                 = $row->home_news_max;
     $_PREFERENCES['show_total_newsletter']         = $row->show_total_newsletter;
     $_PREFERENCES['show_total_signalations']       = $row->show_total_signalations;
     $_PREFERENCES['show_total_search_engine']      = $row->show_total_search_engine;
     $_PREFERENCES['show_online_users_visitors']    = $row->show_online_users_visitors;
     $_PREFERENCES['show_home_news']                = $row->show_home_news;
     $_PREFERENCES['anonymous_vote_news']           = $row->anonymous_vote_news;
     $_PREFERENCES['enable_news_comments']          = $row->enable_news_comments;
     $_PREFERENCES['anonymous_news_comments']       = $row->anonymous_news_comments;
     $_PREFERENCES['show_home_channels']            = $row->show_home_channels;
     $_PREFERENCES['hide_left_panels_action_home']  = $row->hide_left_panels_action_home;
	 $_PREFERENCES['hide_right_panels_action_home'] = $row->hide_right_panels_action_home;
     $_PREFERENCES['anonymous_write_news']          = $row->anonymous_write_news;
     $_PREFERENCES['anonymous_enabled_news']        = $row->anonymous_enabled_news;
     $_PREFERENCES['anonymous_add_directories']     = $row->anonymous_add_directories;
     $_PREFERENCES['anonymous_enabled_directories'] = $row->anonymous_enabled_directories;
     $_PREFERENCES['anonymous_vote_directories']    = $row->anonymous_vote_directories;
     $_PREFERENCES['anonymous_vote_media_albums']   = $row->anonymous_vote_media_albums;
     $_PREFERENCES['anonymous_vote_downloads']      = $row->anonymous_vote_downloads;
	 $_PREFERENCES['ecommerce_type']                 = $row->ecommerce_type;
	 $_PREFERENCES['ecommerce_credit_card_url']      = $row->ecommerce_credit_card_url;
	 $_PREFERENCES['ecommerce_currency']             = $row->ecommerce_currency;
	 $_PREFERENCES['ecommerce_shipping_cost']        = $row->ecommerce_shipping_cost;
	 $_PREFERENCES['ecommerce_show_catalogue_price'] = $row->ecommerce_show_catalogue_price;
	 $_PREFERENCES['ecommerce_show_extra']           = $row->ecommerce_show_extra;
	 $_PREFERENCES['ecommerce_payment_type']         = $row->ecommerce_payment_type;
	 $_PREFERENCES['ecommerce_cart_expire']          = $row->ecommerce_cart_expire;
	 $_PREFERENCES['ecommerce_variable_price']       = $row->ecommerce_variable_price;
	 $_PREFERENCES['ecommerce_variable_id']          = $row->ecommerce_variable_id;
	 $_PREFERENCES['user_enabled'] = $row->user_enabled;
	 $_PREFERENCES['user_special'] = $row->user_special;
	 $_PREFERENCES['user_flag1']   = $row->user_flag1;
	 $_PREFERENCES['user_flag2']   = $row->user_flag2;
	 $_PREFERENCES['user_flag3']   = $row->user_flag3;
	 $_PREFERENCES['user_flag4']   = $row->user_flag4;
	 $_PREFERENCES['user_flag5']   = $row->user_flag5;
	 $_PREFERENCES['user_flag6']   = $row->user_flag6;
	 $_PREFERENCES['user_flag7']   = $row->user_flag7;
	 $_PREFERENCES['user_flag8']   = $row->user_flag8;
	 $_PREFERENCES['user_groupID'] = $row->user_groupID;
	 $_PREFERENCES['logging_enabled'] = $row->logging_enabled;

     return $_PREFERENCES;
    }

   public function loadPreferencesContents($w3,$languageID)
    {
     // Load contents preferences from db (1 row for language)
     $rs = $w3->getDBObj()->query("SELECT *
                                   FROM   ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                                   WHERE  languageID = '$languageID'");
     $row = $w3->getDBObj()->fetch($rs);
     $_PREFERENCES_CONTENTS['browser_bar_title']               = $row->browser_bar_title;
     $_PREFERENCES_CONTENTS['title']                           = $row->title;
	 $_PREFERENCES_CONTENTS['head']                            = $row->head;
     $_PREFERENCES_CONTENTS['home']                            = $row->home;
	 $_PREFERENCES_CONTENTS['foot']                            = $row->foot;
	 $_PREFERENCES_CONTENTS['staff_name']                      = $row->staff_name;
	 $_PREFERENCES_CONTENTS['special_user_label']              = $row->special_user_label;
	 $_PREFERENCES_CONTENTS['signalation_email_subject']       = $row->signalation_email_subject;
	 $_PREFERENCES_CONTENTS['signalation_email_text']          = $row->signalation_email_text;
	 $_PREFERENCES_CONTENTS['user_registration_email_subject'] = $row->user_registration_email_subject;
	 $_PREFERENCES_CONTENTS['user_registration_email_text']    = $row->user_registration_email_text;

     return $_PREFERENCES_CONTENTS;
    }

   public static function loadTotalVisitors($w3)
    {
     // Get total visitors from db
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT total_visitors FROM ".WM3_cCONFIG_DB_PREFIX."_counters"));
     return $row->total_visitors;
    }

   public static function loadTotalSignalations($w3)
    {
     // Get total visitors from db
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query("SELECT total_signalations FROM ".WM3_cCONFIG_DB_PREFIX."_counters"));
     return $row->total_signalations;
    }

   public static function setPreferencesBanner($w3,$positionID,$bannerID)
    {
     // Update preferences for a banner position
     $field = "banner".$positionID."ID";
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                             SET $field = '$bannerID'");
    }

   public static function selectGeneralPreferencesFootContent($w3)
    {
     // Return an array of wm3GUIOption objects for general preferences foot content select
	 $_LABELS = array($w3->getWord(1625),$w3->getWord(59),$w3->getWord(1626),$w3->getWord(1627),$w3->getWord(60),$w3->getWord(61),$w3->getWord(1628),$w3->getWord(62));
	 $_VALUES = array(WM3_cPREFERENCES_FOOT_ALL,WM3_cPREFERENCES_FOOT_COUNTER_DATE,WM3_cPREFERENCES_FOOT_COUNTER_TIME,WM3_cPREFERENCES_FOOT_DATE_TIME,WM3_cPREFERENCES_FOOT_COUNTER,WM3_cPREFERENCES_FOOT_DATE,WM3_cPREFERENCES_FOOT_TIME,WM3_cPREFERENCES_FOOT_NONE);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function selectGeneralPreferencesRegistrationForm($w3)
    {
     // Return an array of wm3GUIOption objects for general preferences foot content select
	 $_LABELS = array($w3->getWord(1775),$w3->getWord(1776),$w3->getWord(1777));
	 $_VALUES = array(WM3_cPREFERENCES_REGISTRATION_FULL,WM3_cPREFERENCES_REGISTRATION_NORMAL,WM3_cPREFERENCES_REGISTRATION_FAST);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function selectEcommercePreferencesType($w3)
    {
     // Return an array of wm3GUIOption objects for ecommerce preferences type select
	 $_LABELS = array($w3->getWord(752),$w3->getWord(753));
	 $_VALUES = array(WM3_cPREFERENCES_ECOMMERCE_CATALOGUE_ONLY,WM3_cPREFERENCES_ECOMMERCE_FULL);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function selectEcommerceFieldPreferencesType($w3)
    {
     // Return an array of wm3GUIOption objects for ecommerce preferences custom fields type select
	 $_LABELS = array($w3->getWord(1475),$w3->getWord(1476),$w3->getWord(1477));
	 $_VALUES = array(WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_INTEGER,WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_DECIMAL,WM3_cPREFERENCES_ECOMMERCE_FIELD_TYPE_STRING);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function selectEcommerceFieldPreferencesShowIn($w3)
    {
     // Return an array of wm3GUIOption objects for ecommerce preferences custom fields show in select
	 $_LABELS = array($w3->getWord(980),$w3->getWord(1478),$w3->getWord(1479));
	 $_VALUES = array(WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_CATALOGUE,WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_TRANSACTIONS,WM3_cPREFERENCES_ECOMMERCE_FIELD_SHOW_IN_BOTH);
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function makeEcommerceFieldPreferencesInputLabel($w3)
    {
	 // Make text fields for field labels input (one for each language)
	 $fields = array(); $p = 0;
	 $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_languages WHERE enabled='".WM3_cENABLED."'");
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $lang_flag = "<img src=\"".WM3_cPATH_DATA.$row->flag."\" alt=\"$row->name\" title=\"$row->name\" width=\"19\" height=\"13\" align=\"middle\"> ";
	   if($p == 0) $label = $w3->getWord(1226); else $label = '';
       $fields['label'.$row->languageID] = new wm3GUITextField('label'.$row->languageID,'',$label,40);
       $fields['label'.$row->languageID]->setExtraContentBefore($lang_flag);
       $fields['label'.$row->languageID]->setColor(1);
	   $p++;
      }
	 return $fields;
	}

   public static function makeEcommerceFieldPreferencesSubmenu($w3,$label='')
    {
     // Create submenu for ecommerce preferences
	 $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
	 $_SEP = $w3->getSkinObj()->getSeparator();

     // Render List (header only)
     $list = new wm3GUIList($w3,array());
     $list->setTitle(wm3Util::actionButton($base_link."&section=".WM3_cSECTION_PREFERENCES."&action=".WM3_cACTION_EDIT_ECOMMERCE_PREFERENCES,"action_setup.png","","",$w3->getWord(1371),0,16,16));
     $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link."&action=".WM3_cACTION_SHOW_ECOMMERCE_FIELD_PREFERENCES,"action_show.png","","",$w3->getWord(1292),0,16,16));
     $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link."&action=".WM3_cACTION_ADD_ECOMMERCE_FIELD_PREFERENCES,"action_add.png","","",$w3->getWord(1472),0,16,16));
     $list->setTitle($list->getTitle()."<br><br>$label");
     $list->setColumns(5); // Force header to span 5 columns
     return $list->renderHeader();
	}

  }

?>
