<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Section
  {
   // Variables
   private $allowed_section,$allow_category_description,$allow_subcategory_description;
   private $table_categories,$table_subcategories,$table_subcategories_count,$table_items_count,$field_items_count;
   private $category_form,$subcategory_form,$search_form;
   private $action_add_category,$action_edit_category;
   private $action_show_subcategory,$action_add_subcategory;
   private $action_save_subcategory,$action_update_subcategory;
   private $action_show_items,$action_add_item,$action_search;
   private $action_disable_category,$action_enable_category,$action_delete_category;
   private $action_disable_subcategory,$action_enable_subcategory,$action_edit_subcategory,$action_delete_subcategory;   
   private $label_category_list_title,$label_subcategory_add,$label_item_add,$label_subcategories_count,$label_items_count;
   private $label_category_icon,$label_category_name,$label_category_info;
   private $label_subcategory_icon,$label_subcategory_name,$label_subcategory_info;
   private $label_add_category_title,$label_edit_category_title,$label_add_subcategory_title,$label_edit_subcategory_title;
   private $extra_buttons;
   private $section;

   function __construct() { }

   public function setParameters($_P)
    {
     // Parameters with default values
     if(isset($_P['allowed_section'])) $this->allowed_section = $_P['allowed_section'];
     else                              $this->allowed_section = 0;

     if(isset($_P['allow_category_description']))    $this->allow_category_description    = $_P['allow_category_description'];
     else                                            $this->allow_category_description    = false;
     if(isset($_P['allow_subcategory_description'])) $this->allow_subcategory_description = $_P['allow_subcategory_description'];
     else                                            $this->allow_subcategory_description = false;

     if(isset($_P['table_items_count'])) $this->table_items_count = $_P['table_items_count'];
     else                                $this->table_items_count = '';
     if(isset($_P['field_items_count'])) $this->field_items_count = $_P['field_items_count'];
     else                                $this->field_items_count = 'subcategoryID';

     if(isset($_P['subcategory_form'])) $this->subcategory_form = $_P['subcategory_form'];
     else                               $this->subcategory_form = '';
     if(isset($_P['search_form']))      $this->search_form = $_P['search_form'];
     else                               $this->search_form = '';

     if(isset($_P['action_save_subcategory']))    $this->action_save_subcategory    = $_P['action_save_subcategory'];
     else                                         $this->action_save_subcategory    = '';
     if(isset($_P['action_update_subcategory']))  $this->action_update_subcategory  = $_P['action_update_subcategory'];
     else                                         $this->action_update_subcategory  = '';
     if(isset($_P['action_show_items']))          $this->action_show_items          = $_P['action_show_items'];
     else                                         $this->action_show_items          = '';
     if(isset($_P['action_add_item']))            $this->action_add_item            = $_P['action_add_item'];
     else                                         $this->action_add_item            = '';
     if(isset($_P['action_disable_subcategory'])) $this->action_disable_subcategory = $_P['action_disable_subcategory'];
     else                                         $this->action_disable_subcategory = '';
     if(isset($_P['action_enable_subcategory']))  $this->action_enable_subcategory  = $_P['action_enable_subcategory'];
     else                                         $this->action_enable_subcategory  = '';
     if(isset($_P['action_edit_subcategory']))    $this->action_edit_subcategory    = $_P['action_edit_subcategory'];
     else                                         $this->action_edit_subcategory    = '';
     if(isset($_P['action_delete_subcategory']))  $this->action_delete_subcategory  = $_P['action_delete_subcategory'];
     else                                         $this->action_delete_subcategory  = '';

     if(isset($_P['label_category_icon']))          $this->label_category_icon          = $_P['label_category_icon'];
     else                                           $this->label_category_icon          = 1670;
     if(isset($_P['label_category_name']))          $this->label_category_name          = $_P['label_category_name'];
     else                                           $this->label_category_name          = 1045;
     if(isset($_P['label_category_info']))          $this->label_category_info          = $_P['label_category_info'];
     else                                           $this->label_category_info          = 1671;
     if(isset($_P['label_subcategory_icon']))       $this->label_subcategory_icon       = $_P['label_subcategory_icon'];
     else                                           $this->label_subcategory_icon       = 1670;
     if(isset($_P['label_subcategory_name']))       $this->label_subcategory_name       = $_P['label_subcategory_name'];
     else                                           $this->label_subcategory_name       = 1045;
     if(isset($_P['label_subcategory_info']))       $this->label_subcategory_info       = $_P['label_subcategory_info'];
     else                                           $this->label_subcategory_info       = 1671;
     if(isset($_P['label_items_count']))            $this->label_items_count            = $_P['label_items_count'];
     else                                           $this->label_items_count            = 0;
     if(isset($_P['label_item_add']))               $this->label_item_add               = $_P['label_item_add'];
     else                                           $this->label_item_add               = 0;
     if(isset($_P['label_add_category_title']))     $this->label_add_category_title     = $_P['label_add_category_title'];
     else                                           $this->label_add_category_title     = 649;
     if(isset($_P['label_edit_category_title']))    $this->label_edit_category_title    = $_P['label_edit_category_title'];
     else                                           $this->label_edit_category_title    = 653;
     if(isset($_P['label_add_subcategory_title']))  $this->label_add_subcategory_title  = $_P['label_add_subcategory_title'];
     else                                           $this->label_add_subcategory_title  = 1666;
     if(isset($_P['label_edit_subcategory_title'])) $this->label_edit_subcategory_title = $_P['label_edit_subcategory_title'];
     else                                           $this->label_edit_subcategory_title = 663;
     if(isset($_P['extra_button_action']))          $this->extra_button_action          = $_P['extra_button_action'];
     else                                           $this->extra_button_action          = 0;
     if(isset($_P['extra_button_icon']))            $this->extra_button_icon            = $_P['extra_button_icon'];
     else                                           $this->extra_button_icon            = '';
     if(isset($_P['extra_button_label']))           $this->extra_button_label           = $_P['extra_button_label'];
     else                                           $this->extra_button_label           = 0;

     // Parameters without a default value
     $this->section                   = $_P['section'];
     
     $this->table_categories          = $_P['table_categories'];
     $this->table_subcategories       = $_P['table_subcategories'];
     $this->table_subcategories_count = $_P['table_subcategories_count'];

     $this->category_form             = $_P['category_form'];

     $this->action_add_category       = $_P['action_add_category'];
     $this->action_show_subcategory   = $_P['action_show_subcategory'];
     $this->action_add_subcategory    = $_P['action_add_subcategory'];
     $this->action_disable_category   = $_P['action_disable_category'];
     $this->action_enable_category    = $_P['action_enable_category'];
     $this->action_edit_category      = $_P['action_edit_category'];
     $this->action_delete_category    = $_P['action_delete_category'];
     $this->action_search             = $_P['action_search'];     

     $this->label_category_list_title = $_P['label_category_list_title'];
     $this->label_subcategory_add     = $_P['label_subcategory_add'];
     $this->label_subcategories_count = $_P['label_subcategories_count'];
    }

   protected function getCategoryFieldsArray()
    {
     if($this->allow_category_description) return array('categoryID','name','description','icon','enabled','languageID','ts');
     else                                  return array('categoryID','name','icon','enabled','languageID','ts');
    }

   protected function getSubcategoryFieldsArray()
    {
     if($this->allow_subcategory_description) return array('subcategoryID','categoryID','name','description','icon','enabled','languageID','ts');
     else                                     return array('subcategoryID','categoryID','name','icon','enabled','languageID','ts');
    }

   protected function getCategoryList($w3,$currentID,$admin,$no_icon = false,$no_allowed = false,$base_link = '',$no_page_link = false,$show_subcategories = false,$folder_style = false,$no_header = false,$simple_counter = false,$alternate_search_form = '',$all_language = false)
    {
     // Get generic category list (admin and home side)

     // Prepare variables to create the list
     if($no_allowed) $allowed = false;
     else            $allowed = wm3User::checkAdminPermission($w3,$this->allowed_section); // Used to enable admin buttons in home stage
     if($all_language) {
	                    $language_filter       = "AND (languageID = '".$w3->getHomeLanguage()."' OR languageID = '".WM3_cLANGUAGE_ALL."')";
						$language_filter_count = "AND (
						                               (
													       ".WM3_cCONFIG_DB_PREFIX."$this->table_items_count.languageID='".$w3->getHomeLanguage()."'
														OR ".WM3_cCONFIG_DB_PREFIX."$this->table_items_count.languageID='".WM3_cLANGUAGE_ALL."'
                                                       )
													   AND
													   (   ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories_count.languageID='".$w3->getHomeLanguage()."'
														OR ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories_count.languageID='".WM3_cLANGUAGE_ALL."'
													   )
													  )";
					   }
	 else              {
		                $language_filter       = "AND languageID = '".$w3->getHomeLanguage()."'";
						$language_filter_count = "AND ".WM3_cCONFIG_DB_PREFIX."$this->table_items_count.languageID='".$w3->getHomeLanguage()."'
												  AND ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories_count.languageID='".$w3->getHomeLanguage()."'";
                       }
     $page_link  = '';
     if($admin) {
                 if(!$base_link)
                  $base_link  = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	        }
     else       {
                 if(!$base_link)
     	          $base_link  = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection(); 
     	         if(!$no_page_link) $page_link = "&pageID=".$w3->getVariable('pageID','get');
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=$this->allowed_section";
     if($this->search_form) {
     	                     $filter = $w3->getVariable('filter'); // Search field
     	                     $categoryID = $w3->getVariable('categoryID');
     	                     $subcategoryID = 0; // If a search form with category->subcategory select its used
     	                     if($admin) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=$this->action_search";
     	                     else       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=$this->action_search$page_link";
     	                    }

     // Do the query
     if($admin) $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                                              ORDER BY name");
     else       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                                              WHERE enabled = '".WM3_cENABLED."' $language_filter
                                              ORDER BY name");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$page_link."&categoryID=$row->categoryID";
	   if($allowed) $allowed_link = $base_allowed_link."&categoryID=$row->categoryID";
       if(!$no_icon) $_DATA[$p]->icon = "<a href=\"$link&action=$this->action_show_subcategory\"><img src=\"".WM3_cPATH_ICONS."$row->icon\" width=\"36\" height=\"36\" border=\"0\"></a>";
       if(!$this->table_items_count) {
                                      if($admin) $counter = wm3Section::makeCounterCategorySub($w3,$row->categoryID,'',$simple_counter);
                                      else       $counter = wm3Section::makeCounterCategorySub($w3,$row->categoryID," AND enabled = '".WM3_cENABLED."' $language_filter",$simple_counter);
                                     }
       else                          {
                                      if($admin) $counter = wm3Section::makeCounterCategorySubItem($w3,$row->categoryID,array('',''),$simple_counter);
									  else       $counter = wm3Section::makeCounterCategorySubItem($w3,$row->categoryID,array(" AND enabled = '".WM3_cENABLED."' $language_filter"," AND ".WM3_cCONFIG_DB_PREFIX."$this->table_items_count.enabled*".WM3_cCONFIG_DB_PREFIX."$this->table_categories.enabled*".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories_count.enabled='".WM3_cENABLED."' $language_filter_count"),$simple_counter);
                                     }
	   if($simple_counter) $name = wm3Util::makeLink("$link&action=$this->action_show_subcategory","$row->name $counter");
       else                $name = wm3Util::makeLink("$link&action=$this->action_show_subcategory","$row->name")."<br>$counter";
       if($this->allow_category_description) $name .= "<p><i>$row->description</i></p>";
       $_DATA[$p]->name = $name;
       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag;
         // Buttons
         $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=$this->action_add_subcategory","action_add_from.png",$w3->getWord($this->label_subcategory_add));
         if($row->enabled) $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=$this->action_disable_category","action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=$this->action_enable_category","action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=$this->action_edit_category","action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=$this->action_delete_category","action_delete.png",$w3->getWord(179),$w3->getWord(702));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=$this->action_edit_category","action_edit.png",$w3->getWord(178));
        }

       // Show also subcategories when select a category (if requested)
       if($show_subcategories)
        if($row->categoryID == $currentID)
         $_DATA[$p]->name .= wm3Section::getSubcategoryList($w3,$w3->getVariable('subcategoryID'),$admin,$no_icon,$no_allowed,$base_link,$no_page_link,$folder_style,$no_header,$simple_counter,$all_language);
       if($row->categoryID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     if(!$no_header) {
		              $list->setTitle($w3->getWord($this->label_category_list_title));
                      if(!$admin) if($this->extra_button_action) $list->setTitle($list->getTitle()." ".$w3->getSkinObj()->getSeparator()." ".wm3Util::actionButton($base_link.$page_link."&action=".$this->extra_button_action,$this->extra_button_icon,"","",$w3->getWord($this->extra_button_label),0,16,16));
                     }
     $list->setTotalItems($total_items);
     if($this->search_form) require(WM3_cPATH_INCLUDE.$this->search_form); else $search_form = '';
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);     
     if($admin) {
                 $list->setCaptionLabels(array($w3->getWord($this->label_category_icon),$w3->getWord($this->label_category_name),$w3->getWord($this->label_category_info)));
		         $list->setCaptionWidths(array(0,60,40));
                 $list->setCaptionColspan(array(1,1,1,4));
                 $list->setWidths(array(0,60,40));
			    }
	 else
	            {
				 $list->setRenderCaption(false);
				 $list->setWidths(array(0,100));
				}
     $list->setRenderPagesNavigator(false);
	 $list->setBottomContent($alternate_search_form);
     return $list->render();
    }

   protected function getSubcategoryList($w3,$currentID,$admin,$no_icon = false,$no_allowed = false,$base_link = "",$no_page_link = false,$folder_style = false,$no_header = false,$simple_counter = false,$all_language = false)
    {
     // Get generic subcategory list (admin and home side)

     // Prepare variables to create the list
     if($folder_style) $no_icon = false;// TODO verificare
     if($no_allowed) $allowed = false;
     else            $allowed = wm3User::checkAdminPermission($w3,$this->allowed_section); // Used to enable admin buttons in home stage
     if($all_language)
	  {
	   $language_filter = "AND (".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.languageID='".$w3->getHomeLanguage()."' OR ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.languageID='".WM3_cLANGUAGE_ALL."')";
       $language_filter_count = "AND (languageID = '".$w3->getHomeLanguage()."' OR languageID = '".WM3_cLANGUAGE_ALL."')";
      }
	 else
	  {
	   $language_filter = "AND ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.languageID='".$w3->getHomeLanguage()."'";
	   $language_filter_count = "AND languageID = '".$w3->getHomeLanguage()."'";
      }
     $page_link  = '';
     $categoryID = $w3->getVariable('categoryID');
     if($categoryID) $query_filter = " AND ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.categoryID = '$categoryID'"; else $query_filter = "";
     if($admin) {
     	         if(!$base_link)
     	          $base_link  = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $id_link    = "&categoryID=$categoryID";
     	        }
     else       {
                 if(!$base_link)
      	          $base_link  = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     	         $id_link    = "&categoryID=$categoryID";
     	         if(!$no_page_link) $page_link  = "&pageID=".$w3->getVariable('pageID','get');
     	         $width_name = 100;
                 $query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.enabled*".WM3_cCONFIG_DB_PREFIX."$this->table_categories.enabled='".WM3_cENABLED."' $language_filter";
     	         if($allowed) { $columns = 3; $buttons = 1; } else { $columns = 2; $buttons = 0; }
     	        }
     if($allowed) $base_allowed_link = WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."&section=$this->allowed_section";
     if($this->search_form) {
     	                     $filter = $w3->getVariable('filter'); // Search field
     	                     $subcategoryID = $w3->getVariable('subcategoryID');
     	                     if($admin) $search_form_link = WM3_cCONFIG_ADMIN_FILE."?action=$this->action_search";
     	                     else       $search_form_link = WM3_cCONFIG_HOME_FILE."?action=$this->action_search$id_link$page_link";
     	                    }
     // Do the query
     $rs = $w3->getDBObj()->query("SELECT   ".WM3_cCONFIG_DB_PREFIX."$this->table_categories.enabled,".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.*
                             FROM     ".WM3_cCONFIG_DB_PREFIX."$this->table_categories,".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories
                             WHERE    ".WM3_cCONFIG_DB_PREFIX."$this->table_categories.categoryID=".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.categoryID
                             $query_filter
                             ORDER BY ".WM3_cCONFIG_DB_PREFIX."$this->table_subcategories.name DESC");
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$page_link."&subcategoryID=$row->subcategoryID";
	   if($allowed) $allowed_link = $base_allowed_link.$id_link."&subcategoryID=$row->subcategoryID";
       if(!$no_icon) {
                      if($folder_style) $_DATA[$p]->icon = "<a href=\"$link&action=$this->action_show_items\"><img src=\"".WM3_cPATH_DATA."misc_folder.png\" width=\"36\" height=\"36\" border=\"0\"></a>";
                      else              $_DATA[$p]->icon = "<a href=\"$link&action=$this->action_show_items\"><img src=\"".WM3_cPATH_ICONS."$row->icon\"    width=\"36\" height=\"36\" border=\"0\"></a>";
                     }
       if($admin) $counter = wm3Section::makeCounterSubcategoryItem($w3,$row->subcategoryID,'',$simple_counter);
       else       $counter = wm3Section::makeCounterSubcategoryItem($w3,$row->subcategoryID," AND enabled = '".WM3_cENABLED."' $language_filter_count",$simple_counter);
       if($simple_counter) {
		                    $_PSEP = $w3->getSkinObj()->getPathSeparator();
	                        $name = "<a href=\"$link&action=$this->action_show_items\">$_PSEP $row->name $counter</a>";
						   }
       else                {
		                    $name = "<a href=\"$link&action=$this->action_show_items\">$row->name</a><br>$counter";
						   }
       if($this->allow_subcategory_description) $name .= "<p><i>$row->description</i></p>";
       $_DATA[$p]->name = $name;

       if($admin)
        {
         $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         $_DATA[$p]->info = $lang_flag;
         // Buttons
         $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=$this->action_add_item","action_add_from.png",$w3->getWord($this->label_item_add));
         if($row->enabled) $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=$this->action_disable_subcategory","action_disable.png",$w3->getWord(180));
         else              $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=$this->action_enable_subcategory","action_enable.png",$w3->getWord(181));
         $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=$this->action_edit_subcategory","action_edit.png",$w3->getWord(178));
         $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=$this->action_delete_subcategory","action_delete.png",$w3->getWord(179),$w3->getWord(702));
        }
       else
        {
         if($allowed) $_DATA[$p]->b1 = wm3Util::actionButton("$allowed_link&action=$this->action_edit_subcategory","action_edit.png",$w3->getWord(178));
        }
       if($row->subcategoryID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     if(!$no_header) {
                      $_PSEP = $w3->getSkinObj()->getPathSeparator();
		              $list->setTitle("<a href=\"$base_link$page_link\">".$w3->getWord($this->label_category_list_title)."</a>");
		              if($admin) $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link."&action=".$this->action_show_subcategory."\">".wm3Section::getCategoryName($w3,$categoryID,$this->table_categories)."</a>");
                      else       $list->setTitle($list->getTitle()." $_PSEP <a href=\"".$base_link.$id_link.$page_link."&action=".$this->action_show_subcategory."\">".wm3Section::getCategoryName($w3,$categoryID,$this->table_categories)."</a>");		              
                      if($admin) $list->setTitle($list->getTitle()." ".$w3->getSkinObj()->getSeparator()." ".wm3Util::actionButton($base_link.$id_link."&action=$this->action_add_subcategory","action_add.png","","",$w3->getWord($this->label_subcategory_add),0,16,16));
	                  if(!$admin) if($this->extra_button_action) $list->setTitle($list->getTitle()." ".$w3->getSkinObj()->getSeparator()." ".wm3Util::actionButton($base_link.$page_link."&action=".$this->extra_button_action,$this->extra_button_icon,"","",$w3->getWord($this->extra_button_label),0,16,16));
                     }
     $list->setTotalItems($total_items);
     if($this->search_form) require(WM3_cPATH_INCLUDE.$this->search_form); else $search_form = '';
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     if($admin) {
                 $list->setCaptionLabels(array($w3->getWord($this->label_subcategory_icon),$w3->getWord($this->label_subcategory_name),$w3->getWord($this->label_subcategory_info)));
		         $list->setCaptionWidths(array(0,60,40));
                 $list->setCaptionColspan(array(1,1,1,4));
                 $list->setWidths(array(0,60,40));
			    }
	 else
	            {
				 $list->setRenderCaption(false);
				 $list->setWidths(array(0,100));
				}
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   protected function addCategory($w3,$error)
    {
     // Make a generic category form to add a new category

	 // Initialize form     
     $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray());
	 $action  = $this->action_add_category;
     $section = $this->section;
	 require(WM3_cPATH_INCLUDE.$this->category_form);
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord($this->label_add_category_title));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = $this->saveCategory($w3);
         return $this->getCategoryList($w3,$lastID,true);
		}
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['icon']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ICONS); // Set due preview image
     $_F['icon']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_ICONS,1,'top','preview_image'));

     return $form->render();
    }

   protected function addSubcategory($w3,$error)
    {
     // Make a generic subcategory form to add a new subcategory

	 // Initialize form     
     $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray());
     $action  = $this->action_add_subcategory;
     $section = $this->section;
     require(WM3_cPATH_INCLUDE.$this->subcategory_form);
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord($this->label_add_subcategory_title));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['categoryID']->setValue($w3->getVariable('categoryID','get')); // Take categoryID from get
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX.$this->table_categories.   " WRITE");
       if($form->validate())
        {
		 $lastID = $this->saveSubcategory($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return $this->getSubcategoryList($w3,$lastID,true);
		}
	   $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['icon']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ICONS); // Set due preview image
     $_F['icon']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_ICONS,1,'top','preview_image'));

     return $form->render();
    }

   protected function editCategory($w3,$error)
    {
     // Make generic category form to edit a category

	 // Initialize form
	 $action  = $this->action_edit_category;
	 $section = $this->section;
	 require(WM3_cPATH_INCLUDE.$this->category_form);
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord($this->label_add_category_title));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                               WHERE categoryID = '".$w3->getVariable('categoryID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray($this->getCategoryFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = $this->updateCategory($w3);
         return $this->getCategoryList($w3,$lastID,true);
		}
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['icon'];
     $_F['icon']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_ICONS,1,'top','preview_image'));

     return $form->render();
    }

   protected function editSubcategory($w3,$error)
    {
     // Make generic subcategory form to edit a subcategory

	 // Initialize form
	 $action  = $this->action_edit_subcategory;
     $section = $this->section;
	 require(WM3_cPATH_INCLUDE.$this->subcategory_form);
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord($this->label_edit_subcategory_title));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                               WHERE subcategoryID = '".$w3->getVariable('subcategoryID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray($this->getSubcategoryFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX.$this->table_categories.   " WRITE");
       if($form->validate())
        {
         $lastID = $this->updateSubcategory($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return $this->getSubcategoryList($w3,$lastID,true);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }

     // Operation to do before render the form
     $preview_image = $_FIELD['icon']; if(!$preview_image) $preview_image = wm3Util::getFirstFile(WM3_cPATH_ICONS); // Set due preview image
     $_F['icon']->setExtraContentAfter(" ".wm3Util::renderImg($preview_image,$w3->getWord(893),36,36,WM3_cPATH_ICONS,1,'top','preview_image'));

     return $form->render();
    }

   protected function saveCategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields($this->table_categories,$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   protected function saveSubcategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields($this->table_subcategories,$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   protected function updateCategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getCategoryFieldsArray(),WM3_cQUOTE_DB);
     if($this->allow_category_description) $extra_query = "description = '".$_FIELD['description']."',";
     else                                  $extra_query = "";
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                       SET   name       = '".$_FIELD['name']."',
                             $extra_query
                             icon       = '".$_FIELD['icon']."',
                             enabled    = '".$_FIELD['enabled']."',
                             languageID = '".$_FIELD['languageID']."'
                       WHERE categoryID = '".$_FIELD['categoryID']."'");
     return $_FIELD['categoryID'];
    }

   protected function updateSubcategory($w3)
    {
     $_FIELD = webmatic3::getPostValueArray($this->getSubcategoryFieldsArray(),WM3_cQUOTE_DB);
     if($this->allow_subcategory_description) $extra_query = "description = '".$_FIELD['description']."',";
     else                                     $extra_query = "";     
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                       SET   categoryID    = '".$_FIELD['categoryID']."',
                             name          = '".$_FIELD['name']."',
                             $extra_query
                             icon          = '".$_FIELD['icon']."',
                             enabled       = '".$_FIELD['enabled']."',
                             languageID    = '".$_FIELD['languageID']."'
                       WHERE subcategoryID = '".$_FIELD['subcategoryID']."'");
     return $_FIELD['subcategoryID'];
    }

   protected function deleteCategory($w3,$categoryID,$sub_id_field = 'subcategoryID')
    {
	 if(!$this->table_items_count) // Without subcategories
	  {
	   $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WRITE,
	                                 ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE categoryID = '$categoryID'");
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WHERE categoryID = '$categoryID'");
	   $w3->getDBObj()->query("UNLOCK TABLES");
      }
     else // With subcategories
	  {
	   $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WRITE,
	                                 ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE,
									 ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WRITE");
	   $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE categoryID = '$categoryID'");
	   while($row = $w3->getDBObj()->fetch($rs))
	    {
	     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WHERE $sub_id_field = '".$row->$sub_id_field."'");
	    }
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE categoryID = '$categoryID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WHERE categoryID = '$categoryID'");
	   $w3->getDBObj()->query("UNLOCK TABLES");
      }

    }

   protected function deleteSubcategory($w3,$subcategoryID,$sub_id_field = 'subcategoryID')
    {
	 $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX.$this->table_categories." WRITE, ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WRITE, ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WRITE");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count." WHERE $sub_id_field = '$subcategoryID'");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories." WHERE $sub_id_field = '$subcategoryID'");
	 $w3->getDBObj()->query("UNLOCK TABLES");
    }

   protected function selectCategory($w3,$all,$admin)
    {
     // Return an array of wm3GUIOption objects for category select
     $array = array();
     if($admin) $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories);
     else       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                                        WHERE enabled='".WM3_cENABLED."' AND languageID='".$w3->getHomeLanguage()."'");
     if($all) array_push($array,new wm3GUIOption("All the categories",0));// TODO
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($row->name,$row->categoryID));
     return $array;
    }

   protected function selectSubcategory($w3,$all,$admin,$field = 'name',$fieldID = 'subcategoryID')
    {
     // Return an array of wm3GUIOption objects for category->subcategory select
     $array = array();
     //if($admin) TODO
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                             ORDER BY name");
     if($all) array_push($array,new wm3GUIOption("All the categories",0));//TODO
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $sub_rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                                   WHERE categoryID = '".$row->categoryID."'
                                   ORDER BY $field");
       while($sub_row = $w3->getDBObj()->fetch($sub_rs))
        array_push($array,new wm3GUIOption($row->name."->".$sub_row->$field,$sub_row->$fieldID));
      }
     return $array;
    }

   protected function getCategoryName($w3,$categoryID)
    {
     // Get category name from generic category
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                             WHERE categoryID = '$categoryID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->name;
    }

   protected function getSubcategoryName($w3,$subcategoryID, $field = "name", $fieldID = "subcategoryID")
    {
     // Get subcategory name from generic subcategory
     $rs = $w3->getDBObj()->query("SELECT $field FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                             WHERE  $fieldID = '$subcategoryID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return "";
     $row = $w3->getDBObj()->fetch($rs);
     return $row->$field;
    }

   protected function getCategoryID($w3,$subcategoryID,$fieldID = 'subcategoryID')
    {
     // Get categoryID from generic subcategoryID
     $rs = $w3->getDBObj()->query("SELECT categoryID FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                             WHERE  $fieldID = '$subcategoryID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0;
     $row = $w3->getDBObj()->fetch($rs);
     return $row->categoryID;
    }

   protected function getCategoryIcon($w3,$categoryID)
    {
     // Get category name from generic category
     $rs = $w3->getDBObj()->query("SELECT icon FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                                   WHERE categoryID = '$categoryID'");
     if($w3->getDBObj()->totalRows($rs) == 0) return '';
     $row = $w3->getDBObj()->fetch($rs);
     return $row->icon;
    }

   public function existsCategory($w3,$categoryID)
    {
     // Return true if the category with categoryID exists else return false
     $rs = $w3->getDBObj()->query("SELECT categoryID FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_categories."
                             WHERE  categoryID = '$categoryID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                         return false;
    }

   public function existsSubcategory($w3,$subcategoryID,$sub_id_field = 'subcategoryID')
    {
     // Return true if the subcategory with subcategoryID exists else return false
     $rs = $w3->getDBObj()->query("SELECT $sub_id_field FROM ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories."
                                   WHERE  $sub_id_field = '$subcategoryID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                         return false;
    }

   private function makeCounterCategorySub($w3,$categoryID,$filter = '',$simple_counter = false)
    {
     // Get the number of subcategory in a category and return a formatted string for output
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.$this->table_subcategories_count,"WHERE categoryID = '$categoryID'$filter");
     if($total == 1) $label = $w3->getWord($this->label_subcategories_count);
     else            $label = $w3->getWord($this->label_subcategories_count+1);
     if($simple_counter) return "($total)"; return "($total $label)";
    }

   private function makeCounterCategorySubItem($w3,$categoryID,$filter = array('','') ,$simple_counter = false)
    {
     // Get the number of subcategory and item in a category and return a formatted string for output
     $total     = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.$this->table_subcategories_count,"WHERE categoryID = '$categoryID'$filter[0]");
     if($total != 1) $label = $w3->getWord($this->label_subcategories_count); else $label = $w3->getWord($this->label_subcategories_count+1);
     $query = "SELECT count(*) AS total
	           FROM   ".WM3_cCONFIG_DB_PREFIX.$this->table_categories.",
                      ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories_count.",
                      ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count."
               WHERE  ".WM3_cCONFIG_DB_PREFIX.$this->table_categories.".categoryID = ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories_count.".categoryID
                 AND  ".WM3_cCONFIG_DB_PREFIX.$this->table_subcategories_count.".$this->field_items_count = ".WM3_cCONFIG_DB_PREFIX.$this->table_items_count.".$this->field_items_count
                 AND  ".WM3_cCONFIG_DB_PREFIX.$this->table_categories.".categoryID = '$categoryID'
				      $filter[1]";
     $row = $w3->getDBObj()->fetch($w3->getDBObj()->query($query));
     $sub_total = $row->total;

     if($sub_total != 1) $sub_label = $w3->getWord($this->label_items_count); else $sub_label = $w3->getWord($this->label_items_count+1);    
     if($simple_counter) return "($sub_total)"; return "($total $label, $sub_total $sub_label)";
    }

   private function makeCounterSubcategoryItem($w3,$subcategoryID,$filter = "",$simple_counter = false)
    {
     // Get the number of item in a subcategory and return a formatted string for output
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX.$this->table_items_count,"WHERE subcategoryID = '$subcategoryID'$filter");
     $label = $w3->getWord($this->label_items_count);
     if($simple_counter) return "($total)"; else return "($total $label)";
    }

   public static function isActionPrintable($w3)
    {
	 // Return true if a printable action is performed
	 if($w3->getStage()   == WM3_cSTAGE_HOME                    &&
	    $w3->getSection() == WM3_cSECTION_NEWS                  &&
	    $w3->getAction()  == WM3_cACTION_PRINTABLE_SINGLE_NEWS) return true;
	 if($w3->getStage()   == WM3_cSTAGE_HOME                                 &&
	    $w3->getSection() == WM3_cSECTION_HOME                               &&
	    $w3->getAction()  == WM3_cACTION_PRINTABLE_SINGLE_ECOMMERCE_PRODUCT) return true;
	 if($w3->getStage()   == WM3_cSTAGE_ADMIN                       &&
	    $w3->getSection() == WM3_cSECTION_ECOMMERCE                 &&
	    $w3->getAction()  == WM3_cACTION_PRINTABLE_ECOMMERCE_ORDER) return true;
	 return false;
	}

  }

?>
