<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Session
  {

   function __construct() { }

   public static function getSessionFieldsArray()
    {
     return array('sessionID','hash','ip','userID','expire_ts');
    }

   public static function getChatroomSessionFieldsArray()
    {
     return array('chatroom_sessionID','chatroomID','userID','nickname','ip','join_ts','expire_ts');
    }

   public static function manageSession($w3)
    {
     // Manage website visitors session

     wm3Session::deleteExpiredSessions($w3);
	 wm3Preferences::updateMaxUsersVisitors($w3);
	 wm3Preferences::updateLastUserVisitor($w3);
     if($w3->getPreferences('logging_enabled')) wm3Logs::writeLog($w3); // TODO non eseguire questo per rendere il superutente invisibile

     // if(!anyUserLogged(1)) // TODO Se il superutente non è loggato (utile per rendere il superutente invisibile). E per i voti e gli hits (sessions_survey, sessions_media_albums eccetera) come fare???
      {
       if(session_id() == "") session_start();
       $_FIELD['sessionID'] = '';
       $_FIELD['hash']      = 0;// session_id(); // "hash" field unused for now (only "ip" identify a session)
       $_FIELD['ip']        = getenv('REMOTE_ADDR');
       $_FIELD['userID']    = $w3->getAuthenticateAdminUserID();
       $_FIELD['expire_ts'] = time() + WM3_cCONFIG_SESSION_TIME; // Session expire time

       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_sessions WHERE ip = '".$_FIELD['ip']."'");
       if($w3->getDBObj()->totalRows($rs) == 0) // New session
        {
         // Action to perform when a new visitor browse the website
         wm3Session::saveSession($w3,$_FIELD);
         wm3Statistic::updateStatisticBrowser($w3);
         wm3Statistic::updateStatisticOS($w3);
		 wm3Statistic::updateStatisticCountry($w3);
		 wm3Statistic::updateStatisticHistory($w3);
         wm3Preferences::incrementTotalVisitorsPreferences($w3);
        }
       else // Session already in the database
        {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions
                                 SET   expire_ts = '".$_FIELD['expire_ts']."',
                                       userID    = '".$_FIELD['userID']."'
                                 WHERE ip        = '".$_FIELD['ip']."'");
        }
      }
    }

   public static function saveSession($w3,$_FIELD)
    {
     $w3->getDBObj()->saveAllTableFields('_sessions',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function deleteExpiredSessions($w3)
    {
     // Remove expired sessions from database
     $ts = time();
	 $rs = $w3->getDBObj()->query("SELECT sessionID FROM ".WM3_cCONFIG_DB_PREFIX."_sessions
	                               WHERE expire_ts <= '$ts'");
	 while($row = $w3->getDBObj()->fetch($rs))
	  {
       $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions                    WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_news               WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_pages              WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items  WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys            WHERE sessionID = '$row->sessionID' AND userID = '".WM3_cUSER_ANONYMOUS."'"); // Do not delete users votes for a survey
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_actions            WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_forums_posts       WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_downloads          WHERE sessionID = '$row->sessionID'");
	   $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_banners_exchange   WHERE sessionID = '$row->sessionID'");
      }
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms WHERE expire_ts <= '$ts'"); // Expire the chat sessions
    }

   public static function chatroomSessionExists($w3)
    {
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 if($userID)
	  {
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
	                           WHERE chatroomID = '$chatroomID' AND userID = '$userID'");
	  }
	 else
	  {
	   $nickname = wm3Util::quoteDB($w3->getVariable('nickname','get'));
	   $ip       = getenv('REMOTE_ADDR');
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
	                           WHERE chatroomID = '$chatroomID' AND ip = '$ip' AND nickname = '$nickname'");
	  }
	 if($w3->getDBObj()->totalRows($rs) == 0) return false;
     else                         return true;
    }

   public static function chatroomSessionCreate($w3)
    {
	 // Create a new chatroom session
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 $ts         = time();
	 $_FIELD = webmatic3::getPostValueArray(wm3Session::getChatroomSessionFieldsArray(),WM3_cQUOTE_DB);
	 $_FIELD['chatroomID'] = $chatroomID;
     $_FIELD['join_ts']    = $ts;
	 $_FIELD['expire_ts']  = $ts + 60; // Chatroom session expire time
	 if($userID)
	  {
	   $_FIELD['userID']   = $userID;
	   $_FIELD['nickname'] = "";
	   $_FIELD['ip']       = "";
      }
	 else
	  {
	   $_FIELD['userID']   = 0;
	   $_FIELD['nickname'] = wm3Util::quoteDB($w3->getVariable('nickname','get'));
	   $_FIELD['ip']       = getenv('REMOTE_ADDR');
	  }
     $w3->getDBObj()->saveAllTableFields('_sessions_chatrooms',$_FIELD);
    }

   public static function chatroomSessionUpdate($w3,$update_join_ts = false)
    {
	 // Update a chatroom session
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 $ts         = time();
	 $_FIELD = webmatic3::getPostValueArray(wm3Session::getChatroomSessionFieldsArray(),WM3_cQUOTE_DB);
	 if($userID)
	  {
	   if($update_join_ts)
	    {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                           SET    join_ts   = '$ts', expire_ts = '".($ts + 60)."'
                           WHERE  chatroomID = '$chatroomID' AND userID = '$userID'");
	    }
	   else
	    {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                           SET    expire_ts = '".($ts + 60)."'
                           WHERE  chatroomID = '$chatroomID' AND userID = '$userID'");
	    }
	  }
	 else
	  {
       $nickname = wm3Util::quoteDB($w3->getVariable('nickname','get'));
	   $ip       = getenv('REMOTE_ADDR');
	   if($update_join_ts)
	    {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                           SET    join_ts   = '$ts', expire_ts = '".($ts + 60)."'
                           WHERE  chatroomID = '$chatroomID' AND ip = '$ip' AND nickname = '$nickname'");
	    }
	   else
	    {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                           SET    expire_ts = '".($ts + 60)."'
                           WHERE  chatroomID = '$chatroomID' AND ip = '$ip' AND nickname = '$nickname'");
	    }
	  }
    }

   public static function getChatroomSessionJoinTS($w3)
    {
	 $chatroomID = $w3->getVariable('chatroomID','get');
	 $userID     = $w3->getAuthenticateAdminUserID();
	 if($userID)
	  {
       $rs = $w3->getDBObj()->query("SELECT join_ts FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
	                           WHERE chatroomID = '$chatroomID' AND userID = '$userID'");
	  }
	 else
	  {
	   $nickname = wm3Util::quoteDB($w3->getVariable('nickname','get'));
	   $ip       = getenv('REMOTE_ADDR');
       $rs = $w3->getDBObj()->query("SELECT join_ts FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
	                           WHERE chatroomID = '$chatroomID' AND ip = '$ip' AND nickname = '$nickname'");
	  }
	 $row = $w3->getDBObj()->fetch($rs);
	 return $row->join_ts;
    }

   public static function protectAction($w3,$id)
    {
     // Protected from repost form data and massive form post attack
     $_FIELD['actionID'] = '';
     $_FIELD['sessionID'] = wm3Session::getSessionID($w3);
     $_FIELD['action_ts'] = $id;
     $w3->getDBObj()->saveAllTableFields('_sessions_actions',$_FIELD);
    }

   public static function actionAllowed($w3,$id)
    {
     // Return true if form data can be posted
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_actions
                             WHERE action_ts = '$id' AND sessionID = '".wm3Session::getSessionID($w3)."'");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function newsAllowed($w3,$newsID,$type)
    {
     // Return true if a news can be rated or hitted
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_news
                             WHERE newsID = '$newsID'
							   AND session_type = '$type'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_news.sessionID");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function newsProtect($w3,$newsID,$type)
    {
     // Protected news when same user try to rate or hit again
     $_FIELD['news_sessionID'] = '';
	 $_FIELD['newsID']         = $newsID;
     $_FIELD['sessionID']      = wm3Session::getSessionID($w3);
     $_FIELD['userID']         = 0; // TODO
	 $_FIELD['session_type']   = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_news',$_FIELD);
	}

   public static function downloadAllowed($w3,$downloadID,$type)
    {
     // Return true if a download can be rated or hitted
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_downloads
                             WHERE downloadID = '$downloadID'
							   AND session_type = '$type'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_downloads.sessionID");  
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function downloadProtect($w3,$downloadID,$type)
    {
     // Protected download when same user try to rate or hit again
     $_FIELD['download_sessionID'] = '';
	 $_FIELD['downloadID']         = $downloadID;
     $_FIELD['sessionID']          = wm3Session::getSessionID($w3);
     $_FIELD['userID']             = 0; // TODO
	 $_FIELD['session_type']       = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_downloads',$_FIELD);
	}

   public static function forumPostAllowed($w3,$forum_postID,$type)
    {
     // Return true if a post forum discussion can be rated or hitted
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_forums_posts
                             WHERE forum_postID = '$forum_postID'
							   AND session_type = '$type'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_forums_posts.sessionID");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function forumPostProtect($w3,$forum_postID,$type)
    {
     // Protected forum post discussion when same user try to rate or hit again
     $_FIELD['forum_post_sessionID'] = '';
	 $_FIELD['forum_postID']         = $forum_postID;
     $_FIELD['sessionID']            = wm3Session::getSessionID($w3);
     $_FIELD['userID']               = 0; // TODO
	 $_FIELD['session_type']         = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_forums_posts',$_FIELD);
	}

   public static function pageAllowed($w3,$pageID,$type)
    {
     // Return true if a page can be rated or hitted
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_pages
                             WHERE pageID = '$pageID'
							   AND session_type = '$type'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_pages.sessionID");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function pageProtect($w3,$pageID,$type)
    {
     // Protected page when same user try to rate or hit again
     $_FIELD['page_sessionID'] = '';
	 $_FIELD['pageID']         = $pageID;
     $_FIELD['sessionID']      = wm3Session::getSessionID($w3);
     $_FIELD['userID']         = 0; // TODO
	 $_FIELD['session_type']   = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_pages',$_FIELD);
	}

   public static function mediaAlbumItemAllowed($w3,$media_album_itemID,$type)
    {
     // Return true if a media album item can be rated or hitted
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items
                             WHERE media_album_itemID = '$media_album_itemID'
							   AND session_type = '$type'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items.sessionID");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function mediaAlbumItemProtect($w3,$media_album_itemID,$type)
    {
     // Protected media album items when same user try to rate or hit again
     $_FIELD['media_album_item_sessionID'] = '';
	 $_FIELD['media_album_itemID'] = $media_album_itemID;
     $_FIELD['sessionID']          = wm3Session::getSessionID($w3);
     $_FIELD['userID']             = 0; // TODO
	 $_FIELD['session_type']       = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_media_albums_items',$_FIELD);
	}

   public static function directoryItemAllowed($w3,$directory_itemID,$type)
    {
     // Return true if a directory item can be rated or hitted
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items
                             WHERE directory_itemID = '$directory_itemID'
							   AND session_type = '$type'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items.sessionID");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function directoryItemProtect($w3,$directory_itemID,$type)
    {
     // Protected directory items when same user try to rate or hit again
     $_FIELD['directory_item_sessionID'] = '';
	 $_FIELD['directory_itemID'] = $directory_itemID;
     $_FIELD['sessionID']        = wm3Session::getSessionID($w3);
     $_FIELD['userID']           = 0; // TODO
	 $_FIELD['session_type']     = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_directories_items',$_FIELD);
	}

   public static function surveyAllowed($w3,$surveyID,$type)
    {
     // Return true if a survey item can be voted

	 // Prevent a registered user to vote again (a registered user can give only one vote)
     if($w3->getAuthenticateAdminUserID())
      {
       $rs = $w3->getDBObj()->query("SELECT *
                               FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
                               WHERE surveyID = '$surveyID'
			                   AND session_type = '$type'
							   AND userID = '".$w3->getAuthenticateAdminUserID()."'");
	  }
	 else
      {
       $rs = $w3->getDBObj()->query("SELECT *
                               FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                    ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
                               WHERE surveyID = '$surveyID'
			                   AND session_type = '$type'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.userID = '".WM3_cUSER_ANONYMOUS."'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.sessionID");
      }
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function surveyProtect($w3,$surveyID,$survey_itemID,$type)
    {
     // Protected survey items when same user try to vote again
     $_FIELD['survey_sessionID'] = '';
	 $_FIELD['surveyID']         = $surveyID;
	 $_FIELD['survey_itemID']    = $survey_itemID;
     $_FIELD['sessionID']        = wm3Session::getSessionID($w3);
     $_FIELD['userID']           = $w3->getAuthenticateAdminUserID();
	 $_FIELD['session_type']     = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_surveys',$_FIELD);
	}

   public static function bannerExchangeAllowed($w3,$banner_exchangeID,$type)
    {
     // Return true if a clicked banner exchange can add credits
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions,
                                  ".WM3_cCONFIG_DB_PREFIX."_sessions_banners_exchange
                             WHERE banner_exchangeID = '$banner_exchangeID'
							   AND session_type = '$type'
							   AND ip = '".getenv('REMOTE_ADDR')."'
							   AND ".WM3_cCONFIG_DB_PREFIX."_sessions.sessionID = ".WM3_cCONFIG_DB_PREFIX."_sessions_banners_exchange.sessionID");
     if($w3->getDBObj()->totalRows($rs) == 0) return true;
     return false;
    }

   public static function bannerExchangeProtect($w3,$banner_exchangeID,$type)
    {
     // Protected banner exchange when same user try to click again
     $_FIELD['banner_exchange_sessionID'] = '';
	 $_FIELD['banner_exchangeID']         = $banner_exchangeID;
     $_FIELD['sessionID']                 = wm3Session::getSessionID($w3);
     $_FIELD['userID']                    = 0; // TODO
	 $_FIELD['session_type']              = $type;
     $w3->getDBObj()->saveAllTableFields('_sessions_banners_exchange',$_FIELD);
	}

   public static function getSessionID($w3)
    {
	 // Return current sessionID
	 // Usare anche session_id() per identificare le sessioni o solo l'ip ???
	 $ip = getenv('REMOTE_ADDR');
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions
                             WHERE ip = '$ip'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0; // No session found                             
     $row = $w3->getDBObj()->fetch($rs);
     return $row->sessionID;
	}

   public static function getSessionIDFromUserID($w3,$userID)
    {
	 // Return sessionID for an userID 
     $rs = $w3->getDBObj()->query("SELECT *
                             FROM ".WM3_cCONFIG_DB_PREFIX."_sessions
                             WHERE userID = '$userID'");
     if($w3->getDBObj()->totalRows($rs) != 1) return 0; // No session found                             
     $row = $w3->getDBObj()->fetch($rs);
     return $row->sessionID;
	}

   public static function getOnlineUsers($w3)
    {
     $rs  = $w3->getDBObj()->query("SELECT COUNT(*) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_sessions WHERE userID != ".WM3_cUSER_ANONYMOUS);
     $row = $w3->getDBObj()->fetch($rs);
     return $row->total;
    }

   public static function getOnlineVisitors($w3)
    {
     $rs  = $w3->getDBObj()->query("SELECT COUNT(*) AS total FROM ".WM3_cCONFIG_DB_PREFIX."_sessions WHERE userID = ".WM3_cUSER_ANONYMOUS);
     $row = $w3->getDBObj()->fetch($rs);
     return $row->total;
    }

  }

?>
