<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Social
  {
   // Variables
   private $link;

   function __construct() { }

   public static function renderFacebook($w3,$link)
    {
     // Render facebook like
     if(wm3Social::isFacebookEnabled())
      {
       $site_address = "http://".$w3->getPreferences('site_address');
       return "class=\"fb-like\" data-href=\"$site_address/$link\" data-send=\"false\" data-layout=\"".WM3_cSKIN_FACEBOOK_LAYOUT."\" data-width=\"1\" data-show-faces=\"false\"";
      }
    }

   public static function renderGPlusone($w3,$link)
    {
     // Render Google plusone
     if(wm3Social::isGPlusoneEnabled())
      {
	   $site_address = "http://".$w3->getPreferences('site_address');
       return "<g:plusone size=\"".WM3_cSKIN_GPLUSONE_LAYOUT."\" href=\"$site_address/$link\"></g:plusone>";
      }
    }

   public static function renderTwitter($w3,$link,$text)
    {
     // Render Twitter
     if(wm3Social::isTwitterEnabled())
      {
	   $site_address = "http://".$w3->getPreferences('site_address');
       return "<a href=\"https://twitter.com/share\" class=\"twitter-share-button\" data-url=\"$site_address/$link\" data-text=\"$text\" data-count=\"".WM3_cSKIN_TWITTER_LAYOUT."\" data-lang=\"en\">Tweet</a>";//TODO data-lang...
      }
    }

   public static function renderSocialDefaultMetatags($w3)
    {
	 $str = "";

     // Facebook
     $site_address = $w3->getPreferences('site_address');
     $image        = "http://".$site_address."/".WM3_cPATH_LOGO.$w3->getPreferences('logo');
	 $str .= "  <meta property=\"og:image\" content=\"$image\" />\n";
	 return $str;
	}

   public static function renderSocialMetatags($w3)
    {
	 $str = "";

     // Facebook
     if(wm3Social::isFacebookEnabled())
      {
	   // News
       if($w3->getStage() == WM3_cSTAGE_HOME && $w3->getAction() == WM3_cACTION_SHOW_SINGLE_NEWS)
        {
		 $newsID = $w3->getVariable('newsID');
		 $row = wm3News::getNewsData($w3,$newsID);
		 if($row && $row->enabled == WM3_cENABLED)
		  {
		   $title        = $row->title;
		   $type         = "article";
		   $site_address = $w3->getPreferences('site_address');
		   $url          = "http://".$site_address."/".WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_NEWS."&newsID=$newsID&action=".WM3_cACTION_SHOW_SINGLE_NEWS; 
		   $image        = "http://".$site_address."/".WM3_cPATH_ICONS.$row->icon;
           $str .= "  <meta property=\"og:title\"     content=\"$title\" />\n";
           $str .= "  <meta property=\"og:type\"      content=\"article\"   />\n";
           $str .= "  <meta property=\"og:site_name\" content=\"$site_address\" />\n";
           $str .= "  <meta property=\"og:url\"       content=\"$url\" />\n";
           $str .= "  <meta property=\"og:image\"     content=\"$image\" />\n";
           return $str;
	      }
	    }
	   // Ecommerce products
       if($w3->getStage() == WM3_cSTAGE_HOME && $w3->getAction() == WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT)
        {
		 $categoryID    = $w3->getVariable('categoryID');
		 $subcategoryID = $w3->getVariable('subcategoryID');
		 $productID     = $w3->getVariable('productID');
		 $row = wm3Ecommerce::getEcommerceProductData($w3,$categoryID,$subcategoryID,$productID);
		 if($row)
		  {
		   $title        = $row->name;
		   $type         = "article";
		   $site_address = $w3->getPreferences('site_address');
		   $url          = "http://".$site_address."/".WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&section=".WM3_cSECTION_HOME."&categoryID=$categoryID&subcategoryID=$subcategoryID&productID=$productID&action=".WM3_cACTION_SHOW_SINGLE_ECOMMERCE_PRODUCT; 
		   if($row->image) $image = "http://".$site_address."/".WM3_cPATH_ECOMMERCE.$row->image;
		   else            $image = "http://".$site_address."/".WM3_cPATH_LOGO.$w3->getPreferences('logo');
           $str .= "  <meta property=\"og:title\"     content=\"$title\" />\n";
           $str .= "  <meta property=\"og:type\"      content=\"article\"   />\n";
           $str .= "  <meta property=\"og:site_name\" content=\"$site_address\" />\n";
           $str .= "  <meta property=\"og:url\"       content=\"$url\" />\n";
           $str .= "  <meta property=\"og:image\"     content=\"$image\" />\n";
           return $str;
	      }
	    }
	   return wm3Social::renderSocialDefaultMetatags($w3);
      }
    }

   public static function isFacebookEnabled() { return WM3_cCONFIG_USE_SOCIAL_FACEBOOK; }
   
   public static function isGPlusoneEnabled() { return WM3_cCONFIG_USE_SOCIAL_GPLUSONE; }
   
   public static function isTwitterEnabled()  { return WM3_cCONFIG_USE_SOCIAL_TWITTER;  }

  }

?>
