<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Survey
  {

   function __construct() { }

   public static function getSurveyFieldsArray()
    {
     return array('surveyID','title','render_mode','question','target_type','result_type','layout_type','enabled','languageID','closed','backID','ts');
    }

   public static function getSurveyItemFieldsArray()
    {
     return array('survey_itemID','surveyID','render_mode','answer','enabled','languageID','ts');
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_ADD_SURVEY:
        {
         return wm3Survey::addSurvey($w3);
         break;
        }
       case WM3_cACTION_EDIT_SURVEY:
        {
         return wm3Survey::editSurvey($w3);
         break;
        }
       case WM3_cACTION_DISABLE_SURVEY:
        {
         wm3Survey::disableSurvey($w3,$w3->getVariable('surveyID','get'));
         return wm3Survey::getSurveyList($w3,$w3->getVariable('surveyID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_SURVEY:
        {
         wm3Survey::enableSurvey($w3,$w3->getVariable('surveyID','get'));
         return wm3Survey::getSurveyList($w3,$w3->getVariable('surveyID','get'));
         break;
        }
       case WM3_cACTION_DELETE_SURVEY:
        {
         wm3Survey::deleteSurvey($w3,$w3->getVariable('surveyID','get'));
         return wm3survey::getSurveyList($w3);
         break;
        }
	   case WM3_cACTION_RESET_SURVEY:
	    {
         wm3Survey::resetSurvey($w3,$w3->getVariable('surveyID','get'));
		 return wm3Survey::getSurveyList($w3,$w3->getVariable('surveyID','get'));
         break;
		}
       case WM3_cACTION_ADD_SURVEY_ITEM:
        {
         return wm3Survey::addSurveyItem($w3);
         break;
        }
       case WM3_cACTION_EDIT_SURVEY_ITEM:
        {
         return wm3Survey::editSurveyItem($w3);
         break;
        }
       case WM3_cACTION_DISABLE_SURVEY_ITEM:
        {
         wm3Survey::disableSurveyItem($w3,$w3->getVariable('survey_itemID','get'));
         return wm3Survey::getSurveyItemList($w3,$w3->getVariable('survey_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_SURVEY_ITEM:
        {
         wm3Survey::enableSurveyItem($w3,$w3->getVariable('survey_itemID','get'));
         return wm3Survey::getSurveyItemList($w3,$w3->getVariable('survey_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_SURVEY_ITEM:
        {
         wm3Survey::deleteSurveyItem($w3,$w3->getVariable('survey_itemID','get'));
         return wm3Survey::getSurveyItemList($w3);
         break;
        }
	   case WM3_cACTION_RESET_SURVEY_ITEM:
	    {
         wm3Survey::resetSurveyItem($w3,$w3->getVariable('survey_itemID','get'));
		 return wm3Survey::getSurveyItemList($w3,$w3->getVariable('survey_itemID','get'));
         break;
		}
       case WM3_cACTION_SHOW_SURVEY_ITEM:
        {
         return wm3Survey::getSurveyItemList($w3);
         break;
        }
       default:
        {
         return wm3Survey::getSurveyList($w3);
        }
      }
    }

   public static function getSurveyList($w3,$currentID = 0,$admin = true)
    {
     // Get surveys list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
     if($filter) { $search_link = "&filter=$filter";
                   $query_filter = "WHERE question LIKE '%$filter%'"; }
     else        { $search_link = $query_filter = ''; }
     $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY title";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'surveyID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&surveyID=$row->surveyID";
       $total_votes = wm3Survey::getSurveyTotalVotes($w3,$row->surveyID,$admin);
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
	   if($row->result_type == WM3_cSURVEY_RESULT_PUBLIC) $results = "Result are public..."; else $results = "Result are private...";
	   if($row->target_type == WM3_cSURVEY_TARGET_ALL)    $target  = "All can vote...";      else $target  = "Only registered users can vote...";
       $_DATA[$p]->title = "<a href=\"$link&action=".WM3_cACTION_SHOW_SURVEY_ITEM."\">$row->title</a><br>($total_votes votes)";
       $_DATA[$p]->info = "$lang_flag<br>$target<br>$results";
       // Buttons
       $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ADD_SURVEY_ITEM,"action_add_from.png",$w3->getWord(859));
       if($row->enabled) $_DATA[$p]->b2 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DISABLE_SURVEY,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b2 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_ENABLE_SURVEY,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SURVEY,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b4 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_RESET_SURVEY,"action_reset.png",$w3->getWord(179),$w3->getWord(932));
       $_DATA[$p]->b5 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_SURVEY,"action_delete.png",$w3->getWord(179),$w3->getWord(854));
       if($row->surveyID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;       
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(855));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_survey_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_LINK.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(887),$w3->getWord(1407)));
     $list->setCaptionWidths(array(60,40));
     $list->setCaptionColspan(array(1,1,5));
     $list->setWidths(array(60,40));
     return $list->render();
    }

   public static function getSurveyItemList($w3,$currentID = 0,$admin = true)
    {
     // Get survey items list (admin and home side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $surveyID = $w3->getVariable('surveyID'); // Take surveyID from both
     $query_filter = "WHERE surveyID = '$surveyID'";
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
	 $search_form_link = WM3_cCONFIG_ADMIN_FILE;
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = "&surveyID=$surveyID";

     // Do the query and take the total items number
	 $order_by =" ORDER BY ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'survey_itemID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = "";
     if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     $total_votes = wm3Survey::getSurveyTotalVotes($w3,$surveyID,$admin);
     while($row = $w3->getDBObj()->fetch($rs))
      {
	   $link = $base_link.$id_link.$extra_link."&survey_itemID=$row->survey_itemID";
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
	   if($total_votes) $percentage = $row->votes / $total_votes * 100; else $percentage = 0;
       $_DATA[$p]->answer = $row->answer;
       $_DATA[$p]->info   = "$lang_flag ".wm3Util::makePercentageBar($w3,$percentage,200,10)." (".round($percentage,2)."%, $row->votes votes)";
       // Buttons
       if($row->enabled) $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_SURVEY_ITEM,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_SURVEY_ITEM,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_SURVEY_ITEM,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_RESET_SURVEY_ITEM,"action_reset.png",$w3->getWord(179),$w3->getWord(932));
       $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_SURVEY_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(772));
       if($row->survey_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'');
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_survey_search_form.inc');
	 $_SEP  = $w3->getSkinObj()->getSeparator();
	 $_PSEP = $w3->getSkinObj()->getPathSeparator();
     $list->setTitle("<a href=\"$base_link\">".$w3->getWord(855)."</a> $_PSEP 
                           ".wm3Survey::getSurveyTitle($w3,$surveyID)." $_SEP 
                           ".wm3Util::actionButton($base_link.$id_link."&action=".WM3_cACTION_ADD_SURVEY_ITEM,"action_add.png","","",$w3->getWord(859),0,16,16));
     if($found) $list->setCurrentID($currentID);
	 $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link."&action=".WM3_cACTION_SHOW_SURVEY_ITEM.$id_link);
     $list->setCaptionLabels(array($w3->getWord(194),$w3->getWord(1407)));
     $list->setCaptionWidths(array(50,50));
     $list->setCaptionColspan(array(1,1,4));
     $list->setWidths(array(50,50));
     return $list->render();
    }

   public static function checkSurveyVoteError($w3,$surveyID,$survey_itemID)
    {
     // Check form invalid survey vote inputs
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_surveys       WRITE");
	 $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray());
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if($w3->getDBObj()->totalRows($rs) == 0) { $w3->getDBObj()->query("UNLOCK TABLES"); return 1; } // Survey do not exists
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                             WHERE surveyID = '$surveyID' AND survey_itemID = '$survey_itemID'");
     if($w3->getDBObj()->totalRows($rs) == 0) { $w3->getDBObj()->query("UNLOCK TABLES"); return 2; } // Survey item do not exists or not in surveyID 
     $w3->getDBObj()->query("UNLOCK TABLES"); return 0;
    }

   public static function addSurvey($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray());
	 $action = WM3_cACTION_ADD_SURVEY;
	 require(WM3_cPATH_INCLUDE.'admin_survey_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(837));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3Survey::saveSurvey($w3);
         return wm3Survey::getSurveyList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function editSurvey($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_SURVEY;
	 require(WM3_cPATH_INCLUDE.'admin_survey_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit survey");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                               WHERE surveyID = '".$w3->getVariable('surveyID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Survey::getSurveyFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3Survey::updateSurvey($w3);
         return wm3Survey::getSurveyList($w3,$lastID);
		}
      }
     return $form->render();
    }

   public static function saveSurvey($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts']     = time();
     $_FIELD['closed'] = WM3_cDISABLED;
     $_FIELD['backID'] = 0;
     $w3->getDBObj()->saveAllTableFields('_surveys',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateSurvey($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys
                       SET title       = '".$_FIELD['title']."',
                           question    = '".$_FIELD['question']."',
						   render_mode = '".$_FIELD['render_mode']."',
                           target_type = '".$_FIELD['target_type']."',
						   result_type = '".$_FIELD['result_type']."',
						   layout_type = '".$_FIELD['layout_type']."',
                           enabled     = '".$_FIELD['enabled']."',
                           languageID  = '".$_FIELD['languageID']."'
                       WHERE surveyID  = '".$_FIELD['surveyID']."'");
     return $_FIELD['surveyID'];
    }

   public static function selectSurvey($w3)
    {
     // Return an array of wm3GUIOption objects for surveys select
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys");
     $i = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $_LABEL[$i] = $row->title;
       $_VALUE[$i] = $row->surveyID;
       $i++;
      }
     if($i != 0) return wm3Util::selectArray($_LABEL,$_VALUE);
    }

   public static function disableSurvey($w3,$surveyID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys SET enabled = '".WM3_cDISABLED."' WHERE surveyID = '$surveyID'");
	}

   public static function enableSurvey($w3,$surveyID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys SET enabled = '".WM3_cENABLED."' WHERE surveyID = '$surveyID'");
	}
   
   public static function deleteSurvey($w3,$surveyID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items    WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_surveys          WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WRITE");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WHERE surveyID = '$surveyID'");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items WHERE surveyID = '$surveyID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_surveys WHERE surveyID = '$surveyID'");
	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function resetSurvey($w3,$surveyID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items SET votes = '0' WHERE surveyID = '$surveyID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WHERE surveyID = '$surveyID'");
	}

   public static function addSurveyItem($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray());
	 $action = WM3_cACTION_ADD_SURVEY_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_survey_item_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(859));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
       $_F['surveyID']->setValue($w3->getVariable('surveyID','get')); // Take surveyID from get
      }
     else
      {
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_surveys       WRITE");
       if($form->validate())
        {
         $lastID = wm3Survey::saveSurveyItem($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Survey::getSurveyItemList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function editSurveyItem($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_SURVEY_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_survey_item_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle("Edit survey item");

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                               WHERE survey_itemID = '".$w3->getVariable('survey_itemID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3Survey::getSurveyItemFieldsArray(),$row);
       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray());
       $form->setFieldsValues($_FIELD);
       $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items    WRITE,
		                             ".WM3_cCONFIG_DB_PREFIX."_surveys          WRITE,
                                     ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WRITE");
       if($form->validate())
        {
         $lastID = wm3Survey::updateSurveyItem($w3);
         $w3->getDBObj()->query("UNLOCK TABLES");
         return wm3Survey::getSurveyItemList($w3,$lastID);
		}
       $w3->getDBObj()->query("UNLOCK TABLES");
      }
     return $form->render();
    }

   public static function saveSurveyItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['votes'] = 0;
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_surveys_items',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateSurveyItem($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray(),WM3_cQUOTE_DB);
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                       SET   surveyID      = '".$_FIELD['surveyID']."',
                             answer        = '".$_FIELD['answer']."',
							 render_mode   = '".$_FIELD['render_mode']."',
                             enabled       = '".$_FIELD['enabled']."',
                             languageID    = '".$_FIELD['languageID']."'
                       WHERE survey_itemID = '".$_FIELD['survey_itemID']."'");
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
                       SET   surveyID      = '".$_FIELD['surveyID']."'
                       WHERE survey_itemID = '".$_FIELD['survey_itemID']."'");
     return $_FIELD['survey_itemID'];
    }

   public static function disableSurveyItem($w3,$survey_itemID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items SET enabled = '".WM3_cDISABLED."' WHERE survey_itemID = '$survey_itemID'");
	}

   public static function enableSurveyItem($w3,$survey_itemID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items SET enabled = '".WM3_cENABLED."' WHERE survey_itemID = '$survey_itemID'");
	}
   
   public static function deleteSurveyItem($w3,$survey_itemID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items    WRITE,
								   ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WRITE");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items WHERE survey_itemID = '$survey_itemID'");
     $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WHERE survey_itemID = '$survey_itemID'");
	 $w3->getDBObj()->query("UNLOCK TABLES");
	}

   public static function resetSurveyItem($w3,$survey_itemID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items SET votes = '0' WHERE survey_itemID = '$survey_itemID'");
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys WHERE survey_itemID = '$survey_itemID'");
	}

   public function existsSurvey($w3,$surveyID)
    {
     // Return true if the survey with surveyID exists else return false
     $rs = $w3->getDBObj()->query("SELECT surveyID FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE  surveyID = '$surveyID'");
     if($w3->getDBObj()->totalRows($rs) == 1) return true;
	 else                         return false;
    }

   public static function getSurveyTitle($w3,$surveyID)
    {
     $rs = $w3->getDBObj()->query("SELECT title FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $row->title;
    }

   public static function getSurveyTotalVotes($w3,$surveyID,$admin = false)
    {
	 if(!$admin) $query_filter = "AND enabled = '".WM3_cENABLED."'";
	 else        $query_filter = "";
     $rs = $w3->getDBObj()->query("SELECT SUM(votes) AS total_votes FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                             WHERE  surveyID = '$surveyID'
							 $query_filter");
     $row = $w3->getDBObj()->fetch($rs);
     if(!$row->total_votes) return 0; else return $row->total_votes;
    }

   public static function selectTargetType($w3)
    {
     // Return an array of wm3GUIOption objects for survey voters type
     return wm3Util::selectArray(array($w3->getWord(843),$w3->getWord(844)),
                                 array(WM3_cSURVEY_TARGET_ALL,WM3_cSURVEY_TARGET_USERS));
    }

   public static function selectResultType($w3)
    {
     // Return an array of wm3GUIOption objects for survey result type
     return wm3Util::selectArray(array($w3->getWord(845),$w3->getWord(846)),
                                 array(WM3_cSURVEY_RESULT_PUBLIC,WM3_cSURVEY_RESULT_PRIVATE));
    }

   public static function selectLayoutType($w3)
    {
     // Return an array of wm3GUIOption objects for survey layout type
     return wm3Util::selectArray(array($w3->getWord(847),$w3->getWord(848)),
                                 array(WM3_cSURVEY_LAYOUT_COMBO,WM3_cSURVEY_LAYOUT_MENU));
    }

   public static function voteSurvey($w3)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3Survey::getSurveyItemFieldsArray(),WM3_cQUOTE_DB);
	 if(wm3Survey::isSurveyVotable($w3,$_FIELD['surveyID'],$_FIELD['survey_itemID']))
	  {
	   if(wm3Session::surveyAllowed($w3,$_FIELD['surveyID'],WM3_cSESSION_VOTE))
	    {
	     wm3Session::surveyProtect($w3,$_FIELD['surveyID'],$_FIELD['survey_itemID'],WM3_cSESSION_VOTE);
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                           SET   votes         = votes + 1
                           WHERE survey_itemID = '".$_FIELD['survey_itemID']."'
                             AND surveyID      = '".$_FIELD['surveyID']."'");
         return wm3Survey::renderSurveyResult($w3,$_FIELD['survey_itemID']);
	    }
       else
	    {
         $w3->getPageObj()->setSubTitle($w3->getWord(-1)."Already voted...");
		 return wm3Survey::renderSurveyResult($w3);
		}
      }
	 else
	  {
	   $error = wm3Survey::checkSurveyVoteError($w3,$_FIELD['surveyID'],$_FIELD['survey_itemID']);
	   switch($error)
	    {
	     case 1: // Survey do not exists
		  {
		   $w3->getPageObj()->setSubTitle($w3->getWord(-1)."Survey do not exists...");
		   break;
	      }
	     case 2: // Survey item do not exists or not in surveyID 
		  {
		   $w3->getPageObj()->setSubTitle($w3->getWord(-1)."Please select an answare...");
		   break;
	      }
		 default:
		  {
		   $w3->getPageObj()->setSubTitle($w3->getWord(-1)."You can not vote a survey only for registered users...");
		  }
		}
	   return wm3Survey::renderSurveyResult($w3);
	  }
    }

   public function renderSurveyResult($w3,$currentID = 0)
    {
     // Render a survey result in home page
     $surveyID = $w3->getVariable('surveyID'); // Take surveyID from both
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                        WHERE surveyID = '$surveyID' AND enabled = '".WM3_cENABLED."'";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create survey question and answers
     $_DATA = $_COLSPAN = array();
	 $row = $w3->getDBObj()->fetch($rs);
     if($total_items)
      {
       $total_votes = wm3Survey::getSurveyTotalVotes($w3,$surveyID);
       $_DATA[0]->content = wm3Survey::renderSurveyItems($w3,$surveyID,true,$currentID);
       $_DATA[1]->total = "<nobr>".$w3->getWord(881)." <b>$total_votes</b></nobr>";
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
	 if(wm3Survey::isSurveyPublic($w3,$surveyID) || $w3->getAuthenticateAdminUserID())
      if($total_items) $list->setTitle($row->question);
	 if(!wm3Survey::isSurveyPublic($w3,$surveyID) && !$w3->getAuthenticateAdminUserID())
	  $list->setEmptyLabel($w3->getWord(876));
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(100));
     $str = $list->render();

     // Create survey result by gender
     if($total_items)
      {
       $_DATA = array();
       $_DATA[0]->content = wm3Survey::renderSurveyResultGender($w3,$surveyID);
       $list->setData($_DATA);
       $list->setTitle("<b>".$w3->getWord(871)."</b>");
       $str .= "<br>".$list->render();
      }
     return $str;
    }

   public function renderSurvey($w3,$surveyID)
    {
     // Render a survey panel in home page
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".WM3_cSECTION_HOME;

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                        WHERE surveyID = '$surveyID' AND enabled = '".WM3_cENABLED."'";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create survey question and answers
     $_DATA = array();
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
       $link = $base_link."&surveyID=$row->surveyID";
       $question = "<b>$row->question<b><br><br>";
       $_DATA[0]->question = $question;
	   $votable = (wm3Survey::isSurveyTargetAll($w3,$surveyID) || $w3->getAuthenticateAdminUserID());
	   $public  = (wm3Survey::isSurveyPublic($w3,$row->surveyID) || $w3->getAuthenticateAdminUserID());     
       $_DATA[1]->content = wm3Survey::renderSurveyItems($w3,$surveyID);
       
       if($votable)
        {
         $send = new wm3GUIButton('send',$w3->getWord(865));
         $_DATA[2]->button = "<br><div align=\"center\">".$send->render()."</div>";
	    }
	   else         $_DATA[2]->button = "<br><div align=\"center\"><i>(only members can vote)</i></div>";
       if($public)  $_DATA[3]->content = "<div align=\"center\"><a href=\"$link&action=".WM3_cACTION_SURVEY_RESULTS."\">".$w3->getWord(872)."</a></div>";
	   else         $_DATA[3]->content = "<div align=\"center\"><i>(survey results are private)</i></div>";
      }
     else return $w3->getWord(851);

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setEmptyLabel($w3->getWord(1633));
     $list->setRenderCaption(false);
     $list->setUseColors(false);
     $list->setRenderPagesNavigator(false);
     $list->setWidths(array(100));
     if($votable)
      {
       $form = new wm3GUIForm($w3,$link.'&action='.WM3_cACTION_SURVEY_VOTE,'','wm3_form');
       $hidden = new wm3GUIHiddenField('surveyID',$surveyID);
       return $form->renderOpen().$list->render().$hidden->render().$form->renderClose();
      }
     else return $list->render();
    }

   public function renderSurveyItems($w3,$surveyID,$show_result = false,$currentID = 0)
    {
     // Render survey item list
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                        WHERE surveyID = '$surveyID' AND enabled = '".WM3_cENABLED."'";
     if($show_result) $query .= "ORDER BY votes DESC";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link."&surveyID=$row->surveyID";
       if($show_result)
        {
         $total_votes = wm3Survey::getSurveyTotalVotes($w3,$surveyID);
         if($total_votes) $percentage = $row->votes / $total_votes * 100; else $percentage = 0;
         $_DATA[$p]->answer = $row->answer;
         $_DATA[$p]->bar    = wm3Util::makePercentageBar($w3,$percentage,200,10);
         $_DATA[$p]->info   = "<nobr>(".round($percentage,2)."%, $row->votes votes)</nobr>";
        }
       else
        {
         $radio = new wm3GUIRadio('survey_itemID',$row->survey_itemID);
         $_DATA[$p]->radio  = $radio->render();
         $_DATA[$p]->answer = $row->answer;
        }
       if($row->survey_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setRenderCaption(false);
     $list->setEmptyLabel($w3->getWord(939));
     if($found) $list->setCurrentID($currentID);
     if($show_result) $list->setWidths(array(60,0,40));
     else             $list->setWidths(array(0,100));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public function renderSurveyResultGender($w3,$surveyID)
    {
     // Render survey gender result

     // Do the query and take the total items number
     $query = "SELECT   ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.userID,
	                    ".WM3_cCONFIG_DB_PREFIX."_users.gender,
					    COUNT(*) as total
               FROM     ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys,
			            ".WM3_cCONFIG_DB_PREFIX."_users,
						".WM3_cCONFIG_DB_PREFIX."_surveys_items
               WHERE    ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.surveyID = '$surveyID'
			     AND    ".WM3_cCONFIG_DB_PREFIX."_surveys_items.enabled = '".WM3_cENABLED."'
			     AND    ".WM3_cCONFIG_DB_PREFIX."_users.userID = ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.userID
				 AND    ".WM3_cCONFIG_DB_PREFIX."_surveys_items.survey_itemID = ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys.survey_itemID
               GROUP BY ".WM3_cCONFIG_DB_PREFIX."_users.gender
               ORDER BY ".WM3_cCONFIG_DB_PREFIX."_users.gender DESC";
     $rs = $w3->getDBObj()->query($query); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $total_votes = wm3Survey::getSurveyTotalVotes($w3,$surveyID);
       if($total_votes) $percentage = $row->total / $total_votes * 100; else $percentage = 0;
       if($row->gender == 'M') $label  = $w3->getWord(869);
	   else                    $label  = $w3->getWord(870);
       $_DATA[$p]->label = $label;
       $_DATA[$p]->bar   = wm3Util::makePercentageBar($w3,$percentage,200,10);
       $_DATA[$p]->info  = "<nobr>(".round($percentage,2)."%, $row->total votes)</nobr>";
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA);
     $list->setRenderCaption(false);
     $list->setEmptyLabel($w3->getWord(939));
     $list->setWidths(array(60,0,40));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function isSurveyPublic($w3,$surveyID)
    {
     $rs = $w3->getDBObj()->query("SELECT result_type FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
     $row = $w3->getDBObj()->fetch($rs);
	 if($row->result_type == WM3_cSURVEY_RESULT_PUBLIC) return true;
     else                                               return false;
    }

   public static function isSurveyTargetAll($w3,$surveyID)
    {
     $rs = $w3->getDBObj()->query("SELECT target_type FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if($w3->getDBObj()->totalRows($rs) == 0) return false;
     $row = $w3->getDBObj()->fetch($rs);
	 if($row->target_type == WM3_cSURVEY_TARGET_ALL) return true;
     else                                            return false;
    }

   public static function isSurveyVotable($w3,$surveyID,$survey_itemID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_surveys_items WRITE,
	                               ".WM3_cCONFIG_DB_PREFIX."_surveys       WRITE");
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys
                             WHERE surveyID = '$surveyID'");
     if($w3->getDBObj()->totalRows($rs) == 0) { $w3->getDBObj()->query("UNLOCK TABLES"); return false; } // Survey do not exists
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                             WHERE surveyID = '$surveyID' AND survey_itemID = '$survey_itemID'");
     if($w3->getDBObj()->totalRows($rs) == 0) { $w3->getDBObj()->query("UNLOCK TABLES"); return false; } // Survey item do not exists or not in surveyID

	 if(!wm3Survey::isSurveyTargetAll($w3,$surveyID))
	  {
       if($w3->getAuthenticateAdminUserID()) { $w3->getDBObj()->query("UNLOCK TABLES"); return true; }
	   else                                  { $w3->getDBObj()->query("UNLOCK TABLES"); return false; }
      }
	 else { $w3->getDBObj()->query("UNLOCK TABLES"); return true; }
    }

  }

?>
