<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3UserMessage
  {

   function __construct() { }

   public static function getUserMessageFieldsArray()
    {
     return array('messageID','toID','subject','message','message_high_priority','enabled','languageID','fromID','message_read','message_replied','ts');
    }

   public static function executeUserAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_SET_NOT_READ_USER_MESSAGE:
        {
         wm3UserMessage::setNotReadUserMessage($w3,$w3->getVariable('messageID','get'));
         return wm3UserMessage::getUserMessageList($w3,$w3->getVariable('messageID','get'),false);
         break;
        }
       case WM3_cACTION_DELETE_USER_MESSAGE:
        {
         wm3UserMessage::deleteUserMessage($w3,$w3->getVariable('messageID','get'),false);
         return wm3UserMessage::getUserMessageList($w3,0,false);
         break;
        }
       case WM3_cACTION_ADD_USER_MESSAGE:
        {
         return wm3UserMessage::addUserMessage($w3,false);
         break;
        }
       case WM3_cACTION_REPLY_USER_MESSAGE:
        {
		 return wm3UserMessage::replyUserMessage($w3,false);
         break;
        }
       case WM3_cACTION_SHOW_USER_MESSAGE:
        {
         return wm3UserMessage::renderUserMessage($w3,$w3->getVariable('messageID','get'),false);
         break;
        }
       default:
        {
         return wm3UserMessage::getUserMessageList($w3,0,false);
        }
      }
    }

   public static function executeAdminAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_SET_NOT_READ_USER_MESSAGE:
        {
         wm3UserMessage::setNotReadUserMessage($w3,$w3->getVariable('messageID','get'));
         return wm3UserMessage::getUserMessageList($w3,$w3->getVariable('messageID','get'));
         break;
        }
       case WM3_cACTION_DELETE_USER_MESSAGE:
        {
         wm3UserMessage::deleteUserMessage($w3,$w3->getVariable('messageID','get'));
         return wm3UserMessage::getUserMessageList($w3);
         break;
        }
       case WM3_cACTION_ADD_USER_MESSAGE:
        {
         return wm3UserMessage::addUserMessage($w3);
         break;
        }
       case WM3_cACTION_REPLY_USER_MESSAGE:
        {
		 return wm3UserMessage::replyUserMessage($w3);
         break;
        }
       case WM3_cACTION_SHOW_USER_MESSAGE:
        {
         return wm3UserMessage::renderUserMessage($w3,$w3->getVariable('messageID','get'));
         break;
        }
       default:
        {
         return wm3UserMessage::getUserMessageList($w3);
        }
      }
    }

   public static function getUserMessageList($w3,$currentID = 0,$admin = true)
    {
     // Get messages list (admin and user side)

     // Prepare variables to create the list
     $max_page_items = 12;
     $pg = $w3->getVariable('pg');
     $filter = $w3->getVariable('filter'); // Search field
	 $search_link = ''; $query_filter = "WHERE 1=1";
     if($filter)
      {
       $search_link  = "&filter=$filter";
       $query_filter = "WHERE message LIKE '%$filter%'";
      }
     if($admin)
	  {
	   $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	   $query_filter .= " AND toID='".$w3->getAuthenticateAdminID()."'";
	  }
     else
      {
	   $search_form_link = WM3_cCONFIG_USER_FILE;
       $query_filter .= " AND toID='".$w3->getAuthenticateUserID()."'";
      }
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link = '';

     // Do the query and take the total items number
	 $order_by = " ORDER BY ".WM3_cCONFIG_DB_PREFIX."_users_messages.ts DESC";
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users_messages
                        $query_filter";
     $rs = $w3->getDBObj()->query($query.$order_by); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     $pg = wm3GUIList::fixNavigatorPage($w3,$currentID,$total_items,$max_page_items,$pg,'messageID',$rs);
	 if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
	 if($total_items != 0) $rs = $w3->getDBObj()->query($query.$order_by." LIMIT ".($pg*$max_page_items).",$max_page_items");

     // Create list content
     $_DATA = array(); $p = 0; $found = false;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link.$extra_link."&messageID=$row->messageID";
       //if($admin)
        {
		 if($row->message_read) $image = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\"><img src=\"".WM3_cPATH_DATA."misc_message_open.png\" width=\"24\" height=\"24\" border=\"0\" alt=\"".$w3->getWord(610)."\" title=\"".$w3->getWord(610)."\"></a>";
		 else                   $image = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\"><img src=\"".WM3_cPATH_DATA."misc_message_close.png\" width=\"24\" height=\"24\" border=\"0\" alt=\"".$w3->getWord(610)."\" title=\"".$w3->getWord(610)."\"></a>";
		 $from    = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\">".wm3User::getUserLogin($w3,$row->fromID)."</a>";
		 $subject = "<a href=\"$link&action=".WM3_cACTION_SHOW_USER_MESSAGE."\">".wm3Util::renderContent($w3,$row->subject,WM3_cRENDER_MODE_PLAIN_TEXT)."</a>";
		 $date    = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());
		 if(!$row->message_read) $date = "<b>$date</b>";
         //$lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\">";
         //$_DATA[$p]->flag = $lang_flag;
		 $_DATA[$p]->image   = $image;
		 $_DATA[$p]->from    = $from;
		 $_DATA[$p]->subject = $subject;
		 $_DATA[$p]->date    = $date;
         // Buttons
         $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_REPLY_USER_MESSAGE,"action_message_reply.png",$w3->getWord(607));
         if($row->message_read) $_DATA[$p]->b2 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_SET_NOT_READ_USER_MESSAGE,"action_message_close.png",$w3->getWord(608));
		 else                   $_DATA[$p]->b2 = "<img src=\"".WM3_cPATH_DATA."action_message_close_inactive.png\" width=\"24\" height=\"24\">";
         $_DATA[$p]->b3 = wm3Util::actionButton("$link$search_link&action=".WM3_cACTION_DELETE_USER_MESSAGE,"action_message_delete.png",$w3->getWord(609),$w3->getWord(774));
        }
       if($row->messageID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(603));
     $list->setTotalItems($total_items);
     require(WM3_cPATH_INCLUDE.'admin_user_message_search_form.inc');
     $list->setSearchForm($search_form);
     if($found) $list->setCurrentID($currentID);
     $list->setMaxPageItems($max_page_items);
     $list->setPage($pg);
     $list->setPagesNavigatorLink($base_link.$id_link.$search_link);
     $list->setCaptionLabels(array($w3->getWord(-1),$w3->getWord(1285),$w3->getWord(31),$w3->getWord(807)));
     $list->setCaptionWidths(array(0,25,55,20));
     $list->setCaptionColspan(array(1,1,1,1,3));
     $list->setWidths(array(0,25,55,20));
     return $list->render();
    }

   public static function addUserMessage($w3,$admin = true)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3UserMessage::getUserMessageFieldsArray());
	 $action = WM3_cACTION_ADD_USER_MESSAGE;
     if($admin) require(WM3_cPATH_INCLUDE.'admin_user_message_form.inc');
	 else       require(WM3_cPATH_INCLUDE.'user_user_message_form.inc');
     $form->setSubmitLabel($w3->getWord(294));
     $form->setTitle($w3->getWord(351));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['toID']->setValue($w3->getVariable('toID','get')); // Take toID from get (used for user message link in users informations page)
      }
     else
      {
       if($form->validate())
        {
         if($admin) $lastID = wm3UserMessage::saveUserMessage($w3);
         else       $lastID = wm3UserMessage::saveUserMessage($w3,false);
         if($admin) return wm3UserMessage::getUserMessageList($w3,$lastID);
         else       return wm3UserMessage::getUserMessageList($w3,$lastID,false);
		}
      }

     return $form->render();
    }

   public static function replyUserMessage($w3,$admin = true)
    {
	 // Initialize form
	 if($admin) $toID = $w3->getAuthenticateAdminID();
	 else       $toID = $w3->getAuthenticateUserID();
	 $action = WM3_cACTION_ADD_USER_MESSAGE;
     if($admin) require(WM3_cPATH_INCLUDE.'admin_user_message_form.inc');
	 else       require(WM3_cPATH_INCLUDE.'user_user_message_form.inc');
     $form->setSubmitLabel($w3->getWord(294));
     $form->setTitle($w3->getWord(607));

	 // Set message as read
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   SET message_read = '".WM3_cENABLED."'
	   			       WHERE messageID = '".$w3->getVariable('messageID','get')."' AND toID = '$toID'");

     // Render form
     // Take variables value from db
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users_messages
                             WHERE messageID = '".$w3->getVariable('messageID','get')."' AND toID = '$toID'");
     $row = $w3->getDBObj()->fetch($rs);
     if(!$row) return wm3GUIList::makeNotFoundItem($w3);
     $_FIELD = webmatic3::getRowValueArray(wm3UserMessage::getUserMessageFieldsArray(),$row);

     // Default value for fields not in $row object
     $_FIELD['toID']    = $_FIELD['fromID'];
	 $_FIELD['subject'] = "RE: ".$_FIELD['subject'];
	 $_FIELD['message'] = "\n\n\n---------\n\n".$_FIELD['message'];
	 $_FIELD['message_high_priority'] = WM3_cDISABLED;
     $form->setFieldsValues($_FIELD);

     return $form->render();
    }

   public static function saveUserMessage($w3,$admin = true)
    {
     $_FIELD = webmatic3::getPostValueArray(wm3UserMessage::getUserMessageFieldsArray(),WM3_cQUOTE_DB);
	 if($admin) $_FIELD['fromID'] = $w3->getAuthenticateAdminID();
	 else       $_FIELD['fromID'] = $w3->getAuthenticateUserID();
	 $_FIELD['message_read']    = WM3_cDISABLED;
	 $_FIELD['message_replied'] = WM3_cDISABLED;
	 $_FIELD['enabled']         = WM3_cENABLED;
     $_FIELD['ts'] = time();
     $w3->getDBObj()->saveAllTableFields('_users_messages',$_FIELD);
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function duplicateUserMessage($w3)
    {
     // Take fields from database and duplicate data creating a new row
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_messages
                             WHERE messageID = '".$w3->getVariable('messageID','get')."'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) // Duplicate only if ID exist
      {
       $_FIELD = webmatic3::getRowValueArray(wm3UserMessage::getUserMessageFieldsArray(),$row);
       $_FIELD['message'] = $w3->getWord(1417).$_FIELD['message'];
       $_FIELD['enabled'] = WM3_cDISABLED;
       $_FIELD['update_ts'] = $_FIELD['ts'] = time();
       $w3->getDBObj()->saveAllTableFields('_messages',$_FIELD,array('update_ts'));
       return $w3->getDBObj()->getLastInsertID();
      }
    }

   public static function setNotReadUserMessage($w3,$messageID)
    {
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   SET message_read = '".WM3_cDISABLED."'
					   WHERE messageID = '$messageID'");// AND toID = '".$w3->getAuthenticateUserID()."'");
	}
   
   public static function deleteUserMessage($w3,$messageID,$admin = true)
    {
	 if($admin) $toID = $w3->getAuthenticateAdminID();
	 else       $toID = $w3->getAuthenticateUserID();
	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   WHERE messageID = '$messageID' AND toID = '$toID'");
	}

   public static function renderUserMessage($w3,$messageID,$admin = true)
    {
	 // Set message as read
	 if($admin) $toID = $w3->getAuthenticateAdminID();
	 else       $toID = $w3->getAuthenticateUserID();
	 $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                   SET message_read = '".WM3_cENABLED."'
	   			       WHERE messageID = '$messageID' AND toID = '$toID'");

     // Prepare variables to create the list
	 //$query_filter = '';
     $filter = $w3->getVariable('filter'); // Search field
     $pg     = $w3->getVariable('pg');
     if($filter) $search_link = "&filter=$filter"; else $search_link = '';
     if($pg) $extra_link = "&pg=$pg"; else $extra_link = '';
     //$pageID = $w3->getVariable('pageID');
     //$page_link = "&pageID=$pageID";
     if($admin) $search_form_link = WM3_cCONFIG_ADMIN_FILE;
	 else       $search_form_link = WM3_cCONFIG_USER_FILE;
     $base_link = WM3_cCONFIG_HOME_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     //$query_filter .= " AND ".WM3_cCONFIG_DB_PREFIX."_faqs.enabled*".WM3_cCONFIG_DB_PREFIX."_faqs_categories.enabled='".WM3_cENABLED."' AND ".WM3_cCONFIG_DB_PREFIX."_faqs.languageID='".$w3->getHomeLanguage()."'";
     $id_link = '';

     // Do the query and take the total items number
     $query = "SELECT *
               FROM   ".WM3_cCONFIG_DB_PREFIX."_users_messages
               WHERE toID = '$toID'";
     $rs = $rs_aux = $w3->getDBObj()->query($query." ORDER BY ts DESC"); // Do the query without "limit"
     $total_items = $w3->getDBObj()->totalRows($rs);
     if($total_items != 0) $rs = $w3->getDBObj()->query($query." AND messageID = '$messageID'");

     // Create item
     $_DATA = $_COLSPAN = array();
     $row = $w3->getDBObj()->fetch($rs);
     if($row)
      {
       $link = $base_link.$id_link.$search_link.$extra_link;
       $image = "<img src=\"".WM3_cPATH_DATA."misc_message_open.png\" width=\"24\" height=\"24\">";
	   $from    = "<b>".wm3User::getUserLogin($w3,$row->fromID)."</b>";
       $subject = "<b>".wm3Util::renderContent($w3,$row->subject,WM3_cRENDER_MODE_PLAIN_TEXT)."</b>";
	   $date    = wm3Util::renderDate($w3,$row->ts,$w3->getHomeLanguage());	 
       $message = "$image Date: <i>$date</i><br><br>".wm3Util::renderContent($w3,$row->message,WM3_cRENDER_MODE_PLAIN_TEXT);
       $_DATA[0]->label = $w3->getWord(403); $_DATA[0]->text = $from;
       $_DATA[1]->label = $w3->getWord(31);  $_DATA[1]->text = $subject;
       $_DATA[2]->text  = $message; $_COLSPAN[2] = array(2);
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,'',$_COLSPAN);
     $list->setTotalItems($total_items);
     $list->setMaxPageItems(1);
     require(WM3_cPATH_INCLUDE.'admin_user_message_search_form.inc');
     $list->setSearchForm($search_form);
	 $_SEP = $w3->getSkinObj()->getSeparator();
     $list->setTitle($list->getTitle().wm3Util::actionButton($base_link.$id_link."&messageID=$messageID&action=".WM3_cACTION_REPLY_USER_MESSAGE,"action_message_reply.png","","",$w3->getWord(607),0,16,16));
	 $list->setTitle($list->getTitle()." $_SEP ".wm3Util::actionButton($base_link.$id_link."&messageID=$messageID&action=".WM3_cACTION_DELETE_USER_MESSAGE,"action_message_delete.png","","",$w3->getWord(609),0,16,16));
     $list->setRenderCaption(false);
     $list->setWidths(array(0,100));
     if($row) {
               $list->setPageNavigatorRS($rs_aux);
               $list->setPageNavigatorField('messageID');
               $list->setPageNavigatorID($row->messageID);
               $list->setPagesNavigatorLink($base_link.$id_link.$search_link.$extra_link."&action=".WM3_cACTION_SHOW_USER_MESSAGE);
		      }
     return $list->render();
	}

   public static function selectTo($w3)
    {
     // Return an array of wm3GUIOption objects for users select (get administrators and users with user message flag on)
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_users
	                         WHERE f3 = '".WM3_cENABLED."' OR admin = '".WM3_cENABLED."'
							 ORDER BY name");

     array_push($array,new wm3GUIOption("To all user in the group (4)",0));//TODO to all user (solo per admin)
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($row->login,$row->userID));
     return $array;
    }

   public static function makeNotReadUserMessage($w3,$label,$toID)
    {
     // Get the number of subcategory in a category and return a formatted string for output
     $total = $w3->getDBObj()->countTable(WM3_cCONFIG_DB_PREFIX."_users_messages","WHERE toID = '$toID' AND message_read = '".WM3_cDISABLED."'");
     if($total == 1) $label = $w3->getWord($label);
     else            $label = $w3->getWord($label+1);
	 return $w3->getWord(888)." $total ".$label;
    }

  }

?>
