<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Util
  {
   
   function __construct() { }

   public static function getBBCodeArray()
    {
	 return array('img','/img','url','/url','left','/left','center','/center','right','/right','b','/b','i','/i','u','/u','br','hr','sp','more',
	              ':)',':o',':p','lD',':(','|)',';)','B)','|(',':/',':|','8|',':s',':D');
	}

   /** Render all the constants used by java script
    * @param webmatic3 $w3 a webmatic3 instance
	* @return String
    */
   public static function renderJavaScriptConstants($w3)
    {
     ob_start();
	 $content = '';
	 require($w3->getSkinObj()->getCodeStart());
     $code_start = wm3Util::quoteDB(ob_get_contents());
	 $code_start = str_replace("\"","\\\"",$code_start);
	 $code_start = str_replace("\r",""    ,$code_start);
	 $code_start = str_replace("\n",""    ,$code_start);
     ob_end_clean();

     ob_start();
	 $content = '';
	 require($w3->getSkinObj()->getCodeEnd());
     $code_end = wm3Util::quoteDB(ob_get_contents());
	 $code_end = str_replace("\"","\\\"",$code_end);
	 $code_end = str_replace("\r",""    ,$code_end);
	 $code_end = str_replace("\n",""    ,$code_end);
     ob_end_clean();

     $str = "
             var WM3_cRENDER_MODE_PLAIN_TEXT   = ".WM3_cRENDER_MODE_PLAIN_TEXT.";
             var WM3_cRENDER_MODE_HTML         = ".WM3_cRENDER_MODE_HTML.";
             var WM3_cRENDER_MODE_BB_CODE      = ".WM3_cRENDER_MODE_BB_CODE.";
             var WM3_cRENDER_MODE_HTML_BB_CODE = ".WM3_cRENDER_MODE_HTML_BB_CODE.";

             var WM3_cPATH_EMOTICONS = '".WM3_cPATH_EMOTICONS."';
             
             var WM3_cMENU_ID_PREFIX = '".WM3_cMENU_ID_PREFIX."';

             var WM3_cPANEL_CATEGORY_CUSTOM    = ".WM3_cPANEL_CATEGORY_CUSTOM.";
             var WM3_cPANEL_CATEGORY_SURVEY    = ".WM3_cPANEL_CATEGORY_SURVEY.";
             var WM3_cPANEL_CATEGORY_MENU      = ".WM3_cPANEL_CATEGORY_MENU.";
             var WM3_cPANEL_CATEGORY_EXPANSION = ".WM3_cPANEL_CATEGORY_EXPANSION.";

             var WM3_cPAGE_CATEGORY_CUSTOM    = ".WM3_cPAGE_CATEGORY_CUSTOM.";
             var WM3_cPAGE_CATEGORY_EXPANSION = ".WM3_cPAGE_CATEGORY_EXPANSION.";

             var WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR               = ".WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR.";
             var WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR_TINYMCE       = ".WM3_cACTION_KERNEL_RENDER_PAGE_EDITOR_TINYMCE.";
             var WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR               = ".WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR.";
             var WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR_TINYMCE       = ".WM3_cACTION_KERNEL_RENDER_NEWS_EDITOR_TINYMCE.";
             var WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR         = ".WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR.";
             var WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR_TINYMCE = ".WM3_cACTION_KERNEL_RENDER_NEWSLETTER_EDITOR_TINYMCE.";

             var WM3_cRE_URL                = ".WM3_cRE_URL.";
             var WM3_cRE_URL_RELATIVE       = ".WM3_cRE_URL_RELATIVE.";
             var WM3_cRE_IMAGE_URL          = ".WM3_cRE_IMAGE_URL.";
             var WM3_cRE_IMAGE_URL_RELATIVE = ".WM3_cRE_IMAGE_URL_RELATIVE.";

             var WM3_cMENU_ITEM_CATEGORY_CHANNEL  = ".WM3_cMENU_ITEM_CATEGORY_CHANNEL.";
             var WM3_cMENU_ITEM_CATEGORY_EXTERNAL = ".WM3_cMENU_ITEM_CATEGORY_EXTERNAL.";
             var WM3_cMENU_ITEM_CATEGORY_CUSTOM   = ".WM3_cMENU_ITEM_CATEGORY_CUSTOM.";\n
             // Skin Javascript related constants
             var WM3_cCODE_CSS_START = '".$code_start."';
             var WM3_cCODE_CSS_END   = '".$code_end."';";
     return $str;
    }

   /** Render a page, news and other website contents in the right render mode
	* @param webmatic3 $w3          webmatic3 instance
	* @param String    $content     the content to render
	* @param int       $render_mode content will be render in different mode (passing WM3_cRENDER_MODE_HTML, WM3_cRENDER_MODE_PLAIN_TEXT, WM3_cRENDER_MODE_BB_CODE or WM3_cRENDER_MODE_HTML_BB_CODE)
	* @param bool      $flag_news   if true the first occurrence of tag [more] will be parsed for any render_mode (used for the news)
	* @param String    $link_news   the link to the news used for "read more" link
	* @return String
    */
   public static function renderContent($w3,$content,$render_mode,$flag_news = false,$link_news = '')
    {
     if($render_mode == WM3_cRENDER_MODE_HTML)         return wm3Util::getHtmlText($w3,$content,$flag_news,$link_news);
     if($render_mode == WM3_cRENDER_MODE_PLAIN_TEXT)   return wm3Util::getPlainText($w3,$content,$flag_news,$link_news);
     if($render_mode == WM3_cRENDER_MODE_BB_CODE)      return wm3Util::getBBCodeText($w3,wm3Util::getPlainText($w3,$content,false,$link_news),$flag_news,$link_news,false);
     if($render_mode == WM3_cRENDER_MODE_HTML_BB_CODE) return wm3Util::getBBCodeText($w3,$content,$flag_news,$link_news,true);
    }

   /** Render html for a page, news and other website content
    * @param webmatic3 $w3        webmatic3 instance
	* @param String    $content   the content to render
	* @param bool      $flag_news if true the first occurrence of tag [more] will be parsed (used for the news)
	* @param String    $link_news the link to the news used for "read more" link
	* @return String
    */
   public static function getHtmlText($w3,$content,$flag_news,$link_news)
    {
     if($flag_news)
	  {
	   $more_pos = strpos($content,"[more]");
	   if($link_news && $more_pos !== false) return substr($content,0,$more_pos)." <a href=\"$link_news\">".$w3->getWord(951)."</a>";
	   else                                  return preg_replace("/\[more\]/","",$content,1); // Replace only the first occurrence
      }
	 else return $content;
    }

   /** Render plain text for a page, news and other website content
    * @param webmatic3 $w3        webmatic3 instance
	* @param String    $content   the content to render
	* @param bool      $flag_news if true the first occurrence of tag [more] will be parsed (used for the news)
	* @param String    $link_news the link to the news used for "read more" link
	* @return String
    */
   public static function getPlainText($w3,$content,$flag_news,$link_news)
    {
     if($flag_news)
	  {
	   $content = nl2br(htmlentities($content,ENT_COMPAT,'UTF-8'));
	   $more_pos = strpos($content,"[more]");
	   if($link_news && $more_pos !== false) return substr($content,0,$more_pos)." <a href=\"$link_news\">".$w3->getWord(951)."</a>";
	   else                                  return preg_replace("/\[more\]/","",$content,1); // Replace only the first occurrence
      }
	 else return nl2br(htmlentities($content,ENT_COMPAT,'UTF-8'));
    }

   /** Render bbcode text (replace bbcode tags with relative html code) for a page, news and other website content
    * @param webmatic3 $w3        webmatic3 instance
	* @param String    $content   the content to render
	* @param bool      $flag_news if true the first occurrence of tag [more] will be parsed (used for the news)
	* @param String    $link_news the link to the news used for "read more" link
	* @param bool      $flag_code if true its used to render correctly [code]...[/code] tag when html and bbcode are both used
	* @return String
    */
   public static function getBBCodeText($w3,$content,$flag_news,$link_news,$flag_code)
    {
     // Replace bbcode with relative html code
     if($flag_news)
	  {
	   $more_pos = strpos($content,"[more]");
	   if($link_news && $more_pos !== false) $str = " ".substr($content,0,$more_pos)." <a href=\"$link_news\">".$w3->getWord(951)."</a>";
	   else                                  $str = " ".preg_replace("/\[more\]/","",$content,1); // Replace only the first occurrence // TODO the first occurrence that not its located inside a [code]...[/code] bbtag
      }
	 else $str = " ".$content;

     // code
     $tl=strlen("[code]"); $tl=strlen("[code]"); $s_pos=strpos($str,"[code]"); $e_pos=strpos($str,"[/code]");
	 $_ARRAY = wm3Util::getBBCodeArray();
     while($s_pos<$e_pos)
      {
       $len=strlen($str);
       $p1=substr($str,0,$s_pos);
       $p2=substr($str,$e_pos+$tl+1,$len);
       $code=substr($str,$s_pos,$len-$s_pos-strlen($p2));
	   if($flag_code) $code = wm3Util::getPlainText($w3,$code,false,$link_news);	   
	   for($i = 0; $i < count($_ARRAY); $i++) $code = str_replace("[".$_ARRAY[$i]."]","&#91;".$_ARRAY[$i]."&#93;",$code);
       $code=str_replace("[code]",'',$code);
       $code=str_replace("[/code]",'',$code);

       ob_start();
	   $content = $code;
       require($w3->getSkinObj()->getCodeStart());
       $code_start = ob_get_contents();
       ob_end_clean();

       ob_start();
       require($w3->getSkinObj()->getCodeEnd());
       $code_end = ob_get_contents();
       ob_end_clean();

       $code = $code_start.$code_end;
       $str=$p1.$code.$p2;
       $s_pos=strpos($str,"[code]");
       $e_pos=strpos($str,"[/code]");
      }

     // img
     $tl=strlen("[img]"); $s_pos=strpos($str,"[img]"); $e_pos=strpos($str,"[/img]");
     while($s_pos<$e_pos)
      {
       $len=strlen($str);
       $p1=substr($str,0,$s_pos);
       $p2=substr($str,$e_pos+$tl+1,$len);
       $code=substr($str,$s_pos,$len-$s_pos-strlen($p2));
	   if( wm3Util::isImageUrlRelative(substr($code,$tl,strlen($code)-(2*$tl+1))) ||
	       wm3Util::isImageUrl        (substr($code,$tl,strlen($code)-(2*$tl+1))) )	   
        {
         $code=str_replace("[img]","<img src=\"",$code);
         $code=str_replace("[/img]","\">",$code);
        }
       else
        {
         $code=str_replace("[img]","[img ]",$code);
         $code=str_replace("[/img]","[/img ]",$code);
        }
       $str=$p1.$code.$p2;
       $s_pos=strpos($str,"[img]");
       $e_pos=strpos($str,"[/img]");
      }

     // url
     $tl=strlen("[url]"); $s_pos=strpos($str,"[url]"); $e_pos=strpos($str,"[/url]");
     while($s_pos<$e_pos)
      {
       $len=strlen($str);
       $p1=substr($str,0,$s_pos);
       $p2=substr($str,$e_pos+$tl+1,$len);
       $code=substr($str,$s_pos,$len-$s_pos-strlen($p2));
	   if( wm3Util::isUrlRelative(substr($code,$tl,strlen($code)-(2*$tl+1))) ||
	       wm3Util::isUrl        (substr($code,$tl,strlen($code)-(2*$tl+1))) )	   
        {
         $code=str_replace("[url]","<a href=\"".substr($code,$tl,strlen($code)-(2*$tl+1))."\" target=\"_blank\">",$code);
         $code=str_replace("[/url]","</a>",$code);
        }
       else
        {
         $code=str_replace("[url]","[url ]",$code);
         $code=str_replace("[/url]","[/url ]",$code);
        }
       $str=$p1.$code.$p2;
       $s_pos=strpos($str,"[url]");
       $e_pos=strpos($str,"[/url]");
      }

     // left
     $tl=strlen("[left]"); $s_pos=strpos($str,"[left]"); $e_pos=strpos($str,"[/left]");
     while($s_pos<$e_pos)
      {
       $len=strlen($str);
       $p1=substr($str,0,$s_pos);
       $p2=substr($str,$e_pos+$tl+1,$len);
       $code=substr($str,$s_pos,$len-$s_pos-strlen($p2));
       $code=str_replace("[left]","<div align=\"left\">",$code);
       $code=str_replace("[/left]","</div>",$code);
       $str=$p1.$code.$p2;
       $s_pos=strpos($str,"[left]");
       $e_pos=strpos($str,"[/left]");
      }

     // center
     $tl=strlen("[center]"); $s_pos=strpos($str,"[center]"); $e_pos=strpos($str,"[/center]");
     while($s_pos<$e_pos)
      {
       $len=strlen($str);
       $p1=substr($str,0,$s_pos);
       $p2=substr($str,$e_pos+$tl+1,$len);
       $code=substr($str,$s_pos,$len-$s_pos-strlen($p2));
       $code=str_replace("[center]","<div align=\"center\">",$code);
       $code=str_replace("[/center]","</div>",$code);
       $str=$p1.$code.$p2;
       $s_pos=strpos($str,"[center]");
       $e_pos=strpos($str,"[/center]");
      }

     // right
     $tl=strlen("[right]"); $s_pos=strpos($str,"[right]"); $e_pos=strpos($str,"[/right]");
     while($s_pos<$e_pos)
      {
       $len=strlen($str);
       $p1=substr($str,0,$s_pos);
       $p2=substr($str,$e_pos+$tl+1,$len);
       $code=substr($str,$s_pos,$len-$s_pos-strlen($p2));
       $code=str_replace("[right]","<div align=\"right\">",$code);
       $code=str_replace("[/right]","</div>",$code);
       $str=$p1.$code.$p2;
       $s_pos=strpos($str,"[right]");
       $e_pos=strpos($str,"[/right]");
      }

     // other tag
     $str=str_replace("[b]","<b>",$str);   $str=str_replace("[/b]","</b>",$str);
     $str=str_replace("[i]","<i>",$str);   $str=str_replace("[/i]","</i>",$str);
     $str=str_replace("[u]","<u>",$str);   $str=str_replace("[/u]","</u>",$str);
     $str=str_replace("[br]","<br>",$str); $str=str_replace("[sp]","&nbsp;",$str);
	 $str=str_replace("[hr]","<hr>",$str);
     $str=str_replace("[:)]",wm3Util::renderImg('s1.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[:o]",wm3Util::renderImg('s2.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[:p]",wm3Util::renderImg('s3.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[lD]",wm3Util::renderImg('s4.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[:(]",wm3Util::renderImg('s5.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[|)]",wm3Util::renderImg('s6.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[;)]",wm3Util::renderImg('s7.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[B)]",wm3Util::renderImg('s8.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[|(]",wm3Util::renderImg('s9.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[:/]",wm3Util::renderImg('s10.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[:|]",wm3Util::renderImg('s11.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[8|]",wm3Util::renderImg('s12.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[:s]",wm3Util::renderImg('s13.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=str_replace("[:D]",wm3Util::renderImg('s14.png','',16,16,WM3_cPATH_EMOTICONS),$str);
     $str=substr($str,1,strlen($str));
     return $str;
    }

   public static function quoteHTML($s,$only_quote = true)
    {//TODO è l'equivalante di htmlspecialchar($s,ENT_QUOTES)???
     // Parse $s before render it in a form field and replace:
     // '&' with '&amp;'
     // '"' with '&quot;'
     // '>' with '&gt;'
     // '<' with '&lt;'
  
     //(only_quote = false for textarea)
     //if($only_quote) return str_replace("\"","&quot;",$s);
     //else
  
      {
 	   $s = str_replace("&", "&amp;", $s);
  	   $s = str_replace("\"","&quot;",$s);
  	   $s = str_replace(">", "&gt;",  $s);
       $s = str_replace("<", "&lt;",  $s);
       return $s;
      }
    }

   /** Refresh browser content to $url after $time seconds (using meta refresh)
	* @param String $time time in seconds to wait
	* @param int    $url  the url to follow
	* @return String
    */
   public static function metaRefresh($time,$url)
    {
     return "<meta http-equiv=\"Refresh\" content=\"$time; url = $url\">";
    }

   public static function makeLink($url,$text,$target='')
    {
	 // Render a link
	 if($target) $target = "target=\"$target\"";
	 $link = "<a href=\"$url\" $target>$text</a>";
	 return $link;
	}

   public static function renderImg($file,$alt = '', $width = 16, $height = 16, $path = WM3_cPATH_DATA, $border = 0, $align = 'absmiddle', $name = '', $js = '')
    {
	 if($alt)   $alt   = "alt=\"$alt\" title=\"$alt\"";
	 if($name)  $name  = "name=\"$name\"";
	 if($align) $align = "align=\"$align\"";
	 if($width)  $width  = "width=\"$width\"";
	 if($height) $height = "height=\"$height\"";
	 return "<img src=\"".$path."$file\" $js $name $width $height border=\"$border\" $align $alt>";
	}

   public static function selectRenderMode($w3,$admin = true)
    {
     // Return an array of wm3GUIOption objects for render mode select
	 if($admin)
	  {
	   $_LABELS = array($w3->getWord(549),$w3->getWord(550),$w3->getWord(551),$w3->getWord(552));
	   $_VALUES = array(WM3_cRENDER_MODE_HTML,WM3_cRENDER_MODE_PLAIN_TEXT,WM3_cRENDER_MODE_BB_CODE,WM3_cRENDER_MODE_HTML_BB_CODE);
      }
	 else
	  {
	   $_LABELS = array($w3->getWord(550),$w3->getWord(551));
	   $_VALUES = array(WM3_cRENDER_MODE_PLAIN_TEXT,WM3_cRENDER_MODE_BB_CODE);
      }
     return wm3Util::selectArray($_LABELS,$_VALUES);
    }

   public static function selectVisibility($w3,$group = true)
    {
     // Return an array of wm3GUIOption objects for visibility select
     $array = array(new wm3GUIOption($w3->getWord(935), WM3_cVISIBILITY_ALL),
	                new wm3GUIOption($w3->getWord(936), WM3_cVISIBILITY_USERS));
     if($group) array_push($array,new wm3GUIOption($w3->getWord(1334),WM3_cVISIBILITY_GROUP));
     return $array;
    }

   public static function selectYesNo($w3)
    {
     // Return an array of wm3GUIOption objects for Yes/No select
     return wm3Util::selectArray(array($w3->getWord(458),$w3->getWord(459)),
                                 array(WM3_cYES,WM3_cNO));
    }

   public static function selectGender($w3)
    {
     // Return an array of wm3GUIOption objects for gender select
     return wm3Util::selectArray(array($w3->getWord(916),$w3->getWord(917)),
                                 array('M','F'));
    }

   public static function selectAlign($w3)
    {
     // Return an array of wm3GUIOption objects for Left/Center/Right select
     return wm3Util::selectArray(array($w3->getWord(462),$w3->getWord(463),$w3->getWord(464)),
                                 array(WM3_cALIGN_LEFT,WM3_cALIGN_CENTER,WM3_cALIGN_RIGHT));
    }

   public static function selectAlignImage($w3)
    {
     // Return an array of wm3GUIOption objects for Left/Right/No image select
     return wm3Util::selectArray(array($w3->getWord(462),$w3->getWord(464),$w3->getWord(592)),
                                 array(WM3_cALIGN_LEFT,WM3_cALIGN_RIGHT,WM3_cNO_IMAGE));
    }

   public static function selectArray($_L,$_V)
    {
     // Return an array of wm3GUIOption objects for a select with labels/values
     $array = array();
     for($i = 0; $i < sizeof($_V); $i++)
      array_push($array,new wm3GUIOption($_L[$i],$_V[$i]));
     return $array;
    }

   public static function selectArrayEquals($_V)
    {
     // Return an array of wm3GUIOption objects for a select with values/labels equals
     $array = array();
     foreach($_V as $value)
      array_push($array,new wm3GUIOption($value,$value));
     return $array;
    }

   public static function selectDirectory($path,$dir_only = false)
    {
     // Return an array of wm3GUIOption objects for directory $path files list
     $fd = opendir($path); $i = 0;
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != ".." && $file != "index.html") // Do not render ".", ".." and index.html
        {
		 if($dir_only)
		  {
		   if(is_dir($path.$file))
		    {
			 $_FILENAMES[$i] = $file;
             $i++;
	        }
		  }
		 else
		  {
		   if(!is_dir($path.$file))
		    {
			 $_FILENAMES[$i] = $file;
             $i++;
	        }
	      }
        }
      }
     closedir($fd);
     if(isset($_FILENAMES))
      {
       sort($_FILENAMES);
       return wm3Util::selectArrayEquals($_FILENAMES);
      }
    }

   public static function actionButton($link,$img,$alt,$accept = "",$text = "",$border = 0,$w = 24, $h = 24, $align = "absmiddle", $target = "_self", $path = WM3_cPATH_DATA)
    {
     // Create an action button
     if($text) $text = " ".$text; 
     if($accept) $str = "<a href=\"$link\" target=\"$target\" onclick=\"return wm3_accept('$accept');\">"; else $str = "<a href=\"$link\" target=\"$target\">";
	 $str .= wm3Util::renderImg($img,$alt,$w,$h,$path,$border,$align)."$text</a>";
     return $str;
    }

   public static function helpButton($file,$help,$alt = '', $width = 16, $height = 16, $path = WM3_cPATH_DATA, $border = 0, $align = 'absmiddle')
    {
	 if($alt) $alt = "alt=\"$alt\" title=\"$alt\"";
	 return "<img src=\"".$path."$file\" width=\"$width\" height=\"$height\" border=\"$border\" align=\"$align\" $alt onclick=\"return alert('$help');\">";
	}

   public static function makeStars($w3,$v,$n = 5)
    {
     // Draw $n stars bar with $v value
     $l = (int)$v;
     $h = $v - $l;
     $d = (int)($n - $v);
     $str = "";

     for($i = 0; $i < $d; $i++) $str .= $w3->getSkinObj()->getStar(0);
     if($h > 0    && $h <= 0.25) $str .= $w3->getSkinObj()->getStar(25);
     if($h > 0.25 && $h <= 0.5 ) $str .= $w3->getSkinObj()->getStar(50);
     if($h > 0.5               ) $str .= $w3->getSkinObj()->getStar(75);
     for($i = 0; $i < $l; $i++) $str .= $w3->getSkinObj()->getStar(100);
     return $str;
    }

   public static function makePercentageBar($w3,$v,$w,$h,$horizontal = true,$alt = '')
    {
     // Draw a percentage bar $w x $h and $v percentage
     if($alt) $alt = "alt=\"$alt\" title=\"$alt\"";
     if($horizontal)
      {
       $left_w  = round(($v*$w/100));
       $right_w = $w - $left_w;
       ob_start();
	   $width_left  = "width=\"$left_w\"";
	   $width_right = "width=\"$right_w\"";
	   $height      = "height=\"$h\"";
	   $title       = $alt;
	   require($w3->getSkinObj()->getHorizontalBar());
       $bar = ob_get_contents();
       ob_end_clean();
	   $str = $bar;
      }
     else
      {
       $bottom_h  = round(($v*$h/100));
       $top_h = $h - $bottom_h;
       ob_start();
	   $width         = "width=\"$w\"";
	   $height_top    = "height=\"$top_h\"";
	   $height_bottom = "height=\"$bottom_h\"";
	   $title         = $alt;
	   require($w3->getSkinObj()->getVerticalBar());
       $bar = ob_get_contents();
       ob_end_clean();
	   $str = $bar;
      }
     return $str;
    }

   public static function renderDate($w3,$ts,$languageID,$full = true,$msg = '',$time = true,$day = false)
    {
     if($msg) if($ts == 0) return $msg; // If $ts its 0 return msg if not empty
     if($full) $m = $w3->getWordMonth(date("n",$ts)); else $m = date("m",$ts);
	 if($time) $t = date(" (H:i:s)",$ts); else $t = "";
	 if($day)  $d = $w3->getWordDayOfTheWeek(date("N",$ts)).", "; else $d = "";
     if($languageID == WM3_cLANGUAGE_EN) return $d.$m.date(" d Y",$ts).$t;              // English language
     else                                return $d.date("d ",$ts).$m.date(" Y",$ts).$t; // Other language
    }

   public static function renderEditor($w3,$form_js_obj,$textarea_js_obj,$mode_js_obj,$editor_type = 0,$hide_tinymce_buttons = false)
    {
     // Render varius editors
     $editor = '';
     $skin = $w3->getSkinObj()->getCSS($w3); // Used in preview button and TinyMCE editor

     switch($editor_type)
      {
       case 1: // Admin editor
        {
         if(wm3Util::useTinyMCE()) require(WM3_cPATH_INCLUDE."editor_page_tiny_mce.inc");
         else                      require(WM3_cPATH_INCLUDE."editor_page.inc");
         break;
        }
       case 2: // Admin news editor
        {
         if(wm3Util::useTinyMCE()) require(WM3_cPATH_INCLUDE."editor_news_tiny_mce.inc");
         else                      require(WM3_cPATH_INCLUDE."editor_news.inc");
         break;
        }
       case 3: // Forum editor
        {
         require(WM3_cPATH_INCLUDE."editor_forum.inc");
         break;
        }
       case 4: // Chat editor
        {
         require(WM3_cPATH_INCLUDE."editor_chat.inc");
         break;
        }
       case 5: // Textarea resize editor
        {
         require(WM3_cPATH_INCLUDE."editor_resize.inc");
         break;
        }
       case 6: // Admin newsletter editor
        {
         if(wm3Util::useTinyMCE()) require(WM3_cPATH_INCLUDE."editor_newsletter_tiny_mce.inc");
         else                      require(WM3_cPATH_INCLUDE."editor_newsletter.inc");
         break;
        }
      }
     return $editor;
    }

   public static function useTinyMCE()
    {
	 if(WM3_cCONFIG_USE_TINY_MCE && file_exists(WM3_cPATH_JAVASCRIPT."tiny_mce/tiny_mce.js")) return true;
	 else return false;
	}

   public static function getFirstFile($path)
    {
     // Get the first file in a $path (do not return ".", ".." and index.html)
     $fd = opendir($path);
     while(($file = readdir($fd)))
      if($file != "." && $file != ".." && $file != "index.html") return $file;
    }

   public static function generatePassword()
    {
     // Generate a random alphanumeric password
	 $ts = time().rand(1,99999);
	 return substr(md5($ts), rand(0,24), 8);
    }

   public static function isInteger($num)
    {
     // Check for positive integer (0 inclusive)
     return @preg_match("/^[0-9]*$/", $num);
    }

   public static function isEmail($email)
    {
	 // Check for email format
     return @preg_match("/^[a-zA-Z0-9][_\.a-zA-Z0-9-]+@([a-zA-Z0-9][0-9a-zA-Z-]+\.)+([a-zA-Z]{2,4})$/", $email);
    }

   public static function isLogin($login)
    {
	 // Return true if $login is 3-16 characters long and have only numbers, letters and '_'
     return @preg_match("/^[[:alnum:]\.\_]{3,16}$/", $login);
	}

   public static function isAlphanumeric($str,$n = 0)
    {
	 // Return true if $str is minimum $n character long its alphanumeric and have ',', '_', ' ', ''', '-' and accented characters (TODO accented characters)
     return @preg_match("/^[a-zA-Z1-9,_ '-]{".$n.",}$/", $str);
	}
 
   public static function isUrl($url)
    {
	 // Return true if $url its an absolute url
     return @preg_match(WM3_cRE_URL, $url);
    } 
 
   public static function isUrlRelative($url)
    {
     // Return true if $url its a relative url/path
     return @preg_match(WM3_cRE_URL_RELATIVE, $url);
    }

   public static function isImageUrl($url)
    {
     // Return true if $url its an absolute url to an image file
     return @preg_match(WM3_cRE_IMAGE_URL, $url);
    }

   public static function isImageUrlRelative($url)
    {
     // Return true if $url its a relative url/path to an image file
     return @preg_match(WM3_cRE_IMAGE_URL_RELATIVE, $url);
    }

   public static function isDate($date,$year_from = 1,$year_to = 32767)
    {
     // Return true if $date (in YYYY-MM-DD format) its a valid date with year between $year_from to $year_to
     $year = substr($date,0,4);
     if($year >= $year_from && $year <= $year_to) return @checkdate(substr($date,5,2),substr($date,8,2),$year);
     else                                         return false;
    }

   public static function isFolderWritable($path)
    {
	 // Check if a folder its writable
     if(@touch($path."/wm3_temp.tmp")) // Use touch for compatibility with windows servers based
	  {
       @unlink($path."/wm3_temp.tmp");
	   return true;
      }
	 else return false;
	}

   public static function isApacheModuleLoaded($module)
    {
     if(function_exists('apache_get_modules'))
      return in_array('mod_'.$module,apache_get_modules());
	 else return true; // If apache is not loaded as module force to return true
    }

   public static function checkMinimumVersion($v1,$v2)
    {
	 // Check two version strings $v1, $v2 (x.y.z format) and return true if $v1 < $v2
     $tok  = strtok($v1,'.'); $i = 0;
     while($tok !== false) {
                            $_V1[$i] = intval($tok);
                            $tok = strtok('.');
                            $i++;
                           }
     $tok  = strtok($v2,'.'); $i = 0;
     while($tok !== false) {
                            $_V2[$i] = intval($tok);
                            $tok = strtok('.');
                            $i++;
                           }
     // Check the tokenized string
     $v1 = $v2 = '';
     for($i = 0; $i < count($_V1); $i++)
      {
       if(strlen($_V1[$i]) < strlen($_V2[$i]))
        {
		 $n = strlen($_V2[$i]) - strlen($_V1[$i]);
		 $z = ''; for($j = 0;$j < $n; $j++) $z .= '0';
	     $v1 .= $z.$_V1[$i];
	     $v2 .= $_V2[$i];         		 
		}
       if(strlen($_V2[$i]) < strlen($_V1[$i]))
        {
		 $n = strlen($_V1[$i]) - strlen($_V2[$i]);
		 $z = ''; for($j = 0;$j < $n; $j++) $z .= '0';
	     $v1 .= $_V1[$i];
	     $v2 .= $z.$_V2[$i];         		 
		}
	   if(strlen($_V2[$i]) == strlen($_V1[$i]))
	    {
	     $v1 .= $_V1[$i];
	     $v2 .= $_V2[$i];
	    }
      }
     return intval($v1) >= intval($v2);
	}

   public static function getFileExists($first_file,$second_file)
    {
     // Return first file if exists else return the second file
     if(file_exists($first_file)) return $first_file;
     else                         return $second_file;
	}

   public static function checkExtension($file,$ext)
    {
     // Verify if a file have $ext extension
     $e = wm3Util::cutExtension($file);
     foreach($ext as $v) if(strtoupper($v) == strtoupper($e)) return 1;
     return 0;
    }

   public static function cutExtension($file)
    {
     // Return the extension of a filename
     $len = strlen($file);
     if($len == 0) return "";
     for($i = $len - 1; $i >= 0; $i--)
      {
       if($file[$i] == ".") return substr($file,$i+1,strlen($file));
      }
     return "";
    }

   public static function parseSearchFilter()
    {
     // Parse the search filter to avoid illecit search and parse pg variable

     // By post
     if(isset($_POST['filter_check'])) $_POST['filter_check'] = intval($_POST['filter_check']);
     if(isset($_POST['filter']))
      {
       $_POST['filter'] = trim(str_replace(array('%','\''),'',$_POST['filter']));
       if(strlen($_POST['filter']) < 3) { $_POST['filter'] = ""; $_POST['filter_check'] = ""; }
      }

     // By get
     if(isset($_GET['filter_check'])) $_GET['filter_check'] = intval($_GET['filter_check']);
     if(isset($_GET['filter']))
      {
	   $_GET['filter'] = trim(str_replace(array('%','\''),'',$_GET['filter']));
       if(strlen($_GET['filter']) < 3) { $_GET['filter'] = ""; $_GET['filter_check'] = ""; }
      }
     
     // Parse also pg variables to by integer
     if(isset($_GET ['pg'])) $_GET['pg']  = abs(intval($_GET ['pg']));
     if(isset($_POST['pg'])) $_POST['pg'] = abs(intval($_POST['pg']));
    }

   public static function setIDToInt()
    {
     // Set all integer IDs to an effective integer value to avoid sql injection.
     // The name of all integer ID variables must end with "ID".
     reset($_POST);
     for($i = 0; $i < sizeof($_POST); $i++)
      {
   	   $nvar = key($_POST);
       if(strpos($nvar,"ID")) $_POST[$nvar] = intval($_POST[$nvar]);
       next($_POST);
      }
     reset($_GET);
     for($i = 0; $i < sizeof($_GET); $i++)
      {
       $nvar = key($_GET);
       if(strpos($nvar,"ID")) $_GET[$nvar] = intval($_GET[$nvar]);
       next($_GET);
      }
	 reset($_COOKIE);
     for($i = 0; $i < sizeof($_COOKIE); $i++)
      {
   	   $nvar = key($_COOKIE);

       if(strpos($nvar,"ID")) $_COOKIE[$nvar] = intval($_COOKIE[$nvar]);
	   //if(strpos($nvar,"ID")) if($nvar != "PHPSESSID") $_COOKIE[$nvar] = intval($_COOKIE[$nvar]);
	   // DO not parse "PHPSESSID" cookie (FARLO O Usare quello sopra)

       next($_COOKIE);
      }
    }
 
   public static function stripMagicQuotes()
    {
     // Dequote all the variables (override magic_quotes_gpc option, works like magic_quotes_gpc as set to Off)
     if(get_magic_quotes_gpc())
      {
	   reset($_POST);
	   reset($_GET);
	   reset($_COOKIE);
       $_POST   = array_map('stripslashes_deep',$_POST);
       $_GET    = array_map('stripslashes_deep',$_GET);
       $_COOKIE = array_map('stripslashes_deep',$_COOKIE);
       for($i = 0; $i < sizeof($_POST); $i++)
        {
         $nvar = key($_POST);
         global $$nvar;
         $$nvar = stripslashes($$nvar);
         next($_POST);
        }
       for($i = 0; $i < sizeof($_GET); $i++)
        {
         $nvar = key($_GET);
         global $$nvar;
         $$nvar = stripslashes($$nvar);
         next($_GET);
        }
       for($i = 0; $i < sizeof($_COOKIE); $i++)
        {
         $nvar = key($_COOKIE);
         global $$nvar;
         $$nvar = stripslashes($$nvar);
         next($_COOKIE);
        }
      }
    }

   public static function microtimeFloat()
    {
     // Return microtime converted to float
     list($usec,$sec) = explode(" ", microtime());
     return ((float)$usec + (float)$sec);
    }

   public static function delayTime()
    {
     // Return page generator time in seconds 	
     $end_time = wm3Util::microtimeFloat();
     return round(($end_time - WM3_cSTART_TIME),5);
    }

   public static function quoteDB($str)
    {
     // Quote / and ' before send data into the database
     //if(!anyUserLogged(1)) $str = htmlspecialchars($str,ENT_NOQUOTES); // If not admin logged, remove all html tags
     $str = str_replace("\\" ,"\\\\", $str);
     $str = str_replace("'",  "\'",   $str);
     return $str;
    }

   public static function unquoteDB($str)
    {
     //TODO è inutile???
     // Remove quote from / and ' after take data from database
     $str = str_replace("\'",  "'",   $str);
     $str = str_replace("\\\\","\\" , $str); 
     return $str;
    }

   public static function getPhpInformations($fl = INFO_ALL)
    {
     ob_start();
     phpinfo($fl);
     $php_info = ob_get_contents();
	 $php_info = str_replace( "module_Zend Optimizer","module_Zend_Optimizer",preg_replace( '%^.*<body>(.*)</body>.*$%ms','$1',$php_info));
	 ob_end_clean();
     $php_info .="<style type=\"text/css\">
                   .center { text-align: left; }
                   .p      { text-align: left;}
                   .e      { background-color: #ccccff; font-weight: bold; color: #000000; }
                   .h      { background-color: #9999cc; font-weight: bold; color: #000000; }
                   .v      { background-color: #cccccc; color: #000000;}
                   .vr     { background-color: #cccccc; text-align: right; color: #000000; }
                  </style>";
	 return $php_info;
    }

   public static function dieMessage($label,$msg)
    {
     $str = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\" \"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">
             <html xmlns=\"http://www.w3.org/1999/xhtml\">
              <head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /></head>
              <body>
	           <table width=\"80%\" border=\"1\" align=\"center\"><tr><td bgcolor=\"#ff2222\"><b>$label:</b></td></tr>
                <tr><td bgcolor=\"#ffffff\">$msg</td></tr>
               </table>
			  </body>
			 </html>";
     die($str);
    }

  }

?>
