<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3Setup
  {

   function __construct() { }

   public static function configNeeded($w3,$setup_on = 1)
    {
     if(!$setup_on) return 0; // Setup disabled

	 if(wm3Setup::checkSystemConfig() &&
	    wm3Setup::configFileExist()   &&
		wm3DB::existsDatabase()       &&
		!wm3Setup::needUpdate()       &&
        wm3User::existSuperUser())    return 0; // No setup needed

	 $action = webmatic3::getVariable('action');
	 if($action == WM3_cACTION_SETUP_CHANGE_LANGUAGE) wm3Setup::changeSetupLanguage($w3);
	 if(!wm3Setup::checkSystemConfig() || !$action) return WM3_cSECTION_NEED_CONFIG_SYSTEM;
     if(!wm3Setup::configFileExist())   return WM3_cSECTION_NEED_CONFIG_FILE;
     if(!wm3DB::existsDatabase())       return WM3_cSECTION_NEED_DATABASE;
     if(wm3Setup::needUpdate())         return WM3_cSECTION_NEED_UPDATE;
     if(!wm3User::existSuperUser())     return WM3_cSECTION_NEED_USER;
     return 0;
    }

   public static function getSystemConfigError($array = false)
    {
	 if($array) $_ARRAY = array('php_version'         => 0,
	                            'root_folder_write'   => 0,
								'temp_folder_write'   => 0,
								'mysql'               => 0,
								'imap'                => 0,
								'gd'                  => 0,
								'upload_foders_write' => 0);
	 // Errors
	 $error = 0;
	 if(!(intval(phpversion()) >= 5))                  { $error = 1; if($array) $_ARRAY['php_version']       = 1; }
	 if(!wm3Util::isFolderWritable('.'))               { $error = 2; if($array) $_ARRAY['root_folder_write'] = 1; }
	 if(!wm3Util::isFolderWritable(WM3_cPATH_TEMP))    { $error = 3; if($array) $_ARRAY['temp_folder_write'] = 1; }
	 if(!extension_loaded('mysql'))                    { $error = 4; if($array) $_ARRAY['mysql']             = 1; }

	 // Warnings
	 if($array)
	  {
	   if(!extension_loaded('imap')) $_ARRAY['imap'] = 1;
	   if(!extension_loaded('gd'))   $_ARRAY['gd']   = 1;
	   if(!wm3Util::isFolderWritable(WM3_cPATH_IMAGES)      ||
	      !wm3Util::isFolderWritable(WM3_cPATH_ECOMMERCE)   ||
		  !wm3Util::isFolderWritable(WM3_cPATH_MEDIA_ALBUM) ||
		  !wm3Util::isFolderWritable(WM3_cPATH_DOWNLOADS)) $_ARRAY['upload_foders_write'] = 1;
	  }
	 if($array) return $_ARRAY; else return $error;
	}

   public static function checkSystemConfig()
    {
     if(wm3Setup::getSystemConfigError()) return 0;
     return 1;
    }

   public static function configFileExist()
    {
     if(file_exists('wm3_config.php')) require_once('wm3_config.php'); else return 0;
     if(!defined('WM3_cCONFIG_DB_SERVER'))     return 0;
     if(!defined('WM3_cCONFIG_DB_USER'))       return 0;
     if(!defined('WM3_cCONFIG_DB_PASSWORD'))   return 0;
     if(!defined('WM3_cCONFIG_DB_NAME'))       return 0;
     if(!defined('WM3_cCONFIG_DB_PREFIX'))     return 0;
     if(!wm3DB::checkConnection(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME)) return 0;
	 if(!wm3DB::checkDatabaseServerVersion(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD)) return 0;
     return 1;
    }

   public static function needUpdate()
    {
	 $db = new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX);
     if($db->getDBVersion() < WM3_cDB_VERSION ) { $db->close(); return true;  }
     else                                       { $db->close(); return false; }
    }

   public static function executeSetup($w3,$setup_ip)
    {
	 if($setup_ip != '*')
	  if(getenv('REMOTE_ADDR') != $setup_ip)
	   wm3Util::dieMessage("Setup error","You can not do the setup from your ip: <b>".getenv('REMOTE_ADDR')."</b>"); // Let the setup only from a user defined ip ($setup_ip)

     $title      = ":: Webmatic ".WM3_cVERSION." ".$w3->getWord(1728)." ::";
     $skin       = "default";
     $setup_css  = WM3_cPATH_SKINS."$skin/$skin.css";
	 $setup_home = " : <a href=\"index.php\">Home</a>";
     switch(wm3Setup::configNeeded($w3))
      {
       case WM3_cSECTION_NEED_CONFIG_SYSTEM:
        {
         $subtitle = $w3->getWord(1711).$setup_home;
         $icon     = wm3Util::renderImg("big_icon_preferences.png",'',48,48);
         $label    = $w3->getWord(1728);
         $content  = wm3Setup::configSystemForm($w3,$skin); // System configuration form
         break;
        }
       case WM3_cSECTION_NEED_CONFIG_FILE:
        {
         $subtitle = $w3->getWord(1729).$setup_home;
         $icon     = wm3Util::renderImg("big_icon_preferences.png",'',48,48);
         $label    = $w3->getWord(1728);
         $content  = wm3Setup::configFileForm($w3,$skin); // Config file form
         break;
        }
       case WM3_cSECTION_NEED_DATABASE:
        {
         if(!wm3Setup::lockSetup()) wm3Util::dieMessage("Setup error","Database Locked, can not do the setup, to continue please remove the file \"lock_setup\" from Webmatic root folder");
         wm3Setup::resetDatabase(); // Create the database
         wm3Setup::unlockSetup();
         header("Location: index.php?action=".WM3_cACTION_SETUP_NEXT);
         break;
        }
       case WM3_cSECTION_NEED_UPDATE:
        {
		 $db = new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX);
		 if($db->getDBVersion() >= 2.8)
		  {
           if(!wm3Setup::lockSetup()) wm3Util::dieMessage("Setup error","Database Locked, can not do the setup, to continue please remove the file \"lock_setup\" from Webmatic root folder");
		   if($db->getDBVersion() == 2.8) wm3Setup::updateDatabase28to30(); // Update the database from 2.8 to 3.0
		   if($db->getDBVersion() == 3.0) wm3Setup::updateDatabase30to31(); // Update the database from 3.0 to 3.1
           wm3Setup::unlockSetup();
	      }
		 else
		  {
		   wm3Util::dieMessage("Setup error","Minimum Webmatic version 2.8, can not update"); // Setup not complete, can not continue
		   $db->close();
		   break;
		  }
		 $db->close();
         header("Location: index.php?action=".WM3_cACTION_SETUP_NEXT);
         break;
        }
       case WM3_cSECTION_NEED_USER:
        {
         $subtitle = $w3->getWord(1744).$setup_home;
         $icon     = wm3Util::renderImg("big_icon_users.png",'',48,48);
         $label    = $w3->getWord(1728);
         $content  = wm3Setup::configUserForm($w3,$skin); // Superuser form
         break;
        }
       default: header("Location: index.php");
      }

     require(WM3_cPATH_SKINS."$skin/setup/setup_head.inc");
     require(WM3_cPATH_SKINS."$skin/setup/setup_page.inc");
     require(WM3_cPATH_SKINS."$skin/setup/setup_foot.inc");
    }

   public static function changeSetupLanguage($w3)
    {
     // Switch to another setup language and set cookie
     wm3Language::writeCookieAdminLanguageID($w3,$_GET['languageID'],true);
     $w3->setAdminLanguage($_GET['languageID']);
	 $action = $w3->getVariable('stepID','get');
	 if($action == WM3_cACTION_SETUP_CHANGE_LANGUAGE) $action = 0;
	 header("Location: index.php?action=$action");
	 die();
    }

   public static function renderSetupLanguageMenu($w3,$skin)
    {
     // Create setup language menu

     // Menu start
     require(WM3_cPATH_SKINS."$skin/menu/admin_menu_start.inc");

     $_DATA  = array('en','it','fr','de','es','nl','el');
     $_LABEL = array('English','Italiano','Français','Deutsch','Español','Nederlands','Ελληνικά');
	 // Menu items
	 $menu_item = "<nobr>".$w3->getWord(1710)." ";
     for($i = 0; $i < count($_DATA); $i++)
      {
       // Menu items
	   $stepID = $w3->getVariable('action');
       $menu_item .= wm3Util::actionButton(WM3_cCONFIG_HOME_FILE."?stage=".WM3_cSTAGE_HOME."&action=".WM3_cACTION_SETUP_CHANGE_LANGUAGE."&stepID=$stepID&languageID=".($i+1),"flag_".$_DATA[$i].".png",$_LABEL[$i],"","",0,19,13)." ";
      }
	 $menu_item .= "</nobr>";
     require(WM3_cPATH_SKINS."$skin/menu/admin_menu_current.inc");

     // Menu end
	 require(WM3_cPATH_SKINS."$skin/menu/admin_menu_end.inc");
    }

   public static function configSystemForm($w3,$skin)
    {
     // System config form
	 $error  = wm3Setup::getSystemConfigError();
	 $_ERROR = wm3Setup::getSystemConfigError(true);
     $_ARRAY = array('php_version','mysql','root_folder_write','temp_folder_write','imap','gd','upload_foders_write');
     $_STYLE = wm3Skin::getFormStyleArray($_ARRAY);

     $_STYLE['php_version']         = "class=\"formEven\"";
     $_STYLE['mysql']               = "class=\"formOdd\"";
     $_STYLE['root_folder_write']   = "class=\"formEven\"";
     $_STYLE['temp_folder_write']   = "class=\"formOdd\"";
     $_STYLE['imap']                = "class=\"formEven\"";
     $_STYLE['gd']                  = "class=\"formOdd\"";
     $_STYLE['upload_foders_write'] = "class=\"formEven\"";	 
     $_STYLE['formTitle']           = "class=\"formTitle\"";
     $form_title = $w3->getWord(1727);
	 foreach($_ERROR as $key => $value)
	  {
	   if($_ERROR[$key]) {
		                  if($key == 'imap' || $key == 'gd' || $key == 'upload_foders_write')
						   {
							$_STYLE[$key] = "class=\"formWarning\"";
						    $_IMAGE[$key] = 'misc_warning.png';
						   }
						  else
						   {
							$_STYLE[$key] = "class=\"formError\"";
                            $_IMAGE[$key] = 'action_enable.png';
						   }
						  $_STYLE['formTitle'] = "class=\"formTitleError\"";
  				          $form_title = $w3->getWord(1709);
                          $next_action_label = $w3->getWord(1703);
                          $next_action       = 0;
	                     }
	   else              {
                          $_IMAGE[$key] = 'action_disable.png';
					     }
  	   if($_ERROR['php_version'])         $_FIELD['php_version']         = $w3->getWord(1705)." ".phpversion()." ".$w3->getWord(1722);
	   else                               $_FIELD['php_version']         = $w3->getWord(1705)." ".phpversion()." ".$w3->getWord(1723);
  	   if($_ERROR['mysql'])               $_FIELD['mysql']               = $w3->getWord(1707);
	   else                               $_FIELD['mysql']               = $w3->getWord(1708);
  	   if($_ERROR['root_folder_write'])   $_FIELD['root_folder_write']   = $w3->getWord(1713);
	   else                               $_FIELD['root_folder_write']   = $w3->getWord(1714);
  	   if($_ERROR['temp_folder_write'])   $_FIELD['temp_folder_write']   = $w3->getWord(1716)." (".WM3_cPATH_TEMP.")".$w3->getWord(1717);
	   else                               $_FIELD['temp_folder_write']   = $w3->getWord(1716)." (".WM3_cPATH_TEMP.")".$w3->getWord(1718);
  	   if($_ERROR['imap'])                $_FIELD['imap']                = $w3->getWord(1720);
	   else                               $_FIELD['imap']                = $w3->getWord(1721);
  	   if($_ERROR['gd'])                  $_FIELD['gd']                  = $w3->getWord(1755);
	   else                               $_FIELD['gd']                  = $w3->getWord(1756);
  	   if($_ERROR['upload_foders_write']) $_FIELD['upload_foders_write'] = $w3->getWord(1724)." (".WM3_cPATH_IMAGES.", ".WM3_cPATH_ECOMMERCE.", ".WM3_cPATH_MEDIA_ALBUM.", ".WM3_cPATH_DOWNLOADS.")".$w3->getWord(1725);
	   else                               $_FIELD['upload_foders_write'] = $w3->getWord(1724)." (".WM3_cPATH_IMAGES.", ".WM3_cPATH_ECOMMERCE.", ".WM3_cPATH_MEDIA_ALBUM.", ".WM3_cPATH_DOWNLOADS.")".$w3->getWord(1726);
      }
     if($error) {
                 require(WM3_cPATH_SKINS."$skin/setup/setup_config_system_form.inc");
			    }
     else       {
                 $next_action_label = $w3->getWord(1703);
                 $next_action       = WM3_cACTION_SETUP_NEXT;
                 require(WM3_cPATH_SKINS."$skin/setup/setup_config_system_form.inc");
                }
     return $content;
    }

   public static function configFileForm($w3,$skin)
    {
     // Config file form
     $error = 0;
     $_ARRAY = array('db_server','db_user','db_password','db_name','db_prefix','languageID');
     $_STYLE = wm3Skin::getFormStyleArray($_ARRAY);
     $_FIELD = webmatic3::getPostValueArray($_ARRAY);
     $_STYLE['db_server']   = "class=\"formEven\"";
     $_STYLE['db_user']     = "class=\"formOdd\"";
     $_STYLE['db_password'] = "class=\"formEven\"";
     $_STYLE['db_name']     = "class=\"formOdd\"";
     $_STYLE['db_prefix']   = "class=\"formEven\"";
     $_STYLE['languageID']  = "class=\"formOdd\"";	 
     $_STYLE['formTitle']   = "class=\"formTitle\"";
     $form_title = $w3->getWord(1729);

     switch($w3->getVariable('action','post'))
      {
       case WM3_cACTION_SETUP_SAVEDB:
      	{
		 if(!wm3DB::checkDatabaseServerVersion($_FIELD['db_server'],$_FIELD['db_user'],$_FIELD['db_password']))         $error = 2;
         if(!wm3DB::checkConnection($_FIELD['db_server'],$_FIELD['db_user'],$_FIELD['db_password'],$_FIELD['db_name'])) $error = 1;
         switch($error)
          {
           case 1:
            {
             $_STYLE['db_server']   = "class=\"formError\"";
             $_STYLE['db_user']     = "class=\"formError\"";
             $_STYLE['db_password'] = "class=\"formError\"";
             $_STYLE['db_name']     = "class=\"formError\"";
             $_STYLE['formTitle']   = "class=\"formTitleError\"";
             $form_title = $w3->getWord(1730);
             $next_action_label = $w3->getWord(1703);
             $next_action       = WM3_cACTION_SETUP_SAVEDB;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_database_form.inc");
             break;
            }
           case 2:
            {
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
             $form_title = $w3->getWord(557)." ".wm3DB::serverInformations($_FIELD['db_server'],$_FIELD['db_user'],$_FIELD['db_password'],$_FIELD['db_name']).". ".$w3->getWord(555)." ".$w3->getWord(558);
             $next_action_label = $w3->getWord(1703);
             $next_action       = WM3_cACTION_SETUP_SAVEDB;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_database_form.inc");
             break;
            }
           default:
            {
             wm3Setup::writeConfig($_FIELD['db_server'],$_FIELD['db_user'],$_FIELD['db_password'],$_FIELD['db_name'],$_FIELD['db_prefix'],$_FIELD['languageID']);
             header("Location: index.php?action=".WM3_cACTION_SETUP_NEXT);
            }
          }
         break;
      	}
       default:
        {          	
         $next_action_label = $w3->getWord(1703);
         $next_action       = WM3_cACTION_SETUP_SAVEDB;
         require(WM3_cPATH_SKINS."$skin/setup/setup_config_database_form.inc");
        }
      }
     return $content;
    }

   public static function configUserForm($w3,$skin)
    {
     // Superuser config form
     $error = 0;
     $_ARRAY = array('name','surname','login','password','ck_password','email');
     $_STYLE = wm3Skin::getFormStyleArray($_ARRAY);
     $_FIELD = webmatic3::getPostValueArray($_ARRAY);
     $_STYLE['name']        = "class=\"formEven\"";
     $_STYLE['surname']     = "class=\"formOdd\"";
     $_STYLE['login']       = "class=\"formEven\"";
     $_STYLE['password']    = "class=\"formOdd\"";
     $_STYLE['ck_password'] = "class=\"formEven\"";
     $_STYLE['email']       = "class=\"formOdd\"";	 
     $_STYLE['formTitle']   = "class=\"formTitle\"";
     $form_title = $w3->getWord(1744);

     switch($w3->getVariable('action','post'))
      {
       case WM3_cACTION_SETUP_SAVEUSER:
      	{
		 $w3->setDBObj(new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX));
	     if(wm3User::emailExists($w3,$_FIELD['email'],0)) $error = 5;
         if(!wm3Util::isEmail($_FIELD['email']))          $error = 4;
         if(!$_FIELD['password'] || !$_FIELD['ck_password'] || $_FIELD['password'] != $_FIELD['ck_password']) $error = 3;
		 if(wm3User::loginExists($w3,$_FIELD['login']))   $error = 2;
         if(!wm3Util::isLogin($_FIELD['login']))          $error = 1;
         if(!$_FIELD['surname'])                          $error = 6;
         if(!$_FIELD['name'])                             $error = 7;
         if($error != 0) $w3->getDBObj()->close();
         switch($error)
          {
           case 1:
            {
             $_STYLE['login']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
             $form_title = "Login must be not empty...";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 2:
            {
             $_STYLE['login']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(-1)."Login already exists \"".$_FIELD['login']."\"".$w3->getWord(444);
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 3:
            {
             $_STYLE['password']    = "class=\"formError\"";
             $_STYLE['ck_password'] = "class=\"formError\"";
             $_STYLE['formTitle']   = "class=\"formTitleError\"";
             $form_title = "Password empty or do not mach";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 4:
            {
             $_STYLE['email']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
             $form_title = $w3->getWord(1151);
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 5:
            {
             $_STYLE['email']     = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(376)." Already exists \"".wm3Util::renderContent($w3,$_FIELD['email'],WM3_cRENDER_MODE_PLAIN_TEXT)."\"".$w3->getWord(444);
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 6:
            {
             $_STYLE['surname']   = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(-1)."Empty surname";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           case 7:
            {
             $_STYLE['name']      = "class=\"formError\"";
             $_STYLE['formTitle'] = "class=\"formTitleError\"";
			 $form_title = $w3->getWord(-1)."Empty name";
             $next_action_label = $w3->getWord(29);
             $next_action       = WM3_cACTION_SETUP_SAVEUSER;
             require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
             break;
            }
           default:
            {
             wm3User::writeSuperUser($w3);
             $w3->getDBObj()->close();
             header("Location: index.php");
            }
          }
         break;
      	}
       default:
        {          	
         $next_action_label = $w3->getWord(29);
         $next_action       = WM3_cACTION_SETUP_SAVEUSER;
         require(WM3_cPATH_SKINS."$skin/setup/setup_config_superuser_form.inc");
        }
      }
     return $content;
    }

   public static function writeConfig($server,$user,$password,$name,$prefix,$languageID)
    {
     $str = "<?php

              // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
              // www.valarsoft.com

              defined('WM3_cEXEC') or die('Denied');

              // Database settings
              define('WM3_cCONFIG_DB_SERVER',   '$server');
              define('WM3_cCONFIG_DB_USER',     '$user');
              define('WM3_cCONFIG_DB_PASSWORD', '$password');
              define('WM3_cCONFIG_DB_NAME',     '$name');
              define('WM3_cCONFIG_DB_PREFIX',   '$prefix');

              // WEBMATIC3 settings
              define('WM3_cCONFIG_STARTING_LANGUAGE', '$languageID'); // 1=English, 2=Italiano, 3=Français, 4=Deutsch, 5=Español, 6=Nederlands, 7=Ελληνικά

             ?>";
     // Open file and save configuration
     $fd = fopen("wm3_config.php",'w');
     fwrite($fd,$str);
     fclose($fd);
    }

   public static function lockSetup()
    {
     // Create setup lock file used to avoid error in database creation/update
	 $fd = @fopen("lock_setup",'r'); if($fd) { fclose($fd); return false; }// Setup not locked (access to setup denied)
     $fd = @fopen("lock_setup",'w'); if($fd) { fclose($fd); return true;  }// Setup locked (access to setup granted)
     return false; // Setup not locked (access to setup denied)
	}

   public static function unlockSetup()
    {
     // Delete setup lock file
	 @unlink("lock_setup");
	}

   public static function resetDatabase()
    {
	 // Reset/Setup query
	 $setup_ts = time();
     $db = new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX);

     $_DB_RESET = array(

      new wm3DBAlterDatabase(WM3_cCONFIG_DB_NAME,'CHARACTER SET '.$db->getCharset()),

      new wm3DBCreateTable('_banners',
      array(
            new wm3DBField('bannerID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('title'      ,WM3_cDB_CHAR),
            new wm3DBField('banner'     ,WM3_cDB_TEXT),
            new wm3DBField('banner_type',WM3_cDB_INT,5),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_banners_exchange',
      array(
            new wm3DBField('bannerID'     ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('userID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'        ,WM3_cDB_CHAR),
            new wm3DBField('banner_alt'   ,WM3_cDB_CHAR),
            new wm3DBField('banner_url'   ,WM3_cDB_CHAR),
            new wm3DBField('banner_image' ,WM3_cDB_CHAR),
            new wm3DBField('impressions'  ,WM3_cDB_BIGINT,20,0,true),
            new wm3DBField('clicks'       ,WM3_cDB_BIGINT,20,0,true),
            new wm3DBField('banner_source',WM3_cDB_INT,5),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_banners_exchange_credits',
      array(
            new wm3DBField('banner_exchange_creditID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('userID'                  ,WM3_cDB_BIGINT,20),
            new wm3DBField('credits'                 ,WM3_cDB_BIGINT,20,0,true),
            new wm3DBField('unlimited_credits'       ,WM3_cDB_INT,1),
            new wm3DBField('ts'                      ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_channels_blocks',
      array(
            new wm3DBField('blockID'      ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('subcategoryID',WM3_cDB_BIGINT,20),
            new wm3DBField('linkID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'        ,WM3_cDB_CHAR),
            new wm3DBField('block_type'   ,WM3_cDB_INT,5),
            new wm3DBField('picture'      ,WM3_cDB_CHAR),
            new wm3DBField('picture_align',WM3_cDB_INT,5),
            new wm3DBField('alt'          ,WM3_cDB_CHAR),
            new wm3DBField('description'  ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'  ,WM3_cDB_INT,5),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_channels_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_channels_subcategories',
      array(
            new wm3DBField('subcategoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('name'         ,WM3_cDB_CHAR),
            new wm3DBField('icon'         ,WM3_cDB_CHAR),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_chatrooms',
      array(
            new wm3DBField('chatroomID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('topic'     ,WM3_cDB_TEXT),
            new wm3DBField('visibility',WM3_cDB_INT,5),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_chatrooms_sentences',
      array(
            new wm3DBField('sentenceID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('chatroomID',WM3_cDB_BIGINT,20),
            new wm3DBField('userID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('nickname'  ,WM3_cDB_CHAR),
            new wm3DBField('sentence'  ,WM3_cDB_TEXT),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16,WM3_cDB_KEY)
           )),

      new wm3DBCreateTable('_counters',
      array(
            new wm3DBField('total_visitors'    ,WM3_cDB_BIGINT,20,0,true),
            new wm3DBField('total_signalations',WM3_cDB_BIGINT,20,0,true),
            new wm3DBField('max_visitors'      ,WM3_cDB_INT,16),
            new wm3DBField('max_users'         ,WM3_cDB_INT,16),
            new wm3DBField('last_user_ip'      ,WM3_cDB_CHAR),
            new wm3DBField('last_user_dns'     ,WM3_cDB_CHAR),
            new wm3DBField('last_userID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('last_user_ts'      ,WM3_cDB_INT,16),
            new wm3DBField('installation_ts'   ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_counters',null,array(0,0,0,0,'','',0,0,$setup_ts)),

      new wm3DBCreateTable('_countries',
      array(
            new wm3DBField('countryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('code'     ,WM3_cDB_CHAR,8,WM3_cDB_UNIQUE),
            new wm3DBField('name'     ,WM3_cDB_CHAR),
            new wm3DBField('hits'     ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_countries',
      array('code','name','hits'),
      array(
       array('ad','Andorra',                                     0),
       array('ae','United arab emirates',                        0),
       array('af','Afghanistan',                                 0),
       array('ag','Antigua and barbuda',                         0),
       array('ai','Anguilla',                                    0),
       array('al','Albania',                                     0),
       array('am','Armenia',                                     0),
       array('an','Netherlands antilles',                        0),
       array('ao','Angola',                                      0),
       array('aq','Antarctica',                                  0),
       array('ar','Argentina',                                   0),
       array('as','American samoa',                              0),
       array('at','Austria',                                     0),
       array('au','Australia',                                   0),
       array('aw','Aruba',                                       0),
       array('az','Azerbaijan',                                  0),
       array('ba','Bosnia and herzegovina',                      0),
       array('bb','Barbados',                                    0),
       array('bd','Bangladesh',                                  0),
       array('be','Belgium',                                     0),
       array('bf','Burkina faso',                                0),
       array('bg','Bulgaria',                                    0),
       array('bh','Bahrain',                                     0),
       array('bi','Burundi',                                     0),
       array('bj','Benin',                                       0),
       array('bm','Bermuda',                                     0),
       array('bn','Brunei darussalam',                           0),
       array('bo','Bolivia',                                     0),
       array('br','Brazil',                                      0),
       array('bs','Bahamas',                                     0),
       array('bt','Bhutan',                                      0),
       array('bv','Bouvet island',                               0),
       array('bw','Botswana',                                    0),
       array('by','Belarus',                                     0),
       array('bz','Belize',                                      0),
       array('ca','Canada',                                      0),
       array('cc','Cocos (keeling) islands',                     0),
       array('cd','Congo, the democratic republic of the',       0),
       array('cf','Central african republic',                    0),
       array('cg','Congo',                                       0),
       array('ch','Switzerland',                                 0),
       array('ci','Cote d\'ivoire',                              0),
       array('ck','Cook islands',                                0),
       array('cl','Chile',                                       0),
       array('cm','Cameroon',                                    0),
       array('cn','China',                                       0),
       array('co','Colombia',                                    0),
       array('cr','Costa rica',                                  0),
       array('cu','Cuba',                                        0),
       array('cv','Cape verde',                                  0),
       array('cx','Christmas island',                            0),
       array('cy','Cyprus',                                      0),
       array('cz','Czech republic',                              0),
       array('de','Germany',                                     0),
       array('dj','Djibouti',                                    0),
       array('dk','Denmark',                                     0),
       array('dm','Dominica',                                    0),
       array('do','Dominican republic',                          0),
       array('dz','Algeria',                                     0),
       array('ec','Ecuador',                                     0),
       array('ee','Estonia',                                     0),
       array('eg','Egypt',                                       0),
       array('eh','Western sahara',                              0),
       array('er','Eritrea',                                     0),
       array('es','Spain',                                       0),
       array('et','Ethiopia',                                    0),
       array('fi','Finland',                                     0),
       array('fj','Fiji',                                        0),
       array('fk','Falkland islands (malvinas)',                 0),
       array('fm','Micronesia, federated states of',             0),
       array('fo','Faroe islands',                               0),
       array('fr','France',                                      0),
       array('ga','Gabon',                                       0),
       array('gb','United kingdom',                              0),
       array('gd','Grenada',                                     0),
       array('ge','Georgia',                                     0),
       array('gf','French guiana',                               0),
       array('gh','Ghana',                                       0),
       array('gi','Gibraltar',                                   0),
       array('gl','Greenland',                                   0),
       array('gm','Gambia',                                      0),
       array('gn','Guinea',                                      0),
       array('gp','Guadeloupe',                                  0),
       array('gq','Equatorial guinea',                           0),
       array('gr','Greece',                                      0),
       array('gs','South georgia and the south sandwich islands',0),
       array('gt','Guatemala',                                   0),
       array('gu','Guam',                                        0),
       array('gw','Guinea-bissau',                               0),
       array('gy','Guyana',                                      0),
       array('hk','Hong kong',                                   0),
       array('hm','Heard island and mcdonald islands',           0),
       array('hn','Honduras',                                    0),
       array('hr','Croatia',                                     0),
       array('ht','Haiti',                                       0),
       array('hu','Hungary',                                     0),
       array('id','Indonesia',                                   0),
       array('ie','Ireland',                                     0),
       array('il','Israel',                                      0),
       array('in','India',                                       0),
       array('io','British indian ocean territory',              0),
       array('iq','Iraq',                                        0),
       array('ir','Iran, islamic republic of',                   0),
       array('is','Iceland',                                     0),
       array('it','Italy',                                       0),
       array('jm','Jamaica',                                     0),
       array('jo','Jordan',                                      0),
       array('jp','Japan',                                       0),
       array('ke','Kenya',                                       0),
       array('kg','Kyrgyzstan',                                  0),
       array('kh','Cambodia',                                    0),
       array('ki','Kiribati',                                    0),
       array('km','Comoros',                                     0),
       array('kn','Saint kitts and nevis',                       0),
       array('kp','Korea, democratic people\'s republic of',     0),
       array('kr','Korea, republic of',                          0),
       array('kw','Kuwait',                                      0),
       array('ky','Cayman islands',                              0),
       array('kz','Kazakstan',                                   0),
       array('la','Lao people\'s democratic republic',           0),
       array('lb','Lebanon',                                     0),
       array('lc','Saint lucia',                                 0),
       array('li','Liechtenstein',                               0),
       array('lk','Sri lanka',                                   0),
       array('lr','Liberia',                                     0),
       array('ls','Lesotho',                                     0),
       array('lt','Lithuania',                                   0),
       array('lu','Luxembourg',                                  0),
       array('lv','Latvia',                                      0),
       array('ly','Libyan arab jamahiriya',                      0),
       array('ma','Morocco',                                     0),
       array('mc','Monaco',                                      0),
       array('md','Moldova, republic of',                        0),
       array('mg','Madagascar',                                  0),
       array('mh','Marshall islands',                            0),
       array('mk','Macedonia, the former yugoslav republic of',  0),
       array('ml','Mali',                                        0),
       array('mm','Myanmar',                                     0),
       array('mn','Mongolia',                                    0),
       array('mo','Macau',                                       0),
       array('mp','Northern mariana islands',                    0),
       array('mq','Martinique',                                  0),
       array('mr','Mauritania',                                  0),
       array('ms','Montserrat',                                  0),
       array('mt','Malta',                                       0),
       array('mu','Mauritius',                                   0),
       array('mv','Maldives',                                    0),
       array('mw','Malawi',                                      0),
       array('mx','Mexico',                                      0),
       array('my','Malaysia',                                    0),
       array('mz','Mozambique',                                  0),
       array('na','Namibia',                                     0),
       array('nc','New caledonia',                               0),
       array('ne','Niger',                                       0),
       array('nf','Norfolk island',                              0),
       array('ng','Nigeria',                                     0),
       array('ni','Nicaragua',                                   0),
       array('nl','Netherlands',                                 0),
       array('no','Norway',                                      0),
       array('np','Nepal',                                       0),
       array('nr','Nauru',                                       0),
       array('nu','Niue',                                        0),
       array('nz','New zealand',                                 0),
       array('om','Oman',                                        0),
       array('pa','Panama',                                      0),
       array('pe','Peru',                                        0),
       array('pf','French polynesia',                            0),
       array('pg','Papua new guinea',                            0),
       array('ph','Philippines',                                 0),
       array('pk','Pakistan',                                    0),
       array('pl','Poland',                                      0),
       array('pm','Saint pierre and miquelon',                   0),
       array('pn','Pitcairn',                                    0),
       array('pr','Puerto rico',                                 0),
       array('ps','Palestinian territory, occupied',             0),
       array('pt','Portugal',                                    0),
       array('pw','Palau',                                       0),
       array('py','Paraguay',                                    0),
       array('qa','Qatar',                                       0),
       array('re','Reunion',                                     0),
       array('ro','Romania',                                     0),
       array('ru','Russian federation',                          0),
       array('rw','Rwanda',                                      0),
       array('sa','Saudi arabia',                                0),
       array('sb','Solomon islands',                             0),
       array('sc','Seychelles',                                  0),
       array('sd','Sudan',                                       0),
       array('se','Sweden',                                      0),
       array('sg','Singapore',                                   0),
       array('sh','Saint helena',                                0),
       array('si','Slovenia',                                    0),
       array('sj','Svalbard and jan mayen',                      0),
       array('sk','Slovakia',                                    0),
       array('sl','Sierra leone',                                0),
       array('sm','San marino',                                  0),
       array('sn','Senegal',                                     0),
       array('so','Somalia',                                     0),
       array('sr','Suriname',                                    0),
       array('st','Sao tome and principe',                       0),
       array('sv','El salvador',                                 0),
       array('sy','Syrian arab republic',                        0),
       array('sz','Swaziland',                                   0),
       array('tc','Turks and caicos islands',                    0),
       array('td','Chad',                                        0),
       array('tf','French southern territories',                 0),
       array('tg','Togo',                                        0),
       array('th','Thailand',                                    0),
       array('tj','Tajikistan',                                  0),
       array('tk','Tokelau',                                     0),
       array('tm','Turkmenistan',                                0),
       array('tn','Tunisia',                                     0),
       array('to','Tonga',                                       0),
       array('tp','East timor',                                  0),
       array('tr','Turkey',                                      0),
       array('tt','Trinidad and tobago',                         0),
       array('tv','Tuvalu',                                      0),
       array('tw','Taiwan, province of china',                   0),
       array('tz','Tanzania, united republic of',                0),
       array('ua','Ukraine',                                     0),
       array('ug','Uganda',                                      0),
       array('um','United states minor outlying islands',        0),
       array('us','United states',                               0),
       array('uy','Uruguay',                                     0),
       array('uz','Uzbekistan',                                  0),
       array('va','Holy see (vatican city state)',               0),
       array('vc','Saint vincent and the grenadines',            0),
       array('ve','Venezuela',                                   0),
       array('vg','Virgin islands, british',                     0),
       array('vi','Virgin islands, u.s.',                        0),
       array('vn','Viet nam',                                    0),
       array('vu','Vanuatu',                                     0),
       array('wf','Wallis and futuna',                           0),
       array('ws','Samoa',                                       0),
       array('ye','Yemen',                                       0),
       array('yt','Mayotte',                                     0),
       array('yu','Yugoslavia',                                  0),
       array('za','South africa',                                0),
       array('zm','Zambia',                                      0),
       array('zw','Zimbabwe',                                    0)
           )),

      new wm3DBCreateTable('_database',
      array(
            new wm3DBField('database_version',WM3_cDB_CHAR)
           )),

      new wm3DBInsertInto('_database',null,array('3.1')),

      new wm3DBCreateTable('_directories',
      array(
            new wm3DBField('directoryID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('parentID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('name'          ,WM3_cDB_CHAR),
            new wm3DBField('description'   ,WM3_cDB_CHAR),
            new wm3DBField('icon'          ,WM3_cDB_CHAR),
            new wm3DBField('directory_type',WM3_cDB_INT,5),
            new wm3DBField('enabled'       ,WM3_cDB_INT,1),
            new wm3DBField('languageID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'            ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_directories_items',
      array(
            new wm3DBField('directory_itemID' ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('directoryID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'           ,WM3_cDB_BIGINT,20),
            new wm3DBField('pageID'           ,WM3_cDB_BIGINT,20),
            new wm3DBField('hits'             ,WM3_cDB_INT,16),
            new wm3DBField('title'            ,WM3_cDB_CHAR),
            new wm3DBField('description'      ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'      ,WM3_cDB_INT,5),
            new wm3DBField('icon'             ,WM3_cDB_CHAR),
            new wm3DBField('home_url'         ,WM3_cDB_CHAR),
            new wm3DBField('download_url'     ,WM3_cDB_CHAR),
            new wm3DBField('votes_counts'     ,WM3_cDB_INT,16),
            new wm3DBField('votes_sum'        ,WM3_cDB_INT,16),
            new wm3DBField('votes_average'    ,WM3_cDB_FLOAT),
            new wm3DBField('source'           ,WM3_cDB_INT,5),
            new wm3DBField('directory_item_ts',WM3_cDB_INT,16),
            new wm3DBField('enabled'          ,WM3_cDB_INT,1),
            new wm3DBField('languageID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'               ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_downloads',
      array(
            new wm3DBField('downloadID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('subcategoryID',WM3_cDB_BIGINT,20),
            new wm3DBField('name'         ,WM3_cDB_CHAR),
            new wm3DBField('description'  ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'  ,WM3_cDB_INT,5),
            new wm3DBField('hits'         ,WM3_cDB_INT,16),
            new wm3DBField('votes_counts' ,WM3_cDB_INT,16),
            new wm3DBField('votes_sum'    ,WM3_cDB_INT,16),
            new wm3DBField('votes_average',WM3_cDB_FLOAT),
            new wm3DBField('download'     ,WM3_cDB_CHAR),
            new wm3DBField('source'       ,WM3_cDB_INT,5),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_downloads_categories',
      array(
            new wm3DBField('categoryID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'         ,WM3_cDB_CHAR),
            new wm3DBField('description'  ,WM3_cDB_CHAR),
            new wm3DBField('icon'  ,WM3_cDB_CHAR),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_downloads_subcategories',
      array(
            new wm3DBField('subcategoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('name'         ,WM3_cDB_CHAR),
            new wm3DBField('description'  ,WM3_cDB_CHAR),
            new wm3DBField('icon'         ,WM3_cDB_CHAR),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_carts_items',
      array(
            new wm3DBField('cart_itemID'        ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('productID'          ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'             ,WM3_cDB_BIGINT,20),
            new wm3DBField('orderID'            ,WM3_cDB_BIGINT,20),
            new wm3DBField('product_code'       ,WM3_cDB_CHAR),
            new wm3DBField('product_name'       ,WM3_cDB_CHAR),
            new wm3DBField('product_description',WM3_cDB_CHAR),
            new wm3DBField('options'            ,WM3_cDB_TEXT),
            new wm3DBField('quantity'           ,WM3_cDB_INT,16),
            new wm3DBField('price'              ,WM3_cDB_DOUBLE),
            new wm3DBField('discount'           ,WM3_cDB_INT,5),
            new wm3DBField('enabled'            ,WM3_cDB_INT,1),
            new wm3DBField('languageID'         ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                 ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_custom_data',
      array(
            new wm3DBField('dataID'    ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('productID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('fieldID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('value'     ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_custom_fields',
      array(
            new wm3DBField('fieldID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('type'      ,WM3_cDB_INT,5),
            new wm3DBField('size'      ,WM3_cDB_INT,16),
            new wm3DBField('show_in'   ,WM3_cDB_INT,5),
            new wm3DBField('required'  ,WM3_cDB_INT,1),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_custom_labels',
      array(
            new wm3DBField('labelID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('fieldID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('label'     ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_orders',
      array(
            new wm3DBField('orderID'      ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('userID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('order_ts'     ,WM3_cDB_INT,16),
            new wm3DBField('status'       ,WM3_cDB_INT,5),
            new wm3DBField('shipping_cost',WM3_cDB_DOUBLE),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_products',
      array(
            new wm3DBField('productID'        ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('subcategoryID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'           ,WM3_cDB_BIGINT,20),
            new wm3DBField('code'             ,WM3_cDB_CHAR),
            new wm3DBField('name'             ,WM3_cDB_CHAR),
            new wm3DBField('description'      ,WM3_cDB_CHAR),
            new wm3DBField('full_description' ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'      ,WM3_cDB_INT,5),
            new wm3DBField('align'            ,WM3_cDB_INT,5),
            new wm3DBField('price'            ,WM3_cDB_DOUBLE),
            new wm3DBField('price_description',WM3_cDB_CHAR),
            new wm3DBField('discount'         ,WM3_cDB_INT,5),
            new wm3DBField('special'          ,WM3_cDB_INT,1),
            new wm3DBField('stock'            ,WM3_cDB_INT,16),
            new wm3DBField('availability'     ,WM3_cDB_INT,5),
            new wm3DBField('options'          ,WM3_cDB_TEXT),
            new wm3DBField('enabled'          ,WM3_cDB_INT,1),
            new wm3DBField('languageID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'               ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_products_pictures',
      array(
            new wm3DBField('pictureID'  ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('productID'  ,WM3_cDB_BIGINT,20),
            new wm3DBField('picture'    ,WM3_cDB_CHAR),
            new wm3DBField('thumbnail'  ,WM3_cDB_CHAR),
            new wm3DBField('description',WM3_cDB_CHAR),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_ecommerce_subcategories',
      array(
            new wm3DBField('subcategoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('name'         ,WM3_cDB_CHAR),
            new wm3DBField('icon'         ,WM3_cDB_CHAR),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_faqs',
      array(
            new wm3DBField('faqID'      ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('question'   ,WM3_cDB_CHAR),
            new wm3DBField('answer'     ,WM3_cDB_TEXT),
            new wm3DBField('render_mode',WM3_cDB_INT,5),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_faqs_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_forums',
      array(
            new wm3DBField('forumID'       ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'         ,WM3_cDB_CHAR),
            new wm3DBField('topic'         ,WM3_cDB_CHAR),
            new wm3DBField('group_open'    ,WM3_cDB_INT,1),
            new wm3DBField('users_read'    ,WM3_cDB_INT,1),
            new wm3DBField('users_write'   ,WM3_cDB_INT,1),
            new wm3DBField('users_open'    ,WM3_cDB_INT,1),
            new wm3DBField('visitors_read' ,WM3_cDB_INT,1),
            new wm3DBField('visitors_write',WM3_cDB_INT,1),
            new wm3DBField('visitors_open' ,WM3_cDB_INT,1),
            new wm3DBField('expire_days'   ,WM3_cDB_INT,16),
            new wm3DBField('denied_words'  ,WM3_cDB_TEXT),
            new wm3DBField('enabled'       ,WM3_cDB_INT,1),
            new wm3DBField('languageID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'            ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_forums_categories',
      array(
            new wm3DBField('categoryID' ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'       ,WM3_cDB_CHAR),
            new wm3DBField('description',WM3_cDB_CHAR),
            new wm3DBField('icon'       ,WM3_cDB_CHAR),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_forums_posts',
      array(
            new wm3DBField('postID'      ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('discussionID',WM3_cDB_BIGINT,20),
            new wm3DBField('forumID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('quoteID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'       ,WM3_cDB_CHAR),
            new wm3DBField('post'        ,WM3_cDB_TEXT),
            new wm3DBField('render_mode' ,WM3_cDB_INT,5),
            new wm3DBField('locked'      ,WM3_cDB_INT,1),
            new wm3DBField('hits'        ,WM3_cDB_INT,16),
            new wm3DBField('enabled'     ,WM3_cDB_INT,1),
            new wm3DBField('languageID'  ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'          ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_forums_posts_read',
      array(
            new wm3DBField('readID' ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('userID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('postID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('read_ts',WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_groups',
      array(
            new wm3DBField('groupID'    ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'       ,WM3_cDB_CHAR),
            new wm3DBField('description',WM3_cDB_TEXT),
            new wm3DBField('icon'       ,WM3_cDB_CHAR),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_groups',
      array('name','description','icon','enabled','languageID','ts'),
      array('Default','Default','',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts)),

      new wm3DBCreateTable('_guestbooks_messages',
      array(
            new wm3DBField('messageID'  ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('guestbookID',WM3_cDB_BIGINT,20),
            new wm3DBField('countryID'  ,WM3_cDB_BIGINT,20),
            new wm3DBField('name'       ,WM3_cDB_CHAR),
            new wm3DBField('email'      ,WM3_cDB_CHAR),
            new wm3DBField('message'    ,WM3_cDB_TEXT),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_horoscopes',
      array(
            new wm3DBField('horoscopeID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('message'    ,WM3_cDB_TEXT),
            new wm3DBField('render_mode',WM3_cDB_INT,5),
            new wm3DBField('p1'         ,WM3_cDB_INT,1),
            new wm3DBField('p2'         ,WM3_cDB_INT,1),
            new wm3DBField('p3'         ,WM3_cDB_INT,1),
            new wm3DBField('p4'         ,WM3_cDB_INT,1),
            new wm3DBField('p5'         ,WM3_cDB_INT,1),
            new wm3DBField('p6'         ,WM3_cDB_INT,1),
            new wm3DBField('p7'         ,WM3_cDB_INT,1),
            new wm3DBField('p8'         ,WM3_cDB_INT,1),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_horoscopes_dailies',
      array(
            new wm3DBField('horoscope_dailyID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('horoscopeID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('sign'             ,WM3_cDB_INT,5),
            new wm3DBField('expire_ts'        ,WM3_cDB_INT,16),
            new wm3DBField('enabled'          ,WM3_cDB_INT,1),
            new wm3DBField('languageID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'               ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_languages',
      array(
            new wm3DBField('languageID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('flag'      ,WM3_cDB_CHAR),
            new wm3DBField('file'      ,WM3_cDB_CHAR),
            new wm3DBField('code'      ,WM3_cDB_CHAR,8),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_languages',
      array('name','flag','file','code','enabled','ts'),
      array(
       array('English',   'flag_en.png','language_en.php','en',WM3_cENABLED,$setup_ts),
       array('Italiano',  'flag_it.png','language_it.php','it',WM3_cENABLED,$setup_ts),
       array('Français',  'flag_fr.png','language_fr.php','fr',WM3_cENABLED,$setup_ts),
       array('Deutsch',   'flag_de.png','language_de.php','de',WM3_cENABLED,$setup_ts),
       array('Español',   'flag_es.png','language_es.php','es',WM3_cENABLED,$setup_ts),
       array('Nederlands','flag_nl.png','language_nl.php','nl',WM3_cENABLED,$setup_ts),
       array('Ελληνικά',  'flag_el.png','language_el.php','el',WM3_cENABLED,$setup_ts)
           )),

      new wm3DBCreateTable('_links',
      array(
            new wm3DBField('linkID'     ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('url'        ,WM3_cDB_CHAR),
            new wm3DBField('title'      ,WM3_cDB_CHAR),
            new wm3DBField('description',WM3_cDB_TEXT),
            new wm3DBField('render_mode',WM3_cDB_INT,1),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_links_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_logs',
      array(
            new wm3DBField('logID'  ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('referer',WM3_cDB_CHAR,255,WM3_cDB_KEY),
            new wm3DBField('ip'     ,WM3_cDB_CHAR),
            new wm3DBField('dns'    ,WM3_cDB_CHAR),
            new wm3DBField('userID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('adminID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'     ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_market_announcements',
      array(
            new wm3DBField('announcementID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('subcategoryID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'           ,WM3_cDB_BIGINT,20),
            new wm3DBField('announcement'     ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'      ,WM3_cDB_INT,5),
            new wm3DBField('title'            ,WM3_cDB_CHAR),
            new wm3DBField('announcement_type',WM3_cDB_INT,5),
            new wm3DBField('always_valid'     ,WM3_cDB_INT,1),
            new wm3DBField('enabled'          ,WM3_cDB_INT,1),
            new wm3DBField('languageID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'               ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_market_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_market_subcategories',
      array(
            new wm3DBField('subcategoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('name'         ,WM3_cDB_CHAR),
            new wm3DBField('icon'         ,WM3_cDB_CHAR),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_media_albums',
      array(
            new wm3DBField('media_albumID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('userID'          ,WM3_cDB_BIGINT,20),
            new wm3DBField('categoryID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'           ,WM3_cDB_CHAR),
            new wm3DBField('description'     ,WM3_cDB_CHAR),
            new wm3DBField('icon'            ,WM3_cDB_CHAR),
            new wm3DBField('media_album_type',WM3_cDB_INT,5),
            new wm3DBField('group_read'      ,WM3_cDB_INT,1),
            new wm3DBField('users_read'      ,WM3_cDB_INT,1),
            new wm3DBField('visitors_read'   ,WM3_cDB_INT,1),
            new wm3DBField('enabled'         ,WM3_cDB_INT,1),
            new wm3DBField('languageID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'              ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_media_albums_categories',
      array(
            new wm3DBField('categoryID' ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'       ,WM3_cDB_CHAR),
            new wm3DBField('description',WM3_cDB_CHAR),
            new wm3DBField('icon'       ,WM3_cDB_CHAR),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_media_albums_items',
      array(
            new wm3DBField('media_album_itemID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('media_albumID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'             ,WM3_cDB_CHAR),
            new wm3DBField('alt'               ,WM3_cDB_CHAR),
            new wm3DBField('media'             ,WM3_cDB_CHAR),
            new wm3DBField('thumbnail'         ,WM3_cDB_CHAR),
            new wm3DBField('hits'              ,WM3_cDB_INT,16),
            new wm3DBField('votes_counts'      ,WM3_cDB_INT,16),
            new wm3DBField('votes_sum'         ,WM3_cDB_INT,16),
            new wm3DBField('votes_average'     ,WM3_cDB_FLOAT),
            new wm3DBField('source_thumbnail'  ,WM3_cDB_INT,5),
            new wm3DBField('source_media'      ,WM3_cDB_INT,5),
            new wm3DBField('enabled'           ,WM3_cDB_INT,1),
            new wm3DBField('languageID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_menus',
      array(
            new wm3DBField('menuID'     ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'       ,WM3_cDB_CHAR),
            new wm3DBField('description',WM3_cDB_CHAR),
            new wm3DBField('icon'       ,WM3_cDB_CHAR),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_menus',
      array('name','description','icon','enabled','languageID','ts'),
      array('','','',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts)),

      new wm3DBCreateTable('_menus_items',
      array(
            new wm3DBField('menu_itemID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('linkID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('categoryID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('menuID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('menudropdownID',WM3_cDB_BIGINT,20),
            new wm3DBField('title'         ,WM3_cDB_CHAR),
            new wm3DBField('url'           ,WM3_cDB_CHAR),
            new wm3DBField('target'        ,WM3_cDB_CHAR),
            new wm3DBField('position'      ,WM3_cDB_INT,5),
            new wm3DBField('is_separator'  ,WM3_cDB_INT,1),
            new wm3DBField('enabled'       ,WM3_cDB_INT,1),
            new wm3DBField('languageID'    ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'            ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_menus_items_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('position'  ,WM3_cDB_INT,5),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_menus_items_categories',
      array('position','name','icon','enabled','languageID','ts'),
      array(
       array(0,   'MENU_ITEM_CHANNEL', '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'MENU_ITEM_HOME',    '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'MENU_ITEM_ADMIN',   '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'MENU_ITEM_USER',    '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'MENU_ITEM_EXTERNAL','',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(1000,'MENU_ITEM_CUSTOM',  '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'MENU_ITEM_VOID',    '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts)
           )),

      new wm3DBCreateTable('_messages',
      array(
            new wm3DBField('messageID'  ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('message'    ,WM3_cDB_TEXT),
            new wm3DBField('render_mode',WM3_cDB_INT,5),
            new wm3DBField('message_ts' ,WM3_cDB_INT,16),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_metatags',
      array(
            new wm3DBField('author'              ,WM3_cDB_TEXT),
            new wm3DBField('keywords'            ,WM3_cDB_TEXT),
            new wm3DBField('description'         ,WM3_cDB_TEXT),
            new wm3DBField('head_extra'          ,WM3_cDB_TEXT),
            new wm3DBField('pageID'              ,WM3_cDB_BIGINT,20),
            new wm3DBField('newsID'              ,WM3_cDB_BIGINT,20),
            new wm3DBField('use_basic_head_extra',WM3_cDB_INT,1),
            new wm3DBField('enabled'             ,WM3_cDB_INT,1),
            new wm3DBField('languageID'          ,WM3_cDB_BIGINT,20)
           )),

      new wm3DBInsertInto('_metatags',null,array('Webmatic Team','php, mysql, webportal, ecommerce, applets, java, forum, users manager, siti web, html, web application','Webportal or website creator, you can create your webportal in an easy way, Creatore di portali o siti web, crea il tuo sito semplicemente','',0,0,WM3_cENABLED,WM3_cENABLED,WM3_cLANGUAGE_ALL)),

      new wm3DBCreateTable('_news',
      array(
            new wm3DBField('newsID'       ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'        ,WM3_cDB_CHAR),
            new wm3DBField('news'         ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'  ,WM3_cDB_INT,5),
            new wm3DBField('hits'         ,WM3_cDB_INT,16),
            new wm3DBField('votes_counts' ,WM3_cDB_INT,16),
            new wm3DBField('votes_sum'    ,WM3_cDB_INT,16),
            new wm3DBField('votes_average',WM3_cDB_FLOAT),
            new wm3DBField('news_ts'      ,WM3_cDB_INT,16),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_news_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_news_comments',
      array(
            new wm3DBField('commentID'  ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('newsID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('comment'    ,WM3_cDB_TEXT),
            new wm3DBField('render_mode',WM3_cDB_INT,5),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_newsletters',
      array(
            new wm3DBField('newsletterID'       ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('groupID'            ,WM3_cDB_BIGINT,20),
            new wm3DBField('newsletter_target'  ,WM3_cDB_INT,5),
            new wm3DBField('user_gender'        ,WM3_cDB_INT,5),
            new wm3DBField('ignore_disabled'    ,WM3_cDB_INT,1),
            new wm3DBField('subject'            ,WM3_cDB_CHAR),
            new wm3DBField('newsletter'         ,WM3_cDB_TEXT),
            new wm3DBField('newsletter_use_foot',WM3_cDB_INT,1),
            new wm3DBField('newsletter_format'  ,WM3_cDB_INT,5),
            new wm3DBField('emails_sended'      ,WM3_cDB_INT,16),
            new wm3DBField('enabled'            ,WM3_cDB_INT,1),
            new wm3DBField('languageID'         ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                 ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_newsletters_items',
      array(
            new wm3DBField('newsletter_itemID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('email'            ,WM3_cDB_CHAR,255,WM3_cDB_UNIQUE),
            new wm3DBField('enabled'          ,WM3_cDB_INT,1),
            new wm3DBField('languageID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'               ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_pages',
      array(
            new wm3DBField('pageID'              ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('groupID'             ,WM3_cDB_BIGINT,20),
            new wm3DBField('categoryID'          ,WM3_cDB_BIGINT,20),
            new wm3DBField('backID'              ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'               ,WM3_cDB_CHAR),
            new wm3DBField('subtitle'            ,WM3_cDB_CHAR),
            new wm3DBField('head'                ,WM3_cDB_TEXT),
            new wm3DBField('body'                ,WM3_cDB_TEXT),
            new wm3DBField('foot'                ,WM3_cDB_TEXT),
            new wm3DBField('expansion'           ,WM3_cDB_CHAR),
            new wm3DBField('expansion_index'     ,WM3_cDB_INT,16),
            new wm3DBField('expansion_config'    ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'         ,WM3_cDB_INT,5),
            new wm3DBField('visibility'          ,WM3_cDB_INT,5),
            new wm3DBField('left_panels_enabled' ,WM3_cDB_INT,1),
            new wm3DBField('right_panels_enabled',WM3_cDB_INT,1),
            new wm3DBField('page_type'           ,WM3_cDB_INT,5),
            new wm3DBField('hits'                ,WM3_cDB_INT,16),
            new wm3DBField('enabled'             ,WM3_cDB_INT,1),
            new wm3DBField('languageID'          ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                  ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_pages_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('position'  ,WM3_cDB_INT,5),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_pages_categories',
      array('position','name','icon','enabled','languageID','ts'),
      array(
       array(0,   'PAGE_MARKET',           '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_FAQ',              '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_SEARCH_ENGINE',    '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_USER_REGISTRATION','',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_LINKS',            '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_STATISTICS',       '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_USER_INFORMATIONS','',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_FORUMS',           '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_DOWNLOADS',        '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_GUESTBOOKS',       '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_DIRECTORIES',      '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_MEDIA_ALBUMS',     '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_CONTACT',          '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_CHAT',             '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PAGE_WEBMAIL',          '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(1000,'PAGE_CUSTOM',           '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(500, 'PAGE_EXPANSION',        '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts)
           )),

      new wm3DBCreateTable('_panels',
      array(
            new wm3DBField('panelID'         ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('categoryID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('extraID'         ,WM3_cDB_BIGINT,20),
            new wm3DBField('title'           ,WM3_cDB_CHAR),
            new wm3DBField('head'            ,WM3_cDB_TEXT),
            new wm3DBField('body'            ,WM3_cDB_TEXT),
            new wm3DBField('foot'            ,WM3_cDB_TEXT),
            new wm3DBField('expansion'       ,WM3_cDB_CHAR),
            new wm3DBField('expansion_index' ,WM3_cDB_INT,16),
            new wm3DBField('expansion_config',WM3_cDB_TEXT),
            new wm3DBField('render_mode'     ,WM3_cDB_INT,5),
            new wm3DBField('visibility'      ,WM3_cDB_INT,5),
            new wm3DBField('position'        ,WM3_cDB_INT,5),
            new wm3DBField('align'           ,WM3_cDB_INT,5),
            new wm3DBField('enabled'         ,WM3_cDB_INT,1),
            new wm3DBField('languageID'      ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'              ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_panels',
      array('categoryID','extraID','title','head','body','foot','expansion','expansion_index','expansion_config','render_mode','visibility','position','align','enabled','languageID','ts'),
      array(
       array(WM3_cPANEL_CATEGORY_LANGUAGES,0,'Language:','Choose your language:','','','',0,'',WM3_cRENDER_MODE_HTML,WM3_cVISIBILITY_ALL,1,WM3_cALIGN_RIGHT,WM3_cENABLED,WM3_cLANGUAGE_EN,$setup_ts),
       array(WM3_cPANEL_CATEGORY_LANGUAGES,0,'Lingua:',  'Scegli la tua lingua:','','','',0,'',WM3_cRENDER_MODE_HTML,WM3_cVISIBILITY_ALL,2,WM3_cALIGN_RIGHT,WM3_cENABLED,WM3_cLANGUAGE_IT,$setup_ts),
       array(WM3_cPANEL_CATEGORY_LANGUAGES,0,'Language:','Choose your language:','','','',0,'',WM3_cRENDER_MODE_HTML,WM3_cVISIBILITY_ALL,3,WM3_cALIGN_RIGHT,WM3_cENABLED,WM3_cLANGUAGE_FR,$setup_ts),
       array(WM3_cPANEL_CATEGORY_LANGUAGES,0,'Language:','Choose your language:','','','',0,'',WM3_cRENDER_MODE_HTML,WM3_cVISIBILITY_ALL,4,WM3_cALIGN_RIGHT,WM3_cENABLED,WM3_cLANGUAGE_DE,$setup_ts),
       array(WM3_cPANEL_CATEGORY_LANGUAGES,0,'Language:','Choose your language:','','','',0,'',WM3_cRENDER_MODE_HTML,WM3_cVISIBILITY_ALL,5,WM3_cALIGN_RIGHT,WM3_cENABLED,WM3_cLANGUAGE_ES,$setup_ts),
       array(WM3_cPANEL_CATEGORY_LANGUAGES,0,'Language:','Choose your language:','','','',0,'',WM3_cRENDER_MODE_HTML,WM3_cVISIBILITY_ALL,6,WM3_cALIGN_RIGHT,WM3_cENABLED,WM3_cLANGUAGE_NL,$setup_ts),
       array(WM3_cPANEL_CATEGORY_LANGUAGES,0,'Language:','Choose your language:','','','',0,'',WM3_cRENDER_MODE_HTML,WM3_cVISIBILITY_ALL,7,WM3_cALIGN_RIGHT,WM3_cENABLED,WM3_cLANGUAGE_EL,$setup_ts)
           )),

      new wm3DBCreateTable('_panels_categories',
      array(
            new wm3DBField('categoryID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('position'  ,WM3_cDB_INT,5),
            new wm3DBField('name'      ,WM3_cDB_CHAR),
            new wm3DBField('icon'      ,WM3_cDB_CHAR),
            new wm3DBField('enabled'   ,WM3_cDB_INT,1),
            new wm3DBField('languageID',WM3_cDB_BIGINT,20),
            new wm3DBField('ts'        ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_panels_categories',
      array('position','name','icon','enabled','languageID','ts'),
      array(
       array(0,   'PANEL_MESSAGES',      '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_LOGIN',         '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_CHANNELS',      '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_SEARCH',        '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_HOROSCOPE',     '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_NEWSLETTER',    '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_SEND_TO_FRIEND','',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_LANGUAGES',     '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_ECOMMERCE',     '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_SURVEY',        '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_FORTUNE',       '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_RSS_FEEDS',     '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_BIRTHDAY',      '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_SPECIAL_OFFER', '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(1000,'PANEL_CUSTOM',        '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(500, 'PANEL_EXPANSION',     '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_MENU',          '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts),
       array(0,   'PANEL_TAGS',          '',WM3_cENABLED,WM3_cLANGUAGE_ALL,$setup_ts)
           )),

      new wm3DBCreateTable('_preferences',
      array(
            new wm3DBField('banners_enabled'                  ,WM3_cDB_INT,1),
            new wm3DBField('banner1ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner2ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner3ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner4ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner5ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner6ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner7ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner8ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banner9ID'                        ,WM3_cDB_BIGINT,20),
            new wm3DBField('banners_exchange_enabled'         ,WM3_cDB_INT,1),
            new wm3DBField('banners_exchange_ratio'           ,WM3_cDB_INT,16),
            new wm3DBField('banners_exchange_extra_content'   ,WM3_cDB_TEXT),
            new wm3DBField('banners_exchange_auto_enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('banners_exchange_starting_credits',WM3_cDB_INT,16),
            new wm3DBField('logo'                             ,WM3_cDB_CHAR),
            new wm3DBField('logo_width'                       ,WM3_cDB_INT,5),
            new wm3DBField('logo_height'                      ,WM3_cDB_INT,5),
            new wm3DBField('logo_printable'                   ,WM3_cDB_CHAR),
            new wm3DBField('skin'                             ,WM3_cDB_CHAR),
            new wm3DBField('site_address'                     ,WM3_cDB_CHAR),
            new wm3DBField('foot_content'                     ,WM3_cDB_INT,5),
            new wm3DBField('registration_form_type'           ,WM3_cDB_INT,5),
            new wm3DBField('home_news_max'                    ,WM3_cDB_INT,16),
            new wm3DBField('webmaster_email'                  ,WM3_cDB_CHAR),
            new wm3DBField('service_email'                    ,WM3_cDB_CHAR),
            new wm3DBField('hide_left_panels_action_home'     ,WM3_cDB_INT,1),
            new wm3DBField('hide_right_panels_action_home'    ,WM3_cDB_INT,1),
            new wm3DBField('show_home_channels'               ,WM3_cDB_INT,1),
            new wm3DBField('show_home_news'                   ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_vote_news'              ,WM3_cDB_INT,1),
            new wm3DBField('enable_news_comments'             ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_news_comments'          ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_write_news'             ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_enabled_news'           ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_add_directories'        ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_enabled_directories'    ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_vote_directories'       ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_vote_media_albums'      ,WM3_cDB_INT,1),
            new wm3DBField('anonymous_vote_downloads'         ,WM3_cDB_INT,1),
            new wm3DBField('show_total_newsletter'            ,WM3_cDB_INT,1),
            new wm3DBField('show_total_signalations'          ,WM3_cDB_INT,1),
            new wm3DBField('show_total_search_engine'         ,WM3_cDB_INT,1),
            new wm3DBField('show_online_users_visitors'       ,WM3_cDB_INT,1),
            new wm3DBField('ecommerce_credit_card_url'        ,WM3_cDB_CHAR),
            new wm3DBField('ecommerce_variable_price'         ,WM3_cDB_CHAR),
            new wm3DBField('ecommerce_variable_id'            ,WM3_cDB_CHAR),
            new wm3DBField('ecommerce_currency'               ,WM3_cDB_CHAR),
            new wm3DBField('ecommerce_type'                   ,WM3_cDB_INT,5),
            new wm3DBField('ecommerce_show_catalogue_price'   ,WM3_cDB_INT,1),
            new wm3DBField('ecommerce_show_extra'             ,WM3_cDB_INT,1),
            new wm3DBField('ecommerce_payment_type'           ,WM3_cDB_INT,5),
            new wm3DBField('ecommerce_cart_expire'            ,WM3_cDB_INT,16),
            new wm3DBField('ecommerce_shipping_cost'          ,WM3_cDB_DOUBLE),
            new wm3DBField('user_enabled'                     ,WM3_cDB_INT,1),
            new wm3DBField('user_special'                     ,WM3_cDB_INT,1),
            new wm3DBField('user_flag1'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_flag2'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_flag3'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_flag4'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_flag5'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_flag6'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_flag7'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_flag8'                       ,WM3_cDB_INT,1),
            new wm3DBField('user_groupID'                     ,WM3_cDB_BIGINT,20),
            new wm3DBField('logging_enabled'                  ,WM3_cDB_INT,1),
            new wm3DBField('ts'                               ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_preferences',null,array(WM3_cDISABLED,0,0,0,0,0,0,0,0,0,WM3_cDISABLED,5,'',WM3_cDISABLED,5000,'webmatic1.gif',32,32,'printable.gif','default','localhost',WM3_cPREFERENCES_FOOT_COUNTER_DATE,WM3_cPREFERENCES_REGISTRATION_FULL,10,'products@valarsoft.com','dontreply@service_email.com',WM3_cDISABLED,WM3_cDISABLED,WM3_cENABLED,WM3_cENABLED,WM3_cDISABLED,WM3_cENABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,'cc_url','n1','n2','Euro',WM3_cPREFERENCES_ECOMMERCE_CATALOGUE_ONLY,WM3_cDISABLED,WM3_cDISABLED,0,5,0,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,WM3_cDISABLED,1,WM3_cENABLED,$setup_ts)),

      new wm3DBCreateTable('_preferences_contents',
      array(
            new wm3DBField('preferences_contentID'          ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('browser_bar_title'              ,WM3_cDB_CHAR),
            new wm3DBField('title'                          ,WM3_cDB_CHAR),
            new wm3DBField('head'                           ,WM3_cDB_TEXT),
            new wm3DBField('home'                           ,WM3_cDB_TEXT),
            new wm3DBField('foot'                           ,WM3_cDB_TEXT),
            new wm3DBField('staff_name'                     ,WM3_cDB_CHAR),
            new wm3DBField('special_user_label'             ,WM3_cDB_CHAR),
            new wm3DBField('signalation_email_subject'      ,WM3_cDB_CHAR),
            new wm3DBField('signalation_email_text'         ,WM3_cDB_TEXT),
            new wm3DBField('user_registration_email_subject',WM3_cDB_CHAR),
            new wm3DBField('user_registration_email_text'   ,WM3_cDB_TEXT),
            new wm3DBField('languageID'                     ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                             ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_preferences_contents',
      array('browser_bar_title','title','head','home','foot','staff_name','special_user_label','signalation_email_subject','signalation_email_text','user_registration_email_subject','user_registration_email_text','languageID','ts'),
      array(
       array('Webmatic','Welcome to Webmatic',  '','<b>Webmatic its now correctly installed, thanks!</b><br><br><table width="40%" border="0" cellspacing="1" cellpadding="5" align="center"><tr><td><p align="left">Now you can:<br><br><nobr>- Start to modify your website by click on <a href="'.WM3_cCONFIG_ADMIN_FILE.'?stage=2">admin</a>;</nobr><br><nobr>- Read Webmatic <a href="'.WM3_cPATH_DOCS.'en" target="_blank">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>',                                                            '','Webmatic editorial staff','Special user',   'Subject','text', 'Subject','text', WM3_cLANGUAGE_EN,$setup_ts),
       array('Webmatic','Benvenuti in Webmatic','','<b>Webmatic e\' stato correttamente installato, grazie!</b><br><br><table width="40%" border="0" cellspacing="1" cellpadding="5" align="center"><tr><td><p align="left">Adesso e\' possibile:<br><br><nobr>- Iniziare a modificare il sito web cliccando su <a href="'.WM3_cCONFIG_ADMIN_FILE.'?stage=2">amministrazione</a>;</nobr><br><nobr>- Consultare la <a href="'.WM3_cPATH_DOCS.'it" target="_blank">documentazione</a> di Webmatic;</nobr><br><nobr>- Scaricare l\'ultima versione di Webmatic dal sito <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>Per qualsiasi domanda o suggerimento visitare il sito di Webmatic <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>','','Redazione Webmatic',      'Utente speciale','Oggetto','testo','Oggetto','testo',WM3_cLANGUAGE_IT,$setup_ts),
       array('Webmatic','Welcome to Webmatic',  '','<b>Webmatic its now correctly installed, thanks!</b><br><br><table width="40%" border="0" cellspacing="1" cellpadding="5" align="center"><tr><td><p align="left">Now you can:<br><br><nobr>- Start to modify your website by click on <a href="'.WM3_cCONFIG_ADMIN_FILE.'?stage=2">admin</a>;</nobr><br><nobr>- Read Webmatic <a href="'.WM3_cPATH_DOCS.'en" target="_blank">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>',                                                            '','Webmatic editorial staff','Special user',   'Subject','text', 'Subject','text', WM3_cLANGUAGE_FR,$setup_ts),
       array('Webmatic','Welcome to Webmatic',  '','<b>Webmatic its now correctly installed, thanks!</b><br><br><table width="40%" border="0" cellspacing="1" cellpadding="5" align="center"><tr><td><p align="left">Now you can:<br><br><nobr>- Start to modify your website by click on <a href="'.WM3_cCONFIG_ADMIN_FILE.'?stage=2">admin</a>;</nobr><br><nobr>- Read Webmatic <a href="'.WM3_cPATH_DOCS.'en" target="_blank">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>',                                                            '','Webmatic editorial staff','Special user',   'Subject','text', 'Subject','text', WM3_cLANGUAGE_DE,$setup_ts),
       array('Webmatic','Welcome to Webmatic',  '','<b>Webmatic its now correctly installed, thanks!</b><br><br><table width="40%" border="0" cellspacing="1" cellpadding="5" align="center"><tr><td><p align="left">Now you can:<br><br><nobr>- Start to modify your website by click on <a href="'.WM3_cCONFIG_ADMIN_FILE.'?stage=2">admin</a>;</nobr><br><nobr>- Read Webmatic <a href="'.WM3_cPATH_DOCS.'en" target="_blank">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>',                                                            '','Webmatic editorial staff','Special user',   'Subject','text', 'Subject','text', WM3_cLANGUAGE_ES,$setup_ts),
       array('Webmatic','Welcome to Webmatic',  '','<b>Webmatic its now correctly installed, thanks!</b><br><br><table width="40%" border="0" cellspacing="1" cellpadding="5" align="center"><tr><td><p align="left">Now you can:<br><br><nobr>- Start to modify your website by click on <a href="'.WM3_cCONFIG_ADMIN_FILE.'?stage=2">admin</a>;</nobr><br><nobr>- Read Webmatic <a href="'.WM3_cPATH_DOCS.'en" target="_blank">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>',                                                            '','Webmatic editorial staff','Special user',   'Subject','text', 'Subject','text', WM3_cLANGUAGE_NL,$setup_ts),
       array('Webmatic','Welcome to Webmatic',  '','<b>Webmatic its now correctly installed, thanks!</b><br><br><table width="40%" border="0" cellspacing="1" cellpadding="5" align="center"><tr><td><p align="left">Now you can:<br><br><nobr>- Start to modify your website by click on <a href="'.WM3_cCONFIG_ADMIN_FILE.'?stage=2">admin</a>;</nobr><br><nobr>- Read Webmatic <a href="'.WM3_cPATH_DOCS.'en" target="_blank">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href="http://www.valarsoft.com" target="_blank">www.valarsoft.com</a>',                                                            '','Webmatic editorial staff','Special user',   'Subject','text', 'Subject','text', WM3_cLANGUAGE_EL,$setup_ts)
           )),

      new wm3DBCreateTable('_quotes',
      array(
            new wm3DBField('quoteID'    ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('quote'      ,WM3_cDB_TEXT),
            new wm3DBField('render_mode',WM3_cDB_INT,5),
            new wm3DBField('author'     ,WM3_cDB_CHAR),
            new wm3DBField('year'       ,WM3_cDB_CHAR),
            new wm3DBField('occupation' ,WM3_cDB_CHAR),
            new wm3DBField('author_url' ,WM3_cDB_CHAR),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_search_engines_items',
      array(
            new wm3DBField('search_engine_itemID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('url'                 ,WM3_cDB_CHAR,255,WM3_cDB_UNIQUE),
            new wm3DBField('keywords'            ,WM3_cDB_CHAR),
            new wm3DBField('description'         ,WM3_cDB_CHAR),
            new wm3DBField('enabled'             ,WM3_cDB_INT,1),
            new wm3DBField('languageID'          ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                  ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_sessions',
      array(
            new wm3DBField('sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('userID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('hash'     ,WM3_cDB_CHAR),
            new wm3DBField('ip'       ,WM3_cDB_CHAR),
            new wm3DBField('expire_ts',WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_sessions_actions',
      array(
            new wm3DBField('actionID' ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('sessionID',WM3_cDB_BIGINT,20),
            new wm3DBField('action_ts',WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_sessions_banners_exchange',
      array(
            new wm3DBField('banner_exchange_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('banner_exchangeID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'                ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'                   ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'             ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_sessions_chatrooms',
      array(
            new wm3DBField('chatroom_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('chatroomID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'            ,WM3_cDB_BIGINT,20),
            new wm3DBField('nickname'          ,WM3_cDB_CHAR),
            new wm3DBField('ip'                ,WM3_cDB_CHAR),
            new wm3DBField('join_ts'           ,WM3_cDB_INT,16,WM3_cDB_KEY),
            new wm3DBField('expire_ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_sessions_directories_items',
      array(
            new wm3DBField('directory_item_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('directory_itemID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'               ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'                  ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'            ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_sessions_downloads',
      array(
            new wm3DBField('download_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('downloadID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'         ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'            ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'      ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_sessions_forums_posts',
      array(
            new wm3DBField('forum_post_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('forum_postID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'           ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'              ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'        ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_sessions_media_albums_items',
      array(
            new wm3DBField('media_album_item_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('media_album_itemID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'                 ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'                    ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'              ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_sessions_news',
      array(
            new wm3DBField('news_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('newsID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'  ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_sessions_pages',
      array(
            new wm3DBField('page_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('pageID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'  ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_sessions_surveys',
      array(
            new wm3DBField('survey_sessionID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('surveyID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('survey_itemID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('sessionID'       ,WM3_cDB_BIGINT,20),
            new wm3DBField('userID'          ,WM3_cDB_BIGINT,20),
            new wm3DBField('session_type'    ,WM3_cDB_INT,5)
           )),

      new wm3DBCreateTable('_states',
      array(
            new wm3DBField('stateID'  ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('countryID',WM3_cDB_BIGINT,20),
            new wm3DBField('code'     ,WM3_cDB_CHAR,8),
            new wm3DBField('name'     ,WM3_cDB_CHAR),
            new wm3DBField('hits'     ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_states',
      array('countryID','code','name','hits'),
      array(
       array(105,'ag','Agrigento',            0),
       array(105,'al','Alessandria',          0),
       array(105,'an','Ancona',               0),
       array(105,'ao','Aosta',                0),
       array(105,'ap','Ascoli Piceno',        0),
       array(105,'aq','L\'Aquila',            0),
       array(105,'ar','Arezzo',               0),
       array(105,'at','Asti',                 0),
       array(105,'av','Avellino',             0),
       array(105,'ba','Bari',                 0),
       array(105,'bg','Bergamo',              0),
       array(105,'bi','Biella',               0),
       array(105,'bl','Belluno',              0),
       array(105,'bn','Benevento',            0),
       array(105,'bo','Bologna',              0),
       array(105,'br','Brindisi',             0),
       array(105,'bs','Brescia',              0),
       array(105,'bz','Bolzano-Bozen',        0),
       array(105,'ca','Cagliari',             0),
       array(105,'cb','Campobasso',           0),
       array(105,'ce','Caserta',              0),
       array(105,'ch','Chieti',               0),
       array(105,'cl','Caltanissetta',        0),
       array(105,'cn','Cuneo',                0),
       array(105,'co','Como',                 0),
       array(105,'cr','Cremona',              0),
       array(105,'cs','Cosenza',              0),
       array(105,'ct','Catania',              0),
       array(105,'cz','Catanzaro',            0),
       array(105,'en','Enna',                 0),
       array(105,'fe','Ferrara',              0),
       array(105,'fg','Foggia',               0),
       array(105,'fi','Firenze',              0),
       array(105,'fo','Forlì-Cesena',         0),
       array(105,'fr','Frosinone',            0),
       array(105,'ge','Genova',               0),
       array(105,'go','Gorizia',              0),
       array(105,'gr','Grosseto',             0),
       array(105,'im','Imperia',              0),
       array(105,'is','Isernia',              0),
       array(105,'kr','Crotone',              0),
       array(105,'lc','Lecco',                0),
       array(105,'le','Lecce',                0),
       array(105,'li','Livorno',              0),
       array(105,'lo','Lodi',                 0),
       array(105,'lt','Latina',               0),
       array(105,'lu','Lucca',                0),
       array(105,'mc','Macerata',             0),
       array(105,'me','Messina',              0),
       array(105,'mi','Milano',               0),
       array(105,'mn','Mantova',              0),
       array(105,'mo','Modena',               0),
       array(105,'ms','Massa-Carrara',        0),
       array(105,'mt','Matera',               0),
       array(105,'na','Napoli',               0),
       array(105,'no','Novara',               0),
       array(105,'nu','Nuoro',                0),
       array(105,'or','Oristano',             0),
       array(105,'pa','Palermo',              0),
       array(105,'pc','Piacenza',             0),
       array(105,'pd','Padova',               0),
       array(105,'pe','Pescara',              0),
       array(105,'pg','Perugia',              0),
       array(105,'pi','Pisa',                 0),
       array(105,'pn','Pordenone',            0),
       array(105,'po','Prato',                0),
       array(105,'pr','Parma',                0),
       array(105,'ps','Pesaro e urbino',      0),
       array(105,'pt','Pistoia',              0),
       array(105,'pv','Pavia',                0),
       array(105,'pz','Potenza',              0),
       array(105,'ra','Ravenna',              0),
       array(105,'rc','Reggio Calabria',      0),
       array(105,'re','Reggio Emilia',        0),
       array(105,'rg','Ragusa',               0),
       array(105,'ri','Rieti',                0),
       array(105,'rm','Roma',                 0),
       array(105,'rn','Rimini',               0),
       array(105,'ro','Rovigo',               0),
       array(105,'sa','Salerno',              0),
       array(105,'si','Siena',                0),
       array(105,'so','Sondrio',              0),
       array(105,'sp','La Spezia',            0),
       array(105,'sr','Siracusa',             0),
       array(105,'ss','Sassari',              0),
       array(105,'sv','Savona',               0),
       array(105,'ta','Taranto',              0),
       array(105,'te','Teramo',               0),
       array(105,'tn','Trento',               0),
       array(105,'to','Torino',               0),
       array(105,'tp','Trapani',              0),
       array(105,'tr','Terni',                0),
       array(105,'ts','Trieste',              0),
       array(105,'tv','Treviso',              0),
       array(105,'ud','Udine',                0),
       array(105,'va','Varese',               0),
       array(105,'vb','Verbano-Cusio-Ossola', 0),
       array(105,'vc','Vercelli',             0),
       array(105,'ve','Venezia',              0),
       array(105,'vi','Vicenza',              0),
       array(105,'vr','Verona',               0),
       array(105,'vt','Viterbo',              0),
       array(105,'vv','Vibo Valentia',        0),
       array(222,'aa','AA',                   0),
       array(222,'ae','AE',                   0),
       array(222,'ak','Alaska',               0),
       array(222,'al','Alabama',              0),
       array(222,'ap','AP',                   0),
       array(222,'ar','Arkansas',             0),
       array(222,'az','Arizona',              0),
       array(222,'ca','California',           0),
       array(222,'co','Colorado',             0),
       array(222,'ct','Connecticut',          0),
       array(222,'dc','District Of Columbia', 0),
       array(222,'de','Delaware',             0),
       array(222,'fl','Florida',              0),
       array(222,'fp','FP',                   0),
       array(222,'ga','Georgia',              0),
       array(222,'hi','Hawaii',               0),
       array(222,'ia','Iowa',                 0),
       array(222,'id','Idaho',                0),
       array(222,'il','Illinois',             0),
       array(222,'in','Indiana',              0),
       array(222,'ks','Kansas',               0),
       array(222,'ky','Kentucky',             0),
       array(222,'la','Louisiana',            0),
       array(222,'ma','Massachusetts',        0),
       array(222,'md','Maryland',             0),
       array(222,'me','Maine',                0),
       array(222,'mi','Michigan',             0),
       array(222,'mn','Minnesota',            0),
       array(222,'mo','Missouri',             0),
       array(222,'ms','Mississippi',          0),
       array(222,'mt','Montana',              0),
       array(222,'nc','North Carolina',       0),
       array(222,'nd','North Dakota',         0),
       array(222,'ne','Nebraska',             0),
       array(222,'nh','New Hampshire',        0),
       array(222,'nj','New Jersey',           0),
       array(222,'nm','New Mexico',           0),
       array(222,'nv','Nevada',               0),
       array(222,'ny','New York',             0),
       array(222,'oh','Ohio',                 0),
       array(222,'ok','Oklahoma',             0),
       array(222,'or','Oregon',               0),
       array(222,'pa','Pennsylvania',         0),
       array(222,'ri','Rhode Island',         0),
       array(222,'sc','South Carolina',       0),
       array(222,'sd','South Dakota',         0),
       array(222,'tn','Tennessee',            0),
       array(222,'tx','Texas',                0),
       array(222,'ut','Utah',                 0),
       array(222,'va','Virginia',             0),
       array(222,'vi','US Virgin Islands',    0),
       array(222,'vt','Vermont',              0),
       array(222,'wa','Washington',           0),
       array(222,'wi','Wisconsin',            0),
       array(222,'wv','West Virginia',        0),
       array(222,'wy','Wyoming',              0),
       array(36, 'ab','Alberta',              0),
       array(36, 'bc','British Columbia',     0),
       array(36, 'mb','Manitoba',             0),
       array(36, 'nb','New Brunswick',        0),
       array(36, 'nf','Newfoundland',         0),
       array(36, 'ns','Nova Scotia',          0),
       array(36, 'nt','Northwest Territories',0),
       array(36, 'nu','Nunavut',              0),
       array(36, 'on','Ontario',              0),
       array(36, 'pe','Prince Edward Island', 0),
       array(36, 'qc','Quebec',               0),
       array(36, 'sk','Saskatchewan',         0),
       array(36, 'yt','Yukon Territory',      0)
           )),

      new wm3DBCreateTable('_statistics_browsers',
      array(
            new wm3DBField('browserID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'     ,WM3_cDB_CHAR),
            new wm3DBField('hits'     ,WM3_cDB_BIGINT,20,0,true),
            new wm3DBField('icon'     ,WM3_cDB_CHAR),
            new wm3DBField('ts'       ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_statistics_browsers',
      array('name','hits','icon','ts'),
      array(
       array('Other',            0,'browser_other.png',        $setup_ts),
       array('Search engine',    0,'browser_search_engine.png',$setup_ts),
       array('Internet explorer',0,'browser_ie.png',           $setup_ts),
       array('Mozilla',          0,'browser_mozilla.png',      $setup_ts),
       array('Google chrome',    0,'browser_chrome.png',       $setup_ts),
       array('Netscape',         0,'browser_netscape.png',     $setup_ts),
       array('Opera',            0,'browser_opera.png',        $setup_ts),
       array('Konqueror',        0,'browser_konqueror.png',    $setup_ts),
       array('IBrowse',          0,'browser_ibrowse.png',      $setup_ts),
       array('Lynx',             0,'browser_lynx.png',         $setup_ts),
       array('WebTV',            0,'browser_webtv.png',        $setup_ts)
           )),

      new wm3DBCreateTable('_statistics_history',
      array(
            new wm3DBField('historyID'      ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('year'           ,WM3_cDB_INT,16),
            new wm3DBField('month'          ,WM3_cDB_INT,2),
            new wm3DBField('day'            ,WM3_cDB_INT,2),
            new wm3DBField('hour'           ,WM3_cDB_INT,2),
            new wm3DBField('day_of_the_week',WM3_cDB_INT,1),
            new wm3DBField('hits'           ,WM3_cDB_INT,16),
            new wm3DBField('ts'             ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_statistics_oses',
      array(
            new wm3DBField('osID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name',WM3_cDB_CHAR),
            new wm3DBField('hits',WM3_cDB_BIGINT,20,0,true),
            new wm3DBField('icon',WM3_cDB_CHAR),
            new wm3DBField('ts'  ,WM3_cDB_INT,16)
           )),

      new wm3DBInsertInto('_statistics_oses',
      array('name','hits','icon','ts'),
      array(
       array('Other',   0,'os_other.png',  $setup_ts),
       array('Windows', 0,'os_windows.png',$setup_ts),
       array('Linux',   0,'os_linux.png',  $setup_ts),
       array('Mac OS',  0,'os_macos.png',  $setup_ts),
       array('Sun OS',  0,'os_sunos.png',  $setup_ts),
       array('Be OS',   0,'os_beos.png',   $setup_ts),
       array('Amiga OS',0,'os_amigaos.png',$setup_ts),
       array('AIX',     0,'os_aix.png',    $setup_ts),
       array('Free BSD',0,'os_freebsd.png',$setup_ts),
       array('Irix',    0,'os_irix.png',   $setup_ts),
       array('OS 2',    0,'os_os2.png',    $setup_ts)
           )),

      new wm3DBCreateTable('_surveys',
      array(
            new wm3DBField('surveyID'   ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('title'      ,WM3_cDB_CHAR),
            new wm3DBField('question'   ,WM3_cDB_TEXT),
            new wm3DBField('render_mode',WM3_cDB_INT,5),
            new wm3DBField('target_type',WM3_cDB_INT,5),
            new wm3DBField('result_type',WM3_cDB_INT,5),
            new wm3DBField('layout_type',WM3_cDB_INT,5),
            new wm3DBField('closed'     ,WM3_cDB_INT,1),
            new wm3DBField('enabled'    ,WM3_cDB_INT,1),
            new wm3DBField('backID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('languageID' ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'         ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_surveys_items',
      array(
            new wm3DBField('survey_itemID',WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('surveyID'     ,WM3_cDB_BIGINT,20),
            new wm3DBField('answer'       ,WM3_cDB_TEXT),
            new wm3DBField('render_mode'  ,WM3_cDB_INT,5),
            new wm3DBField('votes'        ,WM3_cDB_INT,16),
            new wm3DBField('enabled'      ,WM3_cDB_INT,1),
            new wm3DBField('languageID'   ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'           ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_tags',
      array(
            new wm3DBField('tag'   ,WM3_cDB_CHAR,255,WM3_cDB_KEY),
            new wm3DBField('newsID',WM3_cDB_BIGINT,20)
           )),

      new wm3DBCreateTable('_users',
      array(
            new wm3DBField('userID'                 ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('groupID'                ,WM3_cDB_BIGINT,20),
            new wm3DBField('countryID'              ,WM3_cDB_BIGINT,20),
            new wm3DBField('stateID'                ,WM3_cDB_BIGINT,20),
            new wm3DBField('birth_countryID'        ,WM3_cDB_BIGINT,20),
            new wm3DBField('birth_stateID'          ,WM3_cDB_BIGINT,20),
            new wm3DBField('login'                  ,WM3_cDB_CHAR,255,WM3_cDB_UNIQUE | WM3_cDB_NOT_NULL,true),
            new wm3DBField('password'               ,WM3_cDB_CHAR,32),
            new wm3DBField('name'                   ,WM3_cDB_CHAR),
            new wm3DBField('surname'                ,WM3_cDB_CHAR),
            new wm3DBField('address'                ,WM3_cDB_CHAR),
            new wm3DBField('zip_code'               ,WM3_cDB_CHAR,5),
            new wm3DBField('city'                   ,WM3_cDB_CHAR),
            new wm3DBField('phone'                  ,WM3_cDB_CHAR),
            new wm3DBField('fax'                    ,WM3_cDB_CHAR),
            new wm3DBField('cell'                   ,WM3_cDB_CHAR),
            new wm3DBField('msn'                    ,WM3_cDB_CHAR),
            new wm3DBField('skype'                  ,WM3_cDB_CHAR),
            new wm3DBField('icq'                    ,WM3_cDB_CHAR),
            new wm3DBField('email'                  ,WM3_cDB_CHAR,255,WM3_cDB_UNIQUE),
            new wm3DBField('website'                ,WM3_cDB_CHAR),
            new wm3DBField('birth_date'             ,WM3_cDB_DATE),
            new wm3DBField('birth_city'             ,WM3_cDB_CHAR),
            new wm3DBField('gender'                 ,WM3_cDB_CHAR,1),
            new wm3DBField('tax_code'               ,WM3_cDB_CHAR),
            new wm3DBField('vat_code'               ,WM3_cDB_CHAR),
            new wm3DBField('avatar'                 ,WM3_cDB_CHAR),
            new wm3DBField('special'                ,WM3_cDB_INT,1),
            new wm3DBField('enabled'                ,WM3_cDB_INT,1),
            new wm3DBField('visible'                ,WM3_cDB_INT,1),
            new wm3DBField('deleted'                ,WM3_cDB_INT,1),
            new wm3DBField('admin'                  ,WM3_cDB_INT,1),
            new wm3DBField('superuser'              ,WM3_cDB_INT,1),
            new wm3DBField('f1'                     ,WM3_cDB_INT,1),
            new wm3DBField('f2'                     ,WM3_cDB_INT,1),
            new wm3DBField('f3'                     ,WM3_cDB_INT,1),
            new wm3DBField('f4'                     ,WM3_cDB_INT,1),
            new wm3DBField('f5'                     ,WM3_cDB_INT,1),
            new wm3DBField('f6'                     ,WM3_cDB_INT,1),
            new wm3DBField('f7'                     ,WM3_cDB_INT,1),
            new wm3DBField('f8'                     ,WM3_cDB_INT,1),
            new wm3DBField('last_user_login_ts'     ,WM3_cDB_INT,16),
            new wm3DBField('previous_user_login_ts' ,WM3_cDB_INT,16),
            new wm3DBField('af1'                    ,WM3_cDB_INT,1),
            new wm3DBField('af2'                    ,WM3_cDB_INT,1),
            new wm3DBField('af3'                    ,WM3_cDB_INT,1),
            new wm3DBField('af4'                    ,WM3_cDB_INT,1),
            new wm3DBField('af5'                    ,WM3_cDB_INT,1),
            new wm3DBField('af6'                    ,WM3_cDB_INT,1),
            new wm3DBField('af7'                    ,WM3_cDB_INT,1),
            new wm3DBField('af8'                    ,WM3_cDB_INT,1),
            new wm3DBField('af9'                    ,WM3_cDB_INT,1),
            new wm3DBField('af10'                   ,WM3_cDB_INT,1),
            new wm3DBField('af11'                   ,WM3_cDB_INT,1),
            new wm3DBField('af12'                   ,WM3_cDB_INT,1),
            new wm3DBField('af13'                   ,WM3_cDB_INT,1),
            new wm3DBField('af14'                   ,WM3_cDB_INT,1),
            new wm3DBField('af15'                   ,WM3_cDB_INT,1),
            new wm3DBField('af16'                   ,WM3_cDB_INT,1),
            new wm3DBField('af17'                   ,WM3_cDB_INT,1),
            new wm3DBField('af18'                   ,WM3_cDB_INT,1),
            new wm3DBField('af19'                   ,WM3_cDB_INT,1),
            new wm3DBField('af20'                   ,WM3_cDB_INT,1),
            new wm3DBField('af21'                   ,WM3_cDB_INT,1),
            new wm3DBField('af22'                   ,WM3_cDB_INT,1),
            new wm3DBField('af23'                   ,WM3_cDB_INT,1),
            new wm3DBField('af24'                   ,WM3_cDB_INT,1),
            new wm3DBField('af25'                   ,WM3_cDB_INT,1),
            new wm3DBField('af26'                   ,WM3_cDB_INT,1),
            new wm3DBField('af27'                   ,WM3_cDB_INT,1),
            new wm3DBField('af28'                   ,WM3_cDB_INT,1),
            new wm3DBField('af29'                   ,WM3_cDB_INT,1),
            new wm3DBField('af30'                   ,WM3_cDB_INT,1),
            new wm3DBField('af31'                   ,WM3_cDB_INT,1),
            new wm3DBField('af32'                   ,WM3_cDB_INT,1),
            new wm3DBField('af33'                   ,WM3_cDB_INT,1),
            new wm3DBField('af34'                   ,WM3_cDB_INT,1),
            new wm3DBField('af35'                   ,WM3_cDB_INT,1),
            new wm3DBField('af36'                   ,WM3_cDB_INT,1),
            new wm3DBField('af37'                   ,WM3_cDB_INT,1),
            new wm3DBField('af38'                   ,WM3_cDB_INT,1),
            new wm3DBField('af39'                   ,WM3_cDB_INT,1),
            new wm3DBField('af40'                   ,WM3_cDB_INT,1),
            new wm3DBField('last_admin_login_ts'    ,WM3_cDB_INT,16),
            new wm3DBField('previous_admin_login_ts',WM3_cDB_INT,16),
            new wm3DBField('notes'                  ,WM3_cDB_TEXT),
            new wm3DBField('languageID'             ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                     ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_users_messages',
      array(
            new wm3DBField('messageID'            ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('toID'                 ,WM3_cDB_BIGINT,20),
            new wm3DBField('fromID'               ,WM3_cDB_BIGINT,20),
            new wm3DBField('subject'              ,WM3_cDB_CHAR),
            new wm3DBField('message'              ,WM3_cDB_TEXT),
            new wm3DBField('message_read'         ,WM3_cDB_INT,1),
            new wm3DBField('message_replied'      ,WM3_cDB_INT,1),
            new wm3DBField('message_high_priority',WM3_cDB_INT,1),
            new wm3DBField('enabled'              ,WM3_cDB_INT,1),
            new wm3DBField('languageID'           ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                   ,WM3_cDB_INT,16)
           )),

      new wm3DBCreateTable('_webmail_servers',
      array(
            new wm3DBField('serverID'               ,WM3_cDB_BIGINT,20,WM3_cDB_PRIMARY_KEY | WM3_cDB_AUTO_INCREMENT),
            new wm3DBField('name'                   ,WM3_cDB_CHAR),
            new wm3DBField('in_suffix'              ,WM3_cDB_CHAR),
            new wm3DBField('in_use_suffix'          ,WM3_cDB_INT,1),
            new wm3DBField('in_address'             ,WM3_cDB_CHAR),
            new wm3DBField('in_port'                ,WM3_cDB_INT,16),
            new wm3DBField('in_protocol'            ,WM3_cDB_INT,5),
            new wm3DBField('out_login'              ,WM3_cDB_CHAR),
            new wm3DBField('out_password'           ,WM3_cDB_CHAR),
            new wm3DBField('out_address'            ,WM3_cDB_CHAR),
            new wm3DBField('out_port'               ,WM3_cDB_INT,16),
            new wm3DBField('out_authentication_type',WM3_cDB_INT,5),
            new wm3DBField('out_use_internal'       ,WM3_cDB_INT,1),
            new wm3DBField('visibility'             ,WM3_cDB_INT,5),
            new wm3DBField('enabled'                ,WM3_cDB_INT,1),
            new wm3DBField('languageID'             ,WM3_cDB_BIGINT,20),
            new wm3DBField('ts'                     ,WM3_cDB_INT,16)
           )));

     for($i = 0; $i < sizeof($_DB_RESET); $i++) $db->query($_DB_RESET[$i]);
     $db->close();
    }

   public static function deleteDatabase()
    {
     // Delete query (delete all database tables and its contents)
     $db = new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX);

     $_ARRAY = $db->resultToArray($db->listTables(),false);
     for($i = 0; $i < sizeof($_ARRAY); $i++)
      {
       $db->query("LOCK TABLES ".$_ARRAY[$i][0]." WRITE");
       $db->query("DROP TABLE IF EXISTS ".$_ARRAY[$i][0]);
       $db->query("UNLOCK TABLES");
      }
    }

   public static function updateDatabase28to30()
    {
     // Update query (2.8 to 3.0)
     $update_ts = time();
     $db = new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX);

	 $forums_posts_total         = $db->getNextAutoIncrementID(WM3_cCONFIG_DB_PREFIX."_forum_reply") - 1; // TODO Controllare permessi di mysql per questa operazione	 
	 $users_next_auto_increment  = $db->getNextAutoIncrementID(WM3_cCONFIG_DB_PREFIX."_utenti"); // TODO Controllare permessi di mysql per questa operazione
	 $dummy_market_subcategoryID = $db->getFirstRowField(WM3_cCONFIG_DB_PREFIX."_argomenti_mer","arg_merID"); // Exists at least one market subcategory

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_country
                      TO           ".WM3_cCONFIG_DB_PREFIX."_countries";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_province
                      TO           ".WM3_cCONFIG_DB_PREFIX."_states";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_states
                      CHANGE provinceID stateID bigint(20) auto_increment,
					  ADD    countryID          bigint(20) AFTER stateID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_states
                      SET   countryID    = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = 'us')
					  WHERE country_code = 'us'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_states
                      SET   countryID    = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = 'ca')
					  WHERE country_code = 'ca'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_states
                      SET   countryID    = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = 'it')
					  WHERE country_code = 'it'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_states
					  DROP COLUMN country_code";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_lingue
                      TO           ".WM3_cCONFIG_DB_PREFIX."_languages";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_languages
                      CHANGE linguaID languageID bigint(20) auto_increment,
                      CHANGE nome     name       char(255),
                      CHANGE attiva   enabled    int(1)";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_en.png',file = 'language_en.php' WHERE languageID = '".WM3_cLANGUAGE_EN."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_it.png',file = 'language_it.php' WHERE languageID = '".WM3_cLANGUAGE_IT."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_fr.png',file = 'language_fr.php' WHERE languageID = '".WM3_cLANGUAGE_FR."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_de.png',file = 'language_de.php' WHERE languageID = '".WM3_cLANGUAGE_DE."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_es.png',file = 'language_es.php' WHERE languageID = '".WM3_cLANGUAGE_ES."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET flag = 'flag_nl.png',file = 'language_nl.php' WHERE languageID = '".WM3_cLANGUAGE_NL."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_blk
                      TO           ".WM3_cCONFIG_DB_PREFIX."_panels_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                      CHANGE arg_blockID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_pic     icon        char(255),
                      CHANGE ling        languageID  bigint(20),
                      ADD    enabled     int(1)      AFTER icon,
                      ADD    position    int(5)      AFTER categoryID,
                      ADD    ts          int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories
	                  SET ts = UNIX_TIMESTAMP(data), position = '0', enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels_categories
					  DROP COLUMN data,
					  DROP INDEX  arg_name";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_MESSAGES'       WHERE categoryID = '".WM3_cPANEL_CATEGORY_MESSAGES."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_LOGIN'          WHERE categoryID = '".WM3_cPANEL_CATEGORY_LOGIN."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_CHANNELS'       WHERE categoryID = '".WM3_cPANEL_CATEGORY_CHANNELS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SEARCH'         WHERE categoryID = '".WM3_cPANEL_CATEGORY_SEARCH."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_HOROSCOPE'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_HOROSCOPE."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_NEWSLETTER'     WHERE categoryID = '".WM3_cPANEL_CATEGORY_NEWSLETTER."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SEND_TO_FRIEND' WHERE categoryID = '".WM3_cPANEL_CATEGORY_SEND_TO_FRIEND."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_LANGUAGES'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_LANGUAGES."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_ECOMMERCE'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_ECOMMERCE."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SURVEY'         WHERE categoryID = '".WM3_cPANEL_CATEGORY_SURVEY."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_FORTUNE'        WHERE categoryID = '".WM3_cPANEL_CATEGORY_FORTUNE."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_RSS_FEEDS'      WHERE categoryID = '".WM3_cPANEL_CATEGORY_RSS_FEEDS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_BIRTHDAY'       WHERE categoryID = '".WM3_cPANEL_CATEGORY_BIRTHDAY."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels_categories SET name = 'PANEL_SPECIAL_OFFER'  WHERE categoryID = '".WM3_cPANEL_CATEGORY_SPECIAL_OFFER."'";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_panels_categories VALUES
					  ('','1000','PANEL_CUSTOM','','".WM3_cENABLED."','','$update_ts'),
					  ('','500','PANEL_EXPANSION','','".WM3_cENABLED."','','$update_ts')";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_pag
                      TO           ".WM3_cCONFIG_DB_PREFIX."_pages_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                      CHANGE arg_pagID   categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_pic     icon        char(255),
                      CHANGE ling        languageID  bigint(20),
					  ADD    enabled     int(1)      AFTER icon,
                      ADD    position    int(5)      AFTER categoryID,
                      ADD    ts          int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories
	                  SET ts = UNIX_TIMESTAMP(data), position = '0', enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages_categories
					  DROP COLUMN data,
					  DROP INDEX  arg_name";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_MARKET'            WHERE categoryID = '".WM3_cPAGE_CATEGORY_MARKET."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_FAQ'               WHERE categoryID = '".WM3_cPAGE_CATEGORY_FAQ."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_SEARCH_ENGINE'     WHERE categoryID = '".WM3_cPAGE_CATEGORY_SEARCH_ENGINE."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_USER_REGISTRATION' WHERE categoryID = '".WM3_cPAGE_CATEGORY_USER_REGISTRATION."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_LINKS'             WHERE categoryID = '".WM3_cPAGE_CATEGORY_LINKS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_STATISTICS'        WHERE categoryID = '".WM3_cPAGE_CATEGORY_STATISTICS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_USER_INFORMATIONS' WHERE categoryID = '".WM3_cPAGE_CATEGORY_USER_INFORMATIONS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_FORUMS'            WHERE categoryID = '".WM3_cPAGE_CATEGORY_FORUMS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_DOWNLOADS'         WHERE categoryID = '".WM3_cPAGE_CATEGORY_DOWNLOADS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_GUESTBOOKS'        WHERE categoryID = '".WM3_cPAGE_CATEGORY_GUESTBOOKS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_DIRECTORIES'       WHERE categoryID = '".WM3_cPAGE_CATEGORY_DIRECTORIES."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_MEDIA_ALBUMS'      WHERE categoryID = '".WM3_cPAGE_CATEGORY_MEDIA_ALBUMS."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_CONTACT'           WHERE categoryID = '".WM3_cPAGE_CATEGORY_CONTACT."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_CHAT'              WHERE categoryID = '".WM3_cPAGE_CATEGORY_CHAT."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages_categories SET name = 'PAGE_WEBMAIL'           WHERE categoryID = '".WM3_cPAGE_CATEGORY_WEBMAIL."'";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_pages_categories VALUES
	                  ('','1000','PAGE_CUSTOM','','".WM3_cENABLED."','','$update_ts'),
					  ('','500','PAGE_EXPANSION','','".WM3_cENABLED."','','$update_ts')";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_bar
                      TO           ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                      CHANGE arg_barID   categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_pic     icon        char(255),
                      CHANGE ling        languageID  bigint(20),
					  ADD    enabled     int(1)      AFTER icon,
                      ADD    position    int(5)      AFTER categoryID,
                      ADD    ts          int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
	                  SET ts = UNIX_TIMESTAMP(data), position = '0', enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
					  DROP COLUMN data,
					  DROP INDEX  arg_name";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_CHANNEL'  WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_CHANNEL."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_HOME'     WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_HOME."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_ADMIN'    WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_ADMIN."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_USER'     WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_USER."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories SET name = 'MENU_BAR_ITEM_EXTERNAL' WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_EXTERNAL."'";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                      VALUES('','1000','MENU_BAR_ITEM_CUSTOM','','".WM3_cENABLED."','','$update_ts')";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_blocchi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_panels";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels
                      CHANGE blockID      panelID    bigint(20) auto_increment,
                      CHANGE titolo       title      char(255),
                      CHANGE testoup      head       text,
                      CHANGE testo        body       text,
                      CHANGE testodown    foot       text,
                      CHANGE posizione    position   int(5),
                      CHANGE allineamento align      int(5),
                      CHANGE ling         languageID bigint(20),
					  ADD    categoryID   bigint(20) AFTER panelID,
					  ADD    extraID      bigint(20) AFTER categoryID,
					  ADD    enabled      int(1)     AFTER tipo,
					  ADD    render_mode  int(5)     AFTER foot,
					  ADD    expansion    char(255)  AFTER foot,
                      ADD    ts           int(16)    AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      categoryID  = argomento,
						  extraID     = extra,
						  expansion   = '',
					      enabled     = attivo,
	                      ts          = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels
					  DROP COLUMN data,
					  DROP COLUMN argomento,
					  DROP COLUMN extra,
					  DROP COLUMN attivo,
					  DROP COLUMN tipo";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                      SET   categoryID = '".WM3_cPANEL_CATEGORY_CUSTOM."'
                      WHERE categoryID = '0'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_pagine
                      TO           ".WM3_cCONFIG_DB_PREFIX."_pages";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages
                      CHANGE pagID       pageID               bigint(20) auto_increment,
                      CHANGE titolo      title                char(255),
                      CHANGE sottotitolo subtitle             char(255),
                      CHANGE testa       head                 text,
                      CHANGE html        body                 text,
                      CHANGE coda        foot                 text,
                      CHANGE visibilita  visibility           int(5),
                      CHANGE sin         left_panels_enabled  int(1),
                      CHANGE des         right_panels_enabled int(1),
                      CHANGE tipo        page_type            int(5),
                      CHANGE ling        languageID           bigint(20),
					  ADD    categoryID  bigint(20)           AFTER groupID,
					  ADD    backID      bigint(20)           AFTER categoryID,
					  ADD    enabled     int(1)               AFTER hits,
					  ADD    render_mode int(5)               AFTER foot,
					  ADD    expansion   char(255)            AFTER foot,
                      ADD    ts          int(16)              AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
	                  SET ts = UNIX_TIMESTAMP(data), categoryID = argomento, expansion = '', backID = '0', enabled = attivo, render_mode = '".WM3_cRENDER_MODE_HTML."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages
	                  DROP COLUMN data,
					  DROP COLUMN argomento,
					  DROP COLUMN attivo,
					  DROP COLUMN back,
					  DROP COLUMN bcanID,
					  DROP COLUMN arg_canID,
					  DROP COLUMN canID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   left_panels_enabled =  '".WM3_cDISABLED."'
                      WHERE left_panels_enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   right_panels_enabled =  '".WM3_cDISABLED."'
                      WHERE right_panels_enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   categoryID = '".WM3_cPAGE_CATEGORY_CUSTOM."'
                      WHERE categoryID = '0'";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_pages
                       (
                        page_sessionID bigint(20) primary key auto_increment,
                        pageID         bigint(20),
                        sessionID      bigint(20),
                        userID         bigint(20),
                        session_type   int(5)
                       )";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_barra
                      TO           ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      CHANGE barID     menu_bar_itemID bigint(20) auto_increment,
                      CHANGE link      linkID          bigint(20),
                      CHANGE argomento categoryID      bigint(20),
                      CHANGE pos       position        int(5),
                      CHANGE attivo    enabled         int(1),
                      CHANGE ling      languageID      bigint(20),
					  ADD    title     char(255)       AFTER categoryID,
                      ADD    ts        int(16)         AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
	                  SET ts    = UNIX_TIMESTAMP(data),
					      title = name";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
					  DROP COLUMN data,
					  DROP COLUMN name";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      SET   categoryID = '".WM3_cMENU_ITEM_CATEGORY_CUSTOM."'
                      WHERE categoryID = '0'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_utenti
                      TO           ".WM3_cCONFIG_DB_PREFIX."_users";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users
                      CHANGE nome                    name        char(255),
                      CHANGE cognome                 surname     char(255),
                      CHANGE indirizzo               address     char(255),
                      CHANGE cap                     zip_code    char(5),
                      CHANGE citta                   city        char(255),
                      CHANGE tel                     phone       char(255),
                      CHANGE sitoweb                 website     char(255),
                      CHANGE natoil                  birth_date  date,
                      CHANGE natoa                   birth_city  char(255),
                      CHANGE sesso                   gender      char(1),
                      CHANGE foto                    avatar      char(255),
                      CHANGE socio                   special     int(1),
                      CHANGE attivo                  enabled     int(1),
                      CHANGE visibile                visible     int(1),
                      CHANGE cancellato              deleted     int(1),
                      CHANGE isadmin                 admin       int(1),
                      CHANGE ling                    languageID  bigint(20),
					  ADD    countryID               bigint(20)  AFTER groupID,
					  ADD    stateID                 bigint(20)  AFTER countryID,
					  ADD    birth_countryID         bigint(20)  AFTER stateID,
					  ADD    birth_stateID           bigint(20)  AFTER birth_countryID,
                      ADD    superuser               int(1)      AFTER admin,
					  ADD    ts                      int(16)     AFTER languageID,
                      ADD    last_user_login_ts      int(16)     AFTER f8,
					  ADD    previous_user_login_ts  int(16)     AFTER last_user_login_ts,
					  ADD    last_admin_login_ts     int(16)     AFTER af40,
					  ADD    previous_admin_login_ts int(16)     AFTER last_admin_login_ts,
					  ADD    notes                   text        AFTER previous_admin_login_ts,
                      DROP COLUMN                    ats,
					  DROP COLUMN                    prov_st,
					  DROP COLUMN                    natopr_st";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
	                  SET ts                      = UNIX_TIMESTAMP(data),
					      last_user_login_ts      = UNIX_TIMESTAMP(lastlog),
						  previous_user_login_ts  = UNIX_TIMESTAMP(lastlog),
						  last_admin_login_ts     = UNIX_TIMESTAMP(alastlog),
						  previous_admin_login_ts = UNIX_TIMESTAMP(alastlog),
						  notes                   = note,
						  countryID               = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = state),
						  birth_countryID         = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = bstate),
						  stateID                 = (SELECT stateID   FROM ".WM3_cCONFIG_DB_PREFIX."_states    WHERE code = prov
						                             AND countryID = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = state)),
						  birth_stateID           = (SELECT stateID   FROM ".WM3_cCONFIG_DB_PREFIX."_states    WHERE code = natopr
						                             AND countryID = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE name = bstate))";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users
	                  DROP COLUMN newsletter,
					  DROP COLUMN data,
					  DROP COLUMN lastlog,
					  DROP COLUMN alastlog,
					  DROP COLUMN note,
					  DROP COLUMN state,
					  DROP COLUMN bstate,
					  DROP COLUMN prov,
					  DROP COLUMN natopr";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET countryID       = '0' WHERE countryID IS NULL";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET birth_countryID = '0' WHERE birth_countryID IS NULL";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET stateID         = '0' WHERE stateID IS NULL";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET birth_stateID   = '0' WHERE birth_stateID IS NULL";			  
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   special =  '".WM3_cDISABLED."'
                      WHERE special != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   visible =  '".WM3_cDISABLED."'
                      WHERE visible != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   deleted =  '".WM3_cDISABLED."'
                      WHERE deleted != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   admin =  '".WM3_cDISABLED."'
                      WHERE admin != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
                      SET   superuser = '".WM3_cDISABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users SET password = MD5(password)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users
                      CHANGE password password char(32)";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_bbs
                      TO           ".WM3_cCONFIG_DB_PREFIX."_users_messages";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users_messages
					  CHANGE bbsID           messageID             bigint(20) auto_increment,
                      CHANGE oggetto         subject               char(255),
                      CHANGE testo           message               text,
					  CHANGE flag            message_read          int(1),
					  CHANGE pri             message_high_priority int(1),
                      CHANGE attivo          enabled               int(1),
                      CHANGE ling            languageID            bigint(20),
					  ADD    ts              int(16)               AFTER languageID,
					  ADD    message_replied int(1)                AFTER message_read";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users_messages
	                  SET ts = UNIX_TIMESTAMP(data), message_replied = '".WM3_cDISABLED."', message_read = !message_read, enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users_messages
					  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_gruppi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_groups";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_groups
                      CHANGE nome        name        char(255),
                      CHANGE descrizione description text,
                      CHANGE pic         icon        char(255),
                      CHANGE attivo      enabled     int(1),
                      CHANGE ling        languageID  bigint(20),
					  CHANGE ts          temp        int(16),
					  CHANGE data        ts          int(16),
					  DROP COLUMN tipo";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_groups SET ts = temp";
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_groups DROP COLUMN temp";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_messaggi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_messages";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_messages
                      CHANGE msgID       messageID  bigint(20) auto_increment,
                      CHANGE testo       message    text,
                      CHANGE attivo      enabled    int(1),
                      CHANGE ling        languageID bigint(20),
					  ADD    categoryID  bigint(20) AFTER messageID,
					  ADD    render_mode int(5)     AFTER message,
					  ADD    message_ts  int(16)    AFTER render_mode,
                      ADD    ts          int(16)    AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      categoryID  = argomento,
					      message_ts  = UNIX_TIMESTAMP(immesso),
					      ts          = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_messages
	                  DROP COLUMN immesso,
					  DROP COLUMN argomento,
					  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_messages
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_oroscopo
                      TO           ".WM3_cCONFIG_DB_PREFIX."_horoscopes";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_horoscopes
                      CHANGE orosID      horoscopeID bigint(20) auto_increment,
                      CHANGE testo       message     text,
                      CHANGE ling        languageID  bigint(20),
					  ADD    render_mode int(5)      AFTER message,
                      ADD    ts          int(16)     AFTER languageID,
                      ADD    enabled     int(1)      AFTER p8";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_horoscopes
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  enabled     = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_horoscopes
	                  DROP COLUMN lastuse,
					  DROP COLUMN data,
				      DROP COLUMN lastuserID";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies
                       (
                        horoscope_dailyID bigint(20) primary key auto_increment,
                        horoscopeID       bigint(20),
						sign              int(5),
                        expire_ts         int(16),
						enabled           int(1),
						languageID        bigint(20),
						ts                int(16)
                       )";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_fortune
                      TO           ".WM3_cCONFIG_DB_PREFIX."_quotes";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_quotes
                      CHANGE fortuneID  quoteID     bigint(20) auto_increment,
                      CHANGE testo      quote       text,
                      CHANGE autore     author      char(255),
                      CHANGE anno       year        char(255),
                      CHANGE mestiere   occupation  char(255),
                      CHANGE url_autore author_url  char(255),
                      CHANGE ling       languageID  bigint(20),
					  ADD    render_mode int(5)     AFTER quote,
                      ADD    ts         int(16)     AFTER languageID,
                      ADD    enabled    int(1)      AFTER author_url";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_quotes
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  enabled     = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_quotes
	                  DROP COLUMN lastuse,
					  DROP COLUMN data,
					  DROP COLUMN lastuserID";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_not
                      TO           ".WM3_cCONFIG_DB_PREFIX."_news_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news_categories
                      CHANGE arg_notID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE ling      languageID  bigint(20),
                      ADD    enabled   int(1)      AFTER icon,
					  ADD    ts        int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news_categories
					  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_notizie
                      TO           ".WM3_cCONFIG_DB_PREFIX."_news";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news
                      CHANGE notID       newsID     bigint(20) auto_increment,
                      CHANGE autore      userID     bigint(20),
                      CHANGE titolo      title      char(255),
                      CHANGE testo       news       text,
                      CHANGE ling        languageID bigint(20),
					  ADD    render_mode int(5)     AFTER news,
                      ADD    categoryID  bigint(20) AFTER newsID,
					  ADD    news_ts     int(16)    AFTER hits,
					  ADD    enabled     int(1)     AFTER news_ts,
					  ADD    ts          int(16)    AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
	                  SET render_mode = '".WM3_cRENDER_MODE_PLAIN_TEXT."',
					      categoryID  = argomento,
						  enabled     = attiva,
					      news_ts     = UNIX_TIMESTAMP(CONCAT(data,' ',ora)),
					      ts          = UNIX_TIMESTAMP(CONCAT(data,' ',ora))";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news
	                  DROP COLUMN argomento,
					  DROP COLUMN attiva,
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
                      SET   userID      = '$users_next_auto_increment',
					        render_mode = '".WM3_cRENDER_MODE_HTML."'
                      WHERE userID = '0'";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_news
                       (
                        news_sessionID bigint(20) primary key auto_increment,
                        newsID         bigint(20),
                        sessionID      bigint(20),
                        userID         bigint(20),
                        session_type   int(5)
                       )";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_newsletters
                      CHANGE oggetto             subject           char(255),
					  CHANGE testo               newsletter        text,
                      CHANGE formato             newsletter_format int(5),
                      CHANGE num_email           emails_sended     int(16),
                      CHANGE ling                languageID        bigint(20),
					  CHANGE ts                  temp              int(16),
					  CHANGE data                ts                int(16),
					  ADD    ignore_disabled     int(1)     AFTER  newsletterID,
					  ADD    user_gender         int(5)     AFTER  newsletterID,
					  ADD    newsletter_target   int(5)     AFTER  newsletterID,
					  ADD    newsletter_use_foot int(1)     AFTER  newsletter,
					  ADD    groupID             bigint(20) AFTER  newsletterID,
					  ADD    enabled             int(1)     AFTER  emails_sended,
					  DROP COLUMN simulazione";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters
	                  SET ignore_disabled     = '".WM3_cENABLED."',
					      newsletter_use_foot = '".WM3_cENABLED."',
						  user_gender         = '".WM3_cUSER_ALL."',
						  newsletter_target   = '".WM3_cNEWSLETTER_TARGET_MEMBERS."',
						  ts                  = temp,
						  groupID             = '0',
						  enabled             = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters DROP COLUMN temp";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_news_email
                      TO           ".WM3_cCONFIG_DB_PREFIX."_newsletters_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                      CHANGE nemailID newsletter_itemID bigint(20) auto_increment,
                      CHANGE ling     languageID  bigint(20),
                      ADD    ts       int(16)     AFTER languageID,
                      ADD    enabled  int(1)      AFTER email";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_ass
                      TO           ".WM3_cCONFIG_DB_PREFIX."_faqs_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
                      CHANGE arg_assID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE ling      languageID  bigint(20),
                      ADD    ts        int(16)     AFTER languageID,
                      ADD    enabled   int(1)      AFTER icon";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_assistenza
                      TO           ".WM3_cCONFIG_DB_PREFIX."_faqs";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs
                      CHANGE assID       faqID      bigint(20) auto_increment,
                      CHANGE domanda     question   char(255),
                      CHANGE risposta    answer     text,
                      CHANGE attivo      enabled    int(1),
                      CHANGE ling        languageID bigint(20),
					  ADD    render_mode int(5)     AFTER answer,
					  ADD    categoryID  bigint(20) AFTER faqID,
                      ADD    ts          int(16)    AFTER languageID,
					  DROP INDEX         domanda";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  categoryID  = argomento";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_faqs
	                  DROP COLUMN data,
					  DROP COLUMN argomento";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_faqs
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_lin
                      TO           ".WM3_cCONFIG_DB_PREFIX."_links_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links_categories
                      CHANGE arg_linID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE ling      languageID  bigint(20),
                      ADD    ts        int(16)     AFTER languageID,
                      ADD    enabled   int(1)      AFTER icon";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_links_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links_categories
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links
                      CHANGE linID       linkID      bigint(20) auto_increment,
                      CHANGE titolo      title       char(255),
					  CHANGE url         url         char(255),
                      CHANGE descrizione description text,
                      CHANGE attivo      enabled     int(1),
                      CHANGE ling        languageID  bigint(20),
					  ADD    render_mode int(5)      AFTER description,
					  ADD    categoryID  bigint(20)  AFTER linkID,
                      ADD    ts          int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_links
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data),
						  categoryID  = argomento";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_links
	                  DROP COLUMN data,
					  DROP COLUMN argomento";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_links
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_ricerca
                      TO           ".WM3_cCONFIG_DB_PREFIX."_search_engines_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                      CHANGE ricID       search_engine_itemID bigint(20) auto_increment,
                      CHANGE descrizione description          char(255),
                      CHANGE ling        languageID           bigint(20),
                      ADD    ts          int(16)              AFTER languageID,
                      ADD    enabled     int(1)               AFTER description";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_prod
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
                      CHANGE arg_prodID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name   name        char(255),
                      CHANGE arg_pic    icon        char(255),
                      CHANGE attivo     enabled     int(1),
                      CHANGE ling       languageID  bigint(20),
                      ADD    ts         int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_subargomenti_prod
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
                      CHANGE arg_subprodID subcategoryID bigint(20) auto_increment,
                      CHANGE arg_prodID    categoryID    bigint(20), 
                      CHANGE arg_name      name          char(255),
                      CHANGE arg_pic       icon          char(255),
                      CHANGE attivo        enabled       int(1),
                      CHANGE ling          languageID    bigint(20),
                      ADD    ts            int(16)       AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_prodotti
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      CHANGE prodID        productID         bigint(20) auto_increment,
                      CHANGE arg_subprodID subcategoryID     bigint(20),
                      CHANGE codice        code              char(255),
                      CHANGE nome          name              char(255),
                      CHANGE desc_breve    description       char(255),
                      CHANGE desc_lunga    full_description  text,
                      CHANGE posizione     align             int(5),
                      CHANGE prezzo        price             double,
                      CHANGE desc_prezzo   price_description char(255),
                      CHANGE sconto        discount          int(5),
                      CHANGE special       special           int(1),
                      CHANGE numero        stock             int(16),
                      CHANGE disp          availability      int(5),
                      CHANGE opzioni       options           text,
                      CHANGE attivo        enabled           int(1),
                      CHANGE ling          languageID        bigint(20),
					  ADD    render_mode   int(5)            AFTER full_description,
                      ADD    ts            int(16)           AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
	                  SET render_mode = '".WM3_cRENDER_MODE_PLAIN_TEXT."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      SET   special =  '".WM3_cDISABLED."'
                      WHERE special != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      SET   userID      = '$users_next_auto_increment',
					        render_mode = '".WM3_cRENDER_MODE_HTML."'
                      WHERE userID = '0'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_prodotti_pic
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                      CHANGE ppicID pictureID   bigint(20) auto_increment,
                      CHANGE prodID productID   bigint(20),
                      CHANGE pic    picture     char(255),
                      CHANGE tpic   thumbnail   char(255),
                      CHANGE descr  description char(255),
                      CHANGE attivo enabled     int(1),
                      CHANGE ling   languageID  bigint(20),
                      ADD    ts     int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                      SELECT '',productID,pic,tpic,alt,'".WM3_cENABLED."','0',ts
					  FROM   ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
	                  DROP COLUMN pic,
					  DROP COLUMN tpic,
					  DROP COLUMN alt";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_ordini
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
                      CHANGE ordID         orderID    bigint(20) auto_increment,
					  CHANGE stato         status     int(5),
                      CHANGE ling          languageID bigint(20),
					  CHANGE ts_ordine     order_ts   int(16),
                      ADD    ts            int(16)    AFTER languageID,
					  ADD    enabled       int(1)     AFTER status,
					  ADD    shipping_cost double     AFTER status";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
	                  SET order_ts      = UNIX_TIMESTAMP(data),
					      ts            = UNIX_TIMESTAMP(data),
						  status        = status + 1,
						  shipping_cost = (SELECT spese_sped FROM ".WM3_cCONFIG_DB_PREFIX."_pref),
						  enabled       = '".WM3_cENABLED."',
						  languageID    = '".WM3_cLANGUAGE_EN."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders
					  DROP COLUMN data,
					  DROP COLUMN carrID";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_carrello
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                      CHANGE carrID              cart_itemID bigint(20) auto_increment,
                      CHANGE prodID              productID   bigint(20),
					  CHANGE ordID               orderID     bigint(20),
                      CHANGE opzioni             options     text,
                      CHANGE quantita            quantity    int(16),
                      CHANGE prezzo              price       double,
                      CHANGE sconto              discount    int(5),
					  CHANGE attivo              enabled     int(1),
                      CHANGE ling                languageID  bigint(20),
					  ADD    product_description char(255)   AFTER orderID,
					  ADD    product_name        char(255)   AFTER orderID,
					  ADD    product_code        char(255)   AFTER orderID,
					  ADD    ts                  int(16)     AFTER data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
					  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                      SET   enabled =  '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
	                  SET product_code        = (SELECT code        FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.productID),
	                      product_name        = (SELECT name        FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.productID),
					      product_description = (SELECT description FROM ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products WHERE productID = ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items.productID)";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_comm_userfld
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                      CHANGE userfID      fieldID    bigint(20) auto_increment,
                      CHANGE tipo         type       int(5),
                      CHANGE lunghezza    size       int(16),
					  CHANGE appare       show_in    int(5),
					  CHANGE obbligatorio required   int(1),
					  CHANGE attivo       enabled    int(1),
                      CHANGE ling         languageID bigint(20),
                      ADD    ts           int(16)    AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields
                      SET   required =  '".WM3_cDISABLED."'
                      WHERE required != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_comm_userlab
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
                      CHANGE userlID labelID    bigint(20) auto_increment,
					  CHANGE userfID fieldID    bigint(20),
					  CHANGE attivo  enabled    int(1),					  
                      CHANGE ling    languageID bigint(20),
                      ADD    ts      int(16)    AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_comm_userdat
                      TO           ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                      CHANGE userdID dataID     bigint(20) auto_increment,
					  CHANGE prodID  productID  bigint(20),
					  CHANGE userfID fieldID    bigint(20),
					  CHANGE valore  value      char(255),					  
                      CHANGE ling    languageID bigint(20),
					  ADD    enabled int(1)     AFTER value,
                      ADD    ts      int(16)    AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
	                  SET ts = UNIX_TIMESTAMP(data), enabled  = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_survey
                      TO           ".WM3_cCONFIG_DB_PREFIX."_surveys";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys
                      CHANGE surID       surveyID    bigint(20) auto_increment,
                      CHANGE titolo      title       char(255),
                      CHANGE domanda     question    text,
                      CHANGE target      target_type int(5),
                      CHANGE pubblico    result_type int(5),
                      CHANGE layout      layout_type int(5),
                      CHANGE attivo      enabled     int(1),
                      CHANGE ling        languageID  bigint(20),
					  ADD    render_mode int(5)      AFTER question,
                      ADD    ts          int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_survey_item
                      TO           ".WM3_cCONFIG_DB_PREFIX."_surveys_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                      CHANGE sitID       survey_itemID bigint(20) auto_increment,
                      CHANGE surID       surveyID      char(255),
                      CHANGE risposta    answer        text,
                      CHANGE attivo      enabled       int(1),
                      CHANGE ling        languageID    bigint(20),
					  CHANGE hits        votes         int(16),
					  ADD    render_mode int(5)        AFTER answer,
                      ADD    ts          int(16)       AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys_items
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_survey_sess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
                      CHANGE sseID         survey_sessionID bigint(20) auto_increment,
					  ADD    survey_itemID bigint(20)       AFTER surveyID,
                      ADD    session_type  int(5)           AFTER userID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
	                  SET survey_itemID = surItemID,
					      session_type  = '".WM3_cSESSION_VOTE."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys
					  DROP COLUMN surItemID";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_metatags
                      CHANGE ling languageID bigint(20)";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_webmail_server
                      TO           ".WM3_cCONFIG_DB_PREFIX."_webmail_servers";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      CHANGE nome       name                    char(255),
                      CHANGE suffix     in_suffix               char(255),
                      CHANGE usesuffix  in_use_suffix           int(1),
                      CHANGE address    in_address              char(255),
                      CHANGE port       in_port                 int(16),
                      CHANGE protocol   in_protocol             int(5),
                      CHANGE outlogin   out_login               char(255),
                      CHANGE outpwd     out_password            char(255),
                      CHANGE outaddress out_address             char(255),
                      CHANGE outport    out_port                int(16),
                      CHANGE outtipo    out_authentication_type int(5),
                      CHANGE outuse     out_use_internal        int(1),
                      CHANGE visibilita visibility              int(5),
                      CHANGE attivo     enabled                 int(1),
                      CHANGE ling       languageID              bigint(20),
                      ADD    ts         int(16)                 AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
	                  SET ts          = UNIX_TIMESTAMP(data),
					      in_protocol = '".WM3_cWEBMAIL_SERVER_PROTOCOL_POP3."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      SET   out_use_internal =  '".WM3_cDISABLED."'
                      WHERE out_use_internal != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      SET   in_use_suffix =  '".WM3_cDISABLED."'
                      WHERE in_use_suffix != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_can
                      TO           ".WM3_cCONFIG_DB_PREFIX."_channels_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories
                      CHANGE arg_canID categoryID bigint(20) auto_increment,
                      CHANGE arg_name  name       char(255),
                      CHANGE arg_pic   icon       char(255),
                      CHANGE attivo    enabled    int(1),
                      CHANGE ling      languageID bigint(20),
                      ADD    ts        int(16)    AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_categories
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_canali
                      TO           ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
                      CHANGE canID      subcategoryID bigint(20) auto_increment,
                      CHANGE pic        icon          char(255),
                      CHANGE attivo     enabled       int(1),
                      CHANGE ling       languageID    bigint(20),
					  ADD    categoryID bigint(20)    AFTER subcategoryID,
                      ADD    ts         int(16)       AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
	                  SET categoryID = argomento,
	                      ts         = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
	                  DROP COLUMN data,
					  DROP COLUMN argomento";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_blocchi_can
                      TO           ".WM3_cCONFIG_DB_PREFIX."_channels_blocks";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      CHANGE bcanID        blockID       bigint(20) auto_increment,
                      CHANGE tipo          block_type    int(5),
                      CHANGE titolo        title         char(255),
					  CHANGE alt           alt           char(255),
                      CHANGE testo         description   text,
                      CHANGE pic           picture       char(255),
                      CHANGE attivo        enabled       int(1),
                      CHANGE ling          languageID    bigint(20),
					  ADD    render_mode   int(5)        AFTER description,
					  ADD    picture_align int(5)        AFTER picture,
					  ADD    linkID        bigint(20)    AFTER blockID,
					  ADD    subcategoryID bigint(20)    AFTER blockID,
                      ADD    ts            int(16)       AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
	                  SET render_mode   = '".WM3_cRENDER_MODE_HTML."',
					      linkID        = link,
					      picture_align = posizione,
					      subcategoryID = canID,
					      ts            = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
	                  DROP COLUMN canID,
					  DROP COLUMN link,
	                  DROP COLUMN arg_canID,
					  DROP COLUMN posizione,
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      SET   picture_align = '".WM3_cNO_IMAGE."'
                      WHERE picture_align = '".WM3_cALIGN_RIGHT."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      SET   picture_align = '".WM3_cALIGN_RIGHT."'
                      WHERE picture_align = '".WM3_cALIGN_CENTER."'";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_market_categories
                       (
                        categoryID bigint(20) primary key auto_increment,
                        name       char(255),
                        icon       char(255),
                        enabled    int(1),
                        languageID bigint(20),
                        ts         int(16)
                       )";
	 if($dummy_market_subcategoryID)
	  {
       $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_market_categories
	                    VALUES('','Temp category','bomb.png','".WM3_cENABLED."','".WM3_cLANGUAGE_EN."','$update_ts')";
	  }

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_mer
                      TO           ".WM3_cCONFIG_DB_PREFIX."_market_subcategories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
                      CHANGE arg_merID  subcategoryID bigint(20) auto_increment,                       
                      CHANGE arg_name   name       char(255),
                      CHANGE arg_pic    icon       char(255),
                      CHANGE ling       languageID bigint(20),
					  ADD    categoryID bigint(20) AFTER subcategoryID,
                      ADD    ts         int(16)    AFTER languageID,
                      ADD    enabled    int(1)     AFTER icon";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
	                  SET ts         = UNIX_TIMESTAMP(data),
					      categoryID = '1',
					      enabled    = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_mercatino
                      TO           ".WM3_cCONFIG_DB_PREFIX."_market_announcements";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                      CHANGE merID        announcementID    bigint(20) auto_increment,
                      CHANGE testo        announcement      text,
                      CHANGE tipo         announcement_type int(5),
					  CHANGE semprevalido always_valid      int(1),
                      CHANGE ling         languageID        bigint(20),
					  DROP COLUMN         nome,
					  DROP COLUMN         cognome,
					  DROP COLUMN         citta,
					  DROP COLUMN         prov,
					  DROP COLUMN         prov_st,
                      DROP COLUMN         sesso,
					  DROP COLUMN         email,
                      DROP COLUMN         state,
                      ADD  ts             int(16)           AFTER languageID,
					  ADD  title          char(255)         AFTER announcement,
					  ADD  render_mode    int(5)            AFTER announcement,
					  ADD  userID         bigint(20)        AFTER announcementID,
                      ADD  enabled        int(1)            AFTER always_valid,
                      ADD  subcategoryID  bigint(20)        AFTER announcementID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_market_announcements
	                  SET render_mode   = '".WM3_cRENDER_MODE_PLAIN_TEXT."',
					      ts            = UNIX_TIMESTAMP(data),
					      subcategoryID = argomento,
					      title         = '',
						  enabled       = '".WM3_cENABLED."',
						  userID        = '$users_next_auto_increment'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_market_announcements
	                  DROP COLUMN argomento,
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_dow
                      TO           ".WM3_cCONFIG_DB_PREFIX."_downloads_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
                      CHANGE arg_downID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name   name        char(255),
                      CHANGE arg_desc   description char(255),
                      CHANGE arg_pic    icon        char(255),
                      CHANGE ling       languageID  bigint(20),
                      ADD    ts         int(16)     AFTER languageID,
                      ADD    enabled    int(1)      AFTER icon";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_download_sub
                      TO           ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
                      CHANGE sub_downID subcategoryID bigint(20) auto_increment,
                      CHANGE arg_downID categoryID    bigint(20),
                      CHANGE sub_name   name          char(255),
                      CHANGE sub_desc   description   char(255),
                      CHANGE ling       languageID    bigint(20),
                      ADD    ts         int(16)       AFTER languageID,
                      ADD    icon       char(255)     AFTER description,
                      ADD    enabled    int(1)        AFTER icon";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
	                  SET ts = UNIX_TIMESTAMP(data), icon = '', enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
	                  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_download
                      TO           ".WM3_cCONFIG_DB_PREFIX."_downloads";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads
                      CHANGE downID      downloadID    bigint(20) auto_increment,
                      CHANGE sub_downID  subcategoryID bigint(20),
                      CHANGE down_name   name          char(255),
                      CHANGE down_desc   description   text,
                      CHANGE link        download      char(255),
                      CHANGE tipo        source        int(5),                   
                      CHANGE attivo      enabled       int(1),
                      CHANGE ling        languageID    bigint(20),
					  ADD    render_mode int(5)        AFTER description,
                      ADD    ts          int(16)       AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."',
					      ts          = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads
	                  DROP COLUMN arg_downID,
	                  DROP COLUMN size,
					  DROP COLUMN usize,
	                  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   source = '0'
                      WHERE source = '".WM3_cUPLOAD_FROM_URL."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   source = '".WM3_cUPLOAD_FROM_URL."'
                      WHERE source = '".WM3_cUPLOAD_FROM_REMOTE."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      SET   source = '".WM3_cUPLOAD_FROM_REMOTE."'
                      WHERE source = '0'";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_downloads
                       (
                        download_sessionID bigint(20) primary key auto_increment,
                        downloadID         bigint(20),
                        sessionID          bigint(20),
                        userID             bigint(20),
                        session_type       int(5)
                       )";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_commenti
                      TO           ".WM3_cCONFIG_DB_PREFIX."_news_comments";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news_comments
                      CHANGE comID       commentID  bigint(20) auto_increment,
                      CHANGE notID       newsID     bigint(20),
                      CHANGE testo       comment    text,
                      CHANGE attiva      enabled    int(1),
                      CHANGE ling        languageID bigint(20),
					  CHANGE ts          temp       int(16),
					  CHANGE data        ts         int(16),
					  ADD    render_mode int(5)     AFTER comment";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_comments
	                  SET render_mode = '".WM3_cRENDER_MODE_PLAIN_TEXT."', ts = temp";
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news_comments DROP COLUMN temp";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news_comments
                      SET   userID      = '$users_next_auto_increment', 
					        render_mode = '".WM3_cRENDER_MODE_HTML."'
                      WHERE userID      = '-1'";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions
                      CHANGE sesID   sessionID  bigint(20) auto_increment,
                      CHANGE codice  hash       char(255),
                      CHANGE expire  expire_ts  int(16),
					  ADD    tempID  bigint(20) AFTER sessionID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions
	                  SET tempID = userID";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions
	                  DROP COLUMN userID";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions
                      CHANGE tempID userID bigint(20)";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_actions
                       (
                        actionID  bigint(20) primary key auto_increment,
                        sessionID bigint(20),
                        action_ts int(16)
                       )";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers
                       (
                        browserID  bigint(20) primary key auto_increment,
                        name       char(255),
                        hits       bigint(20) unsigned,
                        icon       char(255),
                        ts         int(16)
                       )";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers
                      VALUES ('','Other',            (SELECT altro     FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_other.png',        '$update_ts'),
                             ('','Search engine',    (SELECT ricerca   FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_search_engine.png','$update_ts'),
                             ('','Internet explorer',(SELECT ie        FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_ie.png',           '$update_ts'),
							 ('','Mozilla',          '0',                                                      'browser_mozilla.png',      '$update_ts'),
							 ('','Google chrome',    '0',                                                      'browser_chrome.png',       '$update_ts'),
                             ('','Netscape',         (SELECT netscape  FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_netscape.png',     '$update_ts'),
                             ('','Opera',            (SELECT opera     FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_opera.png',        '$update_ts'),
                             ('','Konqueror',        (SELECT konqueror FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_konqueror.png',    '$update_ts'),
                             ('','IBrowse',          (SELECT ibrowse   FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_ibrowse.png',      '$update_ts'),
                             ('','Lynx',             (SELECT lynx      FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_lynx.png',         '$update_ts'),
                             ('','WebTV',            (SELECT webtv     FROM ".WM3_cCONFIG_DB_PREFIX."_br_stat),'browser_webtv.png',        '$update_ts')";
     $_DB_UPDATE[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_br_stat";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses
                       (
                        osID       bigint(20) primary key auto_increment,
                        name       char(255),
                        hits       bigint(20) unsigned,
                        icon       char(255),
                        ts         int(16)
                       )";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_statistics_oses
                      VALUES ('','Other',   (SELECT altro   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_other.png',  '$update_ts'),
                             ('','Windows', (SELECT windows FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_windows.png','$update_ts'),
                             ('','Linux',   (SELECT linux   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_linux.png',  '$update_ts'),
                             ('','Mac OS',  (SELECT macos   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_macos.png',  '$update_ts'),
                             ('','Sun OS',  (SELECT sunos   FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_sunos.png',  '$update_ts'),
                             ('','Be OS',   (SELECT beos    FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_beos.png',   '$update_ts'),
                             ('','Amiga OS',(SELECT amigaos FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_amigaos.png','$update_ts'),
                             ('','AIX',     (SELECT aix     FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_aix.png',    '$update_ts'),
                             ('','Free BSD',(SELECT freebsd FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_freebsd.png','$update_ts'),
                             ('','Irix',    (SELECT irix    FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_irix.png',   '$update_ts'),
                             ('','OS 2',    (SELECT os2     FROM ".WM3_cCONFIG_DB_PREFIX."_os_stat),'os_os2.png',    '$update_ts')";
     $_DB_UPDATE[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_os_stat";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_for
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                      CHANGE arg_forumID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name    name        char(255),
                      CHANGE arg_desc    description char(255),                         
                      CHANGE arg_pic     icon        char(255),
                      CHANGE attivo      enabled     int(1),                         
                      CHANGE ling        languageID  bigint(20),
                      ADD    ts          int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories
	                  SET ts = UNIX_TIMESTAMP(CONCAT(data,' ',ora))";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_categories
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_forum
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums
                      CHANGE titolo         title        char(255),
                      CHANGE attivo         enabled      int(1),
                      CHANGE ling           languageID   bigint(20),
                      CHANGE userID         temp_userID  bigint(20),
                      ADD    ts             int(16)      AFTER languageID,
                      ADD    visitors_open  int(1)       AFTER topic,
                      ADD    visitors_write int(1)       AFTER topic,
                      ADD    visitors_read  int(1)       AFTER topic,
                      ADD    users_open     int(1)       AFTER topic,
                      ADD    users_write    int(1)       AFTER topic,
                      ADD    users_read     int(1)       AFTER topic,
                      ADD    group_open     int(1)       AFTER topic,
					  ADD    categoryID     bigint(20)   AFTER forumID,
					  ADD    userID         bigint(20)   AFTER categoryID,
					  ADD    denied_words   text         AFTER visitors_open,
					  ADD    expire_days    int(16)      AFTER visitors_open";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
	                  SET ts             = UNIX_TIMESTAMP(CONCAT(data,' ',ora)),
					      visitors_open  = '".WM3_cENABLED."',
						  visitors_write = '".WM3_cENABLED."',
						  visitors_read  = '".WM3_cENABLED."',
						  users_open     = '".WM3_cENABLED."',
						  users_write    = '".WM3_cENABLED."',
						  users_read     = '".WM3_cENABLED."',
						  group_open     = '".WM3_cENABLED."',
						  categoryID     = arg_forumID,
						  userID         = temp_userID,
						  expire_days    = expiredays,
						  denied_words   = badwords";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   visitors_open = '".WM3_cDISABLED."'
                      WHERE write_dis != 1";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   visitors_write = '".WM3_cDISABLED."'
                      WHERE visibilita != 1";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   visitors_read = '".WM3_cDISABLED."'
                      WHERE visibilita = 3 OR visibilita > 4";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   users_open = '".WM3_cDISABLED."'
                      WHERE write_dis > 2";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   users_write = '".WM3_cDISABLED."'
                      WHERE visibilita > 4";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   users_read = '".WM3_cDISABLED."'
                      WHERE visibilita = 6";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   group_open = '".WM3_cDISABLED."'
                      WHERE write_dis > 3";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums
	                  DROP COLUMN arg_forumID,
					  DROP COLUMN temp_userID,
					  DROP COLUMN groupID,
					  DROP COLUMN expiredays,
					  DROP COLUMN badwords,
	                  DROP COLUMN visibilita,
                      DROP COLUMN write_dis,
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";

     $_DB_UPDATE[] = "DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forum_reply
                      WHERE  fraseID NOT IN (SELECT fraseID FROM ".WM3_cCONFIG_DB_PREFIX."_forum_frasi)";
     $_DB_UPDATE[] = "DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_forum_read
                      WHERE  fraseID NOT IN (SELECT fraseID FROM ".WM3_cCONFIG_DB_PREFIX."_forum_frasi)";
     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_forum_reply
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums_posts";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                      CHANGE replyID     postID       bigint(20) auto_increment,
					  CHANGE qreplyID    quoteID      bigint(20),
                      CHANGE testo       post         text,
                      CHANGE fraseID     discussionID bigint(20) AFTER postID,
                      CHANGE userID      userID       bigint(20) AFTER quoteID,
                      CHANGE forumID     forumID      bigint(20) AFTER discussionID,
					  ADD    title       char(255)    AFTER userID,
					  ADD    locked      int(1)       AFTER post,
					  ADD    render_mode int(5)       AFTER post,
                      ADD    hits        int(16)      AFTER locked,
                      ADD    enabled     int(1)       AFTER hits,
                      ADD    languageID  bigint(20)   AFTER enabled,
					  ADD    ts          int(16)      AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  SET render_mode = '".WM3_cRENDER_MODE_BB_CODE."',
					  ts              = UNIX_TIMESTAMP(CONCAT(data,' ',ora))";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  SET discussionID = (
					                      SELECT COUNT(*)
						                  FROM  ".WM3_cCONFIG_DB_PREFIX."_forum_frasi
						 				  WHERE ".WM3_cCONFIG_DB_PREFIX."_forum_frasi.fraseID <= discussionID
										 ) + $forums_posts_total";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  DROP COLUMN groupID,
					  DROP COLUMN censurato,
	                  DROP COLUMN ora,
					  DROP COLUMN data";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                      SELECT '','0',forumID,'0',userID,titolo,testo,'".WM3_cRENDER_MODE_BB_CODE."',locked,hits,'".WM3_cENABLED."','".WM3_cLANGUAGE_ALL."',UNIX_TIMESTAMP(CONCAT(data,' ',ora))
					  FROM   ".WM3_cCONFIG_DB_PREFIX."_forum_frasi
					  ORDER BY fraseID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
	                  SET enabled = '".WM3_cENABLED."', languageID = '".WM3_cLANGUAGE_ALL."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET title  = ''                  WHERE title  IS NULL";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET hits   = '0'                 WHERE hits   IS NULL";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts SET locked = '".WM3_cDISABLED."' WHERE locked IS NULL";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '-1'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_forum_read
                      TO           ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
	                  ADD    readID  bigint(20) primary key auto_increment FIRST,
                      CHANGE fraseID postID bigint(20)";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '-1'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read
	                  SET postID = (
					                SELECT COUNT(*)
						            FROM  ".WM3_cCONFIG_DB_PREFIX."_forum_frasi
						 		    WHERE ".WM3_cCONFIG_DB_PREFIX."_forum_frasi.fraseID <= postID
								   ) + $forums_posts_total";
     $_DB_UPDATE[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_forum_frasi";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_forums_posts
                       (
                        forum_post_sessionID bigint(20) primary key auto_increment,
                        forum_postID         bigint(20),
                        sessionID            bigint(20),
                        userID               bigint(20),
                        session_type         int(5)
                       )";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_rooms
                      TO           ".WM3_cCONFIG_DB_PREFIX."_chatrooms";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                      CHANGE roomID       chatroomID  bigint(20) auto_increment,
                      CHANGE nome         name        char(255),
                      CHANGE descr        topic       text,
                      CHANGE visibilita   visibility  int(5),
                      CHANGE ling         languageID  bigint(20),
                      ADD    enabled      int(1)      AFTER visibility,
                      DROP COLUMN         data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                      SET    enabled = '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_speak
                      TO           ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
                      CHANGE roomID       chatroomID  bigint(20),
                      CHANGE nick         nickname    char(255),
                      CHANGE frase        sentence    text,
                      CHANGE ling         languageID  bigint(20),
					  ADD    enabled      int(1)      AFTER sentence,
					  ADD    sentenceID   bigint(20)  primary key auto_increment FIRST";
     $_DB_UPDATE[] = "TRUNCATE TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_roomsess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                      CHANGE roomID             chatroomID bigint(20),
                      CHANGE nick               nickname   char(255),
					  CHANGE ts                 join_ts    int(16),
					  ADD    chatroom_sessionID bigint(20) primary key auto_increment FIRST,
					  ADD    ip                 char(255)  AFTER nickname,
					  ADD    expire_ts          int(16)    AFTER join_ts,
					  DROP COLUMN               csessID,
					  DROP COLUMN               stato,
					  DROP INDEX ts,
					  ADD  INDEX (join_ts)";
     $_DB_UPDATE[] = "TRUNCATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms";
	 $_DB_UPDATE[] = "DROP TABLE ".WM3_cCONFIG_DB_PREFIX."_chat_sess";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_argomenti_alb
                      TO           ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                      CHANGE arg_albID categoryID  bigint(20) auto_increment,
                      CHANGE arg_name  name        char(255),
                      CHANGE arg_desc  description char(255),
                      CHANGE arg_pic   icon        char(255),
                      CHANGE attivo    enabled     int(1),
                      CHANGE ling      languageID  bigint(20),
                      ADD    ts        int(16)     AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
	                  SET ts = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
					  DROP COLUMN data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_album
                      TO           ".WM3_cCONFIG_DB_PREFIX."_media_albums";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      CHANGE albumID       media_albumID    bigint(20) auto_increment,
                      CHANGE titolo        title            char(255),
                      CHANGE argomento     categoryID       bigint(20),
                      CHANGE descr         description      char(255),
                      CHANGE pic           icon             char(255),
                      CHANGE tipo          media_album_type int(5),
                      CHANGE attivo        enabled          int(1), 
                      CHANGE ling          languageID       bigint(20),
                      ADD    visitors_read int(1)           AFTER visibilita,
					  ADD    users_read    int(1)           AFTER visibilita,
					  ADD    group_read    int(1)           AFTER visibilita";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
	                  SET ts            = UNIX_TIMESTAMP(data),
						  visitors_read = '".WM3_cENABLED."',
						  users_read    = '".WM3_cENABLED."',
						  group_read    = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   visitors_read = '".WM3_cDISABLED."'
                      WHERE visibilita > 1";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   users_read = '".WM3_cDISABLED."'
                      WHERE visibilita > 2";					  
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums
					  DROP COLUMN data,
					  DROP COLUMN visibilita";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_album_item
                      TO           ".WM3_cCONFIG_DB_PREFIX."_media_albums_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      CHANGE ialbumID    media_album_itemID bigint(20) auto_increment,
                      CHANGE albumID     media_albumID      bigint(20),
                      CHANGE titolo      title              char(255),
                      CHANGE media_t     thumbnail          char(255),
                      CHANGE nvoti       votes_counts       int(16),
                      CHANGE totvoti     votes_sum          int(16),
                      CHANGE mediavoti   votes_average      float,
                      CHANGE fonte       source_media       int(5),
                      CHANGE tipo        source_thumbnail   int(5),
                      CHANGE attivo      enabled            int(1), 
                      CHANGE ling        languageID         bigint(20),
                      DROP COLUMN        data";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   source_media     = '0',
					        source_thumbnail = '0'
                      WHERE source_media = '".WM3_cUPLOAD_FROM_URL."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   source_media     = '".WM3_cUPLOAD_FROM_URL."',
					        source_thumbnail = '".WM3_cUPLOAD_FROM_URL."'
                      WHERE source_media = '".WM3_cUPLOAD_FROM_REMOTE."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      SET   source_media     = '".WM3_cUPLOAD_FROM_REMOTE."',
					        source_thumbnail = '".WM3_cUPLOAD_FROM_REMOTE."'
                      WHERE source_media = '0'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
					  DROP COLUMN argomento,
					  DROP COLUMN userID";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_album_sess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items
                      CHANGE asessID media_album_item_sessionID bigint(20) auto_increment,
                      CHANGE aitemID media_album_itemID         bigint(20),
                      CHANGE tipo    session_type               int(5)";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items
                      SET   userID = '".WM3_cUSER_ANONYMOUS."'
                      WHERE userID = '-1'";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners
                      CHANGE banID       bannerID    bigint(20) auto_increment,
                      CHANGE nome        title       char(255),
                      CHANGE html        banner      text,
                      CHANGE tipo        banner_type int(5),
                      CHANGE ling        languageID  bigint(20),
                      ADD    ts          int(16)     AFTER languageID,
                      ADD    enabled     int(1)      AFTER banner_type";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners
	                  SET ts = UNIX_TIMESTAMP(data), enabled = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners
					  DROP COLUMN data";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits
                       (
                        banner_exchange_creditID bigint(20) primary key auto_increment,
                        userID                   bigint(20),
                        credits                  bigint(20) unsigned,
						unlimited_credits        int(1),
                        ts                       int(16)
                       )";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits
                      SELECT '',userID,SUM(impressions),IF(SUM(inf_impr) > 0,1,0),'".$update_ts."'
					  FROM   ".WM3_cCONFIG_DB_PREFIX."_banners_rot
					  GROUP BY userID";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_rot
                      TO           ".WM3_cCONFIG_DB_PREFIX."_banners_exchange";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      CHANGE rbanID    bannerID          bigint(20) auto_increment,
                      CHANGE nome      title             char(255),
					  CHANGE etichetta banner_alt        char(255),
					  CHANGE url       banner_url        char(255),
					  CHANGE pic       banner_image      char(255),
                      CHANGE tipo      banner_source     int(5),
                      CHANGE ling      languageID        bigint(20),
					  CHANGE attivo    enabled           int(1),
					  CHANGE ts        temp              int(16),
					  CHANGE data      ts                int(16),
                      DROP COLUMN      pic_url,
					  DROP COLUMN      impressions,
					  DROP COLUMN      inf_impr,
					  CHANGE hits      impressions       bigint(20) unsigned";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
	                  SET languageID = '".WM3_cLANGUAGE_ALL."' WHERE any_lang = '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange SET ts = temp";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
					  DROP COLUMN  any_lang,
					  DROP COLUMN  temp";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   banner_source = '".WM3_cUPLOAD_FROM_REMOTE."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   banner_source = '".WM3_cUPLOAD_FROM_URL."'
                      WHERE banner_image  = ''";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_banners_exchange
                       (
                        banner_exchange_sessionID bigint(20) primary key auto_increment,
                        banner_exchangeID         bigint(20),
                        sessionID                 bigint(20),
                        userID                    bigint(20),
                        session_type              int(5)
                       )";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_pref
                      TO           ".WM3_cCONFIG_DB_PREFIX."_preferences";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences
                      CHANGE log_on      logging_enabled                   int(1),
                      CHANGE id_ban1     banner1ID                         bigint(20),
                      CHANGE id_ban2     banner2ID                         bigint(20),
                      CHANGE id_ban3     banner3ID                         bigint(20),
                      CHANGE id_ban4     banner4ID                         bigint(20),
                      CHANGE id_ban5     banner5ID                         bigint(20),
                      CHANGE id_ban6     banner6ID                         bigint(20),
                      CHANGE id_ban7     banner7ID                         bigint(20),
                      CHANGE id_ban8     banner8ID                         bigint(20),
                      CHANGE id_ban9     banner9ID                         bigint(20),
					  CHANGE logo        logo                              char(255),
                      CHANGE logox       logo_width                        int(5),
                      CHANGE logoy       logo_height                       int(5),
                      CHANGE site_addr   site_address                      char(255),
                      CHANGE wm_email    webmaster_email                   char(255),
                      CHANGE serv_email  service_email                     char(255),
                      CHANGE condat      foot_content                      int(5),
                      CHANGE num_notizie home_news_max                     int(16),
                      CHANGE usr_act     user_enabled                      int(1),
                      CHANGE usr_spe     user_special                      int(1),                      
                      CHANGE usr_fl1     user_flag1                        int(1),
                      CHANGE usr_fl2     user_flag2                        int(1),
                      CHANGE usr_fl3     user_flag3                        int(1),
                      CHANGE usr_fl4     user_flag4                        int(1),
                      CHANGE usr_fl5     user_flag5                        int(1),
                      CHANGE usr_fl6     user_flag6                        int(1),
                      CHANGE usr_fl7     user_flag7                        int(1),                                                                  
                      CHANGE usr_fl8     user_flag8                        int(1),
                      CHANGE usr_gID     user_groupID                      bigint(20),
                      CHANGE num_nl      show_total_newsletter             int(1),
                      CHANGE num_seg     show_total_signalations           int(1),
                      CHANGE num_mot     show_total_search_engine          int(1),
                      CHANGE num_vis_usr show_online_users_visitors        int(1),
                      CHANGE show_not    show_home_news                    int(1),
                      CHANGE full_not    show_full_news                    int(1),
                      CHANGE show_cnot   enable_news_comments              int(1),
                      CHANGE anon_cnot   anonymous_news_comments           int(1),
                      CHANGE show_hcan   show_home_channels                int(1),
                      CHANGE anon_post   anonymous_write_news              int(1),
                      CHANGE anon_postac anonymous_enabled_news            int(1),
                      CHANGE anon_diradd anonymous_add_directories         int(1),
                      CHANGE anon_diract anonymous_enabled_directories     int(1),
                      CHANGE anon_dirvot anonymous_vote_directories        int(1),
                      CHANGE anon_albvot anonymous_vote_media_albums       int(1),
					  CHANGE ecom_type   ecommerce_type                    int(5),
					  CHANGE cc_wmurl    ecommerce_credit_card_url         char(255),
			          CHANGE moneta      ecommerce_currency                char(255),
					  CHANGE spese_sped  ecommerce_shipping_cost           double,
					  CHANGE scad_cart   ecommerce_cart_expire             int(16),
					  CHANGE ecom_showpr ecommerce_show_catalogue_price    int(1),
                      CHANGE ecom_showex ecommerce_show_extra              int(1),
                      CHANGE tipo_pagam  ecommerce_payment_type            int(5),
					  CHANGE cc_wmprezzo ecommerce_variable_price          char(255),
                      CHANGE cc_wmID     ecommerce_variable_id             char(255),
					  CHANGE rban        banners_exchange_enabled          int(1),
					  CHANGE be_ratio    banners_exchange_ratio            int(16),
                      CHANGE be_extra    banners_exchange_extra_content    text,
                      CHANGE be_attivi   banners_exchange_auto_enabled     int(1),
                      CHANGE be_creini   banners_exchange_starting_credits int(16),
					  ADD    skin                          char(255) AFTER logo_height,
					  ADD    banners_enabled               int(1)    AFTER banner,
					  ADD    hide_left_panels_action_home  int(1)    AFTER service_email,
					  ADD    hide_right_panels_action_home int(1)    AFTER hide_left_panels_action_home,
					  ADD    ts                            int(16)   AFTER logging_enabled,
					  DROP COLUMN ftp_sub,
					  DROP COLUMN ftp_pas,
					  DROP COLUMN editlingua,
					  DROP COLUMN preflingua";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET ecommerce_payment_type        = '0',
                          ecommerce_cart_expire         = '5',
						  skin                          = file_css,
						  hide_left_panels_action_home  = '".WM3_cDISABLED."',
						  hide_right_panels_action_home = '".WM3_cDISABLED."',
						  ts                            = '$update_ts'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET   banners_enabled = '1'
                      WHERE banner          = 'ON'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET   banners_enabled = '0'
                      WHERE banner          = 'OFF'";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences
	                  DROP COLUMN banner,
					  DROP COLUMN file_css,
					  DROP COLUMN fl_home_off";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      SET banners_exchange_auto_enabled  = banners_exchange_auto_enabled - 1,
					      show_home_channels             = show_home_channels - 1,
						  show_home_news                 = show_home_news - 1,
						  show_full_news                 = show_full_news - 1,
						  enable_news_comments           = enable_news_comments -1,
						  anonymous_news_comments        = anonymous_news_comments - 1,
						  anonymous_write_news           = anonymous_write_news - 1,
						  anonymous_enabled_news         = anonymous_enabled_news - 1,
						  anonymous_add_directories      = anonymous_add_directories - 1,
						  anonymous_enabled_directories  = anonymous_enabled_directories -1,
						  anonymous_vote_directories     = anonymous_vote_directories -1,
						  anonymous_vote_media_albums    = anonymous_vote_media_albums - 1,
                          show_total_newsletter          = show_total_newsletter - 1,
                          show_total_signalations        = show_total_signalations - 1,
                          show_total_search_engine       = show_total_search_engine - 1,
                          show_online_users_visitors     = show_online_users_visitors - 1,
					      ecommerce_show_catalogue_price = ecommerce_show_catalogue_price - 1,
                          ecommerce_show_extra           = ecommerce_show_extra - 1,
                          user_enabled                   = user_enabled - 1,
                          user_special                   = user_special - 1,                      
                          user_flag1                     = user_flag1 - 1,
                          user_flag2                     = user_flag2 - 1,
                          user_flag3                     = user_flag3 - 1,
                          user_flag4                     = user_flag4 - 1,
                          user_flag5                     = user_flag5 - 1,
                          user_flag6                     = user_flag6 - 1,
                          user_flag7                     = user_flag7 - 1,                                                            
                          user_flag8                     = user_flag8 - 1";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_morepref
                      TO           ".WM3_cCONFIG_DB_PREFIX."_preferences_contents";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                      CHANGE mprefID    preferences_contentID           bigint(20) auto_increment,
                      CHANGE titolo     browser_bar_title               char(255),
                      CHANGE big_titolo title                           char(255),
                      CHANGE redazione  staff_name                      char(255),
                      CHANGE specialut  special_user_label              char(255),
                      CHANGE ogg_se     signalation_email_subject       char(255),
                      CHANGE mailse     signalation_email_text          text,
                      CHANGE ogg_ut     user_registration_email_subject char(255),
                      CHANGE mailut     user_registration_email_text    text,
                      CHANGE ling       languageID                      bigint(20),
					  ADD    temp       text                            AFTER head,
                      ADD    ts         int(16)                         AFTER languageID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
	                  SET temp = home,
					      ts   = UNIX_TIMESTAMP(data)";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
	                  DROP COLUMN home,
					  DROP COLUMN data";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                      CHANGE temp home text";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_gb_messaggi
                      TO           ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                      CHANGE gbmessaggioID messageID  bigint(20) auto_increment,
                      CHANGE nome          name       char(255),
					  CHANGE email         email      char(255),
                      CHANGE messaggio     message    text,
                      CHANGE attivo        enabled    int(1), 
                      CHANGE ling          languageID bigint(20),
					  CHANGE ts            temp       int(16),
					  CHANGE data          ts         int(16),
					  ADD    countryID     bigint(20) AFTER userID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                      SET countryID = (SELECT countryID FROM ".WM3_cCONFIG_DB_PREFIX."_countries WHERE code = country)";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                      SET countryID = '0' WHERE country = '00'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages SET ts = temp";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
					  DROP COLUMN country,
					  DROP COLUMN userID,
					  DROP COLUMN temp";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_counter
                      TO           ".WM3_cCONFIG_DB_PREFIX."_counters";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_counters
                      CHANGE nvis        total_visitors     bigint(20) unsigned,
                      CHANGE nseg        total_signalations bigint(20) unsigned,
                      CHANGE max_vis     max_visitors       int(16),
                      CHANGE lastusr_ip  last_user_ip       char(255),
                      CHANGE lastusr_dns last_user_dns      char(255),
                      CHANGE lastusr_ID  last_userID        bigint(20),
                      CHANGE lastusr_ts  last_user_ts       int(16),
					  ADD    installation_ts int(16),
					  ADD    max_users       int(16)        AFTER max_visitors";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_counters
	                  SET installation_ts = start_ts,
					      max_users       = max_usr";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_counters
					  DROP COLUMN start_ts,
					  DROP COLUMN max_usr";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_directory
                      TO           ".WM3_cCONFIG_DB_PREFIX."_directories";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_directories
                      CHANGE dirID    directoryID    bigint(20) auto_increment,
                      CHANGE dir_name name           char(255),
					  CHANGE dir_desc description    char(255),
                      CHANGE dir_pic  icon           char(255),
                      CHANGE tipodir  directory_type int(5),
                      CHANGE attivo   enabled        int(1), 
                      CHANGE ling     languageID     bigint(20),
					  CHANGE ts       temp           int(16),
					  CHANGE data     ts             int(16),
					  ADD    parentID bigint(20)     AFTER directoryID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories
	                  SET    parentID = padreID,
					         ts = temp";
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories
	                  DROP COLUMN padreID,
					  DROP COLUMN temp";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_directory_item
                      TO           ".WM3_cCONFIG_DB_PREFIX."_directories_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      CHANGE ditemID           directory_itemID bigint(20) auto_increment,
					  CHANGE dirID             directoryID      bigint(20),
				      CHANGE pagID             pageID           bigint(20),
                      CHANGE titolo            title            char(255),
					  CHANGE descr             description      text,
					  CHANGE url1              home_url         char(255),
					  CHANGE url2              download_url     char(255),
                      CHANGE item_pic          icon             char(255),
                      CHANGE nvoti             votes_counts     int(16),
                      CHANGE totvoti           votes_sum        int(16),
                      CHANGE mediavoti         votes_average    float,					  
                      CHANGE tipoditem         source           int(5),
                      CHANGE attivo            enabled          int(1),
                      CHANGE ling              languageID       bigint(20),
					  CHANGE ts                temp             int(16),
					  CHANGE data              ts               int(16),
					  ADD    render_mode       int(5)           AFTER description,
					  ADD    directory_item_ts int(16)          AFTER source";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      SET   enabled =  '".WM3_cDISABLED."'
                      WHERE enabled != '".WM3_cENABLED."'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
	                  SET render_mode = '".WM3_cRENDER_MODE_HTML."', source = source - 1, ts = temp, directory_item_ts = tsupd";
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories_items DROP COLUMN temp";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      SET   userID = '$users_next_auto_increment'
                      WHERE userID = '0'";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      SET   userID = '".WM3_cUSER_ANONYMOUS."'
                      WHERE userID = '-1'";
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories_items
	                  DROP COLUMN tsupd";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_directory_sess
                      TO           ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items
                      CHANGE dsessID directory_item_sessionID bigint(20) auto_increment,
                      CHANGE ditemID directory_itemID         bigint(20),
                      CHANGE tipo    session_type             int(5)";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items
                      SET   userID = '".WM3_cUSER_ANONYMOUS."'
                      WHERE userID = '-1'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_time_stat
                      TO           ".WM3_cCONFIG_DB_PREFIX."_statistics_history";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_statistics_history
                      CHANGE tstatID    historyID bigint(20) auto_increment,
                      CHANGE anno       year            int(16),
                      CHANGE mese       month           int(2),
					  CHANGE giorno     day             int(2),
					  CHANGE ora        hour            int(2),
					  CHANGE nomegiorno day_of_the_week int(1),
					  DROP COLUMN dataora,
					  DROP COLUMN data";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_log
                      TO           ".WM3_cCONFIG_DB_PREFIX."_logs";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_logs
	                  ADD logID   bigint(20) primary key auto_increment FIRST,
                      ADD adminID bigint(20) AFTER userID";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_logs SET adminID = '0'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_wcm
                      TO           ".WM3_cCONFIG_DB_PREFIX."_database";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_database
	                  CHANGE wcm database_version char(255)";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_database SET database_version = '3.0'";

     for($i = 0; $i < sizeof($_DB_UPDATE); $i++) $db->query($_DB_UPDATE[$i]);
     $db->close();
    }

   public static function updateDatabase30to31()
    {
     // Update query (3.0 to 3.1)
     $update_ts = time();
     $db = new wm3DB(WM3_cCONFIG_DB_SERVER,WM3_cCONFIG_DB_USER,WM3_cCONFIG_DB_PASSWORD,WM3_cCONFIG_DB_NAME,WM3_cCONFIG_DB_PREFIX);

     $max_panel_position = ($db->getFirstRowField(WM3_cCONFIG_DB_PREFIX."_panels","MAX(position)")) + 1; // Get max position + 1 in panels table

     $_DB_UPDATE[] = "ALTER DATABASE ".WM3_cCONFIG_DB_NAME." CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_banners                     CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange            CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange_credits    CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks             CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_categories         CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories      CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms                   CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences         CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_counters                    CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_countries                   CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_database                    CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories                 CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories_items           CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads                   CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories     CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items       CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data       CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_fields     CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels     CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_orders            CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products          CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories     CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_faqs                        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_faqs_categories             CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_forums                      CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_categories           CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_posts                CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_posts_read           CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_groups                      CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages         CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_horoscopes                  CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_horoscopes_dailies          CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_languages                   CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_links                       CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_links_categories            CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_logs                        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_market_announcements        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_market_categories           CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_market_subcategories        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums                CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories     CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items          CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items             CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories  CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_messages                    CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_metatags                    CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news                        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters                 CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items           CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news_categories             CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news_comments               CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_pages                       CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_pages_categories            CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_panels                      CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_panels_categories           CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_preferences                 CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_preferences_contents        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_quotes                      CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items        CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions                    CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_actions            CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_banners_exchange   CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms          CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_directories_items  CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_downloads          CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_forums_posts       CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_media_albums_items CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_news               CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_pages              CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_surveys            CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_states                      CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers         CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_history          CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses             CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_surveys                     CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_surveys_items               CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_users                       CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_users_messages              CHARSET = ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers             CHARSET = ".$db->getCharset();

     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_banners
                      MODIFY title  char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY banner text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_banners_exchange
                      MODIFY title        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY banner_alt   char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY banner_url   char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY banner_image char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_blocks
                      MODIFY title       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY picture     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY alt         char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_channels_subcategories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms
                      MODIFY name  char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY topic text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_chatrooms_sentences
                      MODIFY nickname char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY sentence text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_counters
                      MODIFY last_user_ip  char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY last_user_dns char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_countries
                      MODIFY code char(8)   CHARACTER SET ".$db->getCharset().",
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_database
                      MODIFY database_version char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories
                      MODIFY name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_directories_items
                      MODIFY title        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description  text      CHARACTER SET ".$db->getCharset().",
                      MODIFY icon         char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY home_url     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY download_url char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads
                      MODIFY name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description text      CHARACTER SET ".$db->getCharset().",
                      MODIFY download    char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads_categories
                      MODIFY name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_downloads_subcategories
                      MODIFY name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_carts_items
                      MODIFY product_code        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY product_name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY product_description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY options             text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_data
                      MODIFY value char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_custom_labels
                      MODIFY label char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products
                      MODIFY code              char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY name              char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY full_description  text      CHARACTER SET ".$db->getCharset().",
                      MODIFY price_description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY options           text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_products_pictures
                      MODIFY picture     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY thumbnail   char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_ecommerce_subcategories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_faqs
                      MODIFY question char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY answer   text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_faqs_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_forums
                      MODIFY title        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY topic        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY denied_words text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_categories
                      MODIFY name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_forums_posts
                      MODIFY title char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY post  text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_groups
                      MODIFY name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description text      CHARACTER SET ".$db->getCharset().",
                      MODIFY icon        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_guestbooks_messages
                      MODIFY name    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY email   char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY message text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_horoscopes
                      MODIFY message text CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_languages
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY flag char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY file char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_links
                      MODIFY url         char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY title       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_links_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_logs
                      MODIFY referer char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY ip      char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY dns     char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_market_announcements
                      MODIFY announcement text      CHARACTER SET ".$db->getCharset().",
                      MODIFY title        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_market_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_market_subcategories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums
                      MODIFY title       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums_categories
                      MODIFY name        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon        char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_media_albums_items
                      MODIFY title     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY alt       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY media     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY thumbnail char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      MODIFY title  char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY url    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY target char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_messages
                      MODIFY message text CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_metatags
                      MODIFY author      text CHARACTER SET ".$db->getCharset().",
                      MODIFY keywords    text CHARACTER SET ".$db->getCharset().",
                      MODIFY description text CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news
                      MODIFY title char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY news  text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters
                      MODIFY subject    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY newsletter text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_newsletters_items
                      MODIFY email char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_news_comments
                      MODIFY comment text CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_pages
                      MODIFY title     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY subtitle  char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY head      text      CHARACTER SET ".$db->getCharset().",
                      MODIFY body      text      CHARACTER SET ".$db->getCharset().",
                      MODIFY foot      text      CHARACTER SET ".$db->getCharset().",
                      MODIFY expansion char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_pages_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_panels
                      MODIFY title     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY head      text      CHARACTER SET ".$db->getCharset().",
                      MODIFY body      text      CHARACTER SET ".$db->getCharset().",
                      MODIFY foot      text      CHARACTER SET ".$db->getCharset().",
                      MODIFY expansion char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_panels_categories
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_preferences
                      MODIFY banners_exchange_extra_content text      CHARACTER SET ".$db->getCharset().",
                      MODIFY logo                           char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY skin                           char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY site_address                   char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY webmaster_email                char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY service_email                  char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY ecommerce_credit_card_url      char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY ecommerce_variable_price       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY ecommerce_variable_id          char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY ecommerce_currency             char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                      MODIFY browser_bar_title               char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY title                           char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY head                            text      CHARACTER SET ".$db->getCharset().",
                      MODIFY home                            text      CHARACTER SET ".$db->getCharset().",
                      MODIFY foot                            text      CHARACTER SET ".$db->getCharset().",
                      MODIFY staff_name                      char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY special_user_label              char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY signalation_email_subject       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY signalation_email_text          text      CHARACTER SET ".$db->getCharset().",
                      MODIFY user_registration_email_subject char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY user_registration_email_text    text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_quotes
                      MODIFY quote      text      CHARACTER SET ".$db->getCharset().",
                      MODIFY author     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY year       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY occupation char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY author_url char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_search_engines_items
                      MODIFY url         char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY keywords    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY description char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions
                      MODIFY hash char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY ip   char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_sessions_chatrooms
                      MODIFY nickname char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY ip       char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_states
                      MODIFY code char(8)   CHARACTER SET ".$db->getCharset().",
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_browsers
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_statistics_oses
                      MODIFY name char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icon char(255) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_surveys
                      MODIFY title    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY question text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_surveys_items
                      MODIFY answer text CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_users
                      MODIFY login      char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY password   char(32)  CHARACTER SET ".$db->getCharset().",
                      MODIFY name       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY surname    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY address    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY zip_code   char(5)   CHARACTER SET ".$db->getCharset().",
                      MODIFY city       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY phone      char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY fax        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY cell       char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY icq        char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY email      char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY website    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY birth_city char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY gender     char(1)   CHARACTER SET ".$db->getCharset().",
                      MODIFY avatar     char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY notes      text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_users_messages
                      MODIFY subject char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY message text      CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "ALTER TABLE ".WM3_cCONFIG_DB_PREFIX."_webmail_servers
                      MODIFY name         char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY in_suffix    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY in_address   char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY out_login    char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY out_password char(255) CHARACTER SET ".$db->getCharset().",
                      MODIFY out_address  char(255) CHARACTER SET ".$db->getCharset();

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_downloads
                      ADD votes_average float   AFTER hits,
	                  ADD votes_sum     int(16) AFTER hits,
	                  ADD votes_counts  int(16) AFTER hits";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_downloads
	                  SET votes_average = '0',
	                      votes_sum     = '0',
	                      votes_counts  = '0'";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_languages
	                  ADD code char(8) AFTER file";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET code = 'en'                    WHERE languageID = '".WM3_cLANGUAGE_EN."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET code = 'it'                    WHERE languageID = '".WM3_cLANGUAGE_IT."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET code = 'fr', name = 'Français' WHERE languageID = '".WM3_cLANGUAGE_FR."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET code = 'de'                    WHERE languageID = '".WM3_cLANGUAGE_DE."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET code = 'es', name = 'Español'  WHERE languageID = '".WM3_cLANGUAGE_ES."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_languages SET code = 'nl'                    WHERE languageID = '".WM3_cLANGUAGE_NL."'";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_languages
                      VALUES('','Ελληνικά','flag_el.png','language_el.php','el','".WM3_cENABLED."','$update_ts')";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_menus
                       (
                        menuID      bigint(20) primary key auto_increment,
                        name        char(255),
                        description char(255),
                        icon        char(255),
                        enabled     int(1),
                        languageID  bigint(20),
                        ts          int(16)
                       ) CHARACTER SET ".$db->getCharset();
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_menus
                      VALUES('','','','','".WM3_cENABLED."','".WM3_cLANGUAGE_ALL."','$update_ts')";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                      TO           ".WM3_cCONFIG_DB_PREFIX."_menus_items";
     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_menus_items
                      CHANGE menu_bar_itemID menu_itemID bigint(20) auto_increment,
                      ADD    menudropdownID  bigint(20)  AFTER categoryID,
                      ADD    menuID          bigint(20)  AFTER categoryID,
                      ADD    is_separator    int(1)      AFTER position";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items
	                  SET    menuID = '".WM3_cMAIN_MENU."', menudropdownID = '0', is_separator = '".WM3_cDISABLED."'";

     $_DB_UPDATE[] = "RENAME TABLE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                      TO           ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories SET name = 'MENU_ITEM_CHANNEL'  WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_CHANNEL."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories SET name = 'MENU_ITEM_HOME'     WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_HOME."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories SET name = 'MENU_ITEM_ADMIN'    WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_ADMIN."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories SET name = 'MENU_ITEM_USER'     WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_USER."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories SET name = 'MENU_ITEM_EXTERNAL' WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_EXTERNAL."'";
	 $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories SET name = 'MENU_ITEM_CUSTOM'   WHERE categoryID = '".WM3_cMENU_ITEM_CATEGORY_CUSTOM."'";
     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_menus_items_categories
                      VALUES('','0','MENU_ITEM_VOID','','".WM3_cENABLED."','".WM3_cLANGUAGE_ALL."','$update_ts')";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_metatags
                      ADD head_extra           text       AFTER description,
                      ADD enabled              int(1)     AFTER head_extra,
                      ADD use_basic_head_extra int(1)     AFTER head_extra,
                      ADD newsID               bigint(20) AFTER head_extra,
                      ADD pageID               bigint(20) AFTER head_extra";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_metatags
	                  SET head_extra           = '',
	                      pageID               = '0',
	                      newsID               = '0',
	                      use_basic_head_extra = '".WM3_cENABLED."',
	                      enabled              = '".WM3_cENABLED."',
                          languageID           = '".WM3_cLANGUAGE_ALL."'";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_news
                      ADD votes_average float   AFTER hits,
	                  ADD votes_sum     int(16) AFTER hits,
	                  ADD votes_counts  int(16) AFTER hits";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_news
	                  SET votes_average = '0',
	                      votes_sum     = '0',
	                      votes_counts  = '0'";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_pages
                      ADD expansion_config text    AFTER expansion,
                      ADD expansion_index  int(16) AFTER expansion";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET expansion_index  = '0',
                          expansion_config = ''";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_pages
                      SET   expansion_index = SUBSTR(expansion,1,INSTR(expansion,'_')-1),
                            expansion       = SUBSTR(expansion,INSTR(expansion,'_')+1)
                      WHERE expansion <> ''";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_panels
                      ADD expansion_config text    AFTER expansion,
                      ADD expansion_index  int(16) AFTER expansion,
                      ADD visibility       int(5)  AFTER render_mode";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                      SET visibility       = '".WM3_cVISIBILITY_ALL."',
                          expansion_index  = '0',
                          expansion_config = ''";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_panels
                      SET   expansion_index = SUBSTR(expansion,1,INSTR(expansion,'_')-1),
                            expansion       = SUBSTR(expansion,INSTR(expansion,'_')+1)
                      WHERE expansion <> ''";

     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_panels VALUES
                      ('','".WM3_cPANEL_CATEGORY_LANGUAGES."','0','Language:','Choose your language:','','','','0','','".WM3_cRENDER_MODE_HTML."','".WM3_cVISIBILITY_ALL."','$max_panel_position','".WM3_cALIGN_RIGHT."','".WM3_cENABLED."','".WM3_cLANGUAGE_EL."','$update_ts')";

     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_panels_categories VALUES
                      ('','0','PANEL_MENU','','".WM3_cENABLED."','".WM3_cLANGUAGE_ALL."','$update_ts'),
                      ('','0','PANEL_TAGS','','".WM3_cENABLED."','".WM3_cLANGUAGE_ALL."','$update_ts')";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_preferences
                      CHANGE show_full_news           anonymous_vote_news int(1),
                      ADD    logo_printable           char(255) AFTER logo_height,
                      ADD    registration_form_type   int(5)    AFTER foot_content,
                      ADD    anonymous_vote_downloads int(1)    AFTER anonymous_vote_media_albums";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_preferences
	                  SET anonymous_vote_news      = '".WM3_cDISABLED."',
	                      anonymous_vote_downloads = '".WM3_cDISABLED."',
	                      logo_printable           = 'printable.gif',
	                      registration_form_type   = '".WM3_cPREFERENCES_REGISTRATION_FULL."'";

     $_DB_UPDATE[] = "INSERT INTO ".WM3_cCONFIG_DB_PREFIX."_preferences_contents
                      VALUES('','Webmatic','Welcome to Webmatic','','<b>Webmatic its now correctly installed, thanks!</b><br><br><table width=\"40%\" border=\"0\" cellspacing=\"1\" cellpadding=\"5\" align=\"center\"><tr><td><p align=\"left\">Now you can:<br><br><nobr>- Start to modify your website by click on <a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=2\">admin</a>;</nobr><br><nobr>- Read Webmatic <a href=\"".WM3_cPATH_DOCS."en\" target=\"_blank\">documentation</a>;</nobr><br><nobr>- Download last Webmatic version from <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>.</nobr></p></td></tr></table><br>For any question or suggestion please visit the Webmatic website <a href=\"http://www.valarsoft.com\" target=\"_blank\">www.valarsoft.com</a>','','Webmatic editorial staff','Special user','Subject','text','Subject','text','".WM3_cLANGUAGE_EL."',$update_ts)";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys
	                  ADD closed int(1)     AFTER layout_type,
	                  ADD backID bigint(20) AFTER enabled";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_surveys
	                  SET closed = '".WM3_cDISABLED."',
	                      backID = '0'";

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_surveys_items
	                  CHANGE surveyID surveyID bigint(20)";

     $_DB_UPDATE[] = "CREATE TABLE ".WM3_cCONFIG_DB_PREFIX."_tags
                       (
                        tag    char(255),
                        newsID bigint(20),
                        KEY tag (tag)
                       ) CHARACTER SET ".$db->getCharset();

     $_DB_UPDATE[] = "ALTER TABLE  ".WM3_cCONFIG_DB_PREFIX."_users
                      ADD skype    char(255) AFTER cell,
	                  ADD msn      char(255) AFTER cell,
	                  ADD vat_code char(255) AFTER gender,
	                  ADD tax_code char(255) AFTER gender";
     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_users
	                  SET skype    = '',
	                      msn      = '',
	                      vat_code = '',
	                      tax_code = ''";

     $_DB_UPDATE[] = "UPDATE ".WM3_cCONFIG_DB_PREFIX."_database SET database_version = '3.1'";

     for($i = 0; $i < sizeof($_DB_UPDATE); $i++) $db->query($_DB_UPDATE[$i]);
     $db->close();
    }

  }

?>
